package org.jboss.errai.ioc.client;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.Frame;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.HeaderPanel;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.RootPanel;
import com.google.gwt.user.client.ui.TextArea;
import com.google.gwt.user.client.ui.Tree;
import com.google.web.bindery.event.shared.EventBus;
import javax.enterprise.event.Event;
import javax.enterprise.inject.Instance;
import javax.validation.Validator;
import org.dashbuilder.client.editor.DisplayerDragComponent;
import org.dashbuilder.client.widgets.common.ClientRuntimeErrorPopupPresenter;
import org.dashbuilder.client.widgets.common.LoadingBox;
import org.dashbuilder.client.widgets.common.LoadingBoxView;
import org.dashbuilder.client.widgets.dataset.editor.DataSetDefColumnsFilterEditor;
import org.dashbuilder.client.widgets.dataset.editor.DataSetDefColumnsFilterEditorView;
import org.dashbuilder.client.widgets.dataset.editor.DataSetDefFilterEditor;
import org.dashbuilder.client.widgets.dataset.editor.DataSetDefFilterEditorView;
import org.dashbuilder.client.widgets.dataset.editor.DataSetDefPreviewTable;
import org.dashbuilder.client.widgets.dataset.editor.DataSetDefPreviewTableView;
import org.dashbuilder.client.widgets.dataset.editor.DataSetDefProviderTypeEditor;
import org.dashbuilder.client.widgets.dataset.editor.DataSetDefProviderTypeEditorView;
import org.dashbuilder.client.widgets.dataset.editor.DataSetEditorView;
import org.dashbuilder.client.widgets.dataset.editor.attributes.DataSetDefBackendCacheAttributesEditor;
import org.dashbuilder.client.widgets.dataset.editor.attributes.DataSetDefBasicAttributesEditor;
import org.dashbuilder.client.widgets.dataset.editor.attributes.DataSetDefBasicAttributesEditorView;
import org.dashbuilder.client.widgets.dataset.editor.attributes.DataSetDefCacheAttributesEditorViewImpl;
import org.dashbuilder.client.widgets.dataset.editor.attributes.DataSetDefClientCacheAttributesEditor;
import org.dashbuilder.client.widgets.dataset.editor.attributes.DataSetDefRefreshAttributesEditor;
import org.dashbuilder.client.widgets.dataset.editor.attributes.DataSetDefRefreshAttributesEditorView;
import org.dashbuilder.client.widgets.dataset.editor.attributes.DataSetDefRefreshIntervalEditor;
import org.dashbuilder.client.widgets.dataset.editor.attributes.DataSetDefRefreshIntervalEditorView;
import org.dashbuilder.client.widgets.dataset.editor.bean.BeanDataSetDefAttributesEditor;
import org.dashbuilder.client.widgets.dataset.editor.bean.BeanDataSetDefAttributesEditorView;
import org.dashbuilder.client.widgets.dataset.editor.bean.BeanDataSetEditor;
import org.dashbuilder.client.widgets.dataset.editor.column.ColumnListEditor;
import org.dashbuilder.client.widgets.dataset.editor.column.ColumnListEditorView;
import org.dashbuilder.client.widgets.dataset.editor.column.ColumnTypeEditor;
import org.dashbuilder.client.widgets.dataset.editor.column.DataColumnDefEditor;
import org.dashbuilder.client.widgets.dataset.editor.column.DataColumnDefEditorView;
import org.dashbuilder.client.widgets.dataset.editor.column.DataSetDefColumnsEditor;
import org.dashbuilder.client.widgets.dataset.editor.csv.CSVDataSetDefAttributesEditor;
import org.dashbuilder.client.widgets.dataset.editor.csv.CSVDataSetDefAttributesEditorView;
import org.dashbuilder.client.widgets.dataset.editor.csv.CSVDataSetEditor;
import org.dashbuilder.client.widgets.dataset.editor.driver.BeanDataSetDefAttributesDriver;
import org.dashbuilder.client.widgets.dataset.editor.driver.BeanDataSetDefDriver;
import org.dashbuilder.client.widgets.dataset.editor.driver.CSVDataSetDefAttributesDriver;
import org.dashbuilder.client.widgets.dataset.editor.driver.CSVDataSetDefDriver;
import org.dashbuilder.client.widgets.dataset.editor.driver.DataColumnDefDriver;
import org.dashbuilder.client.widgets.dataset.editor.driver.DataSetDefBasicAttributesDriver;
import org.dashbuilder.client.widgets.dataset.editor.driver.DataSetDefProviderTypeDriver;
import org.dashbuilder.client.widgets.dataset.editor.driver.DataSetEditorDriverFactory;
import org.dashbuilder.client.widgets.dataset.editor.driver.ElasticSearchDataSetDefAttributesDriver;
import org.dashbuilder.client.widgets.dataset.editor.driver.ElasticSearchDataSetDefDriver;
import org.dashbuilder.client.widgets.dataset.editor.driver.SQLDataSetDefAttributesDriver;
import org.dashbuilder.client.widgets.dataset.editor.driver.SQLDataSetDefDriver;
import org.dashbuilder.client.widgets.dataset.editor.elasticsearch.ElasticSearchDataSetDefAttributesEditor;
import org.dashbuilder.client.widgets.dataset.editor.elasticsearch.ElasticSearchDataSetDefAttributesEditorView;
import org.dashbuilder.client.widgets.dataset.editor.elasticsearch.ElasticSearchDataSetEditor;
import org.dashbuilder.client.widgets.dataset.editor.sql.SQLDataSetDefAttributesEditor;
import org.dashbuilder.client.widgets.dataset.editor.sql.SQLDataSetDefAttributesEditorView;
import org.dashbuilder.client.widgets.dataset.editor.sql.SQLDataSetEditor;
import org.dashbuilder.client.widgets.dataset.editor.workflow.DataSetEditorWorkflowFactory;
import org.dashbuilder.client.widgets.dataset.editor.workflow.DataSetEditorWorkflowView;
import org.dashbuilder.client.widgets.dataset.editor.workflow.create.BeanDataSetBasicAttributesWorkflow;
import org.dashbuilder.client.widgets.dataset.editor.workflow.create.CSVDataSetBasicAttributesWorkflow;
import org.dashbuilder.client.widgets.dataset.editor.workflow.create.DataSetProviderTypeWorkflow;
import org.dashbuilder.client.widgets.dataset.editor.workflow.create.ElasticSearchDataSetBasicAttributesWorkflow;
import org.dashbuilder.client.widgets.dataset.editor.workflow.create.SQLDataSetBasicAttributesWorkflow;
import org.dashbuilder.client.widgets.dataset.editor.workflow.edit.BeanDataSetEditWorkflow;
import org.dashbuilder.client.widgets.dataset.editor.workflow.edit.CSVDataSetEditWorkflow;
import org.dashbuilder.client.widgets.dataset.editor.workflow.edit.ElasticSearchDataSetEditWorkflow;
import org.dashbuilder.client.widgets.dataset.editor.workflow.edit.SQLDataSetEditWorkflow;
import org.dashbuilder.client.widgets.dataset.explorer.DataSetExplorer;
import org.dashbuilder.client.widgets.dataset.explorer.DataSetExplorerView;
import org.dashbuilder.client.widgets.dataset.explorer.DataSetPanel;
import org.dashbuilder.client.widgets.dataset.explorer.DataSetPanelView;
import org.dashbuilder.client.widgets.dataset.explorer.DataSetSummary;
import org.dashbuilder.client.widgets.dataset.explorer.DataSetSummaryView;
import org.dashbuilder.common.client.editor.ToggleSwitchEditor;
import org.dashbuilder.common.client.editor.ToggleSwitchEditorView;
import org.dashbuilder.common.client.editor.ValueBoxEditor;
import org.dashbuilder.common.client.editor.ValueBoxEditorView;
import org.dashbuilder.common.client.editor.file.FileUploadEditor;
import org.dashbuilder.common.client.editor.file.FileUploadEditorView;
import org.dashbuilder.common.client.editor.list.DropDownImageListEditor;
import org.dashbuilder.common.client.editor.list.DropDownImageListEditorView;
import org.dashbuilder.common.client.editor.list.HorizImageListEditor;
import org.dashbuilder.common.client.editor.list.HorizImageListEditorView;
import org.dashbuilder.common.client.editor.map.MapEditor;
import org.dashbuilder.common.client.editor.map.MapEditorView;
import org.dashbuilder.common.client.widgets.AlertPanel;
import org.dashbuilder.common.client.widgets.AlertPanelView;
import org.dashbuilder.dataset.client.ClientDataSetManager;
import org.dashbuilder.dataset.client.DataSetClientServices;
import org.dashbuilder.dataset.client.engine.ClientChronometer;
import org.dashbuilder.dataset.client.engine.ClientDateFormatterImpl;
import org.dashbuilder.dataset.client.engine.ClientIntervalBuilderDynamicDate;
import org.dashbuilder.dataset.client.engine.ClientIntervalBuilderLocator;
import org.dashbuilder.dataset.client.uuid.ClientUUIDGenerator;
import org.dashbuilder.dataset.editor.client.perspectives.DataSetAuthoringPerspective;
import org.dashbuilder.dataset.editor.client.perspectives.DataSetAuthoringPerspectiveActivity;
import org.dashbuilder.dataset.editor.client.screens.DataSetAuthoringHomePresenter;
import org.dashbuilder.dataset.editor.client.screens.DataSetAuthoringHomePresenterActivity;
import org.dashbuilder.dataset.editor.client.screens.DataSetAuthoringHomeView;
import org.dashbuilder.dataset.editor.client.screens.DataSetDefEditorPresenter;
import org.dashbuilder.dataset.editor.client.screens.DataSetDefEditorPresenterActivity;
import org.dashbuilder.dataset.editor.client.screens.DataSetDefExplorerScreen;
import org.dashbuilder.dataset.editor.client.screens.DataSetDefExplorerScreenActivity;
import org.dashbuilder.dataset.editor.client.screens.DataSetDefScreenViewImpl;
import org.dashbuilder.dataset.editor.client.screens.DataSetDefType;
import org.dashbuilder.dataset.editor.client.screens.DataSetDefWizardScreen;
import org.dashbuilder.dataset.editor.client.screens.DataSetDefWizardScreenActivity;
import org.dashbuilder.dataset.engine.function.AggregateFunctionManagerImpl;
import org.dashbuilder.dataset.engine.group.IntervalBuilderDynamicLabel;
import org.dashbuilder.dataset.engine.group.IntervalBuilderFixedDate;
import org.dashbuilder.displayer.client.ClientSettings;
import org.dashbuilder.displayer.client.DisplayerCoordinator;
import org.dashbuilder.displayer.client.DisplayerLocator;
import org.dashbuilder.displayer.client.DisplayerScreenPresenter;
import org.dashbuilder.displayer.client.DisplayerScreenPresenterActivity;
import org.dashbuilder.displayer.client.PerspectiveCoordinator;
import org.dashbuilder.displayer.client.RendererManager;
import org.dashbuilder.displayer.client.formatter.ValueFormatterRegistry;
import org.dashbuilder.displayer.client.prototypes.DataSetPrototypes;
import org.dashbuilder.displayer.client.prototypes.DisplayerPrototypes;
import org.dashbuilder.displayer.client.widgets.DataSetLookupEditor;
import org.dashbuilder.displayer.client.widgets.DataSetLookupEditorView;
import org.dashbuilder.displayer.client.widgets.DisplayerEditor;
import org.dashbuilder.displayer.client.widgets.DisplayerEditorPopup;
import org.dashbuilder.displayer.client.widgets.DisplayerEditorStatus;
import org.dashbuilder.displayer.client.widgets.DisplayerEditorView;
import org.dashbuilder.displayer.client.widgets.DisplayerError;
import org.dashbuilder.displayer.client.widgets.DisplayerSettingsEditor;
import org.dashbuilder.displayer.client.widgets.DisplayerSettingsEditorView;
import org.dashbuilder.displayer.client.widgets.DisplayerSettingsJSONSourceViewer;
import org.dashbuilder.displayer.client.widgets.DisplayerSubtypeSelector;
import org.dashbuilder.displayer.client.widgets.DisplayerSubtypeSelectorView;
import org.dashbuilder.displayer.client.widgets.DisplayerTypeSelector;
import org.dashbuilder.displayer.client.widgets.DisplayerTypeSelectorView;
import org.dashbuilder.displayer.client.widgets.DisplayerViewer;
import org.dashbuilder.displayer.client.widgets.RendererSelector;
import org.dashbuilder.displayer.client.widgets.RendererSelectorListBoxView;
import org.dashbuilder.displayer.client.widgets.RendererSelectorRadioListView;
import org.dashbuilder.displayer.client.widgets.RendererSelectorTabListView;
import org.dashbuilder.displayer.client.widgets.filter.ColumnFilterEditor;
import org.dashbuilder.displayer.client.widgets.filter.ColumnFilterEditorView;
import org.dashbuilder.displayer.client.widgets.filter.DataSetFilterEditorView;
import org.dashbuilder.displayer.client.widgets.filter.DateParameterEditorView;
import org.dashbuilder.displayer.client.widgets.filter.LikeToFunctionEditor;
import org.dashbuilder.displayer.client.widgets.filter.LikeToFunctionEditorView;
import org.dashbuilder.displayer.client.widgets.filter.MultipleNumberParameterEditor;
import org.dashbuilder.displayer.client.widgets.filter.MultipleNumberParameterEditorView;
import org.dashbuilder.displayer.client.widgets.filter.MultipleTextParameterEditor;
import org.dashbuilder.displayer.client.widgets.filter.MultipleTextParameterEditorView;
import org.dashbuilder.displayer.client.widgets.filter.NumberParameterEditor;
import org.dashbuilder.displayer.client.widgets.filter.NumberParameterEditorView;
import org.dashbuilder.displayer.client.widgets.filter.TextParameterEditorView;
import org.dashbuilder.displayer.client.widgets.filter.TimeAmountEditorView;
import org.dashbuilder.displayer.client.widgets.filter.TimeFrameEditor;
import org.dashbuilder.displayer.client.widgets.filter.TimeFrameEditorView;
import org.dashbuilder.displayer.client.widgets.filter.TimeInstantEditor;
import org.dashbuilder.displayer.client.widgets.filter.TimeInstantEditorView;
import org.dashbuilder.displayer.client.widgets.group.ColumnDetailsEditor;
import org.dashbuilder.displayer.client.widgets.group.ColumnDetailsEditorView;
import org.dashbuilder.displayer.client.widgets.group.ColumnFunctionEditor;
import org.dashbuilder.displayer.client.widgets.group.ColumnFunctionEditorView;
import org.dashbuilder.displayer.client.widgets.group.DataSetGroupDateEditor;
import org.dashbuilder.displayer.client.widgets.group.DataSetGroupDateEditorView;
import org.dashbuilder.displayer.json.DisplayerSettingsJSONMarshaller;
import org.dashbuilder.renderer.client.DefaultRenderer;
import org.dashbuilder.renderer.client.selector.SelectorDisplayer;
import org.dashbuilder.renderer.client.selector.SelectorDisplayerView;
import org.dashbuilder.renderer.client.table.TableDisplayer;
import org.dashbuilder.renderer.client.table.TableDisplayerView;
import org.dashbuilder.renderer.google.client.GoogleAreaChartDisplayer;
import org.dashbuilder.renderer.google.client.GoogleAreaChartDisplayerView;
import org.dashbuilder.renderer.google.client.GoogleBarChartDisplayer;
import org.dashbuilder.renderer.google.client.GoogleBarChartDisplayerView;
import org.dashbuilder.renderer.google.client.GoogleBubbleChartDisplayer;
import org.dashbuilder.renderer.google.client.GoogleBubbleChartDisplayerView;
import org.dashbuilder.renderer.google.client.GoogleLineChartDisplayer;
import org.dashbuilder.renderer.google.client.GoogleLineChartDisplayerView;
import org.dashbuilder.renderer.google.client.GoogleMapDisplayer;
import org.dashbuilder.renderer.google.client.GoogleMapDisplayerView;
import org.dashbuilder.renderer.google.client.GoogleMeterChartDisplayer;
import org.dashbuilder.renderer.google.client.GoogleMeterChartDisplayerView;
import org.dashbuilder.renderer.google.client.GooglePieChartDisplayer;
import org.dashbuilder.renderer.google.client.GooglePieChartDisplayerView;
import org.dashbuilder.renderer.google.client.GoogleRenderer;
import org.dashbuilder.renderer.google.client.GoogleTableDisplayer;
import org.dashbuilder.renderer.google.client.GoogleTableDisplayerView;
import org.dashbuilder.validations.dataset.BeanDataSetDefValidator;
import org.dashbuilder.validations.dataset.CSVDataSetDefValidator;
import org.dashbuilder.validations.dataset.DataSetDefValidator;
import org.dashbuilder.validations.dataset.ElasticSearchDataSetDefValidator;
import org.dashbuilder.validations.dataset.SQLDataSetDefValidator;
import org.drools.workbench.screens.drltext.client.DRLEditorEntryPoint;
import org.drools.workbench.screens.drltext.client.editor.DRLEditorPresenter;
import org.drools.workbench.screens.drltext.client.editor.DRLEditorPresenterActivity;
import org.drools.workbench.screens.drltext.client.editor.DRLEditorViewImpl;
import org.drools.workbench.screens.drltext.client.handlers.NewDrlTextHandler;
import org.drools.workbench.screens.drltext.client.type.DRLResourceType;
import org.drools.workbench.screens.drltext.client.type.DSLRResourceType;
import org.drools.workbench.screens.drltext.type.DRLResourceTypeDefinition;
import org.drools.workbench.screens.drltext.type.DSLRResourceTypeDefinition;
import org.drools.workbench.screens.dsltext.client.DSLEditorEntryPoint;
import org.drools.workbench.screens.dsltext.client.editor.DSLEditorPresenter;
import org.drools.workbench.screens.dsltext.client.editor.DSLEditorPresenterActivity;
import org.drools.workbench.screens.dsltext.client.editor.DSLEditorViewImpl;
import org.drools.workbench.screens.dsltext.client.handlers.NewDslTextHandler;
import org.drools.workbench.screens.dsltext.client.type.DSLResourceType;
import org.drools.workbench.screens.dsltext.type.DSLResourceTypeDefinition;
import org.drools.workbench.screens.dtablexls.client.DecisionTableXLSEntryPoint;
import org.drools.workbench.screens.dtablexls.client.editor.DecisionTableXLSEditorPresenter;
import org.drools.workbench.screens.dtablexls.client.editor.DecisionTableXLSEditorPresenterActivity;
import org.drools.workbench.screens.dtablexls.client.editor.DecisionTableXLSEditorViewImpl;
import org.drools.workbench.screens.dtablexls.client.handlers.NewDecisionTableXLSHandler;
import org.drools.workbench.screens.dtablexls.client.type.DecisionTableXLSResourceType;
import org.drools.workbench.screens.dtablexls.client.type.DecisionTableXLSXResourceType;
import org.drools.workbench.screens.dtablexls.type.DecisionTableXLSResourceTypeDefinition;
import org.drools.workbench.screens.dtablexls.type.DecisionTableXLSXResourceTypeDefinition;
import org.drools.workbench.screens.enums.client.EnumEditorEntryPoint;
import org.drools.workbench.screens.enums.client.editor.EnumEditorPresenter;
import org.drools.workbench.screens.enums.client.editor.EnumEditorPresenterActivity;
import org.drools.workbench.screens.enums.client.editor.EnumEditorViewImpl;
import org.drools.workbench.screens.enums.client.handlers.NewEnumHandler;
import org.drools.workbench.screens.enums.client.type.EnumResourceType;
import org.drools.workbench.screens.enums.type.EnumResourceTypeDefinition;
import org.drools.workbench.screens.globals.client.GlobalsEditorEntryPoint;
import org.drools.workbench.screens.globals.client.editor.AddGlobalPopup;
import org.drools.workbench.screens.globals.client.editor.GlobalsEditorPresenter;
import org.drools.workbench.screens.globals.client.editor.GlobalsEditorPresenterActivity;
import org.drools.workbench.screens.globals.client.editor.GlobalsEditorViewImpl;
import org.drools.workbench.screens.globals.client.handlers.NewGlobalHandler;
import org.drools.workbench.screens.globals.client.type.GlobalResourceType;
import org.drools.workbench.screens.globals.type.GlobalResourceTypeDefinition;
import org.drools.workbench.screens.guided.dtable.client.GuidedDecisionTableEditorEntryPoint;
import org.drools.workbench.screens.guided.dtable.client.editor.GuidedDecisionTableEditorPresenter;
import org.drools.workbench.screens.guided.dtable.client.editor.GuidedDecisionTableEditorPresenterActivity;
import org.drools.workbench.screens.guided.dtable.client.editor.GuidedDecisionTableEditorViewImpl;
import org.drools.workbench.screens.guided.dtable.client.editor.clipboard.impl.DefaultClipboard;
import org.drools.workbench.screens.guided.dtable.client.editor.menu.CellContextMenu;
import org.drools.workbench.screens.guided.dtable.client.editor.menu.CellContextMenuViewImpl;
import org.drools.workbench.screens.guided.dtable.client.editor.menu.EditMenuBuilder;
import org.drools.workbench.screens.guided.dtable.client.editor.menu.EditMenuViewImpl;
import org.drools.workbench.screens.guided.dtable.client.editor.menu.InsertMenuBuilder;
import org.drools.workbench.screens.guided.dtable.client.editor.menu.InsertMenuViewImpl;
import org.drools.workbench.screens.guided.dtable.client.editor.menu.RadarMenuBuilder;
import org.drools.workbench.screens.guided.dtable.client.editor.menu.RadarMenuViewImpl;
import org.drools.workbench.screens.guided.dtable.client.editor.menu.RowContextMenu;
import org.drools.workbench.screens.guided.dtable.client.editor.menu.RowContextMenuViewImpl;
import org.drools.workbench.screens.guided.dtable.client.editor.menu.ViewMenuBuilder;
import org.drools.workbench.screens.guided.dtable.client.editor.menu.ViewMenuViewImpl;
import org.drools.workbench.screens.guided.dtable.client.handlers.GuidedDecisionTableOptions;
import org.drools.workbench.screens.guided.dtable.client.handlers.NewGuidedDecisionTableHandler;
import org.drools.workbench.screens.guided.dtable.client.type.GuidedDTableResourceType;
import org.drools.workbench.screens.guided.dtable.client.widget.analysis.panel.AnalysisReportScreen;
import org.drools.workbench.screens.guided.dtable.client.widget.analysis.panel.AnalysisReportScreenActivity;
import org.drools.workbench.screens.guided.dtable.client.widget.analysis.panel.AnalysisReportScreenViewImpl;
import org.drools.workbench.screens.guided.dtable.client.widget.analysis.panel.IssuePresenter;
import org.drools.workbench.screens.guided.dtable.client.widget.analysis.panel.IssuePresenterViewImpl;
import org.drools.workbench.screens.guided.dtable.client.widget.table.GuidedDecisionTableModellerContextMenuSupport;
import org.drools.workbench.screens.guided.dtable.client.widget.table.GuidedDecisionTableModellerPresenter;
import org.drools.workbench.screens.guided.dtable.client.widget.table.GuidedDecisionTableModellerViewImpl;
import org.drools.workbench.screens.guided.dtable.client.widget.table.GuidedDecisionTablePresenter;
import org.drools.workbench.screens.guided.dtable.client.widget.table.lockmanager.GuidedDecisionTableLockManagerImpl;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.converters.cell.impl.GridWidgetCellFactoryImpl;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.converters.column.impl.ActionInsertFactColumnConverter;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.converters.column.impl.ActionRetractFactColumnConverter;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.converters.column.impl.ActionSetFieldColumnConverter;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.converters.column.impl.ActionWorkItemColumnConverter;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.converters.column.impl.ActionWorkItemInsertFactColumnConverter;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.converters.column.impl.ActionWorkItemSetFieldColumnConverter;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.converters.column.impl.AttributeColumnConverter;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.converters.column.impl.BRLActionVariableColumnConverter;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.converters.column.impl.BRLConditionVariableColumnConverter;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.converters.column.impl.ConditionColumnConverter;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.converters.column.impl.DescriptionColumnConverter;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.converters.column.impl.GridWidgetColumnFactoryImpl;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.converters.column.impl.LimitedEntryColumnConverter;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.converters.column.impl.MetaDataColumnConverter;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.converters.column.impl.RowNumberColumnConverter;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.linkmanager.impl.DefaultGuidedDecisionTableLinkManager;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.synchronizers.impl.ActionColumnSynchronizer;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.synchronizers.impl.ActionInsertFactColumnSynchronizer;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.synchronizers.impl.ActionRetractFactColumnSynchronizer;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.synchronizers.impl.ActionSetFieldColumnSynchronizer;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.synchronizers.impl.ActionWorkItemColumnSynchronizer;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.synchronizers.impl.ActionWorkItemInsertFactColumnSynchronizer;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.synchronizers.impl.ActionWorkItemSetFieldColumnSynchronizer;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.synchronizers.impl.AttributeColumnSynchronizer;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.synchronizers.impl.BRLActionColumnSynchronizer;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.synchronizers.impl.BRLConditionColumnSynchronizer;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.synchronizers.impl.ConditionColumnSynchronizer;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.synchronizers.impl.LimitedEntryBRLActionColumnSynchronizer;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.synchronizers.impl.LimitedEntryBRLConditionColumnSynchronizer;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.synchronizers.impl.MetaDataColumnSynchronizer;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.synchronizers.impl.ModelSynchronizerImpl;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.synchronizers.impl.RowSynchronizer;
import org.drools.workbench.screens.guided.dtable.client.wizard.NewGuidedDecisionTableWizard;
import org.drools.workbench.screens.guided.dtable.client.wizard.pages.ActionInsertFactFieldsPage;
import org.drools.workbench.screens.guided.dtable.client.wizard.pages.ActionInsertFactFieldsPageViewImpl;
import org.drools.workbench.screens.guided.dtable.client.wizard.pages.ActionSetFieldsPage;
import org.drools.workbench.screens.guided.dtable.client.wizard.pages.ActionSetFieldsPageViewImpl;
import org.drools.workbench.screens.guided.dtable.client.wizard.pages.ColumnExpansionPage;
import org.drools.workbench.screens.guided.dtable.client.wizard.pages.ColumnExpansionPageViewImpl;
import org.drools.workbench.screens.guided.dtable.client.wizard.pages.FactPatternConstraintsPage;
import org.drools.workbench.screens.guided.dtable.client.wizard.pages.FactPatternConstraintsPageViewImpl;
import org.drools.workbench.screens.guided.dtable.client.wizard.pages.FactPatternsPage;
import org.drools.workbench.screens.guided.dtable.client.wizard.pages.FactPatternsPageViewImpl;
import org.drools.workbench.screens.guided.dtable.client.wizard.pages.ImportsPage;
import org.drools.workbench.screens.guided.dtable.client.wizard.pages.ImportsPageViewImpl;
import org.drools.workbench.screens.guided.dtable.client.wizard.pages.SummaryPage;
import org.drools.workbench.screens.guided.dtable.client.wizard.pages.SummaryPageViewImpl;
import org.drools.workbench.screens.guided.dtable.client.wizard.pages.cells.ActionInsertFactFieldCell;
import org.drools.workbench.screens.guided.dtable.client.wizard.pages.cells.ActionInsertFactFieldPatternCell;
import org.drools.workbench.screens.guided.dtable.client.wizard.pages.cells.ActionSetFieldCell;
import org.drools.workbench.screens.guided.dtable.client.wizard.pages.cells.ActionSetFieldPatternCell;
import org.drools.workbench.screens.guided.dtable.client.wizard.pages.cells.ConditionCell;
import org.drools.workbench.screens.guided.dtable.client.wizard.pages.cells.ConditionPatternCell;
import org.drools.workbench.screens.guided.dtable.client.wizard.pages.cells.DefaultPatternCell;
import org.drools.workbench.screens.guided.dtable.type.GuidedDTableResourceTypeDefinition;
import org.drools.workbench.screens.guided.dtree.client.editor.GuidedDecisionTreeEditorPresenter;
import org.drools.workbench.screens.guided.dtree.client.editor.GuidedDecisionTreeEditorPresenterActivity;
import org.drools.workbench.screens.guided.dtree.client.editor.GuidedDecisionTreeEditorViewImpl;
import org.drools.workbench.screens.guided.dtree.client.handlers.NewGuidedDecisionTreeHandler;
import org.drools.workbench.screens.guided.dtree.client.type.GuidedDTreeResourceType;
import org.drools.workbench.screens.guided.dtree.client.widget.GuidedDecisionTreeWidget;
import org.drools.workbench.screens.guided.dtree.client.widget.factories.ActionInsertNodeFactory;
import org.drools.workbench.screens.guided.dtree.client.widget.factories.ActionRetractNodeFactory;
import org.drools.workbench.screens.guided.dtree.client.widget.factories.ActionUpdateNodeFactory;
import org.drools.workbench.screens.guided.dtree.client.widget.factories.ConstraintNodeFactory;
import org.drools.workbench.screens.guided.dtree.client.widget.factories.TypeNodeFactory;
import org.drools.workbench.screens.guided.dtree.client.widget.palette.GuidedDecisionTreePalette;
import org.drools.workbench.screens.guided.dtree.client.widget.palette.GuidedDecisionTreeStencilPaletteBuilder;
import org.drools.workbench.screens.guided.dtree.type.GuidedDTreeResourceTypeDefinition;
import org.drools.workbench.screens.guided.rule.client.GuidedRuleEditorEntryPoint;
import org.drools.workbench.screens.guided.rule.client.editor.GuidedRuleEditorPresenter;
import org.drools.workbench.screens.guided.rule.client.editor.GuidedRuleEditorPresenterActivity;
import org.drools.workbench.screens.guided.rule.client.editor.GuidedRuleEditorViewImpl;
import org.drools.workbench.screens.guided.rule.client.handlers.NewGuidedRuleHandler;
import org.drools.workbench.screens.guided.rule.client.type.GuidedRuleDRLResourceType;
import org.drools.workbench.screens.guided.rule.client.type.GuidedRuleDSLRResourceType;
import org.drools.workbench.screens.guided.rule.type.GuidedRuleDRLResourceTypeDefinition;
import org.drools.workbench.screens.guided.rule.type.GuidedRuleDSLRResourceTypeDefinition;
import org.drools.workbench.screens.guided.scorecard.client.editor.GuidedScoreCardEditorPresenter;
import org.drools.workbench.screens.guided.scorecard.client.editor.GuidedScoreCardEditorPresenterActivity;
import org.drools.workbench.screens.guided.scorecard.client.editor.GuidedScoreCardEditorViewImpl;
import org.drools.workbench.screens.guided.scorecard.client.handlers.NewGuidedScoreCardHandler;
import org.drools.workbench.screens.guided.scorecard.client.type.GuidedScoreCardResourceType;
import org.drools.workbench.screens.guided.scorecard.type.GuidedScoreCardResourceTypeDefinition;
import org.drools.workbench.screens.guided.template.client.GuidedRuleTemplateEntryPoint;
import org.drools.workbench.screens.guided.template.client.editor.GuidedRuleTemplateDataViewImpl;
import org.drools.workbench.screens.guided.template.client.editor.GuidedRuleTemplateEditorPresenter;
import org.drools.workbench.screens.guided.template.client.editor.GuidedRuleTemplateEditorPresenterActivity;
import org.drools.workbench.screens.guided.template.client.editor.GuidedRuleTemplateEditorViewImpl;
import org.drools.workbench.screens.guided.template.client.handlers.NewGuidedRuleTemplateHandler;
import org.drools.workbench.screens.guided.template.client.type.GuidedRuleTemplateResourceType;
import org.drools.workbench.screens.guided.template.type.GuidedRuleTemplateResourceTypeDefinition;
import org.drools.workbench.screens.scorecardxls.client.ScoreCardXLSEntryPoint;
import org.drools.workbench.screens.scorecardxls.client.editor.ScoreCardXLSEditorPresenter;
import org.drools.workbench.screens.scorecardxls.client.editor.ScoreCardXLSEditorPresenterActivity;
import org.drools.workbench.screens.scorecardxls.client.editor.ScoreCardXLSEditorViewImpl;
import org.drools.workbench.screens.scorecardxls.client.handlers.NewScoreCardXLSHandler;
import org.drools.workbench.screens.scorecardxls.client.type.ScoreCardXLSResourceType;
import org.drools.workbench.screens.scorecardxls.type.ScoreCardXLSResourceTypeDefinition;
import org.drools.workbench.screens.testscenario.client.AuditLog;
import org.drools.workbench.screens.testscenario.client.FixtureLayout;
import org.drools.workbench.screens.testscenario.client.ScenarioEditorPresenter;
import org.drools.workbench.screens.testscenario.client.ScenarioEditorPresenterActivity;
import org.drools.workbench.screens.testscenario.client.ScenarioEditorViewImpl;
import org.drools.workbench.screens.testscenario.client.ScenarioKSessionSelector;
import org.drools.workbench.screens.testscenario.client.ScenarioWidgetComponentCreator;
import org.drools.workbench.screens.testscenario.client.TestScenarioEditorEntryPoint;
import org.drools.workbench.screens.testscenario.client.handlers.NewTestScenarioHandler;
import org.drools.workbench.screens.testscenario.client.reporting.TestRunnerReportingScreen;
import org.drools.workbench.screens.testscenario.client.reporting.TestRunnerReportingScreenActivity;
import org.drools.workbench.screens.testscenario.client.reporting.TestRunnerReportingViewImpl;
import org.drools.workbench.screens.testscenario.client.service.TestRuntimeReportingService;
import org.drools.workbench.screens.testscenario.client.type.TestScenarioResourceType;
import org.drools.workbench.screens.testscenario.type.TestScenarioResourceTypeDefinition;
import org.drools.workbench.screens.workitems.client.WorkItemsEditorEntryPoint;
import org.drools.workbench.screens.workitems.client.editor.WorkItemsEditorPresenter;
import org.drools.workbench.screens.workitems.client.editor.WorkItemsEditorPresenterActivity;
import org.drools.workbench.screens.workitems.client.editor.WorkItemsEditorViewImpl;
import org.drools.workbench.screens.workitems.client.handlers.NewWorkItemHandler;
import org.drools.workbench.screens.workitems.client.type.WorkItemsResourceType;
import org.drools.workbench.screens.workitems.client.widget.WorkItemDefinitionElementsBrowser;
import org.drools.workbench.screens.workitems.client.widget.WorkItemMetaDataLoader;
import org.drools.workbench.screens.workitems.type.WorkItemsTypeDefinition;
import org.guvnor.asset.management.client.editors.build.BuildConfigurationPresenter;
import org.guvnor.asset.management.client.editors.build.BuildConfigurationPresenterActivity;
import org.guvnor.asset.management.client.editors.build.BuildConfigurationViewImpl;
import org.guvnor.asset.management.client.editors.conf.RepositoryConfigurationPresenter;
import org.guvnor.asset.management.client.editors.conf.RepositoryConfigurationPresenterActivity;
import org.guvnor.asset.management.client.editors.conf.RepositoryConfigurationViewImpl;
import org.guvnor.asset.management.client.editors.forms.approve.ApproveOperationPresenter;
import org.guvnor.asset.management.client.editors.forms.approve.ApproveOperationPresenterActivity;
import org.guvnor.asset.management.client.editors.forms.approve.ApproveOperationViewImpl;
import org.guvnor.asset.management.client.editors.forms.error.DisplayErrorPresenter;
import org.guvnor.asset.management.client.editors.forms.error.DisplayErrorPresenterActivity;
import org.guvnor.asset.management.client.editors.forms.error.DisplayErrorViewImpl;
import org.guvnor.asset.management.client.editors.forms.promote.SelectAssetsToPromotePresenter;
import org.guvnor.asset.management.client.editors.forms.promote.SelectAssetsToPromotePresenterActivity;
import org.guvnor.asset.management.client.editors.forms.promote.SelectAssetsToPromoteViewImpl;
import org.guvnor.asset.management.client.editors.forms.promote.util.JSONCommitsReader;
import org.guvnor.asset.management.client.editors.forms.review.ReviewPresenter;
import org.guvnor.asset.management.client.editors.forms.review.ReviewPresenterActivity;
import org.guvnor.asset.management.client.editors.forms.review.ReviewViewImpl;
import org.guvnor.asset.management.client.editors.forms.rework.RequiresReworkPresenter;
import org.guvnor.asset.management.client.editors.forms.rework.RequiresReworkPresenterActivity;
import org.guvnor.asset.management.client.editors.forms.rework.RequiresReworkViewImpl;
import org.guvnor.asset.management.client.editors.project.structure.widgets.ProjectModulesViewImpl;
import org.guvnor.asset.management.client.editors.project.structure.widgets.RepositoryStructureDataPresenter;
import org.guvnor.asset.management.client.editors.project.structure.widgets.RepositoryStructureDataViewImpl;
import org.guvnor.asset.management.client.editors.promote.PromoteChangesPresenter;
import org.guvnor.asset.management.client.editors.promote.PromoteChangesPresenterActivity;
import org.guvnor.asset.management.client.editors.promote.PromoteChangesViewImpl;
import org.guvnor.asset.management.client.editors.release.ReleaseConfigurationPresenter;
import org.guvnor.asset.management.client.editors.release.ReleaseConfigurationPresenterActivity;
import org.guvnor.asset.management.client.editors.release.ReleaseConfigurationViewImpl;
import org.guvnor.asset.management.client.editors.repository.structure.RepositoryManagedStatusUpdater;
import org.guvnor.asset.management.client.editors.repository.structure.RepositoryStructureMenu;
import org.guvnor.asset.management.client.editors.repository.structure.RepositoryStructurePresenter;
import org.guvnor.asset.management.client.editors.repository.structure.RepositoryStructurePresenterActivity;
import org.guvnor.asset.management.client.editors.repository.structure.RepositoryStructureTitle;
import org.guvnor.asset.management.client.editors.repository.structure.RepositoryStructureViewImpl;
import org.guvnor.asset.management.client.editors.repository.structure.configure.ConfigureScreenPopupViewImpl;
import org.guvnor.asset.management.client.editors.repository.structure.promote.PromoteScreenPopupViewImpl;
import org.guvnor.asset.management.client.editors.repository.structure.release.ReleaseScreenPopupViewImpl;
import org.guvnor.asset.management.client.editors.repository.wizard.CreateRepositoryWizard;
import org.guvnor.asset.management.client.editors.repository.wizard.CreateRepositoryWizardModel;
import org.guvnor.asset.management.client.editors.repository.wizard.pages.RepositoryInfoPage;
import org.guvnor.asset.management.client.editors.repository.wizard.pages.RepositoryInfoPageViewImpl;
import org.guvnor.asset.management.client.editors.repository.wizard.pages.RepositoryStructurePage;
import org.guvnor.asset.management.client.editors.repository.wizard.pages.RepositoryStructurePageViewImpl;
import org.guvnor.asset.management.client.perspectives.AssetManagementPerspective;
import org.guvnor.asset.management.client.perspectives.AssetManagementPerspectiveActivity;
import org.guvnor.common.services.project.client.GAVEditor;
import org.guvnor.common.services.project.client.GAVEditorViewImpl;
import org.guvnor.common.services.project.client.POMEditorPanel;
import org.guvnor.common.services.project.client.POMEditorPanelViewImpl;
import org.guvnor.common.services.project.client.repositories.ConflictingRepositoriesPopup;
import org.guvnor.common.services.project.client.repositories.ConflictingRepositoriesPopupViewImpl;
import org.guvnor.common.services.project.client.security.ProjectController;
import org.guvnor.common.services.project.client.security.ProjectTreeProvider;
import org.guvnor.common.services.project.client.type.POMResourceType;
import org.guvnor.common.services.project.context.ProjectContext;
import org.guvnor.common.services.project.editor.type.POMResourceTypeDefinition;
import org.guvnor.common.services.workingset.client.WorkingSetManager;
import org.guvnor.inbox.client.InboxEntryPoint;
import org.guvnor.inbox.client.InboxPresenter;
import org.guvnor.inbox.client.InboxPresenterActivity;
import org.guvnor.inbox.client.InboxWidget;
import org.guvnor.m2repo.client.M2RepoEditorEntryPoint;
import org.guvnor.m2repo.client.M2RepoEditorPresenter;
import org.guvnor.m2repo.client.M2RepoEditorPresenterActivity;
import org.guvnor.m2repo.client.editor.MavenRepositoryPagedJarTable;
import org.guvnor.m2repo.client.upload.UploadFormPresenter;
import org.guvnor.m2repo.client.upload.UploadFormViewImpl;
import org.guvnor.m2repo.client.widgets.ArtifactListPresenterImpl;
import org.guvnor.m2repo.client.widgets.ArtifactListViewImpl;
import org.guvnor.messageconsole.client.console.MessageConsoleScreen;
import org.guvnor.messageconsole.client.console.MessageConsoleScreenActivity;
import org.guvnor.messageconsole.client.console.MessageConsoleService;
import org.guvnor.messageconsole.client.console.MessageConsoleViewImpl;
import org.guvnor.organizationalunit.manager.client.OrganizationalUnitManagerEntryPoint;
import org.guvnor.organizationalunit.manager.client.editor.OrganizationalUnitManagerPresenterImpl;
import org.guvnor.organizationalunit.manager.client.editor.OrganizationalUnitManagerPresenterImplActivity;
import org.guvnor.organizationalunit.manager.client.editor.OrganizationalUnitManagerViewImpl;
import org.guvnor.organizationalunit.manager.client.editor.popups.AddOrganizationalUnitPopup;
import org.guvnor.organizationalunit.manager.client.editor.popups.EditOrganizationalUnitPopup;
import org.guvnor.structure.client.StructureEntryPoint;
import org.guvnor.structure.client.editors.context.GuvnorStructureContext;
import org.guvnor.structure.client.editors.fileexplorer.FileExplorerPresenter;
import org.guvnor.structure.client.editors.fileexplorer.FileExplorerPresenterActivity;
import org.guvnor.structure.client.editors.fileexplorer.FileExplorerViewImpl;
import org.guvnor.structure.client.editors.repository.RepositoryPreferences;
import org.guvnor.structure.client.editors.repository.clone.CloneRepositoryPresenter;
import org.guvnor.structure.client.editors.repository.clone.CloneRepositoryViewImpl;
import org.guvnor.structure.client.editors.repository.edit.RepositoryEditorPresenter;
import org.guvnor.structure.client.editors.repository.edit.RepositoryEditorPresenterActivity;
import org.guvnor.structure.client.editors.repository.edit.RepositoryEditorView;
import org.guvnor.structure.client.editors.repository.list.RepositoriesPresenter;
import org.guvnor.structure.client.editors.repository.list.RepositoriesPresenterActivity;
import org.guvnor.structure.client.editors.repository.list.RepositoriesViewImpl;
import org.guvnor.structure.client.editors.repository.list.RepositoryItemPresenter;
import org.guvnor.structure.client.editors.repository.list.RepositoryItemViewImpl;
import org.guvnor.structure.client.security.OrganizationalUnitController;
import org.guvnor.structure.client.security.OrganizationalUnitTreeProvider;
import org.guvnor.structure.client.security.RepositoryController;
import org.guvnor.structure.client.security.RepositoryTreeProvider;
import org.gwtbootstrap3.client.ui.CheckBox;
import org.gwtbootstrap3.client.ui.Container;
import org.gwtbootstrap3.client.ui.DropDownMenu;
import org.gwtbootstrap3.client.ui.FieldSet;
import org.gwtbootstrap3.client.ui.FormControlStatic;
import org.gwtbootstrap3.client.ui.FormLabel;
import org.gwtbootstrap3.client.ui.HelpBlock;
import org.gwtbootstrap3.client.ui.Icon;
import org.gwtbootstrap3.client.ui.Legend;
import org.gwtbootstrap3.client.ui.LinkedGroup;
import org.gwtbootstrap3.client.ui.ListBox;
import org.gwtbootstrap3.client.ui.Well;
import org.gwtbootstrap3.client.ui.html.Paragraph;
import org.jboss.errai.bus.client.api.ClientMessageBus;
import org.jboss.errai.bus.client.api.messaging.RequestDispatcher;
import org.jboss.errai.common.client.api.BatchCaller;
import org.jboss.errai.common.client.api.Caller;
import org.jboss.errai.common.client.dom.Anchor;
import org.jboss.errai.common.client.dom.CheckboxInput;
import org.jboss.errai.common.client.dom.Div;
import org.jboss.errai.common.client.dom.Document;
import org.jboss.errai.common.client.dom.HTMLElement;
import org.jboss.errai.common.client.dom.Input;
import org.jboss.errai.common.client.dom.NumberInput;
import org.jboss.errai.common.client.dom.Select;
import org.jboss.errai.common.client.dom.Span;
import org.jboss.errai.common.client.dom.TextInput;
import org.jboss.errai.common.client.dom.UnorderedList;
import org.jboss.errai.databinding.client.DataBinderProvider;
import org.jboss.errai.databinding.client.DataBindingModuleBootstrapper;
import org.jboss.errai.databinding.client.ListComponentProvider;
import org.jboss.errai.databinding.client.api.DataBinder;
import org.jboss.errai.databinding.client.components.ListComponent;
import org.jboss.errai.enterprise.client.cdi.CDIEventTypeLookup;
import org.jboss.errai.enterprise.client.cdi.EventProvider;
import org.jboss.errai.enterprise.client.cdi.InstanceProvider;
import org.jboss.errai.enterprise.client.cdi.JsTypeEventObserver;
import org.jboss.errai.enterprise.client.cdi.WindowEventObservers;
import org.jboss.errai.enterprise.client.cdi.api.CDI;
import org.jboss.errai.ioc.client.api.Disposer;
import org.jboss.errai.ioc.client.api.InitBallot;
import org.jboss.errai.ioc.client.api.ManagedInstance;
import org.jboss.errai.ioc.client.api.builtin.CallerProvider;
import org.jboss.errai.ioc.client.api.builtin.DisposerProvider;
import org.jboss.errai.ioc.client.api.builtin.IOCBeanManagerProvider;
import org.jboss.errai.ioc.client.api.builtin.InitBallotProvider;
import org.jboss.errai.ioc.client.api.builtin.ManagedInstanceProvider;
import org.jboss.errai.ioc.client.api.builtin.RootPanelProvider;
import org.jboss.errai.ioc.client.container.ApplicationScopedContext;
import org.jboss.errai.ioc.client.container.Context;
import org.jboss.errai.ioc.client.container.ContextManager;
import org.jboss.errai.ioc.client.container.ContextManagerImpl;
import org.jboss.errai.ioc.client.container.DependentScopeContext;
import org.jboss.errai.ioc.client.container.Factory;
import org.jboss.errai.ioc.client.container.JsTypeProvider;
import org.jboss.errai.ioc.client.container.SyncBeanManager;
import org.jboss.errai.ioc.client.lifecycle.impl.AccessImpl;
import org.jboss.errai.ioc.client.lifecycle.impl.CreationImpl;
import org.jboss.errai.ioc.client.lifecycle.impl.DestructionImpl;
import org.jboss.errai.ioc.client.lifecycle.impl.LifecycleListenerRegistrarImpl;
import org.jboss.errai.ioc.client.lifecycle.impl.StateChangeImpl;
import org.jboss.errai.ioc.support.bus.client.BatchCallerProvider;
import org.jboss.errai.ioc.support.bus.client.MessageBusProvider;
import org.jboss.errai.ioc.support.bus.client.RequestDispatcherProvider;
import org.jboss.errai.ioc.support.bus.client.Sender;
import org.jboss.errai.ioc.support.bus.client.SenderProvider;
import org.jboss.errai.security.client.local.callback.DefaultBusSecurityErrorCallback;
import org.jboss.errai.security.client.local.callback.DefaultRestSecurityErrorCallback;
import org.jboss.errai.security.client.local.context.BasicUserCacheImpl;
import org.jboss.errai.security.client.local.context.SecurityContextImpl;
import org.jboss.errai.security.client.local.context.SecurityContextImpl.SecurityRolesConstraintPage;
import org.jboss.errai.security.client.local.interceptors.AuthenticationServiceInterceptor;
import org.jboss.errai.security.client.local.interceptors.ClientSecurityRoleInterceptor;
import org.jboss.errai.security.client.local.nav.SecurityContextHoldingSingleton;
import org.jboss.errai.security.client.local.roles.ClientRequiredRolesExtractorImpl;
import org.jboss.errai.security.client.local.storage.CookieStorageHandlerProvider;
import org.jboss.errai.security.client.local.storage.UserStorageHandler;
import org.jboss.errai.security.client.local.style.RoleStyleBindingProvider;
import org.jboss.errai.security.shared.api.identity.User;
import org.jboss.errai.ui.client.local.producer.HTMLElementProvider;
import org.jboss.errai.ui.client.local.spi.TranslationService;
import org.jboss.errai.ui.client.local.spi.TranslationServiceProvider;
import org.jboss.errai.ui.client.widget.ListWidget;
import org.jboss.errai.ui.client.widget.ListWidgetProvider;
import org.jboss.errai.ui.client.widget.LocaleListBox;
import org.jboss.errai.ui.client.widget.LocaleSelector;
import org.jboss.errai.ui.nav.client.local.HistoryTokenFactory;
import org.jboss.errai.ui.nav.client.local.Navigation;
import org.jboss.errai.ui.nav.client.local.NavigationPanel;
import org.jboss.errai.ui.nav.client.local.NavigationPanelProvider;
import org.jboss.errai.ui.nav.client.local.PageTransitionProvider;
import org.jboss.errai.ui.nav.client.local.TransitionAnchor;
import org.jboss.errai.ui.nav.client.local.TransitionAnchorFactory;
import org.jboss.errai.ui.nav.client.local.TransitionAnchorFactoryProvider;
import org.jboss.errai.ui.nav.client.local.TransitionAnchorProvider;
import org.jboss.errai.ui.nav.client.local.TransitionTo;
import org.jboss.errai.ui.nav.client.local.TransitionToRole;
import org.jboss.errai.ui.nav.client.local.TransitionToRoleProvider;
import org.jboss.errai.ui.nav.client.local.URLPatternMatcher;
import org.jboss.errai.ui.nav.client.local.URLPatternMatcherProvider;
import org.jboss.errai.ui.nav.client.local.spi.NavigationGraph;
import org.jboss.errai.ui.shared.ServerTemplateProvider;
import org.jboss.errai.validation.client.ValidatorProvider;
import org.jbpm.console.ng.bd.client.editors.deployment.list.DeploymentUnitsListPresenter;
import org.jbpm.console.ng.bd.client.editors.deployment.list.DeploymentUnitsListPresenterActivity;
import org.jbpm.console.ng.bd.client.editors.deployment.list.DeploymentUnitsListViewImpl;
import org.jbpm.console.ng.bd.client.editors.deployment.newunit.NewDeploymentPopup;
import org.jbpm.console.ng.bd.client.perspectives.DeploymentListPerspective;
import org.jbpm.console.ng.bd.client.perspectives.DeploymentListPerspectiveActivity;
import org.jbpm.console.ng.df.client.filter.FilterEditorPopup;
import org.jbpm.console.ng.df.client.filter.FilterSettingsJSONMarshaller;
import org.jbpm.console.ng.df.client.list.base.DataSetEditorManager;
import org.jbpm.console.ng.df.client.list.base.DataSetQueryHelper;
import org.jbpm.console.ng.df.client.popup.filter.DataSetFilterEditor;
import org.jbpm.console.ng.df.client.popup.filter.DateParameterEditor;
import org.jbpm.console.ng.df.client.popup.filter.TextParameterEditor;
import org.jbpm.console.ng.df.client.popup.filter.TimeAmountEditor;
import org.jbpm.console.ng.es.client.editors.jobdetails.JobDetailsPopup;
import org.jbpm.console.ng.es.client.editors.quicknewjob.QuickNewJobPopup;
import org.jbpm.console.ng.es.client.editors.requestlist.RequestListPresenter;
import org.jbpm.console.ng.es.client.editors.requestlist.RequestListPresenterActivity;
import org.jbpm.console.ng.es.client.editors.requestlist.RequestListViewImpl;
import org.jbpm.console.ng.es.client.editors.servicesettings.JobServiceSettingsPopup;
import org.jbpm.console.ng.es.client.perspectives.JobListPerspective;
import org.jbpm.console.ng.es.client.perspectives.JobListPerspectiveActivity;
import org.jbpm.console.ng.gc.client.perspectives.ExperimentalPagingPerspective;
import org.jbpm.console.ng.gc.client.perspectives.ExperimentalPagingPerspectiveActivity;
import org.jbpm.console.ng.gc.client.util.UTCDateBox;
import org.jbpm.console.ng.gc.client.util.UTCTimeBox;
import org.jbpm.console.ng.gc.forms.client.GenericFormsClientEntryPoint;
import org.jbpm.console.ng.gc.forms.client.display.displayers.util.JSNIHelper;
import org.jbpm.console.ng.gc.forms.client.display.displayers.util.PlaceManagerFormActivitySearcher;
import org.jbpm.console.ng.gc.forms.client.display.standalone.FormDisplayPerspective;
import org.jbpm.console.ng.gc.forms.client.display.standalone.FormDisplayPerspectiveActivity;
import org.jbpm.console.ng.gc.forms.client.display.views.EmbeddedFormDisplayView;
import org.jbpm.console.ng.gc.forms.client.display.views.GenericFormDisplayPresenter;
import org.jbpm.console.ng.gc.forms.client.display.views.GenericFormDisplayView;
import org.jbpm.console.ng.ht.client.editors.quicknewtask.QuickNewTaskPopup;
import org.jbpm.console.ng.ht.client.editors.taskadmin.TaskAdminPresenter;
import org.jbpm.console.ng.ht.client.editors.taskadmin.TaskAdminViewImpl;
import org.jbpm.console.ng.ht.client.editors.taskassignments.TaskAssignmentsPresenter;
import org.jbpm.console.ng.ht.client.editors.taskassignments.TaskAssignmentsViewImpl;
import org.jbpm.console.ng.ht.client.editors.taskcomments.TaskCommentsPresenter;
import org.jbpm.console.ng.ht.client.editors.taskcomments.TaskCommentsViewImpl;
import org.jbpm.console.ng.ht.client.editors.taskdetails.TaskDetailsPresenter;
import org.jbpm.console.ng.ht.client.editors.taskdetails.TaskDetailsViewImpl;
import org.jbpm.console.ng.ht.client.editors.taskdetailsmulti.TaskDetailsMultiPresenter;
import org.jbpm.console.ng.ht.client.editors.taskdetailsmulti.TaskDetailsMultiPresenterActivity;
import org.jbpm.console.ng.ht.client.editors.taskdetailsmulti.TaskDetailsMultiViewImpl;
import org.jbpm.console.ng.ht.client.editors.taskform.TaskFormPresenter;
import org.jbpm.console.ng.ht.client.editors.taskform.TaskFormViewImpl;
import org.jbpm.console.ng.ht.client.editors.tasklogs.TaskLogsPresenter;
import org.jbpm.console.ng.ht.client.editors.tasklogs.TaskLogsViewImpl;
import org.jbpm.console.ng.ht.client.editors.taskprocesscontext.TaskProcessContextPresenter;
import org.jbpm.console.ng.ht.client.editors.taskprocesscontext.TaskProcessContextViewImpl;
import org.jbpm.console.ng.ht.client.editors.taskslist.grid.DroolsTasksListGridPresenter;
import org.jbpm.console.ng.ht.client.editors.taskslist.grid.DroolsTasksListGridPresenterActivity;
import org.jbpm.console.ng.ht.client.editors.taskslist.grid.dash.DataSetTasksListGridPresenter;
import org.jbpm.console.ng.ht.client.editors.taskslist.grid.dash.DataSetTasksListGridPresenterActivity;
import org.jbpm.console.ng.ht.client.editors.taskslist.grid.dash.DataSetTasksListGridViewImpl;
import org.jbpm.console.ng.ht.client.perspectives.DataSetTasksListPerspective;
import org.jbpm.console.ng.ht.client.perspectives.DataSetTasksListPerspectiveActivity;
import org.jbpm.console.ng.ht.client.perspectives.DroolsTasksListPerspective;
import org.jbpm.console.ng.ht.client.perspectives.DroolsTasksListPerspectiveActivity;
import org.jbpm.console.ng.ht.forms.client.display.displayers.task.FTLTaskDisplayerImpl;
import org.jbpm.console.ng.ht.forms.client.display.displayers.task.PlaceManagerTaskDisplayerImpl;
import org.jbpm.console.ng.ht.forms.client.display.providers.HumanTaskFormDisplayProviderImpl;
import org.jbpm.console.ng.ht.forms.client.display.standalone.StandaloneTaskFormDisplayPresenter;
import org.jbpm.console.ng.ht.forms.client.display.standalone.StandaloneTaskFormDisplayPresenterActivity;
import org.jbpm.console.ng.ht.forms.modeler.client.editors.taskform.displayers.FormModellerStartProcessDisplayerImpl;
import org.jbpm.console.ng.ht.forms.modeler.client.editors.taskform.displayers.FormModellerTaskDisplayerImpl;
import org.jbpm.console.ng.pr.client.editors.definition.details.advance.AdvancedViewProcessDefDetailsPresenter;
import org.jbpm.console.ng.pr.client.editors.definition.details.advance.AdvancedViewProcessDefDetailsViewImpl;
import org.jbpm.console.ng.pr.client.editors.definition.details.basic.BasicProcessDefDetailsPresenter;
import org.jbpm.console.ng.pr.client.editors.definition.details.basic.BasicProcessDefDetailsViewImpl;
import org.jbpm.console.ng.pr.client.editors.definition.details.multi.advance.AdvancedProcessDefDetailsMultiPresenter;
import org.jbpm.console.ng.pr.client.editors.definition.details.multi.advance.AdvancedProcessDefDetailsMultiPresenterActivity;
import org.jbpm.console.ng.pr.client.editors.definition.details.multi.advance.AdvancedProcessDefDetailsMultiViewImpl;
import org.jbpm.console.ng.pr.client.editors.definition.details.multi.basic.BasicProcessDefDetailsMultiPresenter;
import org.jbpm.console.ng.pr.client.editors.definition.details.multi.basic.BasicProcessDefDetailsMultiPresenterActivity;
import org.jbpm.console.ng.pr.client.editors.definition.details.multi.basic.BasicProcessDefDetailsMultiViewImpl;
import org.jbpm.console.ng.pr.client.editors.definition.list.ProcessDefinitionListPresenter;
import org.jbpm.console.ng.pr.client.editors.definition.list.ProcessDefinitionListPresenterActivity;
import org.jbpm.console.ng.pr.client.editors.definition.list.ProcessDefinitionListViewImpl;
import org.jbpm.console.ng.pr.client.editors.documents.list.ProcessDocumentListPresenter;
import org.jbpm.console.ng.pr.client.editors.documents.list.ProcessDocumentListViewImpl;
import org.jbpm.console.ng.pr.client.editors.instance.details.ProcessInstanceDetailsPresenter;
import org.jbpm.console.ng.pr.client.editors.instance.details.ProcessInstanceDetailsViewImpl;
import org.jbpm.console.ng.pr.client.editors.instance.details.multi.ProcessInstanceDetailsMultiPresenter;
import org.jbpm.console.ng.pr.client.editors.instance.details.multi.ProcessInstanceDetailsMultiPresenterActivity;
import org.jbpm.console.ng.pr.client.editors.instance.details.multi.ProcessInstanceDetailsMultiViewImpl;
import org.jbpm.console.ng.pr.client.editors.instance.list.variables.dash.DataSetProcessInstanceWithVariablesListPresenter;
import org.jbpm.console.ng.pr.client.editors.instance.list.variables.dash.DataSetProcessInstanceWithVariablesListPresenterActivity;
import org.jbpm.console.ng.pr.client.editors.instance.list.variables.dash.DataSetProcessInstanceWithVariablesListViewImpl;
import org.jbpm.console.ng.pr.client.editors.instance.log.RuntimeLogPresenter;
import org.jbpm.console.ng.pr.client.editors.instance.log.RuntimeLogViewImpl;
import org.jbpm.console.ng.pr.client.editors.instance.signal.ProcessInstanceSignalPresenter;
import org.jbpm.console.ng.pr.client.editors.instance.signal.ProcessInstanceSignalPresenterActivity;
import org.jbpm.console.ng.pr.client.editors.instance.signal.ProcessInstanceSignalViewImpl;
import org.jbpm.console.ng.pr.client.editors.variables.edit.VariableEditPopup;
import org.jbpm.console.ng.pr.client.editors.variables.history.VariableHistoryPopup;
import org.jbpm.console.ng.pr.client.editors.variables.list.ProcessVariableListPresenter;
import org.jbpm.console.ng.pr.client.editors.variables.list.ProcessVariableListViewImpl;
import org.jbpm.console.ng.pr.client.perspectives.DataSetProcessInstancesWithVariablesPerspective;
import org.jbpm.console.ng.pr.client.perspectives.DataSetProcessInstancesWithVariablesPerspectiveActivity;
import org.jbpm.console.ng.pr.client.perspectives.ProcessDefinitionsPerspective;
import org.jbpm.console.ng.pr.client.perspectives.ProcessDefinitionsPerspectiveActivity;
import org.jbpm.console.ng.pr.forms.client.display.displayers.process.FTLStartProcessDisplayerImpl;
import org.jbpm.console.ng.pr.forms.client.display.displayers.process.PlaceManagerStartProcessDisplayerImpl;
import org.jbpm.console.ng.pr.forms.client.display.providers.StartProcessFormDisplayProviderImpl;
import org.jbpm.console.ng.pr.forms.client.display.standalone.StandaloneProcessFormDisplayScreen;
import org.jbpm.console.ng.pr.forms.client.display.standalone.StandaloneProcessFormDisplayScreenActivity;
import org.jbpm.console.ng.pr.forms.client.display.views.PopupFormDisplayerView;
import org.jbpm.console.ng.pr.forms.client.editors.quicknewinstance.QuickNewProcessInstancePopup;
import org.jbpm.console.ng.wi.client.editors.deployment.descriptor.DDParametersPopup;
import org.jbpm.console.ng.wi.client.editors.deployment.descriptor.DeploymentDescriptorEditorPresenter;
import org.jbpm.console.ng.wi.client.editors.deployment.descriptor.DeploymentDescriptorEditorPresenterActivity;
import org.jbpm.console.ng.wi.client.editors.deployment.descriptor.DeploymentDescriptorViewImpl;
import org.jbpm.console.ng.wi.client.editors.deployment.descriptor.type.DDResourceType;
import org.jbpm.console.ng.wi.dd.type.DDResourceTypeDefinition;
import org.jbpm.dashboard.renderer.client.panel.DashboardFactory;
import org.jbpm.dashboard.renderer.client.panel.DashboardPerspective;
import org.jbpm.dashboard.renderer.client.panel.DashboardPerspectiveActivity;
import org.jbpm.dashboard.renderer.client.panel.DashboardScreen;
import org.jbpm.dashboard.renderer.client.panel.DashboardScreenActivity;
import org.jbpm.dashboard.renderer.client.panel.DashboardView;
import org.jbpm.dashboard.renderer.client.panel.ProcessDashboard;
import org.jbpm.dashboard.renderer.client.panel.ProcessDashboardView;
import org.jbpm.dashboard.renderer.client.panel.TaskDashboard;
import org.jbpm.dashboard.renderer.client.panel.TaskDashboardView;
import org.jbpm.dashboard.renderer.client.panel.widgets.ProcessBreadCrumb;
import org.jbpm.dashboard.renderer.client.panel.widgets.ProcessBreadCrumbView;
import org.jbpm.designer.client.Bootstrap;
import org.jbpm.designer.client.DesignerPopUpPresenter;
import org.jbpm.designer.client.DesignerPopUpPresenterActivity;
import org.jbpm.designer.client.DesignerPresenter;
import org.jbpm.designer.client.DesignerPresenterActivity;
import org.jbpm.designer.client.DesignerViewImpl;
import org.jbpm.designer.client.DesignerWidgetPresenter;
import org.jbpm.designer.client.DesignerWidgetView;
import org.jbpm.designer.client.handlers.NewProcessHandler;
import org.jbpm.designer.client.notification.DesignerNotificationPopupsManager;
import org.jbpm.designer.client.parameters.DesignerEditorParametersPublisher;
import org.jbpm.designer.client.parameters.DesignerEditorParametersPublisherViewImpl;
import org.jbpm.designer.client.popup.ActivityDataIOEditor;
import org.jbpm.designer.client.popup.ActivityDataIOEditorViewImpl;
import org.jbpm.designer.client.popup.ActivityDataIOEditorWidget;
import org.jbpm.designer.client.popup.ActivityDataIOEditorWidgetViewImpl;
import org.jbpm.designer.client.popup.AssignmentListItemWidgetViewImpl;
import org.jbpm.designer.client.type.Bpmn2Type;
import org.jbpm.designer.client.util.ComboBox;
import org.jbpm.designer.client.util.ComboBoxViewImpl;
import org.jbpm.designer.client.util.DataIOEditorNameTextBox;
import org.jbpm.designer.type.Bpmn2TypeDefinition;
import org.jbpm.formModeler.editor.client.editors.FormModelerPanelPresenter;
import org.jbpm.formModeler.editor.client.editors.FormModelerPanelPresenterActivity;
import org.jbpm.formModeler.editor.client.editors.FormModelerPanelViewImpl;
import org.jbpm.formModeler.editor.client.handlers.NewFormDefinitionHandler;
import org.jbpm.formModeler.editor.client.type.FormDefinitionResourceType;
import org.jbpm.formModeler.editor.type.FormResourceTypeDefinition;
import org.jbpm.formModeler.renderer.client.FormRendererWidget;
import org.jbpm.formModeler.renderer.includer.FormRendererPanelIncluderPresenter;
import org.jbpm.formModeler.renderer.includer.FormRendererPanelIncluderPresenterActivity;
import org.jbpm.formModeler.renderer.includer.FormRendererPanelIncluderViewImpl;
import org.kie.uberfire.social.activities.client.user.SocialUserImageProviderImpl;
import org.kie.uberfire.social.activities.client.widgets.relations.SocialRelationsWidget;
import org.kie.uberfire.social.activities.client.widgets.userbox.UserBoxView;
import org.kie.workbench.client.KieWorkbenchEntryPoint;
import org.kie.workbench.client.RepositoryPreferencesProducer;
import org.kie.workbench.client.home.HomeProducer;
import org.kie.workbench.client.navbar.AppNavBar;
import org.kie.workbench.client.navbar.LogoWidgetPresenter;
import org.kie.workbench.client.navbar.LogoWidgetView;
import org.kie.workbench.client.perspectives.AdministrationPerspective;
import org.kie.workbench.client.perspectives.AdministrationPerspectiveActivity;
import org.kie.workbench.client.perspectives.DroolsAuthoringNoContextNavigationPerspective;
import org.kie.workbench.client.perspectives.DroolsAuthoringNoContextNavigationPerspectiveActivity;
import org.kie.workbench.client.perspectives.DroolsAuthoringPerspective;
import org.kie.workbench.client.perspectives.DroolsAuthoringPerspectiveActivity;
import org.kie.workbench.client.perspectives.M2RepoPerspective;
import org.kie.workbench.client.perspectives.M2RepoPerspectiveActivity;
import org.kie.workbench.common.screens.contributors.client.perspectives.ContributorsPerspective;
import org.kie.workbench.common.screens.contributors.client.perspectives.ContributorsPerspectiveActivity;
import org.kie.workbench.common.screens.contributors.client.screens.ContributorsScreen;
import org.kie.workbench.common.screens.contributors.client.screens.ContributorsScreenActivity;
import org.kie.workbench.common.screens.contributors.client.screens.ContributorsViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter;
import org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenterActivity;
import org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.PersistenceDescriptorEditorPresenter;
import org.kie.workbench.common.screens.datamodeller.client.PersistenceDescriptorEditorPresenterActivity;
import org.kie.workbench.common.screens.datamodeller.client.PersistenceDescriptorEditorViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.command.DataModelChangeNotifier;
import org.kie.workbench.common.screens.datamodeller.client.command.DataModelCommandBuilder;
import org.kie.workbench.common.screens.datamodeller.client.context.DataModelerWorkbenchContext;
import org.kie.workbench.common.screens.datamodeller.client.handlers.DomainHandlerRegistry;
import org.kie.workbench.common.screens.datamodeller.client.handlers.NewJavaFileTextHandler;
import org.kie.workbench.common.screens.datamodeller.client.handlers.advanceddomain.AdvancedDomainHandler;
import org.kie.workbench.common.screens.datamodeller.client.handlers.droolsdomain.DroolsDomainHandler;
import org.kie.workbench.common.screens.datamodeller.client.handlers.jpadomain.JPADomainHandler;
import org.kie.workbench.common.screens.datamodeller.client.handlers.jpadomain.command.JPACommandBuilder;
import org.kie.workbench.common.screens.datamodeller.client.handlers.maindomain.MainDomainHandler;
import org.kie.workbench.common.screens.datamodeller.client.pdescriptor.PersistenceUnitPropertyGrid;
import org.kie.workbench.common.screens.datamodeller.client.pdescriptor.PersistenceUnitPropertyGridViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.pdescriptor.ProjectClassList;
import org.kie.workbench.common.screens.datamodeller.client.pdescriptor.ProjectClassListViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.pdescriptor.XMLViewer;
import org.kie.workbench.common.screens.datamodeller.client.type.PersistenceDescriptorType;
import org.kie.workbench.common.screens.datamodeller.client.validation.JavaFileNameValidator;
import org.kie.workbench.common.screens.datamodeller.client.validation.ValidatorService;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.AdvancedDataObjectEditor;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.AdvancedDataObjectEditorViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.AdvancedDataObjectFieldEditor;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.AdvancedDataObjectFieldEditorViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.AdvancedDomainEditor;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.AdvancedDomainScreen;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.AdvancedDomainScreenActivity;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.AdvancedDomainScreenViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.annotationlisteditor.AdvancedAnnotationListEditor;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.annotationlisteditor.AdvancedAnnotationListEditorViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.annotationwizard.CreateAnnotationWizard;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.annotationwizard.SearchAnnotationPage;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.annotationwizard.SearchAnnotationPageViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.annotationwizard.ValuePairEditorPage;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.annotationwizard.ValuePairEditorPageViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.valuepaireditor.ValuePairEditorPopup;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.valuepaireditor.ValuePairEditorPopupViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.valuepaireditor.ValuePairEditorProvider;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.valuepaireditor.generic.GenericValuePairEditor;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.valuepaireditor.generic.GenericValuePairEditorViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.droolsdomain.DroolsDataObjectEditor;
import org.kie.workbench.common.screens.datamodeller.client.widgets.droolsdomain.DroolsDataObjectEditorViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.droolsdomain.DroolsDataObjectFieldEditor;
import org.kie.workbench.common.screens.datamodeller.client.widgets.droolsdomain.DroolsDataObjectFieldEditorViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.droolsdomain.DroolsDomainEditor;
import org.kie.workbench.common.screens.datamodeller.client.widgets.droolsdomain.DroolsDomainScreen;
import org.kie.workbench.common.screens.datamodeller.client.widgets.droolsdomain.DroolsDomainScreenActivity;
import org.kie.workbench.common.screens.datamodeller.client.widgets.droolsdomain.DroolsDomainScreenViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.editor.DataObjectBrowser;
import org.kie.workbench.common.screens.datamodeller.client.widgets.editor.DataObjectBrowserViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.editor.NewFieldPopup;
import org.kie.workbench.common.screens.datamodeller.client.widgets.editor.NewFieldPopupViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.jpadomain.JPADataObjectEditor;
import org.kie.workbench.common.screens.datamodeller.client.widgets.jpadomain.JPADataObjectEditorViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.jpadomain.JPADataObjectFieldEditor;
import org.kie.workbench.common.screens.datamodeller.client.widgets.jpadomain.JPADataObjectFieldEditorViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.jpadomain.JPADomainEditor;
import org.kie.workbench.common.screens.datamodeller.client.widgets.jpadomain.JPADomainScreen;
import org.kie.workbench.common.screens.datamodeller.client.widgets.jpadomain.JPADomainScreenActivity;
import org.kie.workbench.common.screens.datamodeller.client.widgets.jpadomain.JPADomainScreenViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.jpadomain.options.JPANewResourceOptions;
import org.kie.workbench.common.screens.datamodeller.client.widgets.jpadomain.properties.IdGeneratorField;
import org.kie.workbench.common.screens.datamodeller.client.widgets.jpadomain.properties.RelationshipField;
import org.kie.workbench.common.screens.datamodeller.client.widgets.jpadomain.properties.SequenceGeneratorField;
import org.kie.workbench.common.screens.datamodeller.client.widgets.maindomain.MainDataObjectEditor;
import org.kie.workbench.common.screens.datamodeller.client.widgets.maindomain.MainDataObjectEditorViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.maindomain.MainDataObjectFieldEditor;
import org.kie.workbench.common.screens.datamodeller.client.widgets.maindomain.MainDataObjectFieldEditorViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.maindomain.MainDomainEditor;
import org.kie.workbench.common.screens.datamodeller.client.widgets.packageselector.NewPackagePopup;
import org.kie.workbench.common.screens.datamodeller.client.widgets.packageselector.NewPackagePopupViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.packageselector.PackageSelector;
import org.kie.workbench.common.screens.datamodeller.client.widgets.packageselector.PackageSelectorViewImpl;
import org.kie.workbench.common.screens.defaulteditor.client.editor.GuvnorDefaultEditorPresenter;
import org.kie.workbench.common.screens.defaulteditor.client.editor.GuvnorDefaultEditorPresenterActivity;
import org.kie.workbench.common.screens.defaulteditor.client.editor.GuvnorDefaultEditorViewImpl;
import org.kie.workbench.common.screens.defaulteditor.client.editor.KieMetaDataEditorPresenter;
import org.kie.workbench.common.screens.defaulteditor.client.editor.KieMetaDataEditorPresenterActivity;
import org.kie.workbench.common.screens.defaulteditor.client.editor.KieTextEditorScreenPresenter;
import org.kie.workbench.common.screens.defaulteditor.client.editor.KieTextEditorScreenPresenterActivity;
import org.kie.workbench.common.screens.defaulteditor.client.editor.KieTextEditorViewImpl;
import org.kie.workbench.common.screens.defaulteditor.client.editor.NewFileUploader;
import org.kie.workbench.common.screens.defaulteditor.client.editor.PackageNameWhiteListResourceType;
import org.kie.workbench.common.screens.defaulteditor.client.editor.XmlResourceType;
import org.kie.workbench.common.screens.defaulteditor.service.PackageNameWhiteListResourceTypeDefinition;
import org.kie.workbench.common.screens.defaulteditor.service.XmlResourceTypeDefinition;
import org.kie.workbench.common.screens.examples.client.ExamplesScreenEntryPoint;
import org.kie.workbench.common.screens.examples.client.wizard.ExamplesWizard;
import org.kie.workbench.common.screens.examples.client.wizard.pages.organizationalunit.OUPage;
import org.kie.workbench.common.screens.examples.client.wizard.pages.organizationalunit.OUPageViewImpl;
import org.kie.workbench.common.screens.examples.client.wizard.pages.project.FetchRepositoryViewImpl;
import org.kie.workbench.common.screens.examples.client.wizard.pages.project.NoRepositoryURLViewImpl;
import org.kie.workbench.common.screens.examples.client.wizard.pages.project.ProjectItemViewImpl;
import org.kie.workbench.common.screens.examples.client.wizard.pages.project.ProjectPage;
import org.kie.workbench.common.screens.examples.client.wizard.pages.project.ProjectPageViewImpl;
import org.kie.workbench.common.screens.examples.client.wizard.pages.repository.RepositoryPage;
import org.kie.workbench.common.screens.examples.client.wizard.pages.repository.RepositoryPageViewImpl;
import org.kie.workbench.common.screens.explorer.client.ExplorerEntryPoint;
import org.kie.workbench.common.screens.explorer.client.ExplorerMenu;
import org.kie.workbench.common.screens.explorer.client.ExplorerMenuViewImpl;
import org.kie.workbench.common.screens.explorer.client.ExplorerPresenter;
import org.kie.workbench.common.screens.explorer.client.ExplorerPresenterActivity;
import org.kie.workbench.common.screens.explorer.client.ExplorerViewImpl;
import org.kie.workbench.common.screens.explorer.client.ProjectScreenMenuItem;
import org.kie.workbench.common.screens.explorer.client.utils.Classifier;
import org.kie.workbench.common.screens.explorer.client.widgets.ActiveContextItems;
import org.kie.workbench.common.screens.explorer.client.widgets.ActiveContextManager;
import org.kie.workbench.common.screens.explorer.client.widgets.ActiveContextOptions;
import org.kie.workbench.common.screens.explorer.client.widgets.branches.BranchSelector;
import org.kie.workbench.common.screens.explorer.client.widgets.branches.BranchSelectorViewImpl;
import org.kie.workbench.common.screens.explorer.client.widgets.business.BusinessViewPresenter;
import org.kie.workbench.common.screens.explorer.client.widgets.business.BusinessViewWidget;
import org.kie.workbench.common.screens.explorer.client.widgets.navigator.BreadcrumbNavigator;
import org.kie.workbench.common.screens.explorer.client.widgets.navigator.TreeNavigator;
import org.kie.workbench.common.screens.explorer.client.widgets.tagSelector.TagSelector;
import org.kie.workbench.common.screens.explorer.client.widgets.tagSelector.TagSelectorViewImpl;
import org.kie.workbench.common.screens.explorer.client.widgets.technical.TechnicalViewPresenter;
import org.kie.workbench.common.screens.explorer.client.widgets.technical.TechnicalViewWidget;
import org.kie.workbench.common.screens.home.client.HomeEntryPoint;
import org.kie.workbench.common.screens.home.client.perspectives.HomePerspective;
import org.kie.workbench.common.screens.home.client.perspectives.HomePerspectiveActivity;
import org.kie.workbench.common.screens.home.client.widgets.home.HomePresenter;
import org.kie.workbench.common.screens.home.client.widgets.home.HomePresenterActivity;
import org.kie.workbench.common.screens.home.client.widgets.home.HomeViewImpl;
import org.kie.workbench.common.screens.home.model.HomeModel;
import org.kie.workbench.common.screens.home.model.ModelUtils;
import org.kie.workbench.common.screens.javaeditor.client.editor.JavaEditorPresenter;
import org.kie.workbench.common.screens.javaeditor.client.editor.JavaEditorPresenterActivity;
import org.kie.workbench.common.screens.javaeditor.client.editor.JavaSourceViewImpl;
import org.kie.workbench.common.screens.javaeditor.client.type.JavaResourceType;
import org.kie.workbench.common.screens.javaeditor.client.widget.EditJavaSourceWidget;
import org.kie.workbench.common.screens.javaeditor.client.widget.ViewJavaSourceWidget;
import org.kie.workbench.common.screens.javaeditor.type.JavaResourceTypeDefinition;
import org.kie.workbench.common.screens.projecteditor.client.ProjectEditorEntryPoint;
import org.kie.workbench.common.screens.projecteditor.client.editor.DeploymentScreenPopupViewImpl;
import org.kie.workbench.common.screens.projecteditor.client.editor.ProjectScreenPresenter;
import org.kie.workbench.common.screens.projecteditor.client.editor.ProjectScreenPresenterActivity;
import org.kie.workbench.common.screens.projecteditor.client.editor.ProjectScreenViewImpl;
import org.kie.workbench.common.screens.projecteditor.client.forms.CRUDListBox;
import org.kie.workbench.common.screens.projecteditor.client.forms.CRUDListBoxViewImpl;
import org.kie.workbench.common.screens.projecteditor.client.forms.KBaseForm;
import org.kie.workbench.common.screens.projecteditor.client.forms.KBaseFormViewImpl;
import org.kie.workbench.common.screens.projecteditor.client.forms.KModuleEditorPanel;
import org.kie.workbench.common.screens.projecteditor.client.forms.KModuleEditorPanelViewImpl;
import org.kie.workbench.common.screens.projecteditor.client.forms.KModuleEditorScreenPresenter;
import org.kie.workbench.common.screens.projecteditor.client.forms.KModuleEditorScreenPresenterActivity;
import org.kie.workbench.common.screens.projecteditor.client.forms.KSessionForm;
import org.kie.workbench.common.screens.projecteditor.client.forms.KSessionFormViewImpl;
import org.kie.workbench.common.screens.projecteditor.client.forms.KSessionModelOptionsPopUp;
import org.kie.workbench.common.screens.projecteditor.client.forms.KSessionModelOptionsPopUpViewImpl;
import org.kie.workbench.common.screens.projecteditor.client.forms.KSessionsPanel;
import org.kie.workbench.common.screens.projecteditor.client.forms.KSessionsPanelViewImpl;
import org.kie.workbench.common.screens.projecteditor.client.forms.ListenersPanel;
import org.kie.workbench.common.screens.projecteditor.client.forms.ListenersPanelViewImpl;
import org.kie.workbench.common.screens.projecteditor.client.forms.PackageNameFormPopup;
import org.kie.workbench.common.screens.projecteditor.client.forms.PackageNameFormPopupViewImpl;
import org.kie.workbench.common.screens.projecteditor.client.forms.PomEditorScreenPresenter;
import org.kie.workbench.common.screens.projecteditor.client.forms.PomEditorScreenPresenterActivity;
import org.kie.workbench.common.screens.projecteditor.client.forms.WorkItemHandlersPanel;
import org.kie.workbench.common.screens.projecteditor.client.forms.WorkItemHandlersPanelViewImpl;
import org.kie.workbench.common.screens.projecteditor.client.forms.dependencies.DependencyGrid;
import org.kie.workbench.common.screens.projecteditor.client.forms.dependencies.DependencyGridViewImpl;
import org.kie.workbench.common.screens.projecteditor.client.forms.dependencies.DependencyListWidget;
import org.kie.workbench.common.screens.projecteditor.client.forms.dependencies.DependencyLoader;
import org.kie.workbench.common.screens.projecteditor.client.forms.dependencies.DependencySelectorPopup;
import org.kie.workbench.common.screens.projecteditor.client.forms.dependencies.DependencySelectorPopupViewImpl;
import org.kie.workbench.common.screens.projecteditor.client.forms.dependencies.EnhancedDependenciesManager;
import org.kie.workbench.common.screens.projecteditor.client.forms.dependencies.NewDependencyPopup;
import org.kie.workbench.common.screens.projecteditor.client.forms.dependencies.NewDependencyPopupViewImpl;
import org.kie.workbench.common.screens.projecteditor.client.forms.repositories.RepositoriesWidgetPresenter;
import org.kie.workbench.common.screens.projecteditor.client.forms.repositories.RepositoriesWidgetViewImpl;
import org.kie.workbench.common.screens.projecteditor.client.handlers.NewPackageHandler;
import org.kie.workbench.common.screens.projecteditor.client.handlers.NewProjectHandler;
import org.kie.workbench.common.screens.projecteditor.client.handlers.NewProjectHandlerViewImpl;
import org.kie.workbench.common.screens.projecteditor.client.menu.ProjectMenu;
import org.kie.workbench.common.screens.projecteditor.client.type.KModuleResourceType;
import org.kie.workbench.common.screens.projecteditor.client.util.KiePOMDefaultOptions;
import org.kie.workbench.common.screens.projecteditor.client.validation.ProjectNameValidator;
import org.kie.workbench.common.screens.projecteditor.client.wizard.NewProjectWizard;
import org.kie.workbench.common.screens.projecteditor.client.wizard.POMWizardPage;
import org.kie.workbench.common.screens.projecteditor.client.wizard.POMWizardPageViewImpl;
import org.kie.workbench.common.screens.projecteditor.type.KModuleResourceTypeDefinition;
import org.kie.workbench.common.screens.projectimportsscreen.client.ProjectConfigScreenEntryPoint;
import org.kie.workbench.common.screens.projectimportsscreen.client.forms.ProjectImportsScreenPresenter;
import org.kie.workbench.common.screens.projectimportsscreen.client.forms.ProjectImportsScreenPresenterActivity;
import org.kie.workbench.common.screens.projectimportsscreen.client.forms.ProjectImportsScreenViewImpl;
import org.kie.workbench.common.screens.projectimportsscreen.client.type.ProjectImportsResourceType;
import org.kie.workbench.common.screens.projectimportsscreen.type.ProjectImportsResourceTypeDefinition;
import org.kie.workbench.common.screens.search.client.FindForm;
import org.kie.workbench.common.screens.search.client.FindFormActivity;
import org.kie.workbench.common.screens.search.client.FullTextSearchFormPresenter;
import org.kie.workbench.common.screens.search.client.FullTextSearchFormPresenterActivity;
import org.kie.workbench.common.screens.search.client.FullTextSearchFormView;
import org.kie.workbench.common.screens.search.client.SearchEntryPoint;
import org.kie.workbench.common.screens.search.client.menu.SearchMenuBuilder;
import org.kie.workbench.common.screens.search.client.menu.SearchMenuPresenter;
import org.kie.workbench.common.screens.search.client.menu.SearchMenuView;
import org.kie.workbench.common.screens.server.management.client.ServerManagementBrowserPresenter;
import org.kie.workbench.common.screens.server.management.client.ServerManagementBrowserPresenterActivity;
import org.kie.workbench.common.screens.server.management.client.ServerManagementBrowserView;
import org.kie.workbench.common.screens.server.management.client.ServerManagementEntryPoint;
import org.kie.workbench.common.screens.server.management.client.ServerManagementPerspective;
import org.kie.workbench.common.screens.server.management.client.ServerManagementPerspectiveActivity;
import org.kie.workbench.common.screens.server.management.client.container.ContainerPresenter;
import org.kie.workbench.common.screens.server.management.client.container.config.process.ContainerProcessConfigPresenter;
import org.kie.workbench.common.screens.server.management.client.container.config.process.ContainerProcessConfigView;
import org.kie.workbench.common.screens.server.management.client.container.config.rules.ContainerRulesConfigPresenter;
import org.kie.workbench.common.screens.server.management.client.container.config.rules.ContainerRulesConfigView;
import org.kie.workbench.common.screens.server.management.client.container.empty.ServerContainerEmptyPresenter;
import org.kie.workbench.common.screens.server.management.client.container.empty.ServerContainerEmptyView;
import org.kie.workbench.common.screens.server.management.client.container.status.ContainerRemoteStatusPresenter;
import org.kie.workbench.common.screens.server.management.client.container.status.ContainerRemoteStatusView;
import org.kie.workbench.common.screens.server.management.client.container.status.card.ContainerCardPresenter;
import org.kie.workbench.common.screens.server.management.client.container.status.card.ContainerCardView;
import org.kie.workbench.common.screens.server.management.client.container.status.empty.ContainerStatusEmptyPresenter;
import org.kie.workbench.common.screens.server.management.client.container.status.empty.ContainerStatusEmptyView;
import org.kie.workbench.common.screens.server.management.client.empty.ServerEmptyPresenter;
import org.kie.workbench.common.screens.server.management.client.empty.ServerEmptyView;
import org.kie.workbench.common.screens.server.management.client.navigation.ServerNavigationPresenter;
import org.kie.workbench.common.screens.server.management.client.navigation.ServerNavigationView;
import org.kie.workbench.common.screens.server.management.client.navigation.template.ServerTemplatePresenter;
import org.kie.workbench.common.screens.server.management.client.navigation.template.ServerTemplateView;
import org.kie.workbench.common.screens.server.management.client.navigation.template.copy.CopyPopupPresenter;
import org.kie.workbench.common.screens.server.management.client.navigation.template.copy.CopyPopupView;
import org.kie.workbench.common.screens.server.management.client.remote.RemotePresenter;
import org.kie.workbench.common.screens.server.management.client.remote.RemoteStatusPresenter;
import org.kie.workbench.common.screens.server.management.client.remote.RemoteStatusView;
import org.kie.workbench.common.screens.server.management.client.remote.RemoteView;
import org.kie.workbench.common.screens.server.management.client.remote.empty.RemoteEmptyPresenter;
import org.kie.workbench.common.screens.server.management.client.remote.empty.RemoteEmptyView;
import org.kie.workbench.common.screens.server.management.client.widget.NumericTextBox;
import org.kie.workbench.common.screens.server.management.client.widget.artifact.ArtifactListWidgetPresenter;
import org.kie.workbench.common.screens.server.management.client.widget.artifact.ArtifactListWidgetView;
import org.kie.workbench.common.screens.server.management.client.widget.card.CardPresenter;
import org.kie.workbench.common.screens.server.management.client.widget.card.CardView;
import org.kie.workbench.common.screens.server.management.client.widget.card.body.BodyPresenter;
import org.kie.workbench.common.screens.server.management.client.widget.card.body.BodyView;
import org.kie.workbench.common.screens.server.management.client.widget.card.body.notification.NotificationPresenter;
import org.kie.workbench.common.screens.server.management.client.widget.card.body.notification.NotificationView;
import org.kie.workbench.common.screens.server.management.client.widget.card.footer.FooterPresenter;
import org.kie.workbench.common.screens.server.management.client.widget.card.footer.FooterView;
import org.kie.workbench.common.screens.server.management.client.widget.card.title.InfoTitlePresenter;
import org.kie.workbench.common.screens.server.management.client.widget.card.title.InfoTitleView;
import org.kie.workbench.common.screens.server.management.client.widget.card.title.LinkTitlePresenter;
import org.kie.workbench.common.screens.server.management.client.widget.card.title.LinkTitleView;
import org.kie.workbench.common.screens.server.management.client.widget.config.process.ProcessConfigPresenter;
import org.kie.workbench.common.screens.server.management.client.widget.config.process.ProcessConfigView;
import org.kie.workbench.common.screens.server.management.client.wizard.NewContainerWizard;
import org.kie.workbench.common.screens.server.management.client.wizard.NewServerTemplateWizard;
import org.kie.workbench.common.screens.server.management.client.wizard.config.process.ProcessConfigPagePresenter;
import org.kie.workbench.common.screens.server.management.client.wizard.container.NewContainerFormPresenter;
import org.kie.workbench.common.screens.server.management.client.wizard.container.NewContainerFormView;
import org.kie.workbench.common.screens.server.management.client.wizard.template.NewTemplatePresenter;
import org.kie.workbench.common.screens.server.management.client.wizard.template.NewTemplateView;
import org.kie.workbench.common.screens.social.hp.client.SocialHomePageEntryPoint;
import org.kie.workbench.common.screens.social.hp.client.homepage.DefaultSocialLinkCommandGenerator;
import org.kie.workbench.common.screens.social.hp.client.homepage.SocialHomePageMainPresenter;
import org.kie.workbench.common.screens.social.hp.client.homepage.SocialHomePageMainPresenterActivity;
import org.kie.workbench.common.screens.social.hp.client.homepage.SocialHomePageMainView;
import org.kie.workbench.common.screens.social.hp.client.homepage.SocialHomePagePerspective;
import org.kie.workbench.common.screens.social.hp.client.homepage.SocialHomePagePerspectiveActivity;
import org.kie.workbench.common.screens.social.hp.client.homepage.SocialHomePageSidePresenter;
import org.kie.workbench.common.screens.social.hp.client.homepage.SocialHomePageSidePresenterActivity;
import org.kie.workbench.common.screens.social.hp.client.homepage.SocialHomePageSideView;
import org.kie.workbench.common.screens.social.hp.client.homepage.main.MainPresenter;
import org.kie.workbench.common.screens.social.hp.client.userpage.UserHomePageMainPresenter;
import org.kie.workbench.common.screens.social.hp.client.userpage.UserHomePageMainPresenterActivity;
import org.kie.workbench.common.screens.social.hp.client.userpage.UserHomePageMainView;
import org.kie.workbench.common.screens.social.hp.client.userpage.UserHomePagePerspective;
import org.kie.workbench.common.screens.social.hp.client.userpage.UserHomePagePerspectiveActivity;
import org.kie.workbench.common.screens.social.hp.client.userpage.UserHomePageSidePresenter;
import org.kie.workbench.common.screens.social.hp.client.userpage.UserHomePageSidePresenterActivity;
import org.kie.workbench.common.screens.social.hp.client.userpage.UserHomePageSideView;
import org.kie.workbench.common.screens.social.hp.client.userpage.main.MainView;
import org.kie.workbench.common.screens.social.hp.client.userpage.main.header.HeaderPresenter;
import org.kie.workbench.common.screens.social.hp.client.userpage.main.header.HeaderView;
import org.kie.workbench.common.screens.social.hp.client.userpage.side.EditUserForm;
import org.kie.workbench.common.screens.social.hp.client.userpage.side.SideUserInfoPresenter;
import org.kie.workbench.common.screens.social.hp.client.userpage.side.SideUserInfoView;
import org.kie.workbench.common.screens.social.hp.client.util.IconLocator;
import org.kie.workbench.common.services.shared.messageconsole.MessageConsoleWhiteListImpl;
import org.kie.workbench.common.widgets.client.KieWorkbenchWidgetsCommonEntryPoint;
import org.kie.workbench.common.widgets.client.datamodel.AsyncPackageDataModelOracleFactory;
import org.kie.workbench.common.widgets.client.datamodel.AsyncPackageDataModelOracleImpl;
import org.kie.workbench.common.widgets.client.discussion.DiscussionWidgetPresenter;
import org.kie.workbench.common.widgets.client.discussion.DiscussionWidgetViewImpl;
import org.kie.workbench.common.widgets.client.handlers.NewResourcePresenter;
import org.kie.workbench.common.widgets.client.handlers.NewResourceView;
import org.kie.workbench.common.widgets.client.handlers.NewResourcesMenu;
import org.kie.workbench.common.widgets.client.handlers.PackageListBox;
import org.kie.workbench.common.widgets.client.handlers.PathLabel;
import org.kie.workbench.common.widgets.client.handlers.workbench.configuration.ConfigurationComboBoxItemWidget;
import org.kie.workbench.common.widgets.client.handlers.workbench.configuration.LanguageConfigurationHandler;
import org.kie.workbench.common.widgets.client.handlers.workbench.configuration.WorkbenchConfigurationMenu;
import org.kie.workbench.common.widgets.client.handlers.workbench.configuration.WorkbenchConfigurationPresenter;
import org.kie.workbench.common.widgets.client.handlers.workbench.configuration.WorkbenchConfigurationViewImpl;
import org.kie.workbench.common.widgets.client.menu.AboutMenuBuilder;
import org.kie.workbench.common.widgets.client.menu.FileMenuBuilderImpl;
import org.kie.workbench.common.widgets.client.menu.RepositoryMenu;
import org.kie.workbench.common.widgets.client.menu.ResetPerspectivesMenuBuilder;
import org.kie.workbench.common.widgets.client.popups.alert.AlertPopupViewImpl;
import org.kie.workbench.common.widgets.client.popups.copy.CopyPopupWithPackageViewImpl;
import org.kie.workbench.common.widgets.client.popups.list.FormListPopup;
import org.kie.workbench.common.widgets.client.popups.list.FormListPopupViewImpl;
import org.kie.workbench.common.widgets.client.popups.text.TextBoxFormPopup;
import org.kie.workbench.common.widgets.client.popups.text.TextBoxFormPopupViewImpl;
import org.kie.workbench.common.widgets.client.search.ContextualSearch;
import org.kie.workbench.common.widgets.client.source.ViewDRLSourceWidget;
import org.kie.workbench.common.widgets.client.source.ViewSourceViewImpl;
import org.kie.workbench.common.widgets.client.widget.KSessionSelector;
import org.kie.workbench.common.widgets.client.widget.KSessionSelectorViewImpl;
import org.kie.workbench.common.widgets.configresource.client.widget.bound.AddImportPopup;
import org.kie.workbench.common.widgets.configresource.client.widget.bound.ImportsWidgetViewImpl;
import org.kie.workbench.common.widgets.configresource.client.widget.unbound.ImportsWidgetPresenter;
import org.kie.workbench.common.widgets.decoratedgrid.client.DecoratedGridEntryPoint;
import org.kie.workbench.common.widgets.metadata.client.KieEditorWrapperViewImpl;
import org.kie.workbench.common.widgets.metadata.client.KieMultipleDocumentEditorEntryPoint;
import org.kie.workbench.common.widgets.metadata.client.KieMultipleDocumentEditorWrapperViewImpl;
import org.kie.workbench.common.widgets.metadata.client.menu.DocumentMenuItemImpl;
import org.kie.workbench.common.widgets.metadata.client.menu.RegisteredDocumentsMenuBuilder;
import org.kie.workbench.common.widgets.metadata.client.menu.RegisteredDocumentsMenuViewImpl;
import org.kie.workbench.common.widgets.metadata.client.menu.SaveAllMenuBuilder;
import org.kie.workbench.common.widgets.metadata.client.menu.SaveAllMenuViewImpl;
import org.kie.workbench.common.widgets.metadata.client.popups.SelectDocumentPopup;
import org.kie.workbench.common.widgets.metadata.client.popups.SelectDocumentPopupViewImpl;
import org.kie.workbench.common.widgets.metadata.client.popups.SelectableDocumentImpl;
import org.kie.workbench.common.widgets.metadata.client.widget.OverviewWidgetPresenter;
import org.kie.workbench.common.widgets.metadata.client.widget.OverviewWidgetViewImpl;
import org.kie.workbench.common.widgets.metadata.client.widget.TagWidgetViewImpl;
import org.kie.workbench.common.workbench.client.authz.PermissionTreeSetup;
import org.kie.workbench.common.workbench.client.authz.WorkbenchTreeProvider;
import org.kie.workbench.common.workbench.client.configuration.ContextualView;
import org.kie.workbench.common.workbench.client.configuration.popups.WorkbenchConfigurationPopup;
import org.kie.workbench.common.workbench.client.docks.AuthoringWorkbenchDocks;
import org.kie.workbench.common.workbench.client.menu.DefaultWorkbenchFeaturesMenusHelper;
import org.kie.workbench.common.workbench.client.menu.WorkbenchConfigurationMenuBuilder;
import org.optaplanner.workbench.screens.domaineditor.client.handlers.planner.PlannerDomainHandler;
import org.optaplanner.workbench.screens.domaineditor.client.widgets.planner.PlannerDataObjectEditor;
import org.optaplanner.workbench.screens.domaineditor.client.widgets.planner.PlannerDataObjectEditorViewImpl;
import org.optaplanner.workbench.screens.domaineditor.client.widgets.planner.PlannerDataObjectFieldEditor;
import org.optaplanner.workbench.screens.domaineditor.client.widgets.planner.PlannerDataObjectFieldEditorViewImpl;
import org.optaplanner.workbench.screens.domaineditor.client.widgets.planner.PlannerDomainEditor;
import org.optaplanner.workbench.screens.domaineditor.client.widgets.planner.PlannerDomainScreen;
import org.optaplanner.workbench.screens.domaineditor.client.widgets.planner.PlannerDomainScreenActivity;
import org.optaplanner.workbench.screens.domaineditor.client.widgets.planner.PlannerDomainScreenViewImpl;
import org.optaplanner.workbench.screens.solver.client.SolverEditorEntryPoint;
import org.optaplanner.workbench.screens.solver.client.editor.ConstructionHeuristicForm;
import org.optaplanner.workbench.screens.solver.client.editor.ConstructionHeuristicFormViewImpl;
import org.optaplanner.workbench.screens.solver.client.editor.PhaseConfigForm;
import org.optaplanner.workbench.screens.solver.client.editor.PhaseConfigFormViewImpl;
import org.optaplanner.workbench.screens.solver.client.editor.ScoreDirectorFactoryForm;
import org.optaplanner.workbench.screens.solver.client.editor.ScoreDirectorFactoryFormViewImpl;
import org.optaplanner.workbench.screens.solver.client.editor.SolverEditorPresenter;
import org.optaplanner.workbench.screens.solver.client.editor.SolverEditorPresenterActivity;
import org.optaplanner.workbench.screens.solver.client.editor.SolverEditorViewImpl;
import org.optaplanner.workbench.screens.solver.client.editor.TerminationConfigForm;
import org.optaplanner.workbench.screens.solver.client.editor.TerminationConfigFormViewImpl;
import org.optaplanner.workbench.screens.solver.client.editor.TerminationTreeItemContent;
import org.optaplanner.workbench.screens.solver.client.editor.TerminationTreeItemContentViewImpl;
import org.optaplanner.workbench.screens.solver.client.editor.XMLViewerImpl;
import org.optaplanner.workbench.screens.solver.client.handlers.NewSolverHandler;
import org.optaplanner.workbench.screens.solver.client.type.SolverResourceType;
import org.optaplanner.workbench.screens.solver.type.SolverResourceTypeDefinition;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.uberfire.backend.vfs.impl.ObservablePathImpl;
import org.uberfire.client.DocksEntryPoint;
import org.uberfire.client.JSEntryPoint;
import org.uberfire.client.RuntimePluginsServiceProxyBackendImpl;
import org.uberfire.client.VFSLockServiceProxyBackendImpl;
import org.uberfire.client.VFSServiceProxyBackendImpl;
import org.uberfire.client.WorkbenchBackendEntryPoint;
import org.uberfire.client.WorkbenchServicesProxyBackendImpl;
import org.uberfire.client.authz.DefaultWorkbenchController;
import org.uberfire.client.authz.PerspectiveTreeProvider;
import org.uberfire.client.docks.UberfireDocksImpl;
import org.uberfire.client.docks.view.DocksBars;
import org.uberfire.client.docks.view.menu.MenuBuilder;
import org.uberfire.client.editor.JSNativeEditor;
import org.uberfire.client.exporter.EditorJSExporter;
import org.uberfire.client.exporter.HTML5DndSeleniumSupport;
import org.uberfire.client.exporter.PerspectiveJSExporter;
import org.uberfire.client.exporter.PlaceManagerJSExporter;
import org.uberfire.client.exporter.PluginJSExporter;
import org.uberfire.client.exporter.SplashScreenJSExporter;
import org.uberfire.client.exporter.UberfireJSAPIExporter;
import org.uberfire.client.exporter.VFSJSExporter;
import org.uberfire.client.menu.CustomSplashHelp;
import org.uberfire.client.menu.SplashScreenMenuPresenter;
import org.uberfire.client.menu.WorkbenchViewModeSwitcherMenuBuilder;
import org.uberfire.client.menu.WorkbenchViewModeSwitcherPresenter;
import org.uberfire.client.mvp.ActivityBeansCache;
import org.uberfire.client.mvp.ActivityBeansInfo;
import org.uberfire.client.mvp.ActivityLifecycleErrorHandler;
import org.uberfire.client.mvp.ActivityManagerImpl;
import org.uberfire.client.mvp.ForceUnlockEventObserver;
import org.uberfire.client.mvp.LockDemandDetector;
import org.uberfire.client.mvp.LockManagerImpl;
import org.uberfire.client.mvp.PerspectiveManagerImpl;
import org.uberfire.client.mvp.PlaceHistoryHandler;
import org.uberfire.client.mvp.PlaceManagerImpl;
import org.uberfire.client.mvp.PlaceRequestHistoryMapperImpl;
import org.uberfire.client.perspective.JSNativePerspective;
import org.uberfire.client.resources.i18n.PermissionTreeI18NImpl;
import org.uberfire.client.screen.JSNativeScreen;
import org.uberfire.client.splash.JSNativeSplashScreen;
import org.uberfire.client.views.pfly.dnd.CompassWidgetImpl;
import org.uberfire.client.views.pfly.listbar.ListBarWidgetImpl;
import org.uberfire.client.views.pfly.menu.PartContextMenusView;
import org.uberfire.client.views.pfly.menu.SplashScreenMenuView;
import org.uberfire.client.views.pfly.menu.UserMenu;
import org.uberfire.client.views.pfly.menu.UserMenuViewImpl;
import org.uberfire.client.views.pfly.menu.UtilityMenuBarView;
import org.uberfire.client.views.pfly.menu.WorkbenchMenuBarView;
import org.uberfire.client.views.pfly.menu.WorkbenchMenuCompactNavBarView;
import org.uberfire.client.views.pfly.menu.WorkbenchMenuStandardNavBarView;
import org.uberfire.client.views.pfly.menu.WorkbenchViewModeSwitcherView;
import org.uberfire.client.views.pfly.modal.Bs3Modal;
import org.uberfire.client.views.pfly.modal.ErrorPopupView;
import org.uberfire.client.views.pfly.multipage.MultiPageEditorImpl;
import org.uberfire.client.views.pfly.multipage.MultiPageEditorViewImpl;
import org.uberfire.client.views.pfly.notifications.NotificationPopupsManagerView;
import org.uberfire.client.views.pfly.popup.PopupViewImpl;
import org.uberfire.client.views.pfly.splash.SplashModalFooter;
import org.uberfire.client.views.pfly.splash.SplashViewImpl;
import org.uberfire.client.views.pfly.tab.MultiTabWorkbenchPanelView;
import org.uberfire.client.views.pfly.tab.ResizeTabPanel;
import org.uberfire.client.views.pfly.tab.TabPanelWithDropdowns;
import org.uberfire.client.views.pfly.tab.UberTabPanel;
import org.uberfire.client.views.pfly.toolbar.WorkbenchToolBarView;
import org.uberfire.client.views.pfly.widgets.FormLabelHelp;
import org.uberfire.client.views.pfly.widgets.HelpIcon;
import org.uberfire.client.workbench.DefaultBeanFactory;
import org.uberfire.client.workbench.LayoutSelection;
import org.uberfire.client.workbench.PanelManagerImpl;
import org.uberfire.client.workbench.StandaloneEditorPerspective;
import org.uberfire.client.workbench.VFSLockServiceProxyClientImpl;
import org.uberfire.client.workbench.VFSServiceProxyClientImpl;
import org.uberfire.client.workbench.Workbench;
import org.uberfire.client.workbench.WorkbenchLayoutImpl;
import org.uberfire.client.workbench.WorkbenchLayoutInfoImpl;
import org.uberfire.client.workbench.panels.impl.AdaptiveWorkbenchPanelPresenter;
import org.uberfire.client.workbench.panels.impl.AdaptiveWorkbenchPanelView;
import org.uberfire.client.workbench.panels.impl.ClosableSimpleWorkbenchPanelPresenter;
import org.uberfire.client.workbench.panels.impl.ClosableSimpleWorkbenchPanelView;
import org.uberfire.client.workbench.panels.impl.LayoutPanelPresenter;
import org.uberfire.client.workbench.panels.impl.LayoutPanelView;
import org.uberfire.client.workbench.panels.impl.MultiListWorkbenchPanelPresenter;
import org.uberfire.client.workbench.panels.impl.MultiListWorkbenchPanelView;
import org.uberfire.client.workbench.panels.impl.MultiTabWorkbenchPanelPresenter;
import org.uberfire.client.workbench.panels.impl.SimpleDnDWorkbenchPanelPresenter;
import org.uberfire.client.workbench.panels.impl.SimpleDnDWorkbenchPanelView;
import org.uberfire.client.workbench.panels.impl.SimpleWorkbenchPanelPresenter;
import org.uberfire.client.workbench.panels.impl.SimpleWorkbenchPanelView;
import org.uberfire.client.workbench.panels.impl.SplitLayoutPanelPresenter;
import org.uberfire.client.workbench.panels.impl.SplitLayoutPanelView;
import org.uberfire.client.workbench.panels.impl.StaticWorkbenchPanelPresenter;
import org.uberfire.client.workbench.panels.impl.StaticWorkbenchPanelView;
import org.uberfire.client.workbench.panels.impl.TemplatedWorkbenchPanelPresenter;
import org.uberfire.client.workbench.panels.impl.TemplatedWorkbenchPanelView;
import org.uberfire.client.workbench.panels.impl.UnanchoredStaticWorkbenchPanelPresenter;
import org.uberfire.client.workbench.panels.impl.UnanchoredStaticWorkbenchPanelView;
import org.uberfire.client.workbench.panels.support.PartManager;
import org.uberfire.client.workbench.pmgr.nswe.part.WorkbenchPartPresenterDefault;
import org.uberfire.client.workbench.pmgr.nswe.part.WorkbenchPartView;
import org.uberfire.client.workbench.pmgr.unanchored.part.UnanchoredWorkbenchPartPresenter;
import org.uberfire.client.workbench.pmgr.unanchored.part.UnanchoredWorkbenchPartView;
import org.uberfire.client.workbench.type.AnyResourceType;
import org.uberfire.client.workbench.type.DotResourceType;
import org.uberfire.client.workbench.type.impl.ClientTypeRegistryImpl;
import org.uberfire.client.workbench.widgets.dnd.CompassDropController;
import org.uberfire.client.workbench.widgets.dnd.WorkbenchDragAndDropManager;
import org.uberfire.client.workbench.widgets.dnd.WorkbenchPickupDragController;
import org.uberfire.client.workbench.widgets.listbar.ResizeFlowPanel;
import org.uberfire.client.workbench.widgets.menu.PartContextMenusPresenter;
import org.uberfire.client.workbench.widgets.menu.UtilityMenuBarPresenter;
import org.uberfire.client.workbench.widgets.menu.WorkbenchMenuBarPresenter;
import org.uberfire.client.workbench.widgets.notifications.NotificationManager;
import org.uberfire.client.workbench.widgets.panel.StaticFocusedResizePanel;
import org.uberfire.client.workbench.widgets.toolbar.WorkbenchToolBarPresenter;
import org.uberfire.ext.apps.client.AppsEntryPoint;
import org.uberfire.ext.apps.client.AppsPerspective;
import org.uberfire.ext.apps.client.AppsPerspectiveActivity;
import org.uberfire.ext.apps.client.home.AppsHomePresenter;
import org.uberfire.ext.apps.client.home.AppsHomePresenterActivity;
import org.uberfire.ext.apps.client.home.AppsHomeView;
import org.uberfire.ext.editor.commons.client.file.CopyPopupViewImpl;
import org.uberfire.ext.editor.commons.client.file.RenamePopupViewImpl;
import org.uberfire.ext.editor.commons.client.file.RestorePopup;
import org.uberfire.ext.editor.commons.client.file.RestoreUtil;
import org.uberfire.ext.editor.commons.client.file.SaveOperationService.SaveOperationNotifier;
import org.uberfire.ext.editor.commons.client.history.SaveButton;
import org.uberfire.ext.editor.commons.client.history.VersionHistoryPresenter;
import org.uberfire.ext.editor.commons.client.history.VersionHistoryPresenterViewImpl;
import org.uberfire.ext.editor.commons.client.history.VersionMenuDropDownButton;
import org.uberfire.ext.editor.commons.client.history.VersionMenuDropDownButtonViewImpl;
import org.uberfire.ext.editor.commons.client.history.VersionRecordManager;
import org.uberfire.ext.editor.commons.client.menu.BasicFileMenuBuilderImpl;
import org.uberfire.ext.editor.commons.client.menu.RestoreVersionCommandProvider;
import org.uberfire.ext.editor.commons.client.validation.DefaultFileNameValidator;
import org.uberfire.ext.layout.editor.client.LayoutEditorEntryPoint;
import org.uberfire.ext.layout.editor.client.LayoutEditorPluginImpl;
import org.uberfire.ext.layout.editor.client.LayoutEditorPresenter;
import org.uberfire.ext.layout.editor.client.LayoutEditorView;
import org.uberfire.ext.layout.editor.client.components.columns.ColumnWithComponents;
import org.uberfire.ext.layout.editor.client.components.columns.ColumnWithComponentsView;
import org.uberfire.ext.layout.editor.client.components.columns.ComponentColumn;
import org.uberfire.ext.layout.editor.client.components.columns.ComponentColumnView;
import org.uberfire.ext.layout.editor.client.components.container.ContainerView;
import org.uberfire.ext.layout.editor.client.components.rows.EmptyDropRow;
import org.uberfire.ext.layout.editor.client.components.rows.EmptyDropRowView;
import org.uberfire.ext.layout.editor.client.components.rows.Row;
import org.uberfire.ext.layout.editor.client.components.rows.RowView;
import org.uberfire.ext.layout.editor.client.generator.BootstrapLayoutGenerator;
import org.uberfire.ext.layout.editor.client.infra.DnDManager;
import org.uberfire.ext.layout.editor.client.infra.DragHelperComponentColumn;
import org.uberfire.ext.layout.editor.client.infra.LayoutDragComponentHelper;
import org.uberfire.ext.plugin.client.RuntimePluginsEntryPoint;
import org.uberfire.ext.plugin.client.config.PluginConfigService;
import org.uberfire.ext.plugin.client.editor.DynamicMenuEditorPresenter;
import org.uberfire.ext.plugin.client.editor.DynamicMenuEditorPresenterActivity;
import org.uberfire.ext.plugin.client.editor.DynamicMenuEditorView;
import org.uberfire.ext.plugin.client.editor.EditorPlugInEditorPresenter;
import org.uberfire.ext.plugin.client.editor.EditorPlugInEditorPresenterActivity;
import org.uberfire.ext.plugin.client.editor.EditorPlugInEditorView;
import org.uberfire.ext.plugin.client.editor.ScreenEditorPresenter;
import org.uberfire.ext.plugin.client.editor.ScreenEditorPresenterActivity;
import org.uberfire.ext.plugin.client.editor.ScreenEditorView;
import org.uberfire.ext.plugin.client.editor.SplashEditorPresenter;
import org.uberfire.ext.plugin.client.editor.SplashEditorPresenterActivity;
import org.uberfire.ext.plugin.client.editor.SplashEditorView;
import org.uberfire.ext.plugin.client.explorer.PluginExplorerScreen;
import org.uberfire.ext.plugin.client.explorer.PluginExplorerScreenActivity;
import org.uberfire.ext.plugin.client.info.PluginsInfo;
import org.uberfire.ext.plugin.client.perspective.PlugInAuthoringPerspective;
import org.uberfire.ext.plugin.client.perspective.PlugInAuthoringPerspectiveActivity;
import org.uberfire.ext.plugin.client.perspective.editor.PerspectiveEditorPresenter;
import org.uberfire.ext.plugin.client.perspective.editor.PerspectiveEditorPresenterActivity;
import org.uberfire.ext.plugin.client.perspective.editor.PerspectiveEditorView;
import org.uberfire.ext.plugin.client.perspective.editor.generator.PerspectiveEditorGenerator;
import org.uberfire.ext.plugin.client.perspective.editor.layout.editor.HTMLLayoutDragComponent;
import org.uberfire.ext.plugin.client.perspective.editor.layout.editor.ScreenLayoutDragComponent;
import org.uberfire.ext.plugin.client.security.PluginController;
import org.uberfire.ext.plugin.client.type.DynamicMenuResourceType;
import org.uberfire.ext.plugin.client.type.EditorPluginResourceType;
import org.uberfire.ext.plugin.client.type.PerspectiveLayoutPluginResourceType;
import org.uberfire.ext.plugin.client.type.ScreenPluginResourceType;
import org.uberfire.ext.plugin.client.type.SplashPluginResourceType;
import org.uberfire.ext.plugin.client.validation.PluginNameValidator;
import org.uberfire.ext.plugin.client.widget.media.MediaLibraryWidget;
import org.uberfire.ext.plugin.client.widget.navigator.PluginNavList;
import org.uberfire.ext.plugin.client.widget.plugin.GeneralPluginEditor;
import org.uberfire.ext.plugin.client.widget.popup.NewPluginPopUp;
import org.uberfire.ext.plugin.client.widget.popup.NewPluginPopUpViewImpl;
import org.uberfire.ext.plugin.type.DynamicMenuResourceTypeDefinition;
import org.uberfire.ext.properties.editor.client.PropertyEditorWidget;
import org.uberfire.ext.properties.editor.client.fields.BooleanField;
import org.uberfire.ext.properties.editor.client.fields.ColorField;
import org.uberfire.ext.properties.editor.client.fields.ComboField;
import org.uberfire.ext.properties.editor.client.fields.SecretTextField;
import org.uberfire.ext.properties.editor.client.fields.TextField;
import org.uberfire.ext.security.management.client.ClientUserSystemManager;
import org.uberfire.ext.security.management.client.ResourceBundleEntryPoint;
import org.uberfire.ext.security.management.client.editor.group.GroupEditorDriver;
import org.uberfire.ext.security.management.client.editor.role.RoleEditorDriver;
import org.uberfire.ext.security.management.client.editor.user.UserEditorDriver;
import org.uberfire.ext.security.management.client.perspectives.SecurityManagementPerspective;
import org.uberfire.ext.security.management.client.perspectives.SecurityManagementPerspectiveActivity;
import org.uberfire.ext.security.management.client.screens.BaseScreenView;
import org.uberfire.ext.security.management.client.screens.editor.GroupEditorScreen;
import org.uberfire.ext.security.management.client.screens.editor.GroupEditorScreenActivity;
import org.uberfire.ext.security.management.client.screens.editor.RoleEditorScreen;
import org.uberfire.ext.security.management.client.screens.editor.RoleEditorScreenActivity;
import org.uberfire.ext.security.management.client.screens.editor.UserEditorScreen;
import org.uberfire.ext.security.management.client.screens.editor.UserEditorScreenActivity;
import org.uberfire.ext.security.management.client.screens.explorer.SecurityExplorerScreen;
import org.uberfire.ext.security.management.client.screens.explorer.SecurityExplorerScreenActivity;
import org.uberfire.ext.security.management.client.screens.explorer.SecurityExplorerView;
import org.uberfire.ext.security.management.client.screens.home.SecurityManagementHomeScreen;
import org.uberfire.ext.security.management.client.screens.home.SecurityManagementHomeScreenActivity;
import org.uberfire.ext.security.management.client.screens.home.SecurityManagementHomeView;
import org.uberfire.ext.security.management.client.widgets.management.ChangePassword;
import org.uberfire.ext.security.management.client.widgets.management.ChangePasswordView;
import org.uberfire.ext.security.management.client.widgets.management.CreateEntity;
import org.uberfire.ext.security.management.client.widgets.management.CreateEntityView;
import org.uberfire.ext.security.management.client.widgets.management.editor.AssignedEntitiesExplorerView;
import org.uberfire.ext.security.management.client.widgets.management.editor.AssignedEntitiesInlineEditorView;
import org.uberfire.ext.security.management.client.widgets.management.editor.AssignedEntitiesModalEditorView;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.ACLEditor;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.ACLEditorView;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.ACLSettings;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.ACLSettingsView;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.ACLViewer;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.ACLViewerView;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.PriorityDropDown;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.node.LeafPermissionNodeEditor;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.node.LeafPermissionNodeEditorView;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.node.LeafPermissionNodeViewer;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.node.LeafPermissionNodeViewerView;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.node.MultiplePermissionNodeEditor;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.node.MultiplePermissionNodeEditorView;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.node.MultiplePermissionNodeViewer;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.node.MultiplePermissionNodeViewerView;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.node.PermissionExceptionSwitch;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.node.PermissionExceptionSwitchView;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.node.PermissionSwitch;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.node.PermissionSwitchView;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.node.PermissionWidgetFactory;
import org.uberfire.ext.security.management.client.widgets.management.editor.group.GroupEditor;
import org.uberfire.ext.security.management.client.widgets.management.editor.group.GroupEditorView;
import org.uberfire.ext.security.management.client.widgets.management.editor.group.GroupUsersAssignment;
import org.uberfire.ext.security.management.client.widgets.management.editor.group.workflow.GroupCreationWorkflow;
import org.uberfire.ext.security.management.client.widgets.management.editor.group.workflow.GroupEditorWorkflow;
import org.uberfire.ext.security.management.client.widgets.management.editor.role.RoleEditor;
import org.uberfire.ext.security.management.client.widgets.management.editor.role.RoleEditorView;
import org.uberfire.ext.security.management.client.widgets.management.editor.role.workflow.RoleEditorWorkflow;
import org.uberfire.ext.security.management.client.widgets.management.editor.user.NewUserAttributeEditor;
import org.uberfire.ext.security.management.client.widgets.management.editor.user.NewUserAttributeEditorView;
import org.uberfire.ext.security.management.client.widgets.management.editor.user.UserAssignedGroupsEditor;
import org.uberfire.ext.security.management.client.widgets.management.editor.user.UserAssignedGroupsExplorer;
import org.uberfire.ext.security.management.client.widgets.management.editor.user.UserAssignedRolesEditor;
import org.uberfire.ext.security.management.client.widgets.management.editor.user.UserAssignedRolesExplorer;
import org.uberfire.ext.security.management.client.widgets.management.editor.user.UserAttributesEditor;
import org.uberfire.ext.security.management.client.widgets.management.editor.user.UserAttributesEditorView;
import org.uberfire.ext.security.management.client.widgets.management.editor.user.UserEditor;
import org.uberfire.ext.security.management.client.widgets.management.editor.user.UserEditorView;
import org.uberfire.ext.security.management.client.widgets.management.editor.user.workflow.UserCreationWorkflow;
import org.uberfire.ext.security.management.client.widgets.management.editor.user.workflow.UserEditorWorkflow;
import org.uberfire.ext.security.management.client.widgets.management.editor.workflow.EntityWorkflowViewImpl;
import org.uberfire.ext.security.management.client.widgets.management.explorer.EntitiesExplorerViewImpl;
import org.uberfire.ext.security.management.client.widgets.management.explorer.GroupsExplorer;
import org.uberfire.ext.security.management.client.widgets.management.explorer.RolesExplorer;
import org.uberfire.ext.security.management.client.widgets.management.explorer.UserGroupsExplorer;
import org.uberfire.ext.security.management.client.widgets.management.explorer.UserGroupsExplorerView;
import org.uberfire.ext.security.management.client.widgets.management.explorer.UsersExplorer;
import org.uberfire.ext.security.management.client.widgets.management.list.EntitiesListView;
import org.uberfire.ext.security.management.client.widgets.management.list.GroupsList;
import org.uberfire.ext.security.management.client.widgets.management.list.RolesList;
import org.uberfire.ext.security.management.client.widgets.management.list.UsersList;
import org.uberfire.ext.security.management.client.widgets.popup.ConfirmBox;
import org.uberfire.ext.security.management.client.widgets.popup.ConfirmBoxView;
import org.uberfire.ext.security.management.client.widgets.popup.ErrorBox;
import org.uberfire.ext.security.management.client.widgets.popup.ErrorBoxView;
import org.uberfire.ext.widgets.common.client.CommonsEntryPoint;
import org.uberfire.ext.widgets.common.client.ace.AceEditor;
import org.uberfire.ext.widgets.common.client.common.BusyIndicatorView;
import org.uberfire.ext.widgets.common.client.dropdown.LiveSearchDropDown;
import org.uberfire.ext.widgets.common.client.dropdown.LiveSearchDropDownView;
import org.uberfire.ext.widgets.common.client.dropdown.PerspectiveDropDown;
import org.uberfire.ext.widgets.common.client.tables.FilterPagedTable;
import org.uberfire.ext.widgets.common.client.tables.PagedTable;
import org.uberfire.ext.widgets.common.client.tables.SimpleTable;
import org.uberfire.ext.widgets.common.client.tables.popup.NewFilterPopup;
import org.uberfire.ext.widgets.common.client.tables.popup.NewTabFilterPopup;
import org.uberfire.ext.widgets.core.client.CoreEntryPoint;
import org.uberfire.ext.widgets.core.client.editors.defaulteditor.DefaultEditorNewFileUpload;
import org.uberfire.ext.widgets.core.client.editors.defaulteditor.DefaultFileEditorPresenter;
import org.uberfire.ext.widgets.core.client.editors.defaulteditor.DefaultFileEditorPresenterActivity;
import org.uberfire.ext.widgets.core.client.editors.defaulteditor.DefaultFileEditorView;
import org.uberfire.ext.widgets.core.client.editors.metafile.MetaFileEditorPresenter;
import org.uberfire.ext.widgets.core.client.editors.metafile.MetaFileEditorPresenterActivity;
import org.uberfire.ext.widgets.core.client.editors.texteditor.TextEditorView;
import org.uberfire.ext.widgets.core.client.editors.texteditor.TextEditorWorkbenchEditor;
import org.uberfire.ext.widgets.core.client.editors.texteditor.TextEditorWorkbenchEditorActivity;
import org.uberfire.ext.widgets.core.client.editors.texteditor.TextResourceType;
import org.uberfire.ext.widgets.core.client.screens.iframe.IFrameScreenPresenter;
import org.uberfire.ext.widgets.core.client.screens.iframe.IFrameScreenPresenterActivity;
import org.uberfire.ext.widgets.core.client.screens.iframe.IFrameScreenView;
import org.uberfire.ext.widgets.core.client.wizards.WizardPageTitle;
import org.uberfire.ext.widgets.core.client.wizards.WizardViewImpl;
import org.uberfire.ext.widgets.core.client.workbench.widgets.popups.activities.notfound.ActivityNotFoundPresenter;
import org.uberfire.ext.widgets.core.client.workbench.widgets.popups.activities.notfound.ActivityNotFoundPresenterActivity;
import org.uberfire.ext.widgets.core.client.workbench.widgets.popups.activities.notfound.ActivityNotFoundView;
import org.uberfire.ext.widgets.table.client.TableEntryPoint;
import org.uberfire.ext.wires.core.client.actions.ActionsGroup;
import org.uberfire.ext.wires.core.client.actions.ActionsScreen;
import org.uberfire.ext.wires.core.client.actions.ActionsScreenActivity;
import org.uberfire.ext.wires.core.client.actions.StencilActionBuilder;
import org.uberfire.ext.wires.core.client.canvas.WiresCanvas;
import org.uberfire.ext.wires.core.client.factories.ShapeFactoryCache;
import org.uberfire.ext.wires.core.client.layers.LayersGroup;
import org.uberfire.ext.wires.core.client.layers.LayersScreen;
import org.uberfire.ext.wires.core.client.layers.LayersScreenActivity;
import org.uberfire.ext.wires.core.client.layers.StencilLayerBuilder;
import org.uberfire.ext.wires.core.client.palette.ConnectorsGroup;
import org.uberfire.ext.wires.core.client.palette.ContainersGroup;
import org.uberfire.ext.wires.core.client.palette.FixedShapesGroup;
import org.uberfire.ext.wires.core.client.palette.PaletteScreen;
import org.uberfire.ext.wires.core.client.palette.PaletteScreenActivity;
import org.uberfire.ext.wires.core.client.palette.ShapesGroup;
import org.uberfire.ext.wires.core.client.palette.StencilPaletteBuilder;
import org.uberfire.ext.wires.core.client.properties.DoubleValidator;
import org.uberfire.ext.wires.core.client.properties.PropertiesScreen;
import org.uberfire.ext.wires.core.client.properties.PropertiesScreenActivity;
import org.uberfire.ext.wires.core.client.properties.PropertyEditorAdaptorsCache;
import org.uberfire.ext.wires.core.grids.client.demo.WiresGridsDemoEntryPoint;
import org.uberfire.ext.wires.core.grids.client.demo.WiresGridsDemoPresenter;
import org.uberfire.ext.wires.core.grids.client.demo.WiresGridsDemoPresenterActivity;
import org.uberfire.ext.wires.core.grids.client.demo.WiresGridsDemoViewImpl;
import org.uberfire.ext.wires.core.grids.client.perspectives.WiresGridsDemoPerspective;
import org.uberfire.ext.wires.core.grids.client.perspectives.WiresGridsDemoPerspectiveActivity;
import org.uberfire.ext.wires.core.trees.client.canvas.WiresTreesScreen;
import org.uberfire.ext.wires.core.trees.client.canvas.WiresTreesScreenActivity;
import org.uberfire.ext.wires.core.trees.client.factories.ExampleTreeNode1Factory;
import org.uberfire.ext.wires.core.trees.client.factories.ExampleTreeNode2Factory;
import org.uberfire.ext.wires.core.trees.client.factories.ExampleTreeNode3DynamicFactory;
import org.uberfire.ext.wires.core.trees.client.layout.WiresTreesDefaultLayout;
import org.uberfire.ext.wires.core.trees.client.palette.TreeNodesGroup;
import org.uberfire.ext.wires.core.trees.client.palette.WiresTreesPaletteScreen;
import org.uberfire.ext.wires.core.trees.client.palette.WiresTreesPaletteScreenActivity;
import org.uberfire.ext.wires.core.trees.client.perspectives.WiresTreesPerspective;
import org.uberfire.ext.wires.core.trees.client.perspectives.WiresTreesPerspectiveActivity;
import org.uberfire.rpc.SessionInfo;
import org.uberfire.security.client.SecurityEntryPoint;
import org.uberfire.security.client.authz.AuthorizationManagerHelper;
import org.uberfire.security.client.authz.tree.impl.DefaultPermissionTreeFactory;
import org.uberfire.security.impl.authz.DefaultAuthorizationManager;
import org.uberfire.security.impl.authz.DefaultPermissionManager;
import org.uberfire.security.impl.authz.DefaultPermissionTypeRegistry;

public class BootstrapperImpl implements Bootstrapper {
  {
    addLookups_0();
    new CDI().initLookupTable(CDIEventTypeLookup.get());
    new DataBindingModuleBootstrapper().run();
  }

  private ContextManager contextManager = new ContextManagerImpl();
  private final WindowInjectionContext windowContext = WindowInjectionContext.createOrGet();
  private static final Logger logger = LoggerFactory.getLogger(Bootstrapper.class);
  public abstract class Type_factory__o_g_m_c_c_MessageConsoleScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<MessageConsoleScreen> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_GroupsExplorer__quals__j_e_i_Any_j_e_i_Default extends Factory<GroupsExplorer> { }
  public abstract class ExtensionProvided_factory__o_j_e_c_c_d_CheckboxInput__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<CheckboxInput> { }
  public abstract class Type_factory__o_j_d_r_c_p_w_ProcessBreadCrumbView__quals__j_e_i_Any_j_e_i_Default extends Factory<ProcessBreadCrumbView> { }
  public abstract class Type_factory__o_j_c_n_b_c_p_DeploymentListPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<DeploymentListPerspectiveActivity> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_ChangePasswordView__quals__j_e_i_Any_j_e_i_Default extends Factory<ChangePasswordView> { }
  public abstract class Type_factory__o_o_w_s_s_c_e_SolverEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<SolverEditorPresenterActivity> { }
  public abstract class Type_factory__o_k_w_c_s_s_c_m_SearchMenuView__quals__j_e_i_Any_j_e_i_Default extends Factory<SearchMenuView> { }
  public abstract class Type_factory__o_u_e_s_m_c_s_e_GroupEditorScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<GroupEditorScreen> { }
  public abstract class Type_factory__o_d_d_c_w_DisplayerEditorStatus__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayerEditorStatus> { }
  public abstract class Type_factory__o_o_w_s_s_c_e_SolverEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<SolverEditorViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_a_SearchAnnotationPage__quals__j_e_i_Any_j_e_i_Default extends Factory<SearchAnnotationPage> { }
  public abstract class Type_factory__o_d_w_s_g_t_c_e_GuidedRuleTemplateDataViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedRuleTemplateDataViewImpl> { }
  public abstract class Type_factory__o_d_w_s_t_t_TestScenarioResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default extends Factory<TestScenarioResourceTypeDefinition> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_e_ServerEmptyView__quals__j_e_i_Any_j_e_i_Default extends Factory<ServerEmptyView> { }
  public abstract class ContextualProvider_factory__o_j_e_u_n_c_l_TransitionAnchorFactory__quals__Universal extends Factory<TransitionAnchorFactory> { }
  public abstract class Type_factory__o_d_c_w_d_e_DataSetDefColumnsFilterEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefColumnsFilterEditorView> { }
  public abstract class Type_factory__o_u_c_w_Workbench__quals__j_e_i_Any_j_e_i_Default extends Factory<Workbench> { }
  public abstract class Type_factory__o_j_c_n_h_c_e_t_TaskAssignmentsPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<TaskAssignmentsPresenter> { }
  public abstract class Type_factory__o_d_w_s_w_c_e_WorkItemsEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkItemsEditorViewImpl> { }
  public abstract class Type_factory__o_d_w_s_w_c_e_WorkItemsEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<WorkItemsEditorPresenterActivity> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_r_RoleEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<RoleEditor> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_AdvancedDataObjectEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<AdvancedDataObjectEditor> { }
  public abstract class Type_factory__o_u_c_w_p_i_MultiListWorkbenchPanelPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<MultiListWorkbenchPanelPresenter> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_l_EntitiesListView__quals__j_e_i_Any_j_e_i_Default extends Factory<EntitiesListView> { }
  public abstract class Type_factory__o_k_w_c_s_s_c_SearchEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<SearchEntryPoint> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_d_EnhancedDependenciesManager__quals__j_e_i_Any_j_e_i_Default extends Factory<EnhancedDependenciesManager> { }
  public abstract class Type_factory__o_u_c_m_ActivityBeansInfo__quals__j_e_i_Any_j_e_i_Default extends Factory<ActivityBeansInfo> { }
  public abstract class Type_factory__o_d_c_w_d_e_w_c_SQLDataSetBasicAttributesWorkflow__quals__j_e_i_Any_j_e_i_Default extends Factory<SQLDataSetBasicAttributesWorkflow> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_g_GroupEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<GroupEditorView> { }
  public abstract class Type_factory__o_u_c_w_p_u_p_UnanchoredWorkbenchPartView__quals__j_e_i_Any_j_e_i_Default extends Factory<UnanchoredWorkbenchPartView> { }
  public abstract class Type_factory__o_u_e_s_m_c_s_e_UserEditorScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<UserEditorScreen> { }
  public abstract class Type_factory__o_u_e_w_c_g_c_d_WiresGridsDemoPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<WiresGridsDemoPresenter> { }
  public abstract class Type_factory__o_d_c_c_e_m_MapEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<MapEditorView> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_n_BreadcrumbNavigator__quals__j_e_i_Any_j_e_i_Default extends Factory<BreadcrumbNavigator> { }
  public abstract class Type_factory__o_o_w_s_s_c_e_TerminationConfigForm__quals__j_e_i_Any_j_e_i_Default extends Factory<TerminationConfigForm> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_e_GuvnorDefaultEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<GuvnorDefaultEditorViewImpl> { }
  public abstract class Type_factory__o_j_c_n_h_c_e_t_TaskDetailsMultiViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<TaskDetailsMultiViewImpl> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_n_MultiplePermissionNodeViewerView__quals__j_e_i_Any_j_e_i_Default extends Factory<MultiplePermissionNodeViewerView> { }
  public abstract class Type_factory__o_g_a_m_c_e_p_s_w_ProjectModulesViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectModulesViewImpl> { }
  public abstract class Type_factory__o_d_w_s_d_c_e_DSLEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DSLEditorViewImpl> { }
  public abstract class Type_factory__o_j_c_n_p_c_p_ProcessDefinitionsPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<ProcessDefinitionsPerspectiveActivity> { }
  public abstract class Type_factory__o_j_f_r_c_FormRendererWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<FormRendererWidget> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_d_DroolsDomainScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<DroolsDomainScreenActivity> { }
  public abstract class Type_factory__o_u_e_p_c_e_EditorPlugInEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<EditorPlugInEditorPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_a_ValuePairEditorPage__quals__j_e_i_Any_j_e_i_Default extends Factory<ValuePairEditorPage> { }
  public abstract class Type_factory__o_u_e_w_c_g_c_d_WiresGridsDemoViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<WiresGridsDemoViewImpl> { }
  public abstract class Type_factory__o_d_w_s_g_s_c_e_GuidedScoreCardEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedScoreCardEditorPresenter> { }
  public abstract class Type_factory__o_k_w_c_w_c_c_w_b_ImportsWidgetViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ImportsWidgetViewImpl> { }
  public abstract class Type_factory__o_d_r_g_c_GoogleTableDisplayerView__quals__j_e_i_Any_j_e_i_Default extends Factory<GoogleTableDisplayerView> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_g_w_GroupEditorWorkflow__quals__j_e_i_Any_j_e_i_Default extends Factory<GroupEditorWorkflow> { }
  public abstract class Type_factory__o_u_e_s_m_c_p_SecurityManagementPerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<SecurityManagementPerspective> { }
  public abstract class Type_factory__o_g_c_s_p_c_s_ProjectTreeProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectTreeProvider> { }
  public abstract class Type_factory__o_k_w_c_s_d_s_PackageNameWhiteListResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default extends Factory<PackageNameWhiteListResourceTypeDefinition> { }
  public abstract class Type_factory__o_k_w_c_w_c_m_WorkbenchConfigurationMenuBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchConfigurationMenuBuilder> { }
  public abstract class Type_factory__o_d_r_g_c_GoogleBarChartDisplayer__quals__j_e_i_Any_j_e_i_Default extends Factory<GoogleBarChartDisplayer> { }
  public abstract class Type_factory__o_g_a_m_c_e_r_s_RepositoryStructurePresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoryStructurePresenter> { }
  public abstract class Type_factory__o_d_w_s_g_t_c_t_GuidedRuleTemplateResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedRuleTemplateResourceType> { }
  public abstract class ExtensionProvided_factory__o_g_c_u_Container__quals__j_e_i_Any_j_e_i_Default extends Factory<Container> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_ProjectConfigScreenEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectConfigScreenEntryPoint> { }
  public abstract class Type_factory__o_j_c_n_h_c_e_t_g_d_DataSetTasksListGridPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetTasksListGridPresenter> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_PriorityDropDown__quals__j_e_i_Any_j_e_i_Default extends Factory<PriorityDropDown> { }
  public abstract class Type_factory__o_k_w_c_s_s_h_c_h_SocialHomePagePerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<SocialHomePagePerspective> { }
  public abstract class Type_factory__o_d_d_e_c_s_DataSetDefEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<DataSetDefEditorPresenterActivity> { }
  public abstract class ContextualProvider_factory__j_e_e_Event__quals__Universal extends Factory<Event> { }
  public abstract class Type_factory__o_j_c_n_e_c_e_q_QuickNewJobPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<QuickNewJobPopup> { }
  public abstract class Type_factory__o_j_f_r_i_FormRendererPanelIncluderPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<FormRendererPanelIncluderPresenter> { }
  public abstract class Type_factory__o_k_w_c_KieWorkbenchEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<KieWorkbenchEntryPoint> { }
  public abstract class Type_factory__o_g_c_s_p_c_r_ConflictingRepositoriesPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<ConflictingRepositoriesPopup> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_n_PermissionWidgetFactory__quals__j_e_i_Any_j_e_i_Default extends Factory<PermissionWidgetFactory> { }
  public abstract class Type_factory__o_u_e_w_c_c_p_PropertyEditorAdaptorsCache__quals__j_e_i_Any_j_e_i_Default extends Factory<PropertyEditorAdaptorsCache> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_p_FactPatternConstraintsPage__quals__j_e_i_Any_j_e_i_Default extends Factory<FactPatternConstraintsPage> { }
  public abstract class ExtensionProvided_factory__o_g_c_u_ListBox__quals__j_e_i_Any_j_e_i_Default extends Factory<ListBox> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_u_w_UserCreationWorkflow__quals__j_e_i_Any_j_e_i_Default extends Factory<UserCreationWorkflow> { }
  public abstract class Type_factory__o_g_c_s_p_c_POMEditorPanelViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<POMEditorPanelViewImpl> { }
  public abstract class Type_factory__o_g_s_c_e_c_GuvnorStructureContext__quals__j_e_i_Any_j_e_i_Default extends Factory<GuvnorStructureContext> { }
  public abstract class Type_factory__o_d_d_c_w_DisplayerTypeSelector__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayerTypeSelector> { }
  public abstract class Type_factory__o_u_e_e_c_c_h_VersionRecordManager__quals__j_e_i_Any_j_e_i_Default extends Factory<VersionRecordManager> { }
  public abstract class Type_factory__o_d_w_s_e_t_EnumResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default extends Factory<EnumResourceTypeDefinition> { }
  public abstract class Type_factory__o_d_c_c_e_ValueBoxEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<ValueBoxEditorView> { }
  public abstract class Type_factory__o_u_c_w_p_i_StaticWorkbenchPanelPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<StaticWorkbenchPanelPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_w_NewProjectWizard__quals__j_e_i_Any_j_e_i_Default extends Factory<NewProjectWizard> { }
  public abstract class Type_factory__o_d_d_c_w_f_MultipleNumberParameterEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<MultipleNumberParameterEditorView> { }
  public abstract class Type_factory__o_k_w_c_w_c_h_w_c_ConfigurationComboBoxItemWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<ConfigurationComboBoxItemWidget> { }
  public abstract class Type_factory__o_k_w_c_w_c_m_AboutMenuBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<AboutMenuBuilder> { }
  public abstract class Type_factory__o_g_i_c_InboxEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<InboxEntryPoint> { }
  public abstract class Type_factory__o_u_e_w_t_c_TableEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<TableEntryPoint> { }
  public abstract class Type_factory__o_u_e_w_c_c_e_d_DefaultFileEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultFileEditorPresenter> { }
  public abstract class Type_factory__o_d_w_s_g_c_GlobalsEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<GlobalsEditorEntryPoint> { }
  public abstract class Type_factory__o_j_c_n_b_c_e_d_l_DeploymentUnitsListPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<DeploymentUnitsListPresenterActivity> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_v_ValuePairEditorProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<ValuePairEditorProvider> { }
  public abstract class ExtensionProvided_factory__o_k_w_c_w_c_c_w_b_AddImportPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<AddImportPopup> { }
  public abstract class Type_factory__o_j_d_c_u_DataIOEditorNameTextBox__quals__j_e_i_Any_j_e_i_Default extends Factory<DataIOEditorNameTextBox> { }
  public abstract class Type_factory__o_k_w_c_s_s_c_FindFormActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<FindFormActivity> { }
  public abstract class Type_factory__o_g_a_m_c_e_r_ReleaseConfigurationPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ReleaseConfigurationPresenter> { }
  public abstract class Type_factory__o_u_e_p_c_p_e_g_PerspectiveEditorGenerator__quals__j_e_i_Any_j_e_i_Default extends Factory<PerspectiveEditorGenerator> { }
  public abstract class ExtensionProvided_factory__o_j_e_c_c_d_NumberInput__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<NumberInput> { }
  public abstract class Type_factory__o_d_w_s_s_c_e_ScoreCardXLSEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ScoreCardXLSEditorViewImpl> { }
  public abstract class Type_factory__o_j_c_n_e_c_p_JobListPerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<JobListPerspective> { }
  public abstract class Provider_factory__o_j_e_c_c_a_BatchCaller__quals__j_e_i_Any_j_e_i_Default extends Factory<BatchCaller> { }
  public abstract class Type_factory__o_u_c_w_p_i_SimpleWorkbenchPanelPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<SimpleWorkbenchPanelPresenter> { }
  public abstract class Type_factory__o_j_c_n_h_f_c_d_s_StandaloneTaskFormDisplayPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<StandaloneTaskFormDisplayPresenter> { }
  public abstract class Type_factory__o_d_r_g_c_GoogleBubbleChartDisplayerView__quals__j_e_i_Any_j_e_i_Default extends Factory<GoogleBubbleChartDisplayerView> { }
  public abstract class Type_factory__o_g_s_c_s_OrganizationalUnitTreeProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<OrganizationalUnitTreeProvider> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_c_b_n_NotificationPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<NotificationPresenter> { }
  public abstract class Type_factory__o_d_c_c_e_l_DropDownImageListEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DropDownImageListEditor> { }
  public abstract class Type_factory__o_j_c_n_h_c_e_t_TaskAdminViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<TaskAdminViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_s_h_c_u_UserHomePageSideView__quals__j_e_i_Any_j_e_i_Default extends Factory<UserHomePageSideView> { }
  public abstract class Type_factory__o_u_e_w_c_c_e_t_TextEditorWorkbenchEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<TextEditorWorkbenchEditor> { }
  public abstract class Type_factory__o_j_c_n_h_f_c_d_p_HumanTaskFormDisplayProviderImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<HumanTaskFormDisplayProviderImpl> { }
  public abstract class Type_factory__o_k_w_c_s_c_c_s_ContributorsScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<ContributorsScreen> { }
  public abstract class Type_factory__o_d_r_g_c_GooglePieChartDisplayer__quals__j_e_i_Any_j_e_i_Default extends Factory<GooglePieChartDisplayer> { }
  public abstract class Type_factory__o_g_a_m_c_e_r_ReleaseConfigurationPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<ReleaseConfigurationPresenterActivity> { }
  public abstract class Type_factory__o_u_e_p_c_p_e_l_e_HTMLLayoutDragComponent__quals__j_e_i_Any_j_e_i_Default extends Factory<HTMLLayoutDragComponent> { }
  public abstract class Type_factory__o_d_c_w_d_e_c_DataSetDefColumnsEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefColumnsEditor> { }
  public abstract class Type_factory__o_u_c_WorkbenchBackendEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchBackendEntryPoint> { }
  public abstract class Type_factory__o_u_e_w_c_c_c_WiresCanvas__quals__j_e_i_Any_j_e_i_Default extends Factory<WiresCanvas> { }
  public abstract class Type_factory__o_u_e_w_c_g_c_d_WiresGridsDemoPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<WiresGridsDemoPresenterActivity> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_ExamplesWizard__quals__j_e_i_Any_j_e_i_Default extends Factory<ExamplesWizard> { }
  public abstract class Type_factory__o_u_s_i_a_DefaultPermissionManager__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultPermissionManager> { }
  public abstract class Type_factory__o_u_c_VFSServiceProxyBackendImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<VFSServiceProxyBackendImpl> { }
  public abstract class Type_factory__o_u_e_p_e_c_f_BooleanField__quals__j_e_i_Any_j_e_i_Default extends Factory<BooleanField> { }
  public abstract class Type_factory__o_j_e_u_n_c_l_Navigation__quals__j_e_i_Any_j_e_i_Default extends Factory<Navigation> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_ListenersPanel__quals__j_e_i_Any_j_e_i_Default extends Factory<ListenersPanel> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_f_ActionInsertNodeFactory__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionInsertNodeFactory> { }
  public abstract class Type_factory__o_j_c_n_h_c_e_t_TaskLogsViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<TaskLogsViewImpl> { }
  public abstract class Type_factory__o_k_u_s_a_c_u_SocialUserImageProviderImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<SocialUserImageProviderImpl> { }
  public abstract class Type_factory__o_u_e_w_c_c_w_w_p_a_n_ActivityNotFoundPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<ActivityNotFoundPresenterActivity> { }
  public abstract class Type_factory__o_j_c_n_g_f_c_d_s_FormDisplayPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<FormDisplayPerspectiveActivity> { }
  public abstract class Producer_factory__o_d_c_w_d_e_d_DataColumnDefDriver__quals__j_e_i_Any_j_e_i_Default extends Factory<DataColumnDefDriver> { }
  public abstract class Type_factory__o_d_c_w_d_e_s_SQLDataSetEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<SQLDataSetEditor> { }
  public abstract class Type_factory__o_u_c_v_p_m_WorkbenchMenuStandardNavBarView__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchMenuStandardNavBarView> { }
  public abstract class Type_factory__o_j_e_s_c_l_c_SecurityContextImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<SecurityContextImpl> { }
  public abstract class Type_factory__o_d_d_c_ClientDataSetManager__quals__j_e_i_Any_j_e_i_Default extends Factory<ClientDataSetManager> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_u_NewUserAttributeEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<NewUserAttributeEditorView> { }
  public abstract class Type_factory__o_d_d_e_c_s_DataSetDefWizardScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<DataSetDefWizardScreenActivity> { }
  public abstract class Type_factory__o_j_e_u_n_c_l_TransitionToRoleProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<TransitionToRoleProvider> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_ServerManagementPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<ServerManagementPerspectiveActivity> { }
  public abstract class Producer_factory__o_d_c_w_d_e_d_BeanDataSetDefDriver__quals__j_e_i_Any_j_e_i_Default extends Factory<BeanDataSetDefDriver> { }
  public abstract class Type_factory__o_d_c_w_d_e_a_DataSetDefRefreshAttributesEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefRefreshAttributesEditorView> { }
  public abstract class Type_factory__o_d_d_c_w_f_TimeInstantEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<TimeInstantEditorView> { }
  public abstract class Producer_factory__o_d_c_w_d_e_d_ElasticSearchDataSetDefAttributesDriver__quals__j_e_i_Any_j_e_i_Default extends Factory<ElasticSearchDataSetDefAttributesDriver> { }
  public abstract class Type_factory__o_k_w_c_s_h_c_p_HomePerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<HomePerspective> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_m_EditMenuBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<EditMenuBuilder> { }
  public abstract class Type_factory__o_g_s_c_e_r_l_RepositoriesPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoriesPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_j_JPADataObjectFieldEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<JPADataObjectFieldEditor> { }
  public abstract class Type_factory__o_g_m_c_e_MavenRepositoryPagedJarTable__quals__j_e_i_Any_j_e_i_Default extends Factory<MavenRepositoryPagedJarTable> { }
  public abstract class Type_factory__o_d_w_s_s_c_e_ScoreCardXLSEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ScoreCardXLSEditorPresenter> { }
  public abstract class Type_factory__o_u_c_w_DefaultBeanFactory__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultBeanFactory> { }
  public abstract class Type_factory__o_d_c_w_c_LoadingBoxView__quals__j_e_i_Any_j_e_i_Default extends Factory<LoadingBoxView> { }
  public abstract class Type_factory__o_j_c_n_w_c_e_d_d_DeploymentDescriptorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DeploymentDescriptorViewImpl> { }
  public abstract class Type_factory__o_g_a_m_c_e_c_RepositoryConfigurationPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoryConfigurationPresenter> { }
  public abstract class Type_factory__o_d_d_c_w_g_ColumnDetailsEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<ColumnDetailsEditor> { }
  public abstract class Type_factory__o_k_w_c_w_m_c_p_SelectDocumentPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<SelectDocumentPopup> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_g_w_GroupCreationWorkflow__quals__j_e_i_Any_j_e_i_Default extends Factory<GroupCreationWorkflow> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_n_PermissionExceptionSwitchView__quals__j_e_i_Any_j_e_i_Default extends Factory<PermissionExceptionSwitchView> { }
  public abstract class Type_factory__o_u_e_w_c_c_p_PropertiesScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<PropertiesScreenActivity> { }
  public abstract class Type_factory__o_d_w_s_d_c_t_DecisionTableXLSResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<DecisionTableXLSResourceType> { }
  public abstract class Type_factory__o_k_w_c_s_s_h_c_h_SocialHomePagePerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<SocialHomePagePerspectiveActivity> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_AssignedEntitiesExplorerView__quals__j_e_i_Any_j_e_i_Default extends Factory<AssignedEntitiesExplorerView> { }
  public abstract class ExtensionProvided_factory__c_g_g_u_c_u_TextArea__quals__j_e_i_Any_j_e_i_Default extends Factory<TextArea> { }
  public abstract class Type_factory__o_g_c_s_p_c_s_ProjectController__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectController> { }
  public abstract class Type_factory__o_d_w_s_s_c_e_ScoreCardXLSEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<ScoreCardXLSEditorPresenterActivity> { }
  public abstract class Type_factory__o_k_w_c_w_c_h_PathLabel__quals__j_e_i_Any_j_e_i_Default extends Factory<PathLabel> { }
  public abstract class Type_factory__o_j_c_n_h_c_e_t_TaskProcessContextViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<TaskProcessContextViewImpl> { }
  public abstract class Type_factory__o_u_c_w_p_s_PartManager__quals__j_e_i_Any_j_e_i_Default extends Factory<PartManager> { }
  public abstract class Type_factory__o_d_c_w_d_e_a_DataSetDefRefreshIntervalEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefRefreshIntervalEditorView> { }
  public abstract class Type_factory__o_g_a_m_c_e_r_s_RepositoryStructureTitle__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoryStructureTitle> { }
  public abstract class Type_factory__o_d_d_e_c_s_DataSetAuthoringHomeView__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetAuthoringHomeView> { }
  public abstract class Type_factory__o_j_c_n_h_c_e_t_TaskAssignmentsViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<TaskAssignmentsViewImpl> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_m_RowContextMenuViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<RowContextMenuViewImpl> { }
  public abstract class Type_factory__o_j_c_n_p_c_e_d_d_b_BasicProcessDefDetailsViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<BasicProcessDefDetailsViewImpl> { }
  public abstract class ContextualProvider_factory__o_j_e_u_n_c_l_TransitionTo__quals__Universal extends Factory<TransitionTo> { }
  public abstract class Type_factory__o_g_m_c_c_MessageConsoleScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<MessageConsoleScreenActivity> { }
  public abstract class Type_factory__o_d_r_g_c_GoogleBubbleChartDisplayer__quals__j_e_i_Any_j_e_i_Default extends Factory<GoogleBubbleChartDisplayer> { }
  public abstract class Type_factory__o_g_s_c_e_r_e_RepositoryEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoryEditorPresenter> { }
  public abstract class Type_factory__o_j_c_n_p_c_e_d_d_a_AdvancedViewProcessDefDetailsViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<AdvancedViewProcessDefDetailsViewImpl> { }
  public abstract class Type_factory__o_g_s_c_StructureEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<StructureEntryPoint> { }
  public abstract class Type_factory__o_d_w_s_e_c_e_EnumEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<EnumEditorViewImpl> { }
  public abstract class Type_factory__o_g_a_m_c_e_f_p_u_JSONCommitsReader__quals__j_e_i_Any_j_e_i_Default extends Factory<JSONCommitsReader> { }
  public abstract class Type_factory__o_u_c_w_VFSLockServiceProxyClientImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<VFSLockServiceProxyClientImpl> { }
  public abstract class Type_factory__o_k_w_c_w_c_w_KSessionSelectorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<KSessionSelectorViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_r_RemoteStatusPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<RemoteStatusPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_AdvancedDomainScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<AdvancedDomainScreen> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_ProjectImportsScreenPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<ProjectImportsScreenPresenterActivity> { }
  public abstract class Type_factory__o_j_c_n_p_c_e_i_s_ProcessInstanceSignalViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ProcessInstanceSignalViewImpl> { }
  public abstract class Type_factory__o_k_w_c_w_c_KieWorkbenchWidgetsCommonEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<KieWorkbenchWidgetsCommonEntryPoint> { }
  public abstract class Type_factory__o_u_e_p_c_e_PluginExplorerScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<PluginExplorerScreen> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_p_c_ConditionCell__quals__j_e_i_Any_j_e_i_Default extends Factory<ConditionCell> { }
  public abstract class Type_factory__o_u_c_v_p_m_PartContextMenusView__quals__j_e_i_Any_j_e_i_Default extends Factory<PartContextMenusView> { }
  public abstract class Type_factory__o_u_c_v_p_t_ResizeTabPanel__quals__j_e_i_Any_o_u_c_v_p_t_Resize extends Factory<ResizeTabPanel> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_t_GuidedDTableResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedDTableResourceType> { }
  public abstract class Type_factory__o_d_c_w_d_e_DataSetExplorerView__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetExplorerView> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_p_NewPackagePopupViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<NewPackagePopupViewImpl> { }
  public abstract class Type_factory__o_d_w_s_s_c_t_ScoreCardXLSResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<ScoreCardXLSResourceType> { }
  public abstract class Type_factory__o_k_w_c_w_c_c_w_u_ImportsWidgetViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<org.kie.workbench.common.widgets.configresource.client.widget.unbound.ImportsWidgetViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_d_DependencyGrid__quals__j_e_i_Any_j_e_i_Default extends Factory<DependencyGrid> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_c_NewContainerFormView__quals__j_e_i_Any_j_e_i_Default extends Factory<NewContainerFormView> { }
  public abstract class Type_factory__o_d_c_w_d_e_c_ColumnTypeEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<ColumnTypeEditor> { }
  public abstract class Type_factory__o_u_c_w_p_i_UnanchoredStaticWorkbenchPanelPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<UnanchoredStaticWorkbenchPanelPresenter> { }
  public abstract class ExtensionProvided_factory__o_j_e_c_c_d_UnorderedList__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<UnorderedList> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_AttributeColumnConverter__quals__j_e_i_Any_j_e_i_Default extends Factory<AttributeColumnConverter> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_l_GroupsList__quals__j_e_i_Any_j_e_i_Default extends Factory<GroupsList> { }
  public abstract class Type_factory__o_u_e_p_c_t_PerspectiveLayoutPluginResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<PerspectiveLayoutPluginResourceType> { }
  public abstract class ExtensionProvided_factory__o_k_w_c_w_c_c_w_u_AddImportPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<org.kie.workbench.common.widgets.configresource.client.widget.unbound.AddImportPopup> { }
  public abstract class ExtensionProvided_factory__o_g_c_u_HelpBlock__quals__j_e_i_Any_j_e_i_Default extends Factory<HelpBlock> { }
  public abstract class Type_factory__o_d_d_c_w_f_TimeInstantEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<TimeInstantEditor> { }
  public abstract class Type_factory__o_o_w_s_s_c_e_ConstructionHeuristicForm__quals__j_e_i_Any_j_e_i_Default extends Factory<ConstructionHeuristicForm> { }
  public abstract class Type_factory__o_d_d_c_w_f_NumberParameterEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<NumberParameterEditor> { }
  public abstract class Type_factory__o_k_w_c_s_s_c_FullTextSearchFormView__quals__j_e_i_Any_j_e_i_Default extends Factory<FullTextSearchFormView> { }
  public abstract class Type_factory__o_d_d_e_c_s_DataSetAuthoringHomePresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<DataSetAuthoringHomePresenterActivity> { }
  public abstract class Type_factory__o_u_e_s_m_c_e_g_GroupEditorDriver__quals__j_e_i_Any_j_e_i_Default extends Factory<GroupEditorDriver> { }
  public abstract class Type_factory__o_d_w_s_d_c_e_DRLEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<DRLEditorPresenter> { }
  public abstract class Type_factory__o_g_c_s_p_c_GAVEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<GAVEditor> { }
  public abstract class Type_factory__o_g_a_m_c_e_r_w_CreateRepositoryWizard__quals__j_e_i_Any_j_e_i_Default extends Factory<CreateRepositoryWizard> { }
  public abstract class Type_factory__o_j_c_n_p_c_e_i_l_RuntimeLogPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<RuntimeLogPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_p_NewPackagePopup__quals__j_e_i_Any_j_e_i_Default extends Factory<NewPackagePopup> { }
  public abstract class Type_factory__o_u_e_p_c_e_SplashEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<SplashEditorView> { }
  public abstract class Type_factory__o_u_c_v_p_m_WorkbenchViewModeSwitcherView__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchViewModeSwitcherView> { }
  public abstract class Type_factory__o_u_c_a_PerspectiveTreeProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<PerspectiveTreeProvider> { }
  public abstract class Type_factory__o_u_e_w_c_t_c_p_WiresTreesPerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<WiresTreesPerspective> { }
  public abstract class Type_factory__o_u_c_w_w_m_PartContextMenusPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<PartContextMenusPresenter> { }
  public abstract class Type_factory__o_d_w_s_w_c_h_NewWorkItemHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<NewWorkItemHandler> { }
  public abstract class Type_factory__o_j_f_r_i_FormRendererPanelIncluderPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<FormRendererPanelIncluderPresenterActivity> { }
  public abstract class Type_factory__o_j_c_n_p_c_e_d_d_m_a_AdvancedProcessDefDetailsMultiViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<AdvancedProcessDefDetailsMultiViewImpl> { }
  public abstract class Type_factory__o_d_d_c_w_g_DataSetGroupDateEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetGroupDateEditor> { }
  public abstract class Type_factory__o_k_w_c_w_m_c_KieEditorWrapperViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<KieEditorWrapperViewImpl> { }
  public abstract class Type_factory__o_d_d_c_w_g_ColumnDetailsEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<ColumnDetailsEditorView> { }
  public abstract class Type_factory__o_j_d_r_c_p_TaskDashboard__quals__j_e_i_Any_j_e_i_Default extends Factory<TaskDashboard> { }
  public abstract class Type_factory__o_u_e_w_c_c_p_FixedShapesGroup__quals__j_e_i_Any_j_e_i_Default extends Factory<FixedShapesGroup> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_ACLEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<ACLEditor> { }
  public abstract class Type_factory__o_u_e_p_c_t_ScreenPluginResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<ScreenPluginResourceType> { }
  public abstract class Type_factory__o_u_e_l_e_c_g_BootstrapLayoutGenerator__quals__j_e_i_Any_j_e_i_Default extends Factory<BootstrapLayoutGenerator> { }
  public abstract class Type_factory__o_j_c_n_p_c_e_v_l_ProcessVariableListPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ProcessVariableListPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_d_NewDependencyPopupViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<NewDependencyPopupViewImpl> { }
  public abstract class Type_factory__o_u_e_p_c_v_PluginNameValidator__quals__j_e_i_Any_j_e_i_Default extends Factory<PluginNameValidator> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_KSessionsPanel__quals__j_e_i_Any_j_e_i_Default extends Factory<KSessionsPanel> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_p_ActionInsertFactFieldsPage__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionInsertFactFieldsPage> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_d_DependencyLoader__quals__j_e_i_Any_j_e_i_Default extends Factory<DependencyLoader> { }
  public abstract class Type_factory__o_j_e_s_c_l_c_DefaultRestSecurityErrorCallback__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultRestSecurityErrorCallback> { }
  public abstract class Type_factory__o_d_w_s_g_s_c_h_NewGuidedScoreCardHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<NewGuidedScoreCardHandler> { }
  public abstract class Type_factory__o_u_c_v_p_t_MultiTabWorkbenchPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<MultiTabWorkbenchPanelView> { }
  public abstract class Type_factory__o_k_w_c_w_m_c_m_RegisteredDocumentsMenuBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<RegisteredDocumentsMenuBuilder> { }
  public abstract class Type_factory__o_d_w_s_d_c_DSLEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<DSLEditorEntryPoint> { }
  public abstract class Type_factory__o_o_w_s_d_c_w_p_PlannerDataObjectEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<PlannerDataObjectEditorViewImpl> { }
  public abstract class Type_factory__o_d_w_s_t_c_ScenarioEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ScenarioEditorViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_r_e_RemoteEmptyPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<RemoteEmptyPresenter> { }
  public abstract class Type_factory__o_d_r_g_c_GoogleRenderer__quals__j_e_i_Any_j_e_i_Default extends Factory<GoogleRenderer> { }
  public abstract class Type_factory__o_j_e_u_n_c_l_HistoryTokenFactory__quals__j_e_i_Any_j_e_i_Default extends Factory<HistoryTokenFactory> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_h_NewProjectHandlerViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<NewProjectHandlerViewImpl> { }
  public abstract class Type_factory__o_j_c_n_d_c_p_f_TimeInstantEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<org.jbpm.console.ng.df.client.popup.filter.TimeInstantEditor> { }
  public abstract class Type_factory__o_k_w_c_s_s_h_c_h_SocialHomePageMainPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<SocialHomePageMainPresenter> { }
  public abstract class Type_factory__o_j_d_r_c_p_DashboardScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<DashboardScreen> { }
  public abstract class Type_factory__o_u_e_s_m_c_s_e_SecurityExplorerView__quals__j_e_i_Any_j_e_i_Default extends Factory<SecurityExplorerView> { }
  public abstract class Type_factory__o_k_w_c_w_c_c_p_WorkbenchConfigurationPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchConfigurationPopup> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_c_DataModelChangeNotifier__quals__j_e_i_Any_j_e_i_Default extends Factory<DataModelChangeNotifier> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_c_CardPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<CardPresenter> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_g_GroupUsersAssignment__quals__j_e_i_Any_j_e_i_Default extends Factory<GroupUsersAssignment> { }
  public abstract class Type_factory__o_j_c_n_p_c_p_DataSetProcessInstancesWithVariablesPerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetProcessInstancesWithVariablesPerspective> { }
  public abstract class Type_factory__o_j_e_i_c_a_b_InitBallotProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<InitBallotProvider> { }
  public abstract class Type_factory__o_g_a_m_c_e_r_s_RepositoryStructureViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoryStructureViewImpl> { }
  public abstract class Type_factory__o_o_w_s_d_c_w_p_PlannerDataObjectFieldEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<PlannerDataObjectFieldEditor> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_c_p_ProcessConfigView__quals__j_e_i_Any_j_e_i_Default extends Factory<ProcessConfigView> { }
  public abstract class Type_factory__o_j_c_n_w_d_t_DDResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default extends Factory<DDResourceTypeDefinition> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_p_PersistenceUnitPropertyGridViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<PersistenceUnitPropertyGridViewImpl> { }
  public abstract class Type_factory__o_d_d_e_c_s_DataSetDefEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefEditorPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_p_o_OUPageViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<OUPageViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_c_b_n_NotificationView__quals__j_e_i_Any_j_e_i_Default extends Factory<NotificationView> { }
  public abstract class Type_factory__o_u_c_RuntimePluginsServiceProxyBackendImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<RuntimePluginsServiceProxyBackendImpl> { }
  public abstract class Producer_factory__o_d_c_w_d_e_d_CSVDataSetDefDriver__quals__j_e_i_Any_j_e_i_Default extends Factory<CSVDataSetDefDriver> { }
  public abstract class Type_factory__o_j_e_u_c_w_LocaleListBox__quals__j_e_i_Any_j_e_i_Default extends Factory<LocaleListBox> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_KSessionForm__quals__j_e_i_Any_j_e_i_Default extends Factory<KSessionForm> { }
  public abstract class Type_factory__o_u_e_p_c_e_SplashEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<SplashEditorPresenterActivity> { }
  public abstract class ExtensionProvided_factory__o_g_c_u_FormLabel__quals__j_e_i_Any_j_e_i_Default extends Factory<FormLabel> { }
  public abstract class Type_factory__o_u_e_w_c_c_d_LiveSearchDropDownView__quals__j_e_i_Any_j_e_i_Default extends Factory<LiveSearchDropDownView> { }
  public abstract class Type_factory__o_u_c_w_w_m_UtilityMenuBarPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<UtilityMenuBarPresenter> { }
  public abstract class Type_factory__o_u_e_p_e_c_f_TextField__quals__j_e_i_Any_j_e_i_Default extends Factory<TextField> { }
  public abstract class Type_factory__o_u_e_w_c_g_c_p_WiresGridsDemoPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<WiresGridsDemoPerspectiveActivity> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_ProjectEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectEditorEntryPoint> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_ServerManagementEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<ServerManagementEntryPoint> { }
  public abstract class Type_factory__o_k_w_c_w_c_s_ContextualSearch__quals__j_e_i_Any_j_e_i_Default extends Factory<ContextualSearch> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_DataModelerScreenPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<DataModelerScreenPresenter> { }
  public abstract class Type_factory__o_d_w_s_t_c_r_TestRunnerReportingScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<TestRunnerReportingScreenActivity> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_p_r_RepositoryPage__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoryPage> { }
  public abstract class Type_factory__o_g_a_m_c_e_r_s_p_PromoteScreenPopupViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<PromoteScreenPopupViewImpl> { }
  public abstract class Type_factory__o_u_e_w_c_c_a_StencilActionBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<StencilActionBuilder> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_n_TreeNavigator__quals__j_e_i_Any_j_e_i_Default extends Factory<TreeNavigator> { }
  public abstract class Type_factory__o_d_w_s_g_t_GlobalResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default extends Factory<GlobalResourceTypeDefinition> { }
  public abstract class Type_factory__o_o_w_s_s_c_e_PhaseConfigForm__quals__j_e_i_Any_j_e_i_Default extends Factory<PhaseConfigForm> { }
  public abstract class Type_factory__o_g_a_m_c_e_r_s_RepositoryStructureMenu__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoryStructureMenu> { }
  public abstract class Type_factory__o_d_v_d_ElasticSearchDataSetDefValidator__quals__j_e_i_Any_j_e_i_Default extends Factory<ElasticSearchDataSetDefValidator> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_p_FactPatternsPageViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<FactPatternsPageViewImpl> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_u_NewUserAttributeEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<NewUserAttributeEditor> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_j_JPADomainScreenViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<JPADomainScreenViewImpl> { }
  public abstract class Type_factory__o_u_c_w_p_i_MultiListWorkbenchPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<MultiListWorkbenchPanelView> { }
  public abstract class Type_factory__o_u_e_l_e_c_c_c_ColumnWithComponentsView__quals__j_e_i_Any_j_e_i_Default extends Factory<ColumnWithComponentsView> { }
  public abstract class Type_factory__o_d_d_e_g_IntervalBuilderFixedDate__quals__j_e_i_Any_j_e_i_Default extends Factory<IntervalBuilderFixedDate> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_v_JavaFileNameValidator__quals__j_e_i_Any_j_e_i_Default extends Factory<JavaFileNameValidator> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_u_w_UserEditorWorkflow__quals__j_e_i_Any_j_e_i_Default extends Factory<UserEditorWorkflow> { }
  public abstract class Type_factory__o_u_c_m_LockDemandDetector__quals__j_e_i_Any_j_e_i_Default extends Factory<LockDemandDetector> { }
  public abstract class Type_factory__o_u_e_p_e_c_f_ColorField__quals__j_e_i_Any_j_e_i_Default extends Factory<ColorField> { }
  public abstract class Type_factory__o_u_e_w_c_c_p_PaletteScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<PaletteScreenActivity> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_d_DroolsDataObjectEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DroolsDataObjectEditorViewImpl> { }
  public abstract class Type_factory__o_d_d_c_w_RendererSelectorRadioListView__quals__j_e_i_Any_j_e_i_Default extends Factory<RendererSelectorRadioListView> { }
  public abstract class ExtensionProvided_factory__o_u_c_v_p_w_FormLabelHelp__quals__j_e_i_Any_j_e_i_Default extends Factory<FormLabelHelp> { }
  public abstract class Type_factory__o_u_e_w_c_c_CommonsEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<CommonsEntryPoint> { }
  public abstract class Type_factory__o_d_d_c_w_f_TimeAmountEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<TimeAmountEditorView> { }
  public abstract class Type_factory__o_j_d_c_DesignerViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DesignerViewImpl> { }
  public abstract class Type_factory__o_d_d_e_c_s_DataSetDefType__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefType> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_c_c_r_ContainerRulesConfigPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ContainerRulesConfigPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_n_ServerNavigationView__quals__j_e_i_Any_j_e_i_Default extends Factory<ServerNavigationView> { }
  public abstract class Type_factory__o_u_e_s_m_c_s_h_SecurityManagementHomeScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<SecurityManagementHomeScreen> { }
  public abstract class Type_factory__o_u_c_w_p_i_SimpleWorkbenchPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<SimpleWorkbenchPanelView> { }
  public abstract class Type_factory__o_d_w_s_g_t_c_e_GuidedRuleTemplateEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedRuleTemplateEditorPresenter> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_DescriptionColumnConverter__quals__j_e_i_Any_j_e_i_Default extends Factory<DescriptionColumnConverter> { }
  public abstract class Type_factory__o_u_e_s_m_c_s_e_RoleEditorScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<RoleEditorScreen> { }
  public abstract class Type_factory__o_j_c_n_p_c_e_i_l_v_d_DataSetProcessInstanceWithVariablesListViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetProcessInstanceWithVariablesListViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_j_t_JavaResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default extends Factory<JavaResourceTypeDefinition> { }
  public abstract class Type_factory__o_j_d_c_p_ActivityDataIOEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ActivityDataIOEditorViewImpl> { }
  public abstract class Type_factory__o_u_e_s_m_c_s_h_SecurityManagementHomeView__quals__j_e_i_Any_j_e_i_Default extends Factory<SecurityManagementHomeView> { }
  public abstract class Type_factory__o_d_d_c_w_DisplayerError__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayerError> { }
  public abstract class Type_factory__o_d_d_c_w_f_DateParameterEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DateParameterEditorView> { }
  public abstract class Type_factory__o_j_d_c_DesignerPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<DesignerPresenter> { }
  public abstract class Type_factory__o_j_c_n_h_c_e_t_TaskCommentsViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<TaskCommentsViewImpl> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_w_EntityWorkflowViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<EntityWorkflowViewImpl> { }
  public abstract class Type_factory__o_d_c_w_c_ClientRuntimeErrorPopupPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ClientRuntimeErrorPopupPresenter> { }
  public abstract class ContextualProvider_factory__j_e_i_Instance__quals__Universal extends Factory<Instance> { }
  public abstract class ExtensionProvided_factory__c_g_g_u_c_u_HeaderPanel__quals__j_e_i_Any_j_e_i_Default extends Factory<HeaderPanel> { }
  public abstract class Producer_factory__o_d_c_w_d_e_d_ElasticSearchDataSetDefDriver__quals__j_e_i_Any_j_e_i_Default extends Factory<ElasticSearchDataSetDefDriver> { }
  public abstract class Producer_factory__c_g_w_b_e_s_EventBus__quals__j_e_i_Any_j_e_i_Default extends Factory<EventBus> { }
  public abstract class Type_factory__o_u_e_p_c_e_ScreenEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<ScreenEditorView> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_c_DataModelCommandBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<DataModelCommandBuilder> { }
  public abstract class Type_factory__o_j_c_n_p_c_p_ProcessDefinitionsPerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<ProcessDefinitionsPerspective> { }
  public abstract class Type_factory__o_g_c_s_p_c_POMEditorPanel__quals__j_e_i_Any_j_e_i_Default extends Factory<POMEditorPanel> { }
  public abstract class Type_factory__o_u_c_v_p_m_MultiPageEditorViewImpl__quals__j_e_i_Any_o_u_c_w_w_m_Multiple extends Factory<MultiPageEditorViewImpl> { }
  public abstract class Type_factory__o_d_r_c_t_TableDisplayer__quals__j_e_i_Any_j_e_i_Default extends Factory<TableDisplayer> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_n_MultiplePermissionNodeEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<MultiplePermissionNodeEditorView> { }
  public abstract class Type_factory__o_d_w_s_g_t_t_GuidedRuleTemplateResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedRuleTemplateResourceTypeDefinition> { }
  public abstract class Type_factory__o_g_s_c_s_RepositoryController__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoryController> { }
  public abstract class Type_factory__o_k_w_c_s_s_h_c_u_s_EditUserForm__quals__j_e_i_Any_j_e_i_Default extends Factory<EditUserForm> { }
  public abstract class Type_factory__o_d_d_c_PerspectiveCoordinator__quals__j_e_i_Any_j_e_i_Default extends Factory<PerspectiveCoordinator> { }
  public abstract class Type_factory__o_d_r_g_c_GoogleAreaChartDisplayerView__quals__j_e_i_Any_j_e_i_Default extends Factory<GoogleAreaChartDisplayerView> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_c_s_e_ContainerStatusEmptyPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ContainerStatusEmptyPresenter> { }
  public abstract class Type_factory__o_j_e_i_c_a_b_CallerProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<CallerProvider> { }
  public abstract class Type_factory__o_u_c_r_i_PermissionTreeI18NImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<PermissionTreeI18NImpl> { }
  public abstract class Type_factory__o_d_d_c_w_DisplayerSettingsEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayerSettingsEditor> { }
  public abstract class Type_factory__o_j_d_c_DesignerPopUpPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<DesignerPopUpPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_e_KieMetaDataEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<KieMetaDataEditorPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_t_ProjectImportsResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectImportsResourceType> { }
  public abstract class Type_factory__o_d_d_c_w_f_MultipleTextParameterEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<MultipleTextParameterEditor> { }
  public abstract class Type_factory__o_j_e_s_c_l_s_CookieStorageHandlerProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<CookieStorageHandlerProvider> { }
  public abstract class Type_factory__o_k_w_c_s_s_h_c_u_UserHomePageMainPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<UserHomePageMainPresenter> { }
  public abstract class ExtensionProvided_factory__o_j_e_c_c_d_Span__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<Span> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_ActionWorkItemSetFieldColumnConverter__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionWorkItemSetFieldColumnConverter> { }
  public abstract class Type_factory__o_j_c_n_h_c_e_t_TaskCommentsPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<TaskCommentsPresenter> { }
  public abstract class Type_factory__o_u_b_v_i_ObservablePathImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ObservablePathImpl> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_AdvancedDomainEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<AdvancedDomainEditor> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_p_ActionSetFieldsPageViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionSetFieldsPageViewImpl> { }
  public abstract class Type_factory__o_u_e_w_c_g_c_p_WiresGridsDemoPerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<WiresGridsDemoPerspective> { }
  public abstract class Type_factory__o_j_d_r_c_p_DashboardScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<DashboardScreenActivity> { }
  public abstract class Type_factory__o_d_w_s_d_c_e_DecisionTableXLSEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<DecisionTableXLSEditorPresenterActivity> { }
  public abstract class Type_factory__o_k_w_c_s_p_t_ProjectImportsResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectImportsResourceTypeDefinition> { }
  public abstract class Type_factory__o_k_w_c_w_m_c_m_DocumentMenuItemImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DocumentMenuItemImpl> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_a_CreateAnnotationWizard__quals__j_e_i_Any_j_e_i_Default extends Factory<CreateAnnotationWizard> { }
  public abstract class Type_factory__o_u_e_p_c_p_PlugInAuthoringPerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<PlugInAuthoringPerspective> { }
  public abstract class Type_factory__o_k_w_c_s_p_t_KModuleResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default extends Factory<KModuleResourceTypeDefinition> { }
  public abstract class Type_factory__o_d_c_c_e_m_MapEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<MapEditor> { }
  public abstract class Type_factory__o_u_c_v_p_t_UberTabPanel__quals__j_e_i_Any_j_e_i_Default extends Factory<UberTabPanel> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_c_t_LinkTitlePresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<LinkTitlePresenter> { }
  public abstract class Type_factory__o_d_r_g_c_GoogleMeterChartDisplayer__quals__j_e_i_Any_j_e_i_Default extends Factory<GoogleMeterChartDisplayer> { }
  public abstract class Type_factory__o_g_s_c_e_f_FileExplorerViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<FileExplorerViewImpl> { }
  public abstract class Type_factory__o_u_e_p_c_e_EditorPlugInEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<EditorPlugInEditorPresenterActivity> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_h_DomainHandlerRegistry__quals__j_e_i_Any_j_e_i_Default extends Factory<DomainHandlerRegistry> { }
  public abstract class Type_factory__o_u_s_c_SecurityEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<SecurityEntryPoint> { }
  public abstract class Type_factory__o_u_c_s_JSNativeSplashScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<JSNativeSplashScreen> { }
  public abstract class Producer_factory__o_d_c_w_d_e_d_BeanDataSetDefAttributesDriver__quals__j_e_i_Any_j_e_i_Default extends Factory<BeanDataSetDefAttributesDriver> { }
  public abstract class Type_factory__o_k_w_c_s_s_h_c_u_UserHomePageMainPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<UserHomePageMainPresenterActivity> { }
  public abstract class Type_factory__o_d_d_c_DataSetClientServices__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetClientServices> { }
  public abstract class Type_factory__o_j_e_s_c_l_c_SecurityContextImpl_SecurityRolesConstraintPage__quals__j_e_i_Any_j_e_i_Default extends Factory<SecurityRolesConstraintPage> { }
  public abstract class Type_factory__o_g_s_c_a_TreeNavigator__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<org.guvnor.structure.client.advnavigator.TreeNavigator> { }
  public abstract class Type_factory__o_g_a_m_c_e_r_w_p_RepositoryStructurePage__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoryStructurePage> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_UsersExplorer__quals__j_e_i_Any_j_e_i_Default extends Factory<UsersExplorer> { }
  public abstract class Type_factory__o_j_e_d_c_ListComponentProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<ListComponentProvider> { }
  public abstract class Type_factory__o_k_w_c_s_s_c_FindForm__quals__j_e_i_Any_j_e_i_Default extends Factory<FindForm> { }
  public abstract class Type_factory__o_k_w_c_w_m_c_m_SaveAllMenuBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<SaveAllMenuBuilder> { }
  public abstract class Type_factory__o_u_e_p_c_p_e_PerspectiveEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<PerspectiveEditorView> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_e_ServerEmptyPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ServerEmptyPresenter> { }
  public abstract class Type_factory__o_d_w_s_t_c_ScenarioEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<ScenarioEditorPresenterActivity> { }
  public abstract class Type_factory__o_d_d_e_c_s_DataSetDefWizardScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefWizardScreen> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_BRLActionVariableColumnConverter__quals__j_e_i_Any_j_e_i_Default extends Factory<BRLActionVariableColumnConverter> { }
  public abstract class Type_factory__o_u_s_i_a_DefaultPermissionTypeRegistry__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultPermissionTypeRegistry> { }
  public abstract class JsType_factory__o_j_e_e_c_c_JsTypeEventObserver__quals__Universal extends Factory<JsTypeEventObserver> { }
  public abstract class Type_factory__o_d_d_c_e_ClientDateFormatterImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ClientDateFormatterImpl> { }
  public abstract class Type_factory__o_u_c_e_PluginJSExporter__quals__j_e_i_Any_j_e_i_Default extends Factory<PluginJSExporter> { }
  public abstract class ExtensionProvided_factory__o_d_w_s_g_d_c_h_GuidedDecisionTableOptions__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedDecisionTableOptions> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_LimitedEntryBRLConditionColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default extends Factory<LimitedEntryBRLConditionColumnSynchronizer> { }
  public abstract class Type_factory__o_d_d_c_w_f_TimeFrameEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<TimeFrameEditor> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_p_c_DefaultPatternCell__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultPatternCell> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_e_ProjectScreenPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<ProjectScreenPresenterActivity> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_p_ColumnExpansionPageViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ColumnExpansionPageViewImpl> { }
  public abstract class Type_factory__o_d_w_s_t_c_r_TestRunnerReportingScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<TestRunnerReportingScreen> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_KModuleEditorPanelViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<KModuleEditorPanelViewImpl> { }
  public abstract class Type_factory__o_d_c_w_d_e_w_DataSetEditorWorkflowFactory__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetEditorWorkflowFactory> { }
  public abstract class Type_factory__o_j_c_n_p_c_e_d_d_m_b_BasicProcessDefDetailsMultiViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<BasicProcessDefDetailsMultiViewImpl> { }
  public abstract class Producer_factory__o_j_e_u_n_c_l_URLPatternMatcher__quals__j_e_i_Any_j_e_i_Default extends Factory<URLPatternMatcher> { }
  public abstract class ExtensionProvided_factory__o_g_c_u_h_Paragraph__quals__j_e_i_Any_j_e_i_Default extends Factory<Paragraph> { }
  public abstract class Type_factory__o_u_c_d_UberfireDocksImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<UberfireDocksImpl> { }
  public abstract class Type_factory__o_d_c_w_d_e_DataSetDefFilterEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefFilterEditor> { }
  public abstract class Type_factory__o_j_c_n_h_f_c_d_d_t_FTLTaskDisplayerImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<FTLTaskDisplayerImpl> { }
  public abstract class Type_factory__o_u_c_w_p_i_SimpleDnDWorkbenchPanelPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<SimpleDnDWorkbenchPanelPresenter> { }
  public abstract class ExtensionProvided_factory__c_g_g_u_c_u_Frame__quals__j_e_i_Any_j_e_i_Default extends Factory<Frame> { }
  public abstract class Type_factory__o_d_r_g_c_GoogleLineChartDisplayerView__quals__j_e_i_Any_j_e_i_Default extends Factory<GoogleLineChartDisplayerView> { }
  public abstract class Type_factory__o_j_d_c_t_Bpmn2Type__quals__j_e_i_Any_j_e_i_Default extends Factory<Bpmn2Type> { }
  public abstract class Type_factory__o_d_c_c_e_f_FileUploadEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<FileUploadEditor> { }
  public abstract class Type_factory__o_u_e_w_c_c_d_LiveSearchDropDown__quals__j_e_i_Any_j_e_i_Default extends Factory<LiveSearchDropDown> { }
  public abstract class Type_factory__o_g_a_m_c_e_f_e_DisplayErrorPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<DisplayErrorPresenterActivity> { }
  public abstract class Type_factory__o_u_e_s_m_c_s_h_SecurityManagementHomeScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<SecurityManagementHomeScreenActivity> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_c_e_ServerContainerEmptyView__quals__j_e_i_Any_j_e_i_Default extends Factory<ServerContainerEmptyView> { }
  public abstract class Type_factory__o_d_w_s_d_c_t_DRLResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<DRLResourceType> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_GuidedDecisionTableModellerViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedDecisionTableModellerViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_ExplorerViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ExplorerViewImpl> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_p_ActionSetFieldsPage__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionSetFieldsPage> { }
  public abstract class Type_factory__o_j_e_v_c_ValidatorProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<ValidatorProvider> { }
  public abstract class Type_factory__o_j_c_n_b_c_e_d_l_DeploymentUnitsListPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<DeploymentUnitsListPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_d_DependencyGridViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DependencyGridViewImpl> { }
  public abstract class Type_factory__o_u_c_w_p_i_MultiTabWorkbenchPanelPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<MultiTabWorkbenchPanelPresenter> { }
  public abstract class Type_factory__o_g_a_m_c_p_AssetManagementPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<AssetManagementPerspectiveActivity> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_e_KieMetaDataEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<KieMetaDataEditorPresenterActivity> { }
  public abstract class Type_factory__o_j_c_n_d_c_p_f_TimeAmountEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<TimeAmountEditor> { }
  public abstract class Type_factory__o_k_w_c_w_c_d_AsyncPackageDataModelOracleFactory__quals__j_e_i_Any_j_e_i_Default extends Factory<AsyncPackageDataModelOracleFactory> { }
  public abstract class Type_factory__o_d_d_c_DisplayerScreenPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<DisplayerScreenPresenterActivity> { }
  public abstract class ContextualProvider_factory__o_j_e_i_c_a_Disposer__quals__Universal extends Factory<Disposer> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_p_ErrorBox__quals__j_e_i_Any_j_e_i_Default extends Factory<ErrorBox> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_v_g_GenericValuePairEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<GenericValuePairEditorViewImpl> { }
  public abstract class ContextualProvider_factory__o_j_e_d_c_c_ListComponent__quals__Universal extends Factory<ListComponent> { }
  public abstract class Type_factory__o_u_c_w_p_i_SplitLayoutPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<SplitLayoutPanelView> { }
  public abstract class Type_factory__o_u_e_e_c_c_m_BasicFileMenuBuilderImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<BasicFileMenuBuilderImpl> { }
  public abstract class Type_factory__o_d_w_s_d_t_DSLResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default extends Factory<DSLResourceTypeDefinition> { }
  public abstract class Type_factory__o_k_w_c_s_s_h_c_u_UserHomePagePerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<UserHomePagePerspective> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_v_ValuePairEditorPopupViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ValuePairEditorPopupViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_m_MainDataObjectFieldEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<MainDataObjectFieldEditorViewImpl> { }
  public abstract class Type_factory__o_u_e_w_c_c_w_w_p_a_n_ActivityNotFoundView__quals__j_e_i_Any_j_e_i_Default extends Factory<ActivityNotFoundView> { }
  public abstract class Type_factory__o_d_c_w_d_e_e_ElasticSearchDataSetEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<ElasticSearchDataSetEditor> { }
  public abstract class Type_factory__o_k_w_c_s_s_h_c_SocialHomePageEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<SocialHomePageEntryPoint> { }
  public abstract class Type_factory__o_u_c_m_PlaceHistoryHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<PlaceHistoryHandler> { }
  public abstract class ExtensionProvided_factory__o_k_w_c_s_s_m_c_w_NumericTextBox__quals__j_e_i_Any_j_e_i_Default extends Factory<NumericTextBox> { }
  public abstract class ExtensionProvided_factory__o_j_e_c_c_d_Select__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<Select> { }
  public abstract class Type_factory__o_j_c_n_g_f_c_d_s_FormDisplayPerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<FormDisplayPerspective> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_PackageNameFormPopupViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<PackageNameFormPopupViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_s_h_c_h_DefaultSocialLinkCommandGenerator__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultSocialLinkCommandGenerator> { }
  public abstract class Type_factory__o_u_e_l_e_c_c_c_ComponentColumn__quals__j_e_i_Any_j_e_i_Default extends Factory<ComponentColumn> { }
  public abstract class ContextualProvider_factory__o_j_e_u_n_c_l_TransitionToRole__quals__Universal extends Factory<TransitionToRole> { }
  public abstract class Type_factory__o_k_w_c_s_c_c_s_ContributorsViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ContributorsViewImpl> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_MetaDataColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default extends Factory<MetaDataColumnSynchronizer> { }
  public abstract class Producer_factory__o_j_e_c_c_d_Document__quals__j_e_i_Any_j_e_i_Default extends Factory<Document> { }
  public abstract class Producer_factory__o_d_c_w_d_e_d_DataSetDefBasicAttributesDriver__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefBasicAttributesDriver> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_AssignedEntitiesInlineEditorView__quals__j_e_i_Any_o_u_e_s_m_c_w_m_e_AssignedEntitiesInlineEditor extends Factory<AssignedEntitiesInlineEditorView> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_c_NewContainerFormPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<NewContainerFormPresenter> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_LimitedEntryBRLActionColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default extends Factory<LimitedEntryBRLActionColumnSynchronizer> { }
  public abstract class ExtensionProvided_factory__c_g_g_u_c_u_Button__quals__j_e_i_Any_j_e_i_Default extends Factory<Button> { }
  public abstract class Type_factory__o_u_e_l_e_c_i_DragHelperComponentColumn__quals__j_e_i_Any_j_e_i_Default extends Factory<DragHelperComponentColumn> { }
  public abstract class Type_factory__o_k_w_c_w_c_p_a_AlertPopupViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<AlertPopupViewImpl> { }
  public abstract class Type_factory__o_j_e_i_c_WindowInjectionContext__quals__j_e_i_Any_j_e_i_Default extends Factory<WindowInjectionContext> { }
  public abstract class ExtensionProvided_factory__o_j_e_c_c_d_Anchor__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<Anchor> { }
  public abstract class Type_factory__o_u_e_p_e_c_PropertyEditorWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<PropertyEditorWidget> { }
  public abstract class Type_factory__o_k_w_c_p_DroolsAuthoringNoContextNavigationPerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<DroolsAuthoringNoContextNavigationPerspective> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_LimitedEntryColumnConverter__quals__j_e_i_Any_j_e_i_Default extends Factory<LimitedEntryColumnConverter> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_BRLActionColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default extends Factory<BRLActionColumnSynchronizer> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_ModelSynchronizerImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ModelSynchronizerImpl> { }
  public abstract class Type_factory__o_k_w_c_s_s_h_c_u_UserHomePageSidePresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<UserHomePageSidePresenterActivity> { }
  public abstract class Type_factory__o_u_c_v_p_m_UserMenuViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<UserMenuViewImpl> { }
  public abstract class Type_factory__o_d_w_s_d_c_h_NewDslTextHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<NewDslTextHandler> { }
  public abstract class Type_factory__o_d_r_g_c_GoogleAreaChartDisplayer__quals__j_e_i_Any_j_e_i_Default extends Factory<GoogleAreaChartDisplayer> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_AssignedEntitiesModalEditorView__quals__j_e_i_Any_o_u_e_s_m_c_w_m_e_AssignedEntitiesModalEditor extends Factory<AssignedEntitiesModalEditorView> { }
  public abstract class ExtensionProvided_factory__o_d_w_s_g_c_e_AddGlobalPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<AddGlobalPopup> { }
  public abstract class Type_factory__o_d_r_g_c_GoogleLineChartDisplayer__quals__j_e_i_Any_j_e_i_Default extends Factory<GoogleLineChartDisplayer> { }
  public abstract class ExtensionProvided_factory__o_u_c_v_p_w_HelpIcon__quals__j_e_i_Any_j_e_i_Default extends Factory<HelpIcon> { }
  public abstract class Type_factory__o_u_c_w_p_i_LayoutPanelPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<LayoutPanelPresenter> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_GuidedDecisionTreeWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedDecisionTreeWidget> { }
  public abstract class Type_factory__o_k_w_c_p_DroolsAuthoringPerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<DroolsAuthoringPerspective> { }
  public abstract class Type_factory__o_j_c_n_p_c_e_i_l_v_d_DataSetProcessInstanceWithVariablesListPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<DataSetProcessInstanceWithVariablesListPresenterActivity> { }
  public abstract class Type_factory__o_u_c_a_DefaultWorkbenchController__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultWorkbenchController> { }
  public abstract class ExtensionProvided_factory__o_s_Logger__quals__Universal_2 extends Factory<Logger> { }
  public abstract class ExtensionProvided_factory__o_s_Logger__quals__Universal_1 extends Factory<Logger> { }
  public abstract class ExtensionProvided_factory__o_s_Logger__quals__Universal_4 extends Factory<Logger> { }
  public abstract class ExtensionProvided_factory__o_s_Logger__quals__Universal_3 extends Factory<Logger> { }
  public abstract class ExtensionProvided_factory__o_s_Logger__quals__Universal_6 extends Factory<Logger> { }
  public abstract class ExtensionProvided_factory__o_s_Logger__quals__Universal_5 extends Factory<Logger> { }
  public abstract class ExtensionProvided_factory__o_s_Logger__quals__Universal_8 extends Factory<Logger> { }
  public abstract class ExtensionProvided_factory__o_s_Logger__quals__Universal_7 extends Factory<Logger> { }
  public abstract class ExtensionProvided_factory__o_s_Logger__quals__Universal_9 extends Factory<Logger> { }
  public abstract class Type_factory__o_d_d_e_c_p_DataSetAuthoringPerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetAuthoringPerspective> { }
  public abstract class Type_factory__o_j_c_n_p_f_c_d_s_StandaloneProcessFormDisplayScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<StandaloneProcessFormDisplayScreen> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_n_MultiplePermissionNodeEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<MultiplePermissionNodeEditor> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_n_ServerNavigationPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ServerNavigationPresenter> { }
  public abstract class ExtensionProvided_factory__o_s_Logger__quals__Universal extends Factory<Logger> { }
  public abstract class Type_factory__o_u_c_m_PlaceRequestHistoryMapperImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<PlaceRequestHistoryMapperImpl> { }
  public abstract class ExtensionProvided_factory__o_g_c_u_LinkedGroup__quals__j_e_i_Any_j_e_i_Default extends Factory<LinkedGroup> { }
  public abstract class Type_factory__o_j_c_n_p_c_e_d_d_m_a_AdvancedProcessDefDetailsMultiPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<AdvancedProcessDefDetailsMultiPresenterActivity> { }
  public abstract class Type_factory__o_j_c_n_h_c_p_DroolsTasksListPerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<DroolsTasksListPerspective> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_m_RowContextMenu__quals__j_e_i_Any_j_e_i_Default extends Factory<RowContextMenu> { }
  public abstract class Type_factory__o_k_w_c_n_LogoWidgetView__quals__j_e_i_Any_j_e_i_Default extends Factory<LogoWidgetView> { }
  public abstract class Type_factory__o_j_e_u_c_w_ListWidgetProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<ListWidgetProvider> { }
  public abstract class Type_factory__o_u_e_w_c_c_s_i_IFrameScreenView__quals__j_e_i_Any_j_e_i_Default extends Factory<IFrameScreenView> { }
  public abstract class Type_factory__o_u_e_w_c_c_p_StencilPaletteBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<StencilPaletteBuilder> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_NewGuidedDecisionTableWizard__quals__j_e_i_Any_j_e_i_Default extends Factory<NewGuidedDecisionTableWizard> { }
  public abstract class Type_factory__o_u_e_w_c_c_s_i_IFrameScreenPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<IFrameScreenPresenterActivity> { }
  public abstract class Type_factory__o_u_e_w_c_c_p_DoubleValidator__quals__j_e_i_Any_j_e_i_Default extends Factory<DoubleValidator> { }
  public abstract class Type_factory__o_u_c_v_p_m_Bs3Modal__quals__j_e_i_Any_j_e_i_Default extends Factory<Bs3Modal> { }
  public abstract class Type_factory__o_u_e_e_c_c_f_RestoreUtil__quals__j_e_i_Any_j_e_i_Default extends Factory<RestoreUtil> { }
  public abstract class Type_factory__o_d_d_c_w_g_ColumnFunctionEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<ColumnFunctionEditorView> { }
  public abstract class Type_factory__o_k_w_c_s_c_c_s_ContributorsScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<ContributorsScreenActivity> { }
  public abstract class Type_factory__o_u_e_l_e_c_c_c_ContainerView__quals__j_e_i_Any_j_e_i_Default extends Factory<ContainerView> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_h_j_c_JPACommandBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<JPACommandBuilder> { }
  public abstract class Type_factory__o_d_w_s_d_c_e_DecisionTableXLSEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<DecisionTableXLSEditorPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_a_SearchAnnotationPageViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<SearchAnnotationPageViewImpl> { }
  public abstract class Type_factory__o_d_c_c_e_l_HorizImageListEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<HorizImageListEditorView> { }
  public abstract class Type_factory__o_g_a_m_c_e_f_r_RequiresReworkViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<RequiresReworkViewImpl> { }
  public abstract class Provider_factory__j_v_Validator__quals__j_e_i_Any_j_e_i_Default extends Factory<Validator> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_m_EditMenuViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<EditMenuViewImpl> { }
  public abstract class Type_factory__o_u_c_w_LayoutSelection__quals__j_e_i_Any_j_e_i_Default extends Factory<LayoutSelection> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_c_ContainerView__quals__j_e_i_Any_j_e_i_Default extends Factory<org.kie.workbench.common.screens.server.management.client.container.ContainerView> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_PomEditorScreenPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<PomEditorScreenPresenterActivity> { }
  public abstract class Type_factory__o_u_e_w_c_t_c_p_WiresTreesPaletteScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<WiresTreesPaletteScreen> { }
  public abstract class Type_factory__o_d_d_c_w_DisplayerEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayerEditor> { }
  public abstract class Type_factory__o_j_f_e_c_e_FormModelerPanelPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<FormModelerPanelPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_s_h_c_u_UserHomePageSidePresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<UserHomePageSidePresenter> { }
  public abstract class Type_factory__o_u_e_w_c_c_CoreEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<CoreEntryPoint> { }
  public abstract class Type_factory__o_u_e_p_e_c_f_SecretTextField__quals__j_e_i_Any_j_e_i_Default extends Factory<SecretTextField> { }
  public abstract class Type_factory__o_u_e_e_c_c_h_VersionMenuDropDownButtonViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<VersionMenuDropDownButtonViewImpl> { }
  public abstract class Type_factory__o_u_e_e_c_c_h_VersionHistoryPresenterViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<VersionHistoryPresenterViewImpl> { }
  public abstract class Type_factory__o_d_w_s_s_t_ScoreCardXLSResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default extends Factory<ScoreCardXLSResourceTypeDefinition> { }
  public abstract class Type_factory__o_j_c_n_h_c_e_t_TaskDetailsViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<TaskDetailsViewImpl> { }
  public abstract class Type_factory__o_d_c_w_d_e_DataSetDefFilterEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefFilterEditorView> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_e_ProjectScreenPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectScreenPresenter> { }
  public abstract class Type_factory__o_j_e_i_c_a_b_IOCBeanManagerProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<IOCBeanManagerProvider> { }
  public abstract class ExtensionProvided_factory__o_j_c_n_w_c_e_d_d_DDParametersPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<DDParametersPopup> { }
  public abstract class ExtensionProvided_factory__o_u_c_w_w_l_ResizeFlowPanel__quals__j_e_i_Any_j_e_i_Default extends Factory<ResizeFlowPanel> { }
  public abstract class Type_factory__o_j_c_n_p_c_e_v_h_VariableHistoryPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<VariableHistoryPopup> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_WorkItemHandlersPanel__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkItemHandlersPanel> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_p_ErrorBoxView__quals__j_e_i_Any_j_e_i_Default extends Factory<ErrorBoxView> { }
  public abstract class Type_factory__o_j_c_n_h_f_m_c_e_t_d_FormModellerStartProcessDisplayerImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<FormModellerStartProcessDisplayerImpl> { }
  public abstract class Type_factory__o_u_c_e_JSNativeEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<JSNativeEditor> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_ActionWorkItemColumnConverter__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionWorkItemColumnConverter> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_BRLConditionColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default extends Factory<BRLConditionColumnSynchronizer> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_e_KieTextEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<KieTextEditorViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_s_h_c_h_m_MainPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<MainPresenter> { }
  public abstract class Type_factory__o_j_d_c_p_ActivityDataIOEditorWidgetViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ActivityDataIOEditorWidgetViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_h_c_p_HomePerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<HomePerspectiveActivity> { }
  public abstract class Type_factory__o_d_r_g_c_GoogleTableDisplayer__quals__j_e_i_Any_j_e_i_Default extends Factory<GoogleTableDisplayer> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_h_NewPackageHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<NewPackageHandler> { }
  public abstract class Type_factory__o_k_w_c_w_m_c_m_SaveAllMenuViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<SaveAllMenuViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_c_p_ProcessConfigPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ProcessConfigPresenter> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_GuidedDecisionTableEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedDecisionTableEditorViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_MessageConsoleWhiteListImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<MessageConsoleWhiteListImpl> { }
  public abstract class Type_factory__o_u_c_m_ActivityLifecycleErrorHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<ActivityLifecycleErrorHandler> { }
  public abstract class Type_factory__o_k_w_c_s_s_h_c_u_s_SideUserInfoPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<SideUserInfoPresenter> { }
  public abstract class ExtensionProvided_factory__o_j_e_c_c_d_TextInput__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<TextInput> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_j_JPADataObjectEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<JPADataObjectEditor> { }
  public abstract class Type_factory__o_j_e_i_s_b_c_RequestDispatcherProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<RequestDispatcherProvider> { }
  public abstract class Type_factory__o_d_c_w_d_e_w_DataSetEditorWorkflowView__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetEditorWorkflowView> { }
  public abstract class Type_factory__o_u_e_p_e_c_f_ComboField__quals__j_e_i_Any_j_e_i_Default extends Factory<ComboField> { }
  public abstract class Type_factory__o_u_s_c_a_t_i_DefaultPermissionTreeFactory__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultPermissionTreeFactory> { }
  public abstract class Type_factory__o_u_c_m_ActivityBeansCache__quals__j_e_i_Any_j_e_i_Default extends Factory<ActivityBeansCache> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_u_KiePOMDefaultOptions__quals__j_e_i_Any_j_e_i_Default extends Factory<KiePOMDefaultOptions> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_n_t_c_CopyPopupView__quals__j_e_i_Any_j_e_i_Default extends Factory<CopyPopupView> { }
  public abstract class Type_factory__o_d_c_w_d_e_c_DataColumnDefEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DataColumnDefEditorView> { }
  public abstract class ExtensionProvided_factory__o_u_e_w_c_c_e_d_DefaultEditorNewFileUpload__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultEditorNewFileUpload> { }
  public abstract class Type_factory__o_d_w_s_g_s_c_t_GuidedScoreCardResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedScoreCardResourceType> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_t_KModuleResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<KModuleResourceType> { }
  public abstract class Type_factory__o_j_d_c_p_DesignerEditorParametersPublisherViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DesignerEditorParametersPublisherViewImpl> { }
  public abstract class Type_factory__o_u_e_p_c_w_p_NewPluginPopUpViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<NewPluginPopUpViewImpl> { }
  public abstract class Type_factory__o_k_w_c_w_c_c_w_u_ImportsWidgetPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ImportsWidgetPresenter> { }
  public abstract class Type_factory__o_d_w_s_g_t_c_h_NewGuidedRuleTemplateHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<NewGuidedRuleTemplateHandler> { }
  public abstract class Type_factory__o_j_e_i_s_b_c_MessageBusProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<MessageBusProvider> { }
  public abstract class Type_factory__o_u_c_v_p_m_MultiPageEditorImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<MultiPageEditorImpl> { }
  public abstract class Type_factory__o_j_c_n_g_c_p_ExperimentalPagingPerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<ExperimentalPagingPerspective> { }
  public abstract class Type_factory__o_j_e_i_s_b_c_SenderProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<SenderProvider> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_p_p_ProjectPageViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectPageViewImpl> { }
  public abstract class Type_factory__o_u_e_l_e_c_i_LayoutDragComponentHelper__quals__j_e_i_Any_j_e_i_Default extends Factory<LayoutDragComponentHelper> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_c_t_InfoTitleView__quals__j_e_i_Any_j_e_i_Default extends Factory<InfoTitleView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_t_GuidedDTreeResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedDTreeResourceType> { }
  public abstract class Type_factory__o_j_c_n_g_f_c_d_d_u_PlaceManagerFormActivitySearcher__quals__j_e_i_Any_j_e_i_Default extends Factory<PlaceManagerFormActivitySearcher> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_l_i_DefaultGuidedDecisionTableLinkManager__quals__j_e_i_Any_o_d_w_s_g_d_c_GuidedDecisionTable extends Factory<DefaultGuidedDecisionTableLinkManager> { }
  public abstract class Type_factory__o_u_e_l_e_c_LayoutEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<LayoutEditorView> { }
  public abstract class Type_factory__o_u_c_v_p_l_ListBarWidgetImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ListBarWidgetImpl> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_a_ValuePairEditorPageViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ValuePairEditorPageViewImpl> { }
  public abstract class Type_factory__o_u_c_m_WorkbenchViewModeSwitcherPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchViewModeSwitcherPresenter> { }
  public abstract class Type_factory__o_g_c_s_p_c_t_POMResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<POMResourceType> { }
  public abstract class Type_factory__o_d_w_s_d_c_e_DRLEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<DRLEditorPresenterActivity> { }
  public abstract class Type_factory__o_g_a_m_c_p_AssetManagementPerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<AssetManagementPerspective> { }
  public abstract class Type_factory__o_d_d_e_c_s_DataSetAuthoringHomePresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetAuthoringHomePresenter> { }
  public abstract class ExtensionProvided_factory__o_g_c_u_h_Span__quals__j_e_i_Any_j_e_i_Default extends Factory<org.gwtbootstrap3.client.ui.html.Span> { }
  public abstract class Producer_factory__o_d_c_w_d_e_d_SQLDataSetDefAttributesDriver__quals__j_e_i_Any_j_e_i_Default extends Factory<SQLDataSetDefAttributesDriver> { }
  public abstract class ExtensionProvided_factory__o_g_o_m_c_e_p_EditOrganizationalUnitPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<EditOrganizationalUnitPopup> { }
  public abstract class Type_factory__o_d_d_c_w_f_DataSetFilterEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetFilterEditorView> { }
  public abstract class Type_factory__o_u_e_a_c_h_AppsHomePresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<AppsHomePresenter> { }
  public abstract class Type_factory__o_g_a_m_c_e_p_s_w_RepositoryStructureDataPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoryStructureDataPresenter> { }
  public abstract class Type_factory__o_u_e_w_c_c_t_FilterPagedTable__quals__j_e_i_Any_j_e_i_Default extends Factory<FilterPagedTable> { }
  public abstract class Type_factory__o_o_w_s_s_c_t_SolverResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<SolverResourceType> { }
  public abstract class Type_factory__o_u_c_v_p_m_UtilityMenuBarView__quals__j_e_i_Any_j_e_i_Default extends Factory<UtilityMenuBarView> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_h_a_AdvancedDomainHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<AdvancedDomainHandler> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_KModuleEditorPanel__quals__j_e_i_Any_j_e_i_Default extends Factory<KModuleEditorPanel> { }
  public abstract class Type_factory__o_d_d_c_w_DataSetLookupEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetLookupEditor> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_r_RemotePresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<RemotePresenter> { }
  public abstract class ContextualProvider_factory__o_j_e_u_c_w_ListWidget__quals__Universal extends Factory<ListWidget> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_u_UserEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<UserEditorView> { }
  public abstract class Type_factory__o_g_m_c_u_UploadFormPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<UploadFormPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_s_h_c_h_SocialHomePageMainView__quals__j_e_i_Any_j_e_i_Default extends Factory<SocialHomePageMainView> { }
  public abstract class Type_factory__o_d_c_c_w_AlertPanelView__quals__j_e_i_Any_j_e_i_Default extends Factory<AlertPanelView> { }
  public abstract class ExtensionProvided_factory__o_g_o_m_c_e_p_AddOrganizationalUnitPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<AddOrganizationalUnitPopup> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_ListenersPanelViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ListenersPanelViewImpl> { }
  public abstract class Type_factory__o_g_m_c_M2RepoEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<M2RepoEditorPresenter> { }
  public abstract class Type_factory__o_d_w_s_g_s_c_e_GuidedScoreCardEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedScoreCardEditorViewImpl> { }
  public abstract class Type_factory__o_u_e_s_m_c_s_e_SecurityExplorerScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<SecurityExplorerScreenActivity> { }
  public abstract class Type_factory__o_j_c_n_d_c_f_FilterSettingsJSONMarshaller__quals__j_e_i_Any_j_e_i_Default extends Factory<FilterSettingsJSONMarshaller> { }
  public abstract class Type_factory__o_k_w_c_w_m_c_p_SelectDocumentPopupViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<SelectDocumentPopupViewImpl> { }
  public abstract class Type_factory__o_j_c_n_p_f_c_e_q_QuickNewProcessInstancePopup__quals__j_e_i_Any_j_e_i_Default extends Factory<QuickNewProcessInstancePopup> { }
  public abstract class Type_factory__o_d_w_s_d_t_DSLRResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default extends Factory<DSLRResourceTypeDefinition> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_n_LeafPermissionNodeViewerView__quals__j_e_i_Any_j_e_i_Default extends Factory<LeafPermissionNodeViewerView> { }
  public abstract class Type_factory__o_d_c_w_d_e_c_CSVDataSetDefAttributesEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<CSVDataSetDefAttributesEditorView> { }
  public abstract class Type_factory__o_j_c_n_p_c_p_DataSetProcessInstancesWithVariablesPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<DataSetProcessInstancesWithVariablesPerspectiveActivity> { }
  public abstract class Type_factory__o_u_c_w_p_i_SplitLayoutPanelPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<SplitLayoutPanelPresenter> { }
  public abstract class Type_factory__o_j_c_n_h_c_e_t_g_DroolsTasksListGridPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<DroolsTasksListGridPresenterActivity> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_a_AdvancedAnnotationListEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<AdvancedAnnotationListEditor> { }
  public abstract class Type_factory__o_u_e_w_c_c_e_d_DefaultFileEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultFileEditorView> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_d_DroolsDomainEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DroolsDomainEditor> { }
  public abstract class Type_factory__o_d_c_w_d_e_e_ElasticSearchDataSetDefAttributesEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<ElasticSearchDataSetDefAttributesEditor> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_e_KieTextEditorScreenPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<KieTextEditorScreenPresenter> { }
  public abstract class Type_factory__o_d_d_j_DisplayerSettingsJSONMarshaller__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayerSettingsJSONMarshaller> { }
  public abstract class Type_factory__o_j_c_n_p_c_e_i_d_m_ProcessInstanceDetailsMultiPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<ProcessInstanceDetailsMultiPresenterActivity> { }
  public abstract class JsType_factory__o_j_e_e_c_c_WindowEventObservers__quals__Universal extends Factory<WindowEventObservers> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_n_LeafPermissionNodeViewer__quals__j_e_i_Any_j_e_i_Default extends Factory<LeafPermissionNodeViewer> { }
  public abstract class Type_factory__o_k_w_c_s_s_h_c_u_m_MainPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<org.kie.workbench.common.screens.social.hp.client.userpage.main.MainPresenter> { }
  public abstract class Type_factory__o_u_c_w_w_d_WorkbenchPickupDragController__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchPickupDragController> { }
  public abstract class Type_factory__o_j_d_c_u_ComboBox__quals__j_e_i_Any_j_e_i_Default extends Factory<ComboBox> { }
  public abstract class Type_factory__o_d_c_c_e_l_DropDownImageListEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DropDownImageListEditorView> { }
  public abstract class Type_factory__o_k_w_c_s_h_c_w_h_HomeViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<HomeViewImpl> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_p_ImportsPageViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ImportsPageViewImpl> { }
  public abstract class Type_factory__o_u_e_a_c_AppsPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<AppsPerspectiveActivity> { }
  public abstract class Type_factory__o_d_c_w_d_e_DataSetDefProviderTypeEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefProviderTypeEditor> { }
  public abstract class Type_factory__o_u_e_w_c_c_e_t_TextResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<TextResourceType> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_ExplorerPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ExplorerPresenter> { }
  public abstract class Type_factory__o_k_w_c_w_c_c_w_b_ImportsWidgetPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<org.kie.workbench.common.widgets.configresource.client.widget.bound.ImportsWidgetPresenter> { }
  public abstract class Type_factory__o_j_c_n_h_c_e_t_TaskFormPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<TaskFormPresenter> { }
  public abstract class Type_factory__o_d_d_c_w_DataSetLookupEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetLookupEditorView> { }
  public abstract class Type_factory__o_j_c_n_p_c_e_d_d_m_b_BasicProcessDefDetailsMultiPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<BasicProcessDefDetailsMultiPresenterActivity> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_h_d_DroolsDomainHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<DroolsDomainHandler> { }
  public abstract class Type_factory__o_o_w_s_s_c_e_ScoreDirectorFactoryFormViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ScoreDirectorFactoryFormViewImpl> { }
  public abstract class Type_factory__o_d_r_c_s_SelectorDisplayer__quals__j_e_i_Any_j_e_i_Default extends Factory<SelectorDisplayer> { }
  public abstract class Type_factory__o_k_w_c_s_j_c_e_JavaSourceViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<JavaSourceViewImpl> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_g_GroupEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<GroupEditor> { }
  public abstract class Type_factory__o_u_e_p_c_w_p_NewPluginPopUp__quals__j_e_i_Any_j_e_i_Default extends Factory<NewPluginPopUp> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_RowNumberColumnConverter__quals__j_e_i_Any_j_e_i_Default extends Factory<RowNumberColumnConverter> { }
  public abstract class Type_factory__o_j_c_n_h_c_e_t_TaskAdminPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<TaskAdminPresenter> { }
  public abstract class Type_factory__o_u_e_p_c_p_e_PerspectiveEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<PerspectiveEditorPresenterActivity> { }
  public abstract class Type_factory__o_g_a_m_c_e_b_BuildConfigurationPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<BuildConfigurationPresenterActivity> { }
  public abstract class ExtensionProvided_factory__o_j_e_c_c_d_Div__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<Div> { }
  public abstract class Type_factory__o_j_c_n_p_c_e_d_l_ProcessDocumentListPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ProcessDocumentListPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_ExplorerEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<ExplorerEntryPoint> { }
  public abstract class Type_factory__o_k_w_c_w_c_m_FileMenuBuilderImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<FileMenuBuilderImpl> { }
  public abstract class Type_factory__o_k_w_c_s_j_c_e_JavaEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<JavaEditorPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_j_p_RelationshipField__quals__j_e_i_Any_j_e_i_Default extends Factory<RelationshipField> { }
  public abstract class Type_factory__o_d_c_w_d_e_w_e_ElasticSearchDataSetEditWorkflow__quals__j_e_i_Any_j_e_i_Default extends Factory<ElasticSearchDataSetEditWorkflow> { }
  public abstract class Type_factory__o_d_c_w_d_e_DataSetDefColumnsFilterEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefColumnsFilterEditor> { }
  public abstract class Type_factory__o_k_w_c_w_m_c_w_OverviewWidgetPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<OverviewWidgetPresenter> { }
  public abstract class Type_factory__o_d_d_c_e_ClientIntervalBuilderDynamicDate__quals__j_e_i_Any_j_e_i_Default extends Factory<ClientIntervalBuilderDynamicDate> { }
  public abstract class ExtensionProvided_factory__o_g_c_u_Legend__quals__j_e_i_Any_j_e_i_Default extends Factory<Legend> { }
  public abstract class Type_factory__o_j_c_n_p_c_e_i_d_ProcessInstanceDetailsPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ProcessInstanceDetailsPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_r_RepositoriesWidgetPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoriesWidgetPresenter> { }
  public abstract class Type_factory__o_u_c_JSEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<JSEntryPoint> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_p_o_OUPage__quals__j_e_i_Any_j_e_i_Default extends Factory<OUPage> { }
  public abstract class Type_factory__o_d_w_s_g_c_h_NewGlobalHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<NewGlobalHandler> { }
  public abstract class Type_factory__o_k_w_c_s_c_c_p_ContributorsPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<ContributorsPerspectiveActivity> { }
  public abstract class Producer_factory__o_j_e_s_s_a_i_User__quals__j_e_i_Any_j_e_i_Default extends Factory<User> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_p_r_RepositoryPageViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoryPageViewImpl> { }
  public abstract class Type_factory__o_j_e_d_c_DataBinderProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<DataBinderProvider> { }
  public abstract class Type_factory__o_j_e_u_n_c_l_PageTransitionProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<PageTransitionProvider> { }
  public abstract class Type_factory__o_u_c_w_p_n_p_WorkbenchPartPresenterDefault__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchPartPresenterDefault> { }
  public abstract class Type_factory__o_u_e_a_c_AppsPerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<AppsPerspective> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_j_JPADataObjectFieldEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<JPADataObjectFieldEditorViewImpl> { }
  public abstract class Type_factory__o_d_w_s_t_c_r_TestRunnerReportingViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<TestRunnerReportingViewImpl> { }
  public abstract class Type_factory__o_u_c_v_p_m_WorkbenchMenuCompactNavBarView__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchMenuCompactNavBarView> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_n_t_ServerTemplateView__quals__j_e_i_Any_j_e_i_Default extends Factory<ServerTemplateView> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_t_TechnicalViewWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<TechnicalViewWidget> { }
  public abstract class ExtensionProvided_factory__o_g_c_u_TextArea__quals__j_e_i_Any_j_e_i_Default extends Factory<org.gwtbootstrap3.client.ui.TextArea> { }
  public abstract class Type_factory__o_d_d_c_p_DisplayerPrototypes__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayerPrototypes> { }
  public abstract class Type_factory__o_g_a_m_c_e_p_PromoteChangesPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<PromoteChangesPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_p_p_ProjectPage__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectPage> { }
  public abstract class Type_factory__o_u_c_v_p_p_PopupViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<PopupViewImpl> { }
  public abstract class Type_factory__o_d_w_s_g_t_c_GuidedRuleTemplateEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedRuleTemplateEntryPoint> { }
  public abstract class Type_factory__o_j_e_e_c_c_JsTypeEventObserver__quals__j_e_i_Any_j_e_i_Default extends Factory<JsTypeEventObserver> { }
  public abstract class Type_factory__o_u_e_l_e_c_c_c_ColumnWithComponents__quals__j_e_i_Any_j_e_i_Default extends Factory<ColumnWithComponents> { }
  public abstract class Type_factory__o_k_w_c_w_c_c_ContextualView__quals__j_e_i_Any_j_e_i_Default extends Factory<ContextualView> { }
  public abstract class Type_factory__o_d_w_s_e_c_EnumEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<EnumEditorEntryPoint> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_ProjectScreenMenuItem__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectScreenMenuItem> { }
  public abstract class Type_factory__o_j_c_n_h_c_p_DataSetTasksListPerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetTasksListPerspective> { }
  public abstract class ExtensionProvided_factory__c_g_g_u_c_u_HTML__quals__j_e_i_Any_j_e_i_Default extends Factory<HTML> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_PackageNameFormPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<PackageNameFormPopup> { }
  public abstract class Type_factory__o_d_w_s_d_t_DecisionTableXLSResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default extends Factory<DecisionTableXLSResourceTypeDefinition> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_e_DataObjectBrowser__quals__j_e_i_Any_j_e_i_Default extends Factory<DataObjectBrowser> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_t_NewTemplateView__quals__j_e_i_Any_j_e_i_Default extends Factory<NewTemplateView> { }
  public abstract class Type_factory__o_d_d_e_c_s_DataSetDefScreenViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefScreenViewImpl> { }
  public abstract class Type_factory__o_u_e_p_c_RuntimePluginsEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<RuntimePluginsEntryPoint> { }
  public abstract class Type_factory__o_k_w_c_w_c_h_w_c_WorkbenchConfigurationMenu__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchConfigurationMenu> { }
  public abstract class Type_factory__o_j_e_e_c_c_WindowEventObservers__quals__j_e_i_Any_j_e_i_Default extends Factory<WindowEventObservers> { }
  public abstract class Type_factory__o_d_v_d_DataSetDefValidator__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefValidator> { }
  public abstract class Type_factory__o_k_w_c_s_s_c_FullTextSearchFormPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<FullTextSearchFormPresenter> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_p_ImportsPage__quals__j_e_i_Any_j_e_i_Default extends Factory<ImportsPage> { }
  public abstract class Type_factory__o_u_e_w_c_c_c_BusyIndicatorView__quals__j_e_i_Any_j_e_i_Default extends Factory<BusyIndicatorView> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_p_p_FetchRepositoryViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<FetchRepositoryViewImpl> { }
  public abstract class Type_factory__o_j_c_n_d_c_p_f_DataSetFilterEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetFilterEditor> { }
  public abstract class Type_factory__o_j_c_n_e_c_e_r_RequestListPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<RequestListPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_s_h_c_u_UserHomePagePerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<UserHomePagePerspectiveActivity> { }
  public abstract class Type_factory__o_d_d_c_w_DisplayerSettingsJSONSourceViewer__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayerSettingsJSONSourceViewer> { }
  public abstract class Type_factory__o_d_w_s_g_r_t_GuidedRuleDSLRResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedRuleDSLRResourceTypeDefinition> { }
  public abstract class JsType_factory__o_j_e_i_c_WindowInjectionContext__quals__Universal extends Factory<WindowInjectionContext> { }
  public abstract class Type_factory__o_d_c_w_d_e_c_CSVDataSetEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<CSVDataSetEditor> { }
  public abstract class Type_factory__o_j_e_u_n_c_l_NavigationPanelProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<NavigationPanelProvider> { }
  public abstract class Type_factory__o_k_u_s_a_c_w_u_UserBoxView__quals__j_e_i_Any_j_e_i_Default extends Factory<UserBoxView> { }
  public abstract class JsType_factory__o_j_e_i_c_JsArray__quals__Universal extends Factory<JsArray> { }
  public abstract class Type_factory__o_d_d_c_w_f_DataSetFilterEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<org.dashbuilder.displayer.client.widgets.filter.DataSetFilterEditor> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_v_ValidatorService__quals__j_e_i_Any_j_e_i_Default extends Factory<ValidatorService> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_r_RemoteView__quals__j_e_i_Any_j_e_i_Default extends Factory<RemoteView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_ActionRetractFactColumnConverter__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionRetractFactColumnConverter> { }
  public abstract class Type_factory__o_k_w_c_w_m_c_KieMultipleDocumentEditorWrapperViewImpl__quals__j_e_i_Any_o_k_w_c_w_m_c_KieMultipleDocumentEditorQualifier extends Factory<KieMultipleDocumentEditorWrapperViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_e_KieTextEditorScreenPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<KieTextEditorScreenPresenterActivity> { }
  public abstract class Type_factory__o_u_e_e_c_c_h_VersionMenuDropDownButton__quals__j_e_i_Any_j_e_i_Default extends Factory<VersionMenuDropDownButton> { }
  public abstract class Type_factory__o_g_c_s_p_c_GAVEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<GAVEditorViewImpl> { }
  public abstract class Type_factory__o_k_w_c_w_c_a_PermissionTreeSetup__quals__j_e_i_Any_j_e_i_Default extends Factory<PermissionTreeSetup> { }
  public abstract class Type_factory__o_k_w_c_w_m_c_KieMultipleDocumentEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<KieMultipleDocumentEditorEntryPoint> { }
  public abstract class Type_factory__o_d_c_w_d_e_a_DataSetDefBasicAttributesEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefBasicAttributesEditor> { }
  public abstract class Type_factory__o_k_w_c_p_M2RepoPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<M2RepoPerspectiveActivity> { }
  public abstract class Type_factory__o_u_c_w_p_i_TemplatedWorkbenchPanelPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<TemplatedWorkbenchPanelPresenter> { }
  public abstract class Type_factory__o_k_w_c_w_c_p_t_TextBoxFormPopupViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<TextBoxFormPopupViewImpl> { }
  public abstract class Type_factory__o_j_e_i_c_l_i_StateChangeImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<StateChangeImpl> { }
  public abstract class Provider_factory__o_j_e_b_c_a_m_RequestDispatcher__quals__j_e_i_Any_j_e_i_Default extends Factory<RequestDispatcher> { }
  public abstract class Type_factory__o_g_m_c_u_UploadFormViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<UploadFormViewImpl> { }
  public abstract class ExtensionProvided_factory__o_g_c_u_FormControlStatic__quals__j_e_i_Any_j_e_i_Default extends Factory<FormControlStatic> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_p_FactPatternsPage__quals__j_e_i_Any_j_e_i_Default extends Factory<FactPatternsPage> { }
  public abstract class Type_factory__o_j_c_n_p_c_e_i_l_v_d_DataSetProcessInstanceWithVariablesListPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetProcessInstanceWithVariablesListPresenter> { }
  public abstract class Type_factory__o_k_w_c_h_HomeProducer__quals__j_e_i_Any_j_e_i_Default extends Factory<HomeProducer> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_p_ProjectClassListViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectClassListViewImpl> { }
  public abstract class Type_factory__o_j_e_u_c_l_s_TranslationServiceProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<TranslationServiceProvider> { }
  public abstract class Type_factory__o_u_c_e_VFSJSExporter__quals__j_e_i_Any_j_e_i_Default extends Factory<VFSJSExporter> { }
  public abstract class Type_factory__o_d_d_c_w_g_ColumnFunctionEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<ColumnFunctionEditor> { }
  public abstract class Type_factory__o_j_c_n_h_c_e_t_TaskLogsPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<TaskLogsPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_c_c_r_ContainerRulesConfigView__quals__j_e_i_Any_j_e_i_Default extends Factory<ContainerRulesConfigView> { }
  public abstract class Type_factory__o_u_c_w_p_i_AdaptiveWorkbenchPanelPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<AdaptiveWorkbenchPanelPresenter> { }
  public abstract class Type_factory__o_j_c_n_e_c_e_s_JobServiceSettingsPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<JobServiceSettingsPopup> { }
  public abstract class Type_factory__o_u_e_s_m_c_s_e_GroupEditorScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<GroupEditorScreenActivity> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_AdvancedDataObjectFieldEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<AdvancedDataObjectFieldEditor> { }
  public abstract class ExtensionProvided_factory__o_g_e_s_c_u_Select__quals__j_e_i_Any_j_e_i_Default extends Factory<org.gwtbootstrap3.extras.select.client.ui.Select> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_n_PermissionExceptionSwitch__quals__j_e_i_Any_j_e_i_Default extends Factory<PermissionExceptionSwitch> { }
  public abstract class Type_factory__o_d_w_s_g_d_t_GuidedDTreeResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedDTreeResourceTypeDefinition> { }
  public abstract class Type_factory__o_u_e_p_c_c_PluginConfigService__quals__j_e_i_Any_j_e_i_Default extends Factory<PluginConfigService> { }
  public abstract class Type_factory__o_g_s_c_e_f_FileExplorerPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<FileExplorerPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_c_c_p_ContributorsPerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<ContributorsPerspective> { }
  public abstract class Type_factory__o_d_w_s_g_t_c_e_GuidedRuleTemplateEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedRuleTemplateEditorViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_m_MainDataObjectFieldEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<MainDataObjectFieldEditor> { }
  public abstract class Type_factory__o_k_w_c_s_s_h_c_u_m_MainView__quals__j_e_i_Any_j_e_i_Default extends Factory<MainView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_MetaDataColumnConverter__quals__j_e_i_Any_j_e_i_Default extends Factory<MetaDataColumnConverter> { }
  public abstract class Type_factory__o_k_w_c_s_s_h_c_h_m_MainView__quals__j_e_i_Any_j_e_i_Default extends Factory<org.kie.workbench.common.screens.social.hp.client.homepage.main.MainView> { }
  public abstract class Type_factory__o_u_c_w_p_u_p_UnanchoredWorkbenchPartPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<UnanchoredWorkbenchPartPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_Div__quals__j_e_i_Any_j_e_i_Default extends Factory<org.kie.workbench.common.screens.server.management.client.widget.Div> { }
  public abstract class Type_factory__o_d_d_c_w_f_MultipleNumberParameterEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<MultipleNumberParameterEditor> { }
  public abstract class Type_factory__o_d_c_c_e_f_FileUploadEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<FileUploadEditorView> { }
  public abstract class Type_factory__o_d_w_s_g_t_c_e_GuidedRuleTemplateEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<GuidedRuleTemplateEditorPresenterActivity> { }
  public abstract class Producer_factory__o_j_e_i_c_c_SyncBeanManager__quals__j_e_i_Any_j_e_i_Default extends Factory<SyncBeanManager> { }
  public abstract class Type_factory__o_g_a_m_c_e_r_s_RepositoryStructurePresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<RepositoryStructurePresenterActivity> { }
  public abstract class Type_factory__o_u_e_l_e_c_c_r_Row__quals__j_e_i_Any_j_e_i_Default extends Factory<Row> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_GuidedDecisionTableEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedDecisionTableEditorEntryPoint> { }
  public abstract class Type_factory__o_d_d_e_c_p_DataSetAuthoringPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<DataSetAuthoringPerspectiveActivity> { }
  public abstract class Type_factory__o_u_e_w_c_c_w_WizardViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<WizardViewImpl> { }
  public abstract class ExtensionProvided_factory__o_u_c_w_w_p_StaticFocusedResizePanel__quals__j_e_i_Any_j_e_i_Default extends Factory<StaticFocusedResizePanel> { }
  public abstract class Type_factory__o_d_w_s_d_t_DecisionTableXLSXResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default extends Factory<DecisionTableXLSXResourceTypeDefinition> { }
  public abstract class Type_factory__o_u_c_w_p_n_p_WorkbenchPartView__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchPartView> { }
  public abstract class Provider_factory__o_j_e_u_c_l_s_TranslationService__quals__j_e_i_Any_j_e_i_Default extends Factory<TranslationService> { }
  public abstract class Type_factory__o_j_c_n_h_c_e_t_TaskProcessContextPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<TaskProcessContextPresenter> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_ACLViewer__quals__j_e_i_Any_j_e_i_Default extends Factory<ACLViewer> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_a_ArtifactListWidgetView__quals__j_e_i_Any_j_e_i_Default extends Factory<ArtifactListWidgetView> { }
  public abstract class Type_factory__o_j_d_c_Bootstrap__quals__j_e_i_Any_j_e_i_Default extends Factory<Bootstrap> { }
  public abstract class Type_factory__o_u_c_VFSLockServiceProxyBackendImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<VFSLockServiceProxyBackendImpl> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_e_DataObjectBrowserViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DataObjectBrowserViewImpl> { }
  public abstract class Provider_factory__o_j_e_u_n_c_l_NavigationPanel__quals__j_e_i_Any_j_e_i_Default extends Factory<NavigationPanel> { }
  public abstract class Type_factory__o_u_e_l_e_c_c_c_ComponentColumnView__quals__j_e_i_Any_j_e_i_Default extends Factory<ComponentColumnView> { }
  public abstract class Type_factory__o_j_c_n_p_c_e_i_d_m_ProcessInstanceDetailsMultiPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ProcessInstanceDetailsMultiPresenter> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_u_UserAttributesEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<UserAttributesEditorView> { }
  public abstract class ContextualProvider_factory__o_j_e_c_c_a_Caller__quals__Universal extends Factory<Caller> { }
  public abstract class Producer_factory__o_j_e_b_c_a_ClientMessageBus__quals__j_e_i_Any_j_e_i_Default extends Factory<ClientMessageBus> { }
  public abstract class Type_factory__o_d_c_w_d_e_DataSetDefProviderTypeEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefProviderTypeEditorView> { }
  public abstract class ExtensionProvided_factory__o_g_c_u_FieldSet__quals__j_e_i_Any_j_e_i_Default extends Factory<FieldSet> { }
  public abstract class Type_factory__o_g_a_m_c_e_r_s_r_ReleaseScreenPopupViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ReleaseScreenPopupViewImpl> { }
  public abstract class Type_factory__o_j_c_n_e_c_p_JobListPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<JobListPerspectiveActivity> { }
  public abstract class Type_factory__o_u_c_w_VFSServiceProxyClientImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<VFSServiceProxyClientImpl> { }
  public abstract class Type_factory__o_u_e_l_e_c_LayoutEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<LayoutEditorEntryPoint> { }
  public abstract class Type_factory__o_d_w_s_d_t_DRLResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default extends Factory<DRLResourceTypeDefinition> { }
  public abstract class Type_factory__o_g_o_m_c_e_OrganizationalUnitManagerPresenterImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<OrganizationalUnitManagerPresenterImpl> { }
  public abstract class Type_factory__o_d_c_w_d_e_c_CSVDataSetDefAttributesEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<CSVDataSetDefAttributesEditor> { }
  public abstract class Type_factory__o_d_v_d_CSVDataSetDefValidator__quals__j_e_i_Any_j_e_i_Default extends Factory<CSVDataSetDefValidator> { }
  public abstract class Type_factory__o_d_d_e_g_IntervalBuilderDynamicLabel__quals__j_e_i_Any_j_e_i_Default extends Factory<IntervalBuilderDynamicLabel> { }
  public abstract class Type_factory__o_j_c_n_h_f_c_d_d_t_PlaceManagerTaskDisplayerImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<PlaceManagerTaskDisplayerImpl> { }
  public abstract class Type_factory__o_j_c_n_h_f_c_d_s_StandaloneTaskFormDisplayPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<StandaloneTaskFormDisplayPresenterActivity> { }
  public abstract class Type_factory__o_k_w_c_RepositoryPreferencesProducer__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoryPreferencesProducer> { }
  public abstract class ExtensionProvided_factory__o_g_c_u_Row__quals__j_e_i_Any_j_e_i_Default extends Factory<org.gwtbootstrap3.client.ui.Row> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_h_NewGuidedDecisionTreeHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<NewGuidedDecisionTreeHandler> { }
  public abstract class Type_factory__o_u_e_w_c_t_c_c_WiresTreesScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<WiresTreesScreenActivity> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_ACLEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<ACLEditorView> { }
  public abstract class Type_factory__o_d_c_c_e_ToggleSwitchEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<ToggleSwitchEditorView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_m_InsertMenuViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<InsertMenuViewImpl> { }
  public abstract class Type_factory__o_j_d_t_Bpmn2TypeDefinition__quals__j_e_i_Any_j_e_i_Default extends Factory<Bpmn2TypeDefinition> { }
  public abstract class Type_factory__o_j_c_n_g_f_c_d_d_u_JSNIHelper__quals__j_e_i_Any_j_e_i_Default extends Factory<JSNIHelper> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_p_ColumnExpansionPage__quals__j_e_i_Any_j_e_i_Default extends Factory<ColumnExpansionPage> { }
  public abstract class Type_factory__o_d_c_w_d_e_DataSetSummaryView__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetSummaryView> { }
  public abstract class Type_factory__o_j_c_n_h_c_e_t_TaskDetailsMultiPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<TaskDetailsMultiPresenterActivity> { }
  public abstract class Type_factory__o_d_w_s_g_s_t_GuidedScoreCardResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedScoreCardResourceTypeDefinition> { }
  public abstract class Type_factory__o_u_e_w_c_g_c_d_WiresGridsDemoEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<WiresGridsDemoEntryPoint> { }
  public abstract class Type_factory__o_j_c_n_g_f_c_d_v_EmbeddedFormDisplayView__quals__j_e_i_Any_j_e_i_Default extends Factory<EmbeddedFormDisplayView> { }
  public abstract class Type_factory__o_j_c_n_p_c_e_d_d_a_AdvancedViewProcessDefDetailsPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<AdvancedViewProcessDefDetailsPresenter> { }
  public abstract class Type_factory__o_g_a_m_c_e_f_p_SelectAssetsToPromotePresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<SelectAssetsToPromotePresenterActivity> { }
  public abstract class Type_factory__o_d_w_s_e_c_h_NewEnumHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<NewEnumHandler> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_UserGroupsExplorer__quals__j_e_i_Any_j_e_i_Default extends Factory<UserGroupsExplorer> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_ActiveContextOptions__quals__j_e_i_Any_j_e_i_Default extends Factory<ActiveContextOptions> { }
  public abstract class Type_factory__o_g_m_c_w_ArtifactListViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ArtifactListViewImpl> { }
  public abstract class Type_factory__o_d_w_s_g_d_t_GuidedDTableResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedDTableResourceTypeDefinition> { }
  public abstract class Type_factory__o_u_c_w_p_i_AdaptiveWorkbenchPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<AdaptiveWorkbenchPanelView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_GuidedDecisionTablePresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedDecisionTablePresenter> { }
  public abstract class Type_factory__o_g_a_m_c_e_r_s_c_ConfigureScreenPopupViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ConfigureScreenPopupViewImpl> { }
  public abstract class Type_factory__o_o_w_s_d_c_w_p_PlannerDomainScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<PlannerDomainScreenActivity> { }
  public abstract class Type_factory__o_j_c_n_h_c_p_DroolsTasksListPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<DroolsTasksListPerspectiveActivity> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_WorkItemHandlersPanelViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkItemHandlersPanelViewImpl> { }
  public abstract class Type_factory__o_d_d_e_c_s_DataSetDefExplorerScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefExplorerScreen> { }
  public abstract class Type_factory__o_u_c_w_w_d_WorkbenchDragAndDropManager__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchDragAndDropManager> { }
  public abstract class Type_factory__o_k_w_c_s_s_h_c_u_UserHomePageMainView__quals__j_e_i_Any_j_e_i_Default extends Factory<UserHomePageMainView> { }
  public abstract class Type_factory__o_g_c_s_p_e_t_POMResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default extends Factory<POMResourceTypeDefinition> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_m_MainDomainEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<MainDomainEditor> { }
  public abstract class Type_factory__o_u_c_m_LockManagerImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<LockManagerImpl> { }
  public abstract class Type_factory__o_g_a_m_c_e_f_a_ApproveOperationPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<ApproveOperationPresenterActivity> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_p_p_NoRepositoryURLViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<NoRepositoryURLViewImpl> { }
  public abstract class Type_factory__o_u_c_m_PerspectiveManagerImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<PerspectiveManagerImpl> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_c_i_DefaultClipboard__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultClipboard> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_ServerManagementPerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<ServerManagementPerspective> { }
  public abstract class Type_factory__o_g_c_s_w_c_WorkingSetManager__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkingSetManager> { }
  public abstract class Type_factory__o_j_e_s_c_l_i_ClientSecurityRoleInterceptor__quals__j_e_i_Any_j_e_i_Default extends Factory<ClientSecurityRoleInterceptor> { }
  public abstract class Type_factory__o_u_c_w_StandaloneEditorPerspective__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<StandaloneEditorPerspective> { }
  public abstract class ContextualProvider_factory__o_j_e_i_c_a_InitBallot__quals__Universal extends Factory<InitBallot> { }
  public abstract class Type_factory__o_d_v_d_BeanDataSetDefValidator__quals__j_e_i_Any_j_e_i_Default extends Factory<BeanDataSetDefValidator> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_b_BusinessViewWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<BusinessViewWidget> { }
  public abstract class Type_factory__o_d_c_c_e_ToggleSwitchEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<ToggleSwitchEditor> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_c_b_BodyView__quals__j_e_i_Any_j_e_i_Default extends Factory<BodyView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_GuidedDecisionTreeEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedDecisionTreeEditorPresenter> { }
  public abstract class Type_factory__o_j_d_r_c_p_ProcessDashboardView__quals__j_e_i_Any_j_e_i_Default extends Factory<ProcessDashboardView> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_ExplorerMenuViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ExplorerMenuViewImpl> { }
  public abstract class Type_factory__o_k_w_c_n_LogoWidgetPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<LogoWidgetPresenter> { }
  public abstract class ExtensionProvided_factory__o_j_e_c_c_d_Input__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<Input> { }
  public abstract class Type_factory__o_d_c_w_d_e_w_c_DataSetProviderTypeWorkflow__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetProviderTypeWorkflow> { }
  public abstract class Type_factory__o_d_d_c_u_ClientUUIDGenerator__quals__j_e_i_Any_j_e_i_Default extends Factory<ClientUUIDGenerator> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_c_s_e_ContainerStatusEmptyView__quals__j_e_i_Any_j_e_i_Default extends Factory<ContainerStatusEmptyView> { }
  public abstract class Type_factory__o_u_e_s_m_c_ClientUserSystemManager__quals__j_e_i_Any_j_e_i_Default extends Factory<ClientUserSystemManager> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_r_e_RemoteEmptyView__quals__j_e_i_Any_j_e_i_Default extends Factory<RemoteEmptyView> { }
  public abstract class Type_factory__o_u_e_a_c_h_AppsHomePresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<AppsHomePresenterActivity> { }
  public abstract class Type_factory__o_g_a_m_c_e_f_p_SelectAssetsToPromoteViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<SelectAssetsToPromoteViewImpl> { }
  public abstract class Type_factory__o_j_c_n_h_c_e_t_g_d_DataSetTasksListGridPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<DataSetTasksListGridPresenterActivity> { }
  public abstract class Type_factory__o_u_c_v_p_t_TabPanelWithDropdowns__quals__j_e_i_Any_j_e_i_Default extends Factory<TabPanelWithDropdowns> { }
  public abstract class Type_factory__o_u_e_l_e_c_c_r_RowView__quals__j_e_i_Any_j_e_i_Default extends Factory<RowView> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_AdvancedDomainScreenViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<AdvancedDomainScreenViewImpl> { }
  public abstract class Type_factory__o_g_a_m_c_e_p_PromoteChangesViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<PromoteChangesViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_ProjectImportsScreenPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectImportsScreenPresenter> { }
  public abstract class Type_factory__o_g_a_m_c_e_f_a_ApproveOperationViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ApproveOperationViewImpl> { }
  public abstract class Type_factory__o_j_c_n_p_c_e_i_d_ProcessInstanceDetailsViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ProcessInstanceDetailsViewImpl> { }
  public abstract class Type_factory__o_u_c_e_UberfireJSAPIExporter__quals__j_e_i_Any_j_e_i_Default extends Factory<UberfireJSAPIExporter> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_ProjectImportsScreenViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectImportsScreenViewImpl> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_u_UserAssignedGroupsExplorer__quals__j_e_i_Any_j_e_i_Default extends Factory<UserAssignedGroupsExplorer> { }
  public abstract class Type_factory__o_g_a_m_c_e_f_r_RequiresReworkPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<RequiresReworkPresenterActivity> { }
  public abstract class Type_factory__o_u_e_e_c_c_f_RenamePopupViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<RenamePopupViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_p_PackageSelectorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<PackageSelectorViewImpl> { }
  public abstract class Type_factory__o_d_c_w_d_e_DataSetExplorer__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetExplorer> { }
  public abstract class Type_factory__o_j_c_n_h_c_e_t_TaskDetailsPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<TaskDetailsPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_KSessionFormViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<KSessionFormViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_r_RepositoriesWidgetViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoriesWidgetViewImpl> { }
  public abstract class Type_factory__o_k_w_c_w_c_h_w_c_LanguageConfigurationHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<LanguageConfigurationHandler> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_ServerManagementBrowserPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<ServerManagementBrowserPresenterActivity> { }
  public abstract class ExtensionProvided_factory__o_k_w_c_s_j_c_w_EditJavaSourceWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<EditJavaSourceWidget> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_f_ActionRetractNodeFactory__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionRetractNodeFactory> { }
  public abstract class ContextualProvider_factory__o_j_e_u_n_c_l_TransitionAnchor__quals__Universal extends Factory<TransitionAnchor> { }
  public abstract class Type_factory__o_d_c_w_d_e_a_DataSetDefRefreshAttributesEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefRefreshAttributesEditor> { }
  public abstract class Type_factory__o_u_e_s_m_c_s_e_SecurityExplorerScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<SecurityExplorerScreen> { }
  public abstract class Type_factory__o_o_w_s_s_c_e_XMLViewerImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<XMLViewerImpl> { }
  public abstract class Type_factory__o_j_c_n_b_c_e_d_l_DeploymentUnitsListViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DeploymentUnitsListViewImpl> { }
  public abstract class Type_factory__o_g_a_m_c_e_r_s_RepositoryManagedStatusUpdater__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoryManagedStatusUpdater> { }
  public abstract class Type_factory__o_u_e_l_e_c_c_c_Container__quals__j_e_i_Any_j_e_i_Default extends Factory<org.uberfire.ext.layout.editor.client.components.container.Container> { }
  public abstract class Type_factory__o_j_c_n_d_c_p_f_DateParameterEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DateParameterEditor> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_GuidedDecisionTableModellerPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedDecisionTableModellerPresenter> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_GuidedDecisionTableEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedDecisionTableEditorPresenter> { }
  public abstract class Type_factory__o_g_i_c_InboxPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<InboxPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_d_DroolsDataObjectFieldEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DroolsDataObjectFieldEditor> { }
  public abstract class Type_factory__o_d_c_w_d_e_a_DataSetDefClientCacheAttributesEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefClientCacheAttributesEditor> { }
  public abstract class Type_factory__o_u_e_l_e_c_c_r_EmptyDropRowView__quals__j_e_i_Any_j_e_i_Default extends Factory<EmptyDropRowView> { }
  public abstract class ExtensionProvided_factory__o_j_d_c_DesignerWidgetView__quals__j_e_i_Any_j_e_i_Default extends Factory<DesignerWidgetView> { }
  public abstract class Type_factory__o_u_c_DocksEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<DocksEntryPoint> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_f_TypeNodeFactory__quals__j_e_i_Any_j_e_i_Default extends Factory<TypeNodeFactory> { }
  public abstract class Type_factory__o_u_e_p_c_e_DynamicMenuEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DynamicMenuEditorView> { }
  public abstract class Type_factory__o_j_c_n_w_c_e_d_d_DeploymentDescriptorEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<DeploymentDescriptorEditorPresenterActivity> { }
  public abstract class Type_factory__o_j_e_i_s_b_c_BatchCallerProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<BatchCallerProvider> { }
  public abstract class Type_factory__o_j_c_n_b_c_e_d_n_NewDeploymentPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<NewDeploymentPopup> { }
  public abstract class Type_factory__o_g_s_c_e_r_e_RepositoryEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoryEditorView> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_ActiveContextManager__quals__j_e_i_Any_j_e_i_Default extends Factory<ActiveContextManager> { }
  public abstract class Type_factory__o_u_e_p_c_i_PluginsInfo__quals__j_e_i_Any_j_e_i_Default extends Factory<PluginsInfo> { }
  public abstract class ExtensionProvided_factory__o_d_w_s_t_c_AuditLog__quals__j_e_i_Any_j_e_i_Default extends Factory<AuditLog> { }
  public abstract class Type_factory__o_o_w_s_d_c_w_p_PlannerDataObjectFieldEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<PlannerDataObjectFieldEditorViewImpl> { }
  public abstract class Type_factory__o_d_c_w_d_e_DataSetDefPreviewTableView__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefPreviewTableView> { }
  public abstract class Type_factory__o_u_e_w_c_c_w_WizardPageTitle__quals__j_e_i_Any_j_e_i_Default extends Factory<WizardPageTitle> { }
  public abstract class Type_factory__o_g_m_c_M2RepoEditorPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<M2RepoEditorPresenterActivity> { }
  public abstract class Type_factory__o_u_e_e_c_c_h_SaveButton__quals__j_e_i_Any_j_e_i_Default extends Factory<SaveButton> { }
  public abstract class Type_factory__o_k_w_c_w_c_p_l_FormListPopupViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<FormListPopupViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_v_g_GenericValuePairEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<GenericValuePairEditor> { }
  public abstract class Type_factory__o_u_c_w_w_m_WorkbenchMenuBarPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchMenuBarPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_c_f_FooterView__quals__j_e_i_Any_j_e_i_Default extends Factory<FooterView> { }
  public abstract class Type_factory__o_u_c_WorkbenchServicesProxyBackendImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchServicesProxyBackendImpl> { }
  public abstract class Type_factory__o_d_r_c_s_SelectorDisplayerView__quals__j_e_i_Any_j_e_i_Default extends Factory<SelectorDisplayerView> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_KSessionModelOptionsPopUpViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<KSessionModelOptionsPopUpViewImpl> { }
  public abstract class Type_factory__o_k_w_c_w_c_p_l_FormListPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<FormListPopup> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_j_o_JPANewResourceOptions__quals__j_e_i_Any_j_e_i_Default extends Factory<JPANewResourceOptions> { }
  public abstract class Type_factory__o_d_d_c_e_ClientIntervalBuilderLocator__quals__j_e_i_Any_j_e_i_Default extends Factory<ClientIntervalBuilderLocator> { }
  public abstract class Type_factory__o_j_c_n_d_c_p_f_NumberParameterEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<org.jbpm.console.ng.df.client.popup.filter.NumberParameterEditor> { }
  public abstract class Type_factory__o_u_e_w_c_c_w_w_p_a_n_ActivityNotFoundPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ActivityNotFoundPresenter> { }
  public abstract class Type_factory__o_j_e_i_c_l_i_AccessImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<AccessImpl> { }
  public abstract class Type_factory__o_u_e_p_c_e_PluginExplorerScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<PluginExplorerScreenActivity> { }
  public abstract class Type_factory__o_d_w_s_t_c_FixtureLayout__quals__j_e_i_Any_j_e_i_Default extends Factory<FixtureLayout> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_f_ConstraintNodeFactory__quals__j_e_i_Any_j_e_i_Default extends Factory<ConstraintNodeFactory> { }
  public abstract class Type_factory__o_u_c_v_p_t_WorkbenchToolBarView__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchToolBarView> { }
  public abstract class Type_factory__o_k_w_c_n_AppNavBar__quals__j_e_i_Any_j_e_i_Default extends Factory<AppNavBar> { }
  public abstract class Type_factory__o_k_w_c_w_m_c_m_RegisteredDocumentsMenuViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<RegisteredDocumentsMenuViewImpl> { }
  public abstract class Type_factory__o_k_w_c_p_AdministrationPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<AdministrationPerspectiveActivity> { }
  public abstract class Type_factory__o_d_c_w_d_e_b_BeanDataSetDefAttributesEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<BeanDataSetDefAttributesEditorView> { }
  public abstract class Type_factory__o_d_v_d_SQLDataSetDefValidator__quals__j_e_i_Any_j_e_i_Default extends Factory<SQLDataSetDefValidator> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_j_p_IdGeneratorField__quals__j_e_i_Any_j_e_i_Default extends Factory<IdGeneratorField> { }
  public abstract class Type_factory__o_d_w_s_d_c_e_DSLEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<DSLEditorPresenter> { }
  public abstract class Type_factory__o_k_w_c_w_c_d_AsyncPackageDataModelOracleImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<AsyncPackageDataModelOracleImpl> { }
  public abstract class Type_factory__o_u_e_w_c_c_t_PagedTable__quals__j_e_i_Any_j_e_i_Default extends Factory<PagedTable> { }
  public abstract class ExtensionProvided_factory__o_k_w_c_s_d_c_p_XMLViewer__quals__j_e_i_Any_j_e_i_Default extends Factory<XMLViewer> { }
  public abstract class Type_factory__o_g_a_m_c_e_c_RepositoryConfigurationPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<RepositoryConfigurationPresenterActivity> { }
  public abstract class Type_factory__o_d_d_c_w_DisplayerSettingsEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayerSettingsEditorView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_ActionRetractFactColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionRetractFactColumnSynchronizer> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_ActionWorkItemColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionWorkItemColumnSynchronizer> { }
  public abstract class Type_factory__o_u_e_w_c_c_a_ActionsScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<ActionsScreenActivity> { }
  public abstract class Type_factory__o_g_a_m_c_e_r_w_p_RepositoryStructurePageViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoryStructurePageViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_t_TechnicalViewPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<TechnicalViewPresenter> { }
  public abstract class Type_factory__o_u_c_v_p_n_ActivityNotFoundView__quals__j_e_i_Any_j_e_i_Default extends Factory<org.uberfire.client.views.pfly.notfound.ActivityNotFoundView> { }
  public abstract class Type_factory__o_j_d_c_p_ActivityDataIOEditorWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<ActivityDataIOEditorWidget> { }
  public abstract class Type_factory__o_u_c_e_SplashScreenJSExporter__quals__j_e_i_Any_j_e_i_Default extends Factory<SplashScreenJSExporter> { }
  public abstract class Type_factory__o_u_e_w_c_c_f_ShapeFactoryCache__quals__j_e_i_Any_j_e_i_Default extends Factory<ShapeFactoryCache> { }
  public abstract class Type_factory__o_d_c_c_e_l_HorizImageListEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<HorizImageListEditor> { }
  public abstract class Type_factory__o_d_c_w_d_e_DataSetPanelView__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetPanelView> { }
  public abstract class Type_factory__o_u_c_v_p_s_SplashModalFooter__quals__j_e_i_Any_j_e_i_Default extends Factory<SplashModalFooter> { }
  public abstract class Type_factory__o_k_w_c_s_j_c_e_JavaEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<JavaEditorPresenterActivity> { }
  public abstract class Type_factory__o_u_e_w_c_c_e_d_DefaultFileEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<DefaultFileEditorPresenterActivity> { }
  public abstract class Type_factory__o_j_d_c_DesignerPopUpPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<DesignerPopUpPresenterActivity> { }
  public abstract class Type_factory__o_g_m_c_M2RepoEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<M2RepoEditorEntryPoint> { }
  public abstract class Type_factory__o_d_c_w_c_LoadingBox__quals__j_e_i_Any_j_e_i_Default extends Factory<LoadingBox> { }
  public abstract class Type_factory__o_k_w_c_w_c_h_NewResourcePresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<NewResourcePresenter> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_ActionWorkItemSetFieldColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionWorkItemSetFieldColumnSynchronizer> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_c_b_BodyPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<BodyPresenter> { }
  public abstract class Type_factory__o_u_e_p_c_t_DynamicMenuResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<DynamicMenuResourceType> { }
  public abstract class Type_factory__o_o_w_s_s_t_SolverResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default extends Factory<SolverResourceTypeDefinition> { }
  public abstract class ExtensionProvided_factory__o_g_c_u_Anchor__quals__j_e_i_Any_j_e_i_Default extends Factory<org.gwtbootstrap3.client.ui.Anchor> { }
  public abstract class Type_factory__o_d_r_c_t_TableDisplayerView__quals__j_e_i_Any_j_e_i_Default extends Factory<TableDisplayerView> { }
  public abstract class Type_factory__o_k_w_c_w_c_d_AuthoringWorkbenchDocks__quals__j_e_i_Any_j_e_i_Default extends Factory<AuthoringWorkbenchDocks> { }
  public abstract class Type_factory__o_u_e_s_m_c_e_u_UserEditorDriver__quals__j_e_i_Any_j_e_i_Default extends Factory<UserEditorDriver> { }
  public abstract class Type_factory__o_d_w_s_d_c_t_DecisionTableXLSXResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<DecisionTableXLSXResourceType> { }
  public abstract class Type_factory__o_d_w_s_w_c_w_WorkItemMetaDataLoader__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkItemMetaDataLoader> { }
  public abstract class Type_factory__o_u_c_e_HTML5DndSeleniumSupport__quals__j_e_i_Any_j_e_i_Default extends Factory<HTML5DndSeleniumSupport> { }
  public abstract class Provider_factory__c_g_g_u_c_u_RootPanel__quals__j_e_i_Any_j_e_i_Default extends Factory<RootPanel> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_h_m_MainDomainHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<MainDomainHandler> { }
  public abstract class Type_factory__o_u_e_w_c_c_a_ActionsGroup__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionsGroup> { }
  public abstract class Type_factory__o_u_c_w_p_i_StaticWorkbenchPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<StaticWorkbenchPanelView> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_b_BusinessViewPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<BusinessViewPresenter> { }
  public abstract class Type_factory__o_g_s_c_s_OrganizationalUnitController__quals__j_e_i_Any_j_e_i_Default extends Factory<OrganizationalUnitController> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_ConditionColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default extends Factory<ConditionColumnSynchronizer> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_j_JPADataObjectEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<JPADataObjectEditorViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_ActiveContextItems__quals__j_e_i_Any_j_e_i_Default extends Factory<ActiveContextItems> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_c_f_FooterPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<FooterPresenter> { }
  public abstract class Type_factory__o_j_c_n_p_c_e_d_l_ProcessDocumentListViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ProcessDocumentListViewImpl> { }
  public abstract class Type_factory__o_u_c_v_p_m_SplashScreenMenuView__quals__j_e_i_Any_j_e_i_Default extends Factory<SplashScreenMenuView> { }
  public abstract class Type_factory__o_j_e_i_c_l_i_DestructionImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DestructionImpl> { }
  public abstract class Type_factory__o_j_c_n_p_f_c_d_p_StartProcessFormDisplayProviderImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<StartProcessFormDisplayProviderImpl> { }
  public abstract class Type_factory__o_d_w_s_d_c_e_DRLEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DRLEditorViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_j_JPADomainScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<JPADomainScreen> { }
  public abstract class Type_factory__o_u_c_w_w_d_CompassDropController__quals__j_e_i_Any_j_e_i_Default extends Factory<CompassDropController> { }
  public abstract class Type_factory__o_o_w_s_s_c_e_ConstructionHeuristicFormViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ConstructionHeuristicFormViewImpl> { }
  public abstract class Type_factory__o_d_c_w_d_e_DataSetPanel__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetPanel> { }
  public abstract class Type_factory__o_u_e_w_c_t_c_f_ExampleTreeNode1Factory__quals__j_e_i_Any_j_e_i_Default extends Factory<ExampleTreeNode1Factory> { }
  public abstract class Type_factory__o_k_w_c_s_s_h_c_u_m_h_HeaderView__quals__j_e_i_Any_j_e_i_Default extends Factory<HeaderView> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_c_e_ServerContainerEmptyPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ServerContainerEmptyPresenter> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_UserGroupsExplorerView__quals__j_e_i_Any_j_e_i_Default extends Factory<UserGroupsExplorerView> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_PersistenceDescriptorEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<PersistenceDescriptorEditorPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_t_PersistenceDescriptorType__quals__j_e_i_Any_j_e_i_Default extends Factory<PersistenceDescriptorType> { }
  public abstract class Type_factory__o_d_c_w_d_e_b_BeanDataSetDefAttributesEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<BeanDataSetDefAttributesEditor> { }
  public abstract class Type_factory__o_k_u_s_a_c_w_r_SocialRelationsWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<SocialRelationsWidget> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_l_UsersList__quals__j_e_i_Any_j_e_i_Default extends Factory<UsersList> { }
  public abstract class Type_factory__o_j_c_n_p_c_e_d_d_m_a_AdvancedProcessDefDetailsMultiPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<AdvancedProcessDefDetailsMultiPresenter> { }
  public abstract class Type_factory__o_j_c_n_h_c_e_q_QuickNewTaskPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<QuickNewTaskPopup> { }
  public abstract class Type_factory__o_j_d_c_p_ActivityDataIOEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<ActivityDataIOEditor> { }
  public abstract class Type_factory__o_u_e_s_m_c_p_SecurityManagementPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<SecurityManagementPerspectiveActivity> { }
  public abstract class Type_factory__o_j_e_s_c_l_r_ClientRequiredRolesExtractorImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ClientRequiredRolesExtractorImpl> { }
  public abstract class Type_factory__o_d_d_c_w_f_ColumnFilterEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<ColumnFilterEditor> { }
  public abstract class Type_factory__o_j_c_n_p_c_e_v_e_VariableEditPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<VariableEditPopup> { }
  public abstract class Type_factory__o_d_c_w_d_e_w_c_BeanDataSetBasicAttributesWorkflow__quals__j_e_i_Any_j_e_i_Default extends Factory<BeanDataSetBasicAttributesWorkflow> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_b_BranchSelector__quals__j_e_i_Any_j_e_i_Default extends Factory<BranchSelector> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_PersistenceDescriptorEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<PersistenceDescriptorEditorViewImpl> { }
  public abstract class Type_factory__o_d_d_c_f_ValueFormatterRegistry__quals__j_e_i_Any_j_e_i_Default extends Factory<ValueFormatterRegistry> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_d_DependencySelectorPopupViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DependencySelectorPopupViewImpl> { }
  public abstract class Type_factory__o_g_a_m_c_e_f_r_ReviewPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<ReviewPresenterActivity> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_m_CellContextMenuViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<CellContextMenuViewImpl> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_a_p_IssuePresenterViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<IssuePresenterViewImpl> { }
  public abstract class Type_factory__o_d_c_w_d_e_a_DataSetDefBackendCacheAttributesEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefBackendCacheAttributesEditor> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_c_DataModelerWorkbenchContext__quals__j_e_i_Any_j_e_i_Default extends Factory<DataModelerWorkbenchContext> { }
  public abstract class Type_factory__o_g_s_c_e_f_FileExplorerPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<FileExplorerPresenterActivity> { }
  public abstract class Type_factory__o_u_e_w_c_c_e_m_MetaFileEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<MetaFileEditorPresenterActivity> { }
  public abstract class Type_factory__o_d_d_c_w_RendererSelectorTabListView__quals__j_e_i_Any_j_e_i_Default extends Factory<RendererSelectorTabListView> { }
  public abstract class Type_factory__o_j_d_c_u_ComboBoxViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ComboBoxViewImpl> { }
  public abstract class Type_factory__o_d_d_c_w_DisplayerViewer__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayerViewer> { }
  public abstract class Type_factory__o_g_m_c_w_ArtifactListPresenterImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ArtifactListPresenterImpl> { }
  public abstract class Type_factory__o_g_s_c_e_r_l_RepositoriesViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoriesViewImpl> { }
  public abstract class Type_factory__o_j_c_n_d_c_p_f_TextParameterEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<TextParameterEditor> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_b_BranchSelectorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<BranchSelectorViewImpl> { }
  public abstract class Type_factory__o_g_m_c_c_MessageConsoleViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<MessageConsoleViewImpl> { }
  public abstract class Type_factory__o_j_c_n_p_c_e_d_d_b_BasicProcessDefDetailsPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<BasicProcessDefDetailsPresenter> { }
  public abstract class Type_factory__o_o_w_s_d_c_h_p_PlannerDomainHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<PlannerDomainHandler> { }
  public abstract class Type_factory__o_d_r_c_DefaultRenderer__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultRenderer> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_p_FactPatternConstraintsPageViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<FactPatternConstraintsPageViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_KModuleEditorScreenPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<KModuleEditorScreenPresenterActivity> { }
  public abstract class Type_factory__o_k_w_c_w_c_d_DiscussionWidgetViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DiscussionWidgetViewImpl> { }
  public abstract class Type_factory__o_j_d_c_DesignerWidgetPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<DesignerWidgetPresenter> { }
  public abstract class Type_factory__o_d_w_s_t_c_TestScenarioEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<TestScenarioEditorEntryPoint> { }
  public abstract class Type_factory__o_k_w_c_s_h_m_ModelUtils__quals__j_e_i_Any_j_e_i_Default extends Factory<ModelUtils> { }
  public abstract class Type_factory__o_j_d_c_h_NewProcessHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<NewProcessHandler> { }
  public abstract class Type_factory__o_k_w_c_w_c_m_ResetPerspectivesMenuBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<ResetPerspectivesMenuBuilder> { }
  public abstract class Type_factory__o_u_c_w_w_n_ActivityNotFoundPresenter__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<org.uberfire.client.workbench.widgets.notfound.ActivityNotFoundPresenter> { }
  public abstract class Type_factory__o_g_i_c_InboxWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<InboxWidget> { }
  public abstract class Type_factory__o_j_d_r_c_p_DashboardFactory__quals__j_e_i_Any_j_e_i_Default extends Factory<DashboardFactory> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_ActionSetFieldColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionSetFieldColumnSynchronizer> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_d_DependencySelectorPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<DependencySelectorPopup> { }
  public abstract class Type_factory__o_g_a_m_c_e_f_r_ReviewViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ReviewViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_KSessionModelOptionsPopUp__quals__j_e_i_Any_j_e_i_Default extends Factory<KSessionModelOptionsPopUp> { }
  public abstract class Type_factory__o_g_o_m_c_e_OrganizationalUnitManagerPresenterImplActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<OrganizationalUnitManagerPresenterImplActivity> { }
  public abstract class Type_factory__o_d_w_s_e_c_e_EnumEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<EnumEditorPresenter> { }
  public abstract class Type_factory__o_u_c_w_t_i_ClientTypeRegistryImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ClientTypeRegistryImpl> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_NewServerTemplateWizard__quals__j_e_i_Any_j_e_i_Default extends Factory<NewServerTemplateWizard> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_j_JPADomainEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<JPADomainEditor> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_AdvancedDomainScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<AdvancedDomainScreenActivity> { }
  public abstract class Type_factory__o_d_d_c_w_DisplayerTypeSelectorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayerTypeSelectorView> { }
  public abstract class Type_factory__o_u_c_w_p_i_ClosableSimpleWorkbenchPanelPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ClosableSimpleWorkbenchPanelPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_DataModelerScreenViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DataModelerScreenViewImpl> { }
  public abstract class Type_factory__o_j_e_s_c_l_s_RoleStyleBindingProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<RoleStyleBindingProvider> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_ACLSettingsView__quals__j_e_i_Any_j_e_i_Default extends Factory<ACLSettingsView> { }
  public abstract class ExtensionProvided_factory__o_j_c_n_g_c_u_UTCTimeBox__quals__j_e_i_Any_j_e_i_Default extends Factory<UTCTimeBox> { }
  public abstract class Type_factory__o_d_w_s_e_c_t_EnumResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<EnumResourceType> { }
  public abstract class Type_factory__o_j_d_r_c_p_DashboardView__quals__j_e_i_Any_j_e_i_Default extends Factory<DashboardView> { }
  public abstract class JsType_factory__o_j_e_i_c_c_JsTypeProvider__quals__Universal extends Factory<JsTypeProvider> { }
  public abstract class Type_factory__o_u_c_w_p_i_SimpleDnDWorkbenchPanelView__quals__j_e_i_Any_j_e_i_Default extends Factory<SimpleDnDWorkbenchPanelView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_p_c_ActionInsertFactFieldCell__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionInsertFactFieldCell> { }
  public abstract class Type_factory__o_d_w_s_g_r_t_GuidedRuleDRLResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedRuleDRLResourceTypeDefinition> { }
  public abstract class Type_factory__o_d_c_w_d_e_w_e_BeanDataSetEditWorkflow__quals__j_e_i_Any_j_e_i_Default extends Factory<BeanDataSetEditWorkflow> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_e_DeploymentScreenPopupViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DeploymentScreenPopupViewImpl> { }
  public abstract class Type_factory__o_o_w_s_s_c_SolverEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<SolverEditorEntryPoint> { }
  public abstract class Type_factory__o_u_c_v_p_m_WorkbenchMenuBarView__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchMenuBarView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_ActionColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionColumnSynchronizer> { }
  public abstract class Type_factory__o_j_e_e_c_c_EventProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<EventProvider> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_DataModelerScreenPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<DataModelerScreenPresenterActivity> { }
  public abstract class Type_factory__o_g_c_s_p_c_ProjectContext__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectContext> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_h_NewProjectHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<NewProjectHandler> { }
  public abstract class Type_factory__o_o_w_s_d_c_w_p_PlannerDataObjectEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<PlannerDataObjectEditor> { }
  public abstract class Type_factory__o_d_w_s_d_c_e_DSLEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<DSLEditorPresenterActivity> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_GuidedDecisionTreeEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<GuidedDecisionTreeEditorPresenterActivity> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_e_PackageNameWhiteListResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<PackageNameWhiteListResourceType> { }
  public abstract class Type_factory__o_d_d_c_w_f_MultipleTextParameterEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<MultipleTextParameterEditorView> { }
  public abstract class Type_factory__o_u_c_e_PlaceManagerJSExporter__quals__j_e_i_Any_j_e_i_Default extends Factory<PlaceManagerJSExporter> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_RowSynchronizer__quals__j_e_i_Any_j_e_i_Default extends Factory<RowSynchronizer> { }
  public abstract class Type_factory__o_j_f_e_c_t_FormDefinitionResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<FormDefinitionResourceType> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_r_RoleEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<RoleEditorView> { }
  public abstract class Type_factory__o_j_c_n_p_f_c_d_d_p_PlaceManagerStartProcessDisplayerImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<PlaceManagerStartProcessDisplayerImpl> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_GuidedDecisionTableEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<GuidedDecisionTableEditorPresenterActivity> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_a_p_AnalysisReportScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<AnalysisReportScreenActivity> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_u_UserEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<UserEditor> { }
  public abstract class Type_factory__o_k_w_c_s_s_h_c_u_IconLocator__quals__j_e_i_Any_j_e_i_Default extends Factory<IconLocator> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_t_TagSelectorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<TagSelectorViewImpl> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_GuidedDecisionTableModellerContextMenuSupport__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedDecisionTableModellerContextMenuSupport> { }
  public abstract class Type_factory__o_u_e_w_c_c_a_ActionsScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionsScreen> { }
  public abstract class Type_factory__o_d_c_w_d_e_c_ColumnListEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<ColumnListEditorView> { }
  public abstract class Type_factory__o_u_e_p_c_e_SplashEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<SplashEditorPresenter> { }
  public abstract class Type_factory__o_d_w_s_d_c_t_DSLResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<DSLResourceType> { }
  public abstract class Type_factory__o_u_c_w_p_i_ClosableSimpleWorkbenchPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<ClosableSimpleWorkbenchPanelView> { }
  public abstract class Type_factory__o_j_c_n_h_f_m_c_e_t_d_FormModellerTaskDisplayerImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<FormModellerTaskDisplayerImpl> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_ActionInsertFactColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionInsertFactColumnSynchronizer> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_p_LoadingBox__quals__j_e_i_Any_j_e_i_Default extends Factory<org.uberfire.ext.security.management.client.widgets.popup.LoadingBox> { }
  public abstract class Type_factory__o_k_w_c_p_DroolsAuthoringNoContextNavigationPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<DroolsAuthoringNoContextNavigationPerspectiveActivity> { }
  public abstract class Type_factory__o_d_r_g_c_GoogleMapDisplayerView__quals__j_e_i_Any_j_e_i_Default extends Factory<GoogleMapDisplayerView> { }
  public abstract class Type_factory__o_k_w_c_w_c_h_w_c_WorkbenchConfigurationViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchConfigurationViewImpl> { }
  public abstract class Type_factory__o_u_e_p_c_e_DynamicMenuEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<DynamicMenuEditorPresenterActivity> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_h_NewJavaFileTextHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<NewJavaFileTextHandler> { }
  public abstract class Type_factory__o_k_w_c_s_s_c_FullTextSearchFormPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<FullTextSearchFormPresenterActivity> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_m_CellContextMenu__quals__j_e_i_Any_j_e_i_Default extends Factory<CellContextMenu> { }
  public abstract class Type_factory__o_k_w_c_s_s_h_c_u_s_SideUserInfoView__quals__j_e_i_Any_j_e_i_Default extends Factory<SideUserInfoView> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_p_p_ProjectItemViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectItemViewImpl> { }
  public abstract class Type_factory__o_d_c_w_d_e_w_c_ElasticSearchDataSetBasicAttributesWorkflow__quals__j_e_i_Any_j_e_i_Default extends Factory<ElasticSearchDataSetBasicAttributesWorkflow> { }
  public abstract class Type_factory__o_d_c_e_DisplayerDragComponent__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayerDragComponent> { }
  public abstract class Type_factory__o_d_w_s_g_r_c_t_GuidedRuleDSLRResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedRuleDSLRResourceType> { }
  public abstract class Type_factory__o_o_w_s_d_c_w_p_PlannerDomainEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<PlannerDomainEditor> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_m_InsertMenuBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<InsertMenuBuilder> { }
  public abstract class Type_factory__o_j_c_n_p_c_e_v_l_ProcessVariableListViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ProcessVariableListViewImpl> { }
  public abstract class Type_factory__o_j_e_u_c_w_LocaleSelector__quals__j_e_i_Any_j_e_i_Default extends Factory<LocaleSelector> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_p_ActionInsertFactFieldsPageViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionInsertFactFieldsPageViewImpl> { }
  public abstract class Type_factory__o_d_w_s_d_c_h_NewDecisionTableXLSHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<NewDecisionTableXLSHandler> { }
  public abstract class Type_factory__o_d_w_s_g_r_c_GuidedRuleEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedRuleEditorEntryPoint> { }
  public abstract class Type_factory__o_j_e_i_c_l_i_CreationImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<CreationImpl> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_w_POMWizardPageViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<POMWizardPageViewImpl> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_ActionInsertFactColumnConverter__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionInsertFactColumnConverter> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_d_DroolsDomainScreenViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DroolsDomainScreenViewImpl> { }
  public abstract class Type_factory__o_d_w_s_g_r_c_e_GuidedRuleEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<GuidedRuleEditorPresenterActivity> { }
  public abstract class Type_factory__o_k_w_c_s_h_c_w_h_HomePresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<HomePresenterActivity> { }
  public abstract class Type_factory__o_g_a_m_c_e_f_r_RequiresReworkPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<RequiresReworkPresenter> { }
  public abstract class Type_factory__o_j_d_c_n_DesignerNotificationPopupsManager__quals__j_e_i_Any_j_e_i_Default extends Factory<DesignerNotificationPopupsManager> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_p_PersistenceUnitPropertyGrid__quals__j_e_i_Any_j_e_i_Default extends Factory<PersistenceUnitPropertyGrid> { }
  public abstract class Type_factory__o_u_e_l_e_c_LayoutEditorPluginImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<LayoutEditorPluginImpl> { }
  public abstract class Type_factory__o_g_s_c_e_r_c_CloneRepositoryViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<CloneRepositoryViewImpl> { }
  public abstract class Type_factory__o_u_c_v_p_s_SplashViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<SplashViewImpl> { }
  public abstract class Type_factory__o_u_c_w_WorkbenchLayoutImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchLayoutImpl> { }
  public abstract class Type_factory__o_j_d_c_p_AssignmentListItemWidgetViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<AssignmentListItemWidgetViewImpl> { }
  public abstract class Type_factory__o_k_w_c_w_d_c_DecoratedGridEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<DecoratedGridEntryPoint> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_p_c_ActionSetFieldPatternCell__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionSetFieldPatternCell> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_t_TagSelector__quals__j_e_i_Any_j_e_i_Default extends Factory<TagSelector> { }
  public abstract class Type_factory__o_g_a_m_c_e_c_RepositoryConfigurationViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoryConfigurationViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_CRUDListBoxViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<CRUDListBoxViewImpl> { }
  public abstract class Type_factory__o_d_d_e_c_s_DataSetDefExplorerScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<DataSetDefExplorerScreenActivity> { }
  public abstract class Type_factory__o_k_w_c_w_c_h_PackageListBox__quals__j_e_i_Any_j_e_i_Default extends Factory<PackageListBox> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_p_GuidedDecisionTreeStencilPaletteBuilder__quals__j_e_i_Any_o_d_w_s_g_d_c_w_p_GuidedDecisionTree extends Factory<GuidedDecisionTreeStencilPaletteBuilder> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_PomEditorScreenPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<PomEditorScreenPresenter> { }
  public abstract class ExtensionProvided_factory__o_j_c_n_g_c_u_UTCDateBox__quals__j_e_i_Any_j_e_i_Default extends Factory<UTCDateBox> { }
  public abstract class Type_factory__o_d_d_c_p_DataSetPrototypes__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetPrototypes> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_c_s_c_ContainerCardPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ContainerCardPresenter> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_a_p_AnalysisReportScreenViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<AnalysisReportScreenViewImpl> { }
  public abstract class Type_factory__o_j_e_i_c_l_i_LifecycleListenerRegistrarImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<LifecycleListenerRegistrarImpl> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_a_p_IssuePresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<IssuePresenter> { }
  public abstract class Type_factory__o_j_d_r_c_p_w_ProcessBreadCrumb__quals__j_e_i_Any_j_e_i_Default extends Factory<ProcessBreadCrumb> { }
  public abstract class Type_factory__o_d_d_c_w_g_DataSetGroupDateEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetGroupDateEditorView> { }
  public abstract class Type_factory__o_d_d_c_w_DisplayerSubtypeSelectorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayerSubtypeSelectorView> { }
  public abstract class Type_factory__o_g_a_m_c_e_r_w_p_RepositoryInfoPageViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoryInfoPageViewImpl> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_GridWidgetCellFactoryImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<GridWidgetCellFactoryImpl> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_EntitiesExplorerViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<EntitiesExplorerViewImpl> { }
  public abstract class Type_factory__o_j_c_n_p_c_e_i_s_ProcessInstanceSignalPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<ProcessInstanceSignalPresenterActivity> { }
  public abstract class ContextualProvider_factory__o_j_e_c_c_d_HTMLElement__quals__Universal extends Factory<HTMLElement> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_m_MainDataObjectEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<MainDataObjectEditorViewImpl> { }
  public abstract class Type_factory__o_u_e_a_c_AppsEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<AppsEntryPoint> { }
  public abstract class Type_factory__o_g_s_c_e_r_e_RepositoryEditorPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<RepositoryEditorPresenterActivity> { }
  public abstract class Type_factory__o_j_c_n_g_c_p_ExperimentalPagingPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<ExperimentalPagingPerspectiveActivity> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_a_ArtifactListWidgetPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ArtifactListWidgetPresenter> { }
  public abstract class Type_factory__o_d_d_c_ClientSettings__quals__j_e_i_Any_j_e_i_Default extends Factory<ClientSettings> { }
  public abstract class Type_factory__o_u_e_e_c_c_h_VersionHistoryPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<VersionHistoryPresenter> { }
  public abstract class Type_factory__o_d_c_w_d_e_DataSetEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetEditorView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_ConditionColumnConverter__quals__j_e_i_Any_j_e_i_Default extends Factory<ConditionColumnConverter> { }
  public abstract class Type_factory__o_u_e_w_c_t_c_f_ExampleTreeNode2Factory__quals__j_e_i_Any_j_e_i_Default extends Factory<ExampleTreeNode2Factory> { }
  public abstract class Type_factory__o_u_c_v_p_m_ErrorPopupView__quals__j_e_i_Any_j_e_i_Default extends Factory<ErrorPopupView> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_u_Classifier__quals__j_e_i_Any_j_e_i_Default extends Factory<Classifier> { }
  public abstract class Type_factory__o_u_e_w_c_t_c_p_TreeNodesGroup__quals__j_e_i_Any_j_e_i_Default extends Factory<TreeNodesGroup> { }
  public abstract class Type_factory__o_d_d_c_w_DisplayerSubtypeSelector__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayerSubtypeSelector> { }
  public abstract class Type_factory__o_j_c_n_p_f_c_d_d_p_FTLStartProcessDisplayerImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<FTLStartProcessDisplayerImpl> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_RolesExplorer__quals__j_e_i_Any_j_e_i_Default extends Factory<RolesExplorer> { }
  public abstract class Type_factory__o_j_c_n_p_c_e_d_d_m_b_BasicProcessDefDetailsMultiPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<BasicProcessDefDetailsMultiPresenter> { }
  public abstract class Type_factory__o_d_d_c_DisplayerLocator__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayerLocator> { }
  public abstract class Type_factory__o_j_c_n_d_c_p_f_ColumnFilterEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<org.jbpm.console.ng.df.client.popup.filter.ColumnFilterEditor> { }
  public abstract class Type_factory__o_d_d_c_w_f_LikeToFunctionEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<LikeToFunctionEditorView> { }
  public abstract class Type_factory__o_u_c_w_t_AnyResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<AnyResourceType> { }
  public abstract class Type_factory__o_u_c_w_w_n_NotificationManager__quals__j_e_i_Any_j_e_i_Default extends Factory<NotificationManager> { }
  public abstract class Type_factory__o_j_c_n_h_c_p_DataSetTasksListPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<DataSetTasksListPerspectiveActivity> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_KModuleEditorScreenPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<KModuleEditorScreenPresenter> { }
  public abstract class Type_factory__o_u_e_w_c_c_l_StencilLayerBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<StencilLayerBuilder> { }
  public abstract class Type_factory__o_u_e_e_c_c_m_RestoreVersionCommandProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<RestoreVersionCommandProvider> { }
  public abstract class Type_factory__o_d_r_g_c_GoogleMapDisplayer__quals__j_e_i_Any_j_e_i_Default extends Factory<GoogleMapDisplayer> { }
  public abstract class Type_factory__o_k_w_c_w_c_m_DefaultWorkbenchFeaturesMenusHelper__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultWorkbenchFeaturesMenusHelper> { }
  public abstract class Type_factory__o_o_w_s_d_c_w_p_PlannerDomainScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<PlannerDomainScreen> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_n_MultiplePermissionNodeViewer__quals__j_e_i_Any_j_e_i_Default extends Factory<MultiplePermissionNodeViewer> { }
  public abstract class Type_factory__o_u_e_l_e_c_LayoutEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<LayoutEditorPresenter> { }
  public abstract class Type_factory__o_d_c_w_d_e_c_ColumnListEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<ColumnListEditor> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_KBaseFormViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<KBaseFormViewImpl> { }
  public abstract class Type_factory__o_j_c_n_w_c_e_d_d_DeploymentDescriptorEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<DeploymentDescriptorEditorPresenter> { }
  public abstract class Type_factory__o_u_c_w_t_DotResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<DotResourceType> { }
  public abstract class Type_factory__o_k_w_c_w_c_p_t_TextBoxFormPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<TextBoxFormPopup> { }
  public abstract class Type_factory__o_d_w_s_t_c_h_NewTestScenarioHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<NewTestScenarioHandler> { }
  public abstract class Type_factory__o_d_d_e_f_AggregateFunctionManagerImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<AggregateFunctionManagerImpl> { }
  public abstract class Provider_factory__o_j_e_s_c_l_s_UserStorageHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<UserStorageHandler> { }
  public abstract class Type_factory__o_o_w_s_d_c_w_p_PlannerDomainScreenViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<PlannerDomainScreenViewImpl> { }
  public abstract class ContextualProvider_factory__o_j_e_i_c_a_ManagedInstance__quals__Universal extends Factory<ManagedInstance> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_p_c_ActionInsertFactFieldPatternCell__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionInsertFactFieldPatternCell> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_p_LoadingBoxView__quals__j_e_i_Any_j_e_i_Default extends Factory<org.uberfire.ext.security.management.client.widgets.popup.LoadingBoxView> { }
  public abstract class Type_factory__o_u_e_e_c_c_f_CopyPopupViewImpl__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<CopyPopupViewImpl> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_ActionSetFieldColumnConverter__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionSetFieldColumnConverter> { }
  public abstract class Type_factory__o_u_c_p_JSNativePerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<JSNativePerspective> { }
  public abstract class Type_factory__o_k_w_c_p_AdministrationPerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<AdministrationPerspective> { }
  public abstract class Type_factory__o_j_c_n_p_f_c_d_v_PopupFormDisplayerView__quals__j_e_i_Any_j_e_i_Default extends Factory<PopupFormDisplayerView> { }
  public abstract class Type_factory__o_g_s_c_e_r_l_RepositoriesPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<RepositoriesPresenterActivity> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_n_PermissionSwitch__quals__j_e_i_Any_j_e_i_Default extends Factory<PermissionSwitch> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_u_UserAssignedGroupsEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<UserAssignedGroupsEditor> { }
  public abstract class Type_factory__o_d_c_w_d_e_a_DataSetDefRefreshIntervalEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefRefreshIntervalEditor> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_GuidedDecisionTreeEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedDecisionTreeEditorViewImpl> { }
  public abstract class Type_factory__o_j_f_e_c_e_FormModelerPanelPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<FormModelerPanelPresenterActivity> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_p_SummaryPageViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<SummaryPageViewImpl> { }
  public abstract class ExtensionProvided_factory__o_g_c_u_DropDownMenu__quals__j_e_i_Any_j_e_i_Default extends Factory<DropDownMenu> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_c_s_ContainerRemoteStatusView__quals__j_e_i_Any_j_e_i_Default extends Factory<ContainerRemoteStatusView> { }
  public abstract class Producer_factory__o_k_w_c_s_h_m_HomeModel__quals__j_e_i_Any_j_e_i_Default extends Factory<HomeModel> { }
  public abstract class Type_factory__o_d_c_w_d_e_a_DataSetDefBasicAttributesEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefBasicAttributesEditorView> { }
  public abstract class Type_factory__o_d_d_c_w_f_TextParameterEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<TextParameterEditorView> { }
  public abstract class Type_factory__o_j_c_n_p_c_e_d_l_ProcessDefinitionListPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ProcessDefinitionListPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_d_NewDependencyPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<NewDependencyPopup> { }
  public abstract class Type_factory__o_u_c_s_JSNativeScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<JSNativeScreen> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_ServerManagementBrowserView__quals__j_e_i_Any_j_e_i_Default extends Factory<ServerManagementBrowserView> { }
  public abstract class Type_factory__o_k_w_c_w_c_p_c_CopyPopupWithPackageViewImpl__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<CopyPopupWithPackageViewImpl> { }
  public abstract class ContextualProvider_factory__o_j_e_d_c_a_DataBinder__quals__Universal extends Factory<DataBinder> { }
  public abstract class Type_factory__o_u_e_w_c_c_t_p_NewTabFilterPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<NewTabFilterPopup> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_ActionWorkItemInsertFactColumnConverter__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionWorkItemInsertFactColumnConverter> { }
  public abstract class Type_factory__o_g_s_c_e_r_l_RepositoryItemViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoryItemViewImpl> { }
  public abstract class Type_factory__o_d_w_s_g_r_c_e_GuidedRuleEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedRuleEditorPresenter> { }
  public abstract class Type_factory__o_j_d_c_DesignerPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<DesignerPresenterActivity> { }
  public abstract class Type_factory__o_u_e_e_c_c_f_RestorePopup__quals__j_e_i_Any_j_e_i_Default extends Factory<RestorePopup> { }
  public abstract class Type_factory__o_u_e_p_c_e_DynamicMenuEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<DynamicMenuEditorPresenter> { }
  public abstract class Type_factory__o_o_w_s_s_c_h_NewSolverHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<NewSolverHandler> { }
  public abstract class Type_factory__o_d_w_s_w_c_w_WorkItemDefinitionElementsBrowser__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkItemDefinitionElementsBrowser> { }
  public abstract class Type_factory__o_d_d_c_w_DisplayerEditorPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayerEditorPopup> { }
  public abstract class Type_factory__o_j_c_n_p_f_c_d_s_StandaloneProcessFormDisplayScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<StandaloneProcessFormDisplayScreenActivity> { }
  public abstract class Type_factory__o_j_e_i_c_a_b_RootPanelProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<RootPanelProvider> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_AdvancedDataObjectFieldEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<AdvancedDataObjectFieldEditorViewImpl> { }
  public abstract class Type_factory__o_d_w_s_e_c_e_EnumEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<EnumEditorPresenterActivity> { }
  public abstract class Producer_factory__o_j_e_u_n_c_l_s_NavigationGraph__quals__j_e_i_Any_j_e_i_Default extends Factory<NavigationGraph> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_KBaseForm__quals__j_e_i_Any_j_e_i_Default extends Factory<KBaseForm> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_p_GuidedDecisionTreePalette__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedDecisionTreePalette> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_c_ContainerPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ContainerPresenter> { }
  public abstract class Type_factory__o_u_e_w_c_c_e_t_TextEditorWorkbenchEditorActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<TextEditorWorkbenchEditorActivity> { }
  public abstract class Type_factory__o_j_c_n_g_f_c_GenericFormsClientEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<GenericFormsClientEntryPoint> { }
  public abstract class Type_factory__o_u_e_p_c_e_ScreenEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<ScreenEditorPresenterActivity> { }
  public abstract class Type_factory__o_u_e_w_c_c_e_m_MetaFileEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<MetaFileEditorPresenter> { }
  public abstract class Type_factory__o_d_d_c_w_f_DateParameterEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<org.dashbuilder.displayer.client.widgets.filter.DateParameterEditor> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_v_ProjectNameValidator__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectNameValidator> { }
  public abstract class Type_factory__o_j_e_u_n_c_l_URLPatternMatcherProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<URLPatternMatcherProvider> { }
  public abstract class Type_factory__o_j_c_n_h_c_e_t_g_DroolsTasksListGridPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<DroolsTasksListGridPresenter> { }
  public abstract class Type_factory__o_d_d_c_DisplayerCoordinator__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayerCoordinator> { }
  public abstract class Type_factory__o_d_d_c_w_f_TextParameterEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<org.dashbuilder.displayer.client.widgets.filter.TextParameterEditor> { }
  public abstract class Type_factory__o_u_e_w_c_c_p_ShapesGroup__quals__j_e_i_Any_j_e_i_Default extends Factory<ShapesGroup> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_c_p_ProcessConfigPagePresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ProcessConfigPagePresenter> { }
  public abstract class Type_factory__o_j_c_n_d_c_l_b_DataSetEditorManager__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetEditorManager> { }
  public abstract class Type_factory__o_d_w_s_t_c_t_TestScenarioResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<TestScenarioResourceType> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_m_RadarMenuBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<RadarMenuBuilder> { }
  public abstract class Type_factory__o_u_e_w_c_t_c_p_WiresTreesPaletteScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<WiresTreesPaletteScreenActivity> { }
  public abstract class Type_factory__o_u_e_p_c_s_PluginController__quals__j_e_i_Any_j_e_i_Default extends Factory<PluginController> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_r_w_RoleEditorWorkflow__quals__j_e_i_Any_j_e_i_Default extends Factory<RoleEditorWorkflow> { }
  public abstract class Type_factory__o_k_w_c_s_s_c_m_SearchMenuPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<SearchMenuPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_ServerManagementBrowserPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ServerManagementBrowserPresenter> { }
  public abstract class Type_factory__o_g_s_c_e_r_l_RepositoryItemPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoryItemPresenter> { }
  public abstract class Type_factory__o_j_c_n_h_c_e_t_g_d_DataSetTasksListGridViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetTasksListGridViewImpl> { }
  public abstract class Type_factory__o_d_w_s_t_c_ScenarioWidgetComponentCreator__quals__j_e_i_Any_j_e_i_Default extends Factory<ScenarioWidgetComponentCreator> { }
  public abstract class Type_factory__o_d_w_s_d_c_t_DSLRResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<DSLRResourceType> { }
  public abstract class Type_factory__o_u_c_w_WorkbenchLayoutInfoImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchLayoutInfoImpl> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_e_NewFileUploader__quals__j_e_i_Any_j_e_i_Default extends Factory<NewFileUploader> { }
  public abstract class Type_factory__o_u_e_w_c_t_c_l_WiresTreesDefaultLayout__quals__j_e_i_Any_j_e_i_Default extends Factory<WiresTreesDefaultLayout> { }
  public abstract class Type_factory__o_j_d_r_c_p_DashboardPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<DashboardPerspectiveActivity> { }
  public abstract class Type_factory__o_k_w_c_s_s_h_c_h_SocialHomePageMainPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<SocialHomePageMainPresenterActivity> { }
  public abstract class Type_factory__o_j_c_n_e_c_e_r_RequestListViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<RequestListViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_c_t_InfoTitlePresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<InfoTitlePresenter> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_ACLViewerView__quals__j_e_i_Any_j_e_i_Default extends Factory<ACLViewerView> { }
  public abstract class Type_factory__o_d_c_w_d_e_w_e_CSVDataSetEditWorkflow__quals__j_e_i_Any_j_e_i_Default extends Factory<CSVDataSetEditWorkflow> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_PersistenceDescriptorEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<PersistenceDescriptorEditorPresenterActivity> { }
  public abstract class Type_factory__o_j_e_u_s_ServerTemplateProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<ServerTemplateProvider> { }
  public abstract class Type_factory__o_j_c_n_p_c_e_i_l_RuntimeLogViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<RuntimeLogViewImpl> { }
  public abstract class ExtensionProvided_factory__o_g_c_u_Button__quals__j_e_i_Any_j_e_i_Default extends Factory<org.gwtbootstrap3.client.ui.Button> { }
  public abstract class Type_factory__o_j_f_e_t_FormResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default extends Factory<FormResourceTypeDefinition> { }
  public abstract class Type_factory__o_g_a_m_c_e_p_PromoteChangesPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<PromoteChangesPresenterActivity> { }
  public abstract class Type_factory__o_u_e_s_m_c_s_e_UserEditorScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<UserEditorScreenActivity> { }
  public abstract class Type_factory__o_d_w_s_t_c_ScenarioKSessionSelector__quals__j_e_i_Any_j_e_i_Default extends Factory<ScenarioKSessionSelector> { }
  public abstract class Type_factory__o_d_w_s_g_c_t_GlobalResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<GlobalResourceType> { }
  public abstract class Producer_factory__o_d_c_w_d_e_d_CSVDataSetDefAttributesDriver__quals__j_e_i_Any_j_e_i_Default extends Factory<CSVDataSetDefAttributesDriver> { }
  public abstract class Type_factory__o_u_c_m_PlaceManagerImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<PlaceManagerImpl> { }
  public abstract class Type_factory__o_u_c_m_CustomSplashHelp__quals__j_e_i_Any_j_e_i_Default extends Factory<CustomSplashHelp> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_n_LeafPermissionNodeEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<LeafPermissionNodeEditorView> { }
  public abstract class Type_factory__o_g_s_c_e_r_c_CloneRepositoryPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<CloneRepositoryPresenter> { }
  public abstract class Type_factory__o_j_c_n_h_c_e_t_TaskDetailsMultiPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<TaskDetailsMultiPresenter> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_a_p_AnalysisReportScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<AnalysisReportScreen> { }
  public abstract class Type_factory__o_k_w_c_w_c_h_w_c_WorkbenchConfigurationPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchConfigurationPresenter> { }
  public abstract class Type_factory__o_u_e_w_c_t_c_c_WiresTreesScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<WiresTreesScreen> { }
  public abstract class Type_factory__o_j_f_r_i_FormRendererPanelIncluderViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<FormRendererPanelIncluderViewImpl> { }
  public abstract class Type_factory__o_u_s_i_a_DefaultAuthorizationManager__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultAuthorizationManager> { }
  public abstract class Type_factory__o_u_e_p_c_p_PlugInAuthoringPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<PlugInAuthoringPerspectiveActivity> { }
  public abstract class Type_factory__o_d_w_s_w_c_WorkItemsEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkItemsEditorEntryPoint> { }
  public abstract class Type_factory__o_d_w_s_w_c_t_WorkItemsResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkItemsResourceType> { }
  public abstract class Type_factory__o_j_d_c_p_DesignerEditorParametersPublisher__quals__j_e_i_Any_j_e_i_Default extends Factory<DesignerEditorParametersPublisher> { }
  public abstract class Type_factory__o_u_e_p_c_e_ScreenEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ScreenEditorPresenter> { }
  public abstract class Type_factory__o_j_c_n_d_c_p_f_TimeFrameEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<org.jbpm.console.ng.df.client.popup.filter.TimeFrameEditor> { }
  public abstract class Type_factory__o_u_e_e_c_c_f_SaveOperationService_SaveOperationNotifier__quals__j_e_i_Any_j_e_i_Default extends Factory<SaveOperationNotifier> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_BRLConditionVariableColumnConverter__quals__j_e_i_Any_j_e_i_Default extends Factory<BRLConditionVariableColumnConverter> { }
  public abstract class ExtensionProvided_factory__o_k_w_c_w_c_s_ViewDRLSourceWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<ViewDRLSourceWidget> { }
  public abstract class Type_factory__o_d_w_s_g_c_e_GlobalsEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<GlobalsEditorPresenter> { }
  public abstract class Type_factory__o_d_c_c_w_AlertPanel__quals__j_e_i_Any_j_e_i_Default extends Factory<AlertPanel> { }
  public abstract class Type_factory__o_j_e_u_n_c_l_TransitionAnchorFactoryProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<TransitionAnchorFactoryProvider> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_CreateEntity__quals__j_e_i_Any_j_e_i_Default extends Factory<CreateEntity> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_ChangePassword__quals__j_e_i_Any_j_e_i_Default extends Factory<ChangePassword> { }
  public abstract class Type_factory__o_k_w_c_w_c_a_WorkbenchTreeProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchTreeProvider> { }
  public abstract class Type_factory__o_g_m_c_c_MessageConsoleService__quals__j_e_i_Any_j_e_i_Default extends Factory<MessageConsoleService> { }
  public abstract class Type_factory__o_u_c_m_WorkbenchViewModeSwitcherMenuBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchViewModeSwitcherMenuBuilder> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_l_GuidedDecisionTableLockManagerImpl__quals__j_e_i_Any_o_d_w_s_g_d_c_GuidedDecisionTable extends Factory<GuidedDecisionTableLockManagerImpl> { }
  public abstract class Type_factory__o_u_c_w_p_i_UnanchoredStaticWorkbenchPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<UnanchoredStaticWorkbenchPanelView> { }
  public abstract class Type_factory__o_k_w_c_s_s_h_c_h_SocialHomePageSidePresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<SocialHomePageSidePresenter> { }
  public abstract class Type_factory__o_u_e_l_e_c_i_DnDManager__quals__j_e_i_Any_j_e_i_Default extends Factory<DnDManager> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_r_RemoteStatusView__quals__j_e_i_Any_j_e_i_Default extends Factory<RemoteStatusView> { }
  public abstract class Type_factory__o_k_w_c_s_h_c_w_h_HomePresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<HomePresenter> { }
  public abstract class Type_factory__o_g_i_c_InboxPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<InboxPresenterActivity> { }
  public abstract class Type_factory__o_u_e_w_c_c_p_PropertiesScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<PropertiesScreen> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_u_UserAttributesEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<UserAttributesEditor> { }
  public abstract class Type_factory__o_k_w_c_w_c_h_NewResourceView__quals__j_e_i_Any_j_e_i_Default extends Factory<NewResourceView> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_j_p_SequenceGeneratorField__quals__j_e_i_Any_j_e_i_Default extends Factory<SequenceGeneratorField> { }
  public abstract class Type_factory__o_d_c_w_d_e_w_e_SQLDataSetEditWorkflow__quals__j_e_i_Any_j_e_i_Default extends Factory<SQLDataSetEditWorkflow> { }
  public abstract class Type_factory__o_d_d_c_w_DisplayerEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayerEditorView> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_ExamplesScreenEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<ExamplesScreenEntryPoint> { }
  public abstract class Type_factory__o_u_c_d_v_DocksBars__quals__j_e_i_Any_j_e_i_Default extends Factory<DocksBars> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_d_DroolsDomainScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<DroolsDomainScreen> { }
  public abstract class Type_factory__o_j_e_i_c_a_b_DisposerProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<DisposerProvider> { }
  public abstract class Type_factory__o_o_w_s_s_c_e_TerminationTreeItemContent__quals__j_e_i_Any_j_e_i_Default extends Factory<TerminationTreeItemContent> { }
  public abstract class Type_factory__o_d_d_c_w_RendererSelector__quals__j_e_i_Any_j_e_i_Default extends Factory<RendererSelector> { }
  public abstract class Type_factory__o_u_e_w_c_c_l_LayersScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<LayersScreenActivity> { }
  public abstract class Type_factory__o_u_e_p_t_DynamicMenuResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default extends Factory<DynamicMenuResourceTypeDefinition> { }
  public abstract class ExtensionProvided_factory__o_g_c_u_Icon__quals__j_e_i_Any_j_e_i_Default extends Factory<Icon> { }
  public abstract class Type_factory__o_d_d_c_e_ClientChronometer__quals__j_e_i_Any_j_e_i_Default extends Factory<ClientChronometer> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_KSessionsPanelViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<KSessionsPanelViewImpl> { }
  public abstract class Type_factory__o_g_a_m_c_e_f_p_SelectAssetsToPromotePresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<SelectAssetsToPromotePresenter> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_AttributeColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default extends Factory<AttributeColumnSynchronizer> { }
  public abstract class Type_factory__o_u_e_a_c_h_AppsHomeView__quals__j_e_i_Any_j_e_i_Default extends Factory<AppsHomeView> { }
  public abstract class Type_factory__o_u_e_l_e_c_c_r_EmptyDropRow__quals__j_e_i_Any_j_e_i_Default extends Factory<EmptyDropRow> { }
  public abstract class Type_factory__o_j_e_i_c_a_b_ManagedInstanceProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<ManagedInstanceProvider> { }
  public abstract class Type_factory__o_d_c_w_d_e_w_c_CSVDataSetBasicAttributesWorkflow__quals__j_e_i_Any_j_e_i_Default extends Factory<CSVDataSetBasicAttributesWorkflow> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_f_ActionUpdateNodeFactory__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionUpdateNodeFactory> { }
  public abstract class Type_factory__o_j_c_n_d_c_f_FilterEditorPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<FilterEditorPopup> { }
  public abstract class Type_factory__o_u_e_w_c_t_c_f_ExampleTreeNode3DynamicFactory__quals__j_e_i_Any_j_e_i_Default extends Factory<ExampleTreeNode3DynamicFactory> { }
  public abstract class Type_factory__o_j_d_r_c_p_DashboardPerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<DashboardPerspective> { }
  public abstract class Type_factory__o_u_e_w_c_c_p_ConnectorsGroup__quals__j_e_i_Any_j_e_i_Default extends Factory<ConnectorsGroup> { }
  public abstract class Type_factory__o_d_c_w_d_e_s_SQLDataSetDefAttributesEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<SQLDataSetDefAttributesEditor> { }
  public abstract class Type_factory__o_d_c_w_d_e_DataSetSummary__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetSummary> { }
  public abstract class Type_factory__o_j_e_s_c_l_i_AuthenticationServiceInterceptor__quals__j_e_i_Any_j_e_i_Default extends Factory<AuthenticationServiceInterceptor> { }
  public abstract class Type_factory__o_k_w_c_p_DroolsAuthoringPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<DroolsAuthoringPerspectiveActivity> { }
  public abstract class Type_factory__o_u_e_p_c_p_e_l_e_ScreenLayoutDragComponent__quals__j_e_i_Any_j_e_i_Default extends Factory<ScreenLayoutDragComponent> { }
  public abstract class Type_factory__o_g_a_m_c_e_b_BuildConfigurationViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<BuildConfigurationViewImpl> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_p_c_ActionSetFieldCell__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionSetFieldCell> { }
  public abstract class Type_factory__o_j_e_u_c_l_p_HTMLElementProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<HTMLElementProvider> { }
  public abstract class Type_factory__o_g_a_m_c_e_b_BuildConfigurationPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<BuildConfigurationPresenter> { }
  public abstract class Type_factory__o_o_w_s_s_c_e_PhaseConfigFormViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<PhaseConfigFormViewImpl> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_h_NewGuidedDecisionTableHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<NewGuidedDecisionTableHandler> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_l_RolesList__quals__j_e_i_Any_j_e_i_Default extends Factory<RolesList> { }
  public abstract class Type_factory__o_u_e_e_c_c_v_DefaultFileNameValidator__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultFileNameValidator> { }
  public abstract class Producer_factory__o_d_c_w_d_e_d_DataSetDefProviderTypeDriver__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefProviderTypeDriver> { }
  public abstract class Type_factory__o_u_c_d_v_m_MenuBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<MenuBuilder> { }
  public abstract class Type_factory__o_k_w_c_w_c_s_ViewSourceViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ViewSourceViewImpl> { }
  public abstract class Producer_factory__o_d_c_w_d_e_d_SQLDataSetDefDriver__quals__j_e_i_Any_j_e_i_Default extends Factory<SQLDataSetDefDriver> { }
  public abstract class Type_factory__o_k_w_c_s_s_h_c_h_h_HeaderView__quals__j_e_i_Any_j_e_i_Default extends Factory<org.kie.workbench.common.screens.social.hp.client.homepage.header.HeaderView> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_v_ValuePairEditorPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<ValuePairEditorPopup> { }
  public abstract class Type_factory__o_u_e_w_c_c_t_p_NewFilterPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<NewFilterPopup> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_p_ConfirmBoxView__quals__j_e_i_Any_j_e_i_Default extends Factory<ConfirmBoxView> { }
  public abstract class Type_factory__o_d_r_g_c_GooglePieChartDisplayerView__quals__j_e_i_Any_j_e_i_Default extends Factory<GooglePieChartDisplayerView> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_d_DroolsDataObjectFieldEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DroolsDataObjectFieldEditorViewImpl> { }
  public abstract class Type_factory__o_g_o_m_c_OrganizationalUnitManagerEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<OrganizationalUnitManagerEntryPoint> { }
  public abstract class Type_factory__o_u_e_s_m_c_s_BaseScreenView__quals__j_e_i_Any_j_e_i_Default extends Factory<BaseScreenView> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_j_JPADomainScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<JPADomainScreenActivity> { }
  public abstract class Producer_factory__o_u_r_SessionInfo__quals__j_e_i_Any_j_e_i_Default extends Factory<SessionInfo> { }
  public abstract class Type_factory__o_u_e_s_m_c_s_e_RoleEditorScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<RoleEditorScreenActivity> { }
  public abstract class Type_factory__o_u_e_w_c_c_p_PaletteScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<PaletteScreen> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_c_c_p_ContainerProcessConfigView__quals__j_e_i_Any_j_e_i_Default extends Factory<ContainerProcessConfigView> { }
  public abstract class Type_factory__o_d_w_s_s_c_h_NewScoreCardXLSHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<NewScoreCardXLSHandler> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_m_ViewMenuViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ViewMenuViewImpl> { }
  public abstract class ExtensionProvided_factory__o_s_Logger__quals__Universal_11 extends Factory<Logger> { }
  public abstract class ExtensionProvided_factory__o_s_Logger__quals__Universal_10 extends Factory<Logger> { }
  public abstract class Type_factory__o_d_w_s_g_c_e_GlobalsEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<GlobalsEditorViewImpl> { }
  public abstract class Type_factory__o_k_w_c_w_m_c_w_TagWidgetViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<TagWidgetViewImpl> { }
  public abstract class Type_factory__o_g_a_m_c_e_r_w_p_RepositoryInfoPage__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoryInfoPage> { }
  public abstract class Type_factory__o_o_w_s_s_c_e_ScoreDirectorFactoryForm__quals__j_e_i_Any_j_e_i_Default extends Factory<ScoreDirectorFactoryForm> { }
  public abstract class ExtensionProvided_factory__o_s_Logger__quals__Universal_13 extends Factory<Logger> { }
  public abstract class ExtensionProvided_factory__o_s_Logger__quals__Universal_12 extends Factory<Logger> { }
  public abstract class Type_factory__o_d_c_w_d_e_c_DataColumnDefEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DataColumnDefEditor> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_a_AdvancedAnnotationListEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<AdvancedAnnotationListEditorViewImpl> { }
  public abstract class Type_factory__o_j_e_e_c_c_InstanceProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<InstanceProvider> { }
  public abstract class Type_factory__o_g_a_m_c_e_f_a_ApproveOperationPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ApproveOperationPresenter> { }
  public abstract class Type_factory__o_k_w_c_w_c_w_KSessionSelector__quals__j_e_i_Any_j_e_i_Default extends Factory<KSessionSelector> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_p_SummaryPage__quals__j_e_i_Any_j_e_i_Default extends Factory<SummaryPage> { }
  public abstract class Type_factory__o_g_a_m_c_e_f_e_DisplayErrorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayErrorViewImpl> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_m_RadarMenuViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<RadarMenuViewImpl> { }
  public abstract class Type_factory__o_j_c_n_e_c_e_r_RequestListPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<RequestListPresenterActivity> { }
  public abstract class Type_factory__o_u_c_v_p_n_NotificationPopupsManagerView__quals__j_e_i_Any_j_e_i_Default extends Factory<NotificationPopupsManagerView> { }
  public abstract class Type_factory__o_j_c_n_p_c_e_d_l_ProcessDefinitionListPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<ProcessDefinitionListPresenterActivity> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_p_c_ConditionPatternCell__quals__j_e_i_Any_j_e_i_Default extends Factory<ConditionPatternCell> { }
  public abstract class Type_factory__o_d_w_s_s_c_ScoreCardXLSEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<ScoreCardXLSEntryPoint> { }
  public abstract class Type_factory__o_j_c_n_e_c_e_j_JobDetailsPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<JobDetailsPopup> { }
  public abstract class Type_factory__o_d_d_c_w_f_ColumnFilterEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<ColumnFilterEditorView> { }
  public abstract class Type_factory__o_k_w_c_w_c_d_DiscussionWidgetPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<DiscussionWidgetPresenter> { }
  public abstract class Type_factory__o_u_c_m_ForceUnlockEventObserver__quals__j_e_i_Any_j_e_i_Default extends Factory<ForceUnlockEventObserver> { }
  public abstract class ExtensionProvided_factory__c_g_g_u_c_u_Tree__quals__j_e_i_Any_j_e_i_Default extends Factory<Tree> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_r_c_ContainerCardPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<org.kie.workbench.common.screens.server.management.client.remote.card.ContainerCardPresenter> { }
  public abstract class Type_factory__o_u_c_w_PanelManagerImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<PanelManagerImpl> { }
  public abstract class Type_factory__o_u_e_p_c_t_SplashPluginResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<SplashPluginResourceType> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_c_s_c_ContainerCardView__quals__j_e_i_Any_j_e_i_Default extends Factory<ContainerCardView> { }
  public abstract class Type_factory__o_k_w_c_w_m_c_p_SelectableDocumentImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<SelectableDocumentImpl> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_NewContainerWizard__quals__j_e_i_Any_j_e_i_Default extends Factory<NewContainerWizard> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_t_NewTemplatePresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<NewTemplatePresenter> { }
  public abstract class Type_factory__o_d_w_s_g_r_c_h_NewGuidedRuleHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<NewGuidedRuleHandler> { }
  public abstract class ExtensionProvided_factory__o_g_c_u_CheckBox__quals__j_e_i_Any_j_e_i_Default extends Factory<CheckBox> { }
  public abstract class ContextualProvider_factory__o_j_e_i_s_b_c_Sender__quals__Universal extends Factory<Sender> { }
  public abstract class Type_factory__o_u_e_p_c_w_n_PluginNavList__quals__j_e_i_Any_j_e_i_Default extends Factory<PluginNavList> { }
  public abstract class Type_factory__o_j_c_n_p_c_e_i_d_m_ProcessInstanceDetailsMultiViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ProcessInstanceDetailsMultiViewImpl> { }
  public abstract class Type_factory__o_u_e_w_c_c_l_LayersScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<LayersScreen> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_n_LeafPermissionNodeEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<LeafPermissionNodeEditor> { }
  public abstract class Type_factory__o_d_w_s_d_c_DecisionTableXLSEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<DecisionTableXLSEntryPoint> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_p_ProjectClassList__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectClassList> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_e_ProjectScreenViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectScreenViewImpl> { }
  public abstract class Type_factory__o_u_c_m_SplashScreenMenuPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<SplashScreenMenuPresenter> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_ACLSettings__quals__j_e_i_Any_j_e_i_Default extends Factory<ACLSettings> { }
  public abstract class Type_factory__o_o_w_s_s_c_e_TerminationConfigFormViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<TerminationConfigFormViewImpl> { }
  public abstract class Type_factory__o_d_c_c_e_ValueBoxEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<ValueBoxEditor> { }
  public abstract class ExtensionProvided_factory__o_k_w_c_s_j_c_w_ViewJavaSourceWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<ViewJavaSourceWidget> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_e_NewFieldPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<NewFieldPopup> { }
  public abstract class Type_factory__o_j_d_r_c_p_TaskDashboardView__quals__j_e_i_Any_j_e_i_Default extends Factory<TaskDashboardView> { }
  public abstract class Type_factory__o_j_c_n_h_c_e_t_TaskFormViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<TaskFormViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_e_XmlResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<XmlResourceType> { }
  public abstract class Type_factory__o_d_w_s_g_s_c_e_GuidedScoreCardEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<GuidedScoreCardEditorPresenterActivity> { }
  public abstract class Type_factory__o_j_c_n_g_f_c_d_v_GenericFormDisplayPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<GenericFormDisplayPresenter> { }
  public abstract class Type_factory__o_d_w_s_g_r_c_e_GuidedRuleEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedRuleEditorViewImpl> { }
  public abstract class Type_factory__o_u_e_w_c_c_l_LayersGroup__quals__j_e_i_Any_j_e_i_Default extends Factory<LayersGroup> { }
  public abstract class Type_factory__o_u_e_w_c_c_e_t_TextEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<TextEditorView> { }
  public abstract class Type_factory__o_d_d_c_w_f_TimeFrameEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<TimeFrameEditorView> { }
  public abstract class Type_factory__o_j_c_n_p_c_e_d_l_ProcessDefinitionListViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ProcessDefinitionListViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_s_h_c_u_m_h_HeaderPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<HeaderPresenter> { }
  public abstract class Type_factory__o_d_d_c_DisplayerScreenPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayerScreenPresenter> { }
  public abstract class Type_factory__o_d_c_w_d_e_s_SQLDataSetDefAttributesEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<SQLDataSetDefAttributesEditorView> { }
  public abstract class Type_factory__o_g_a_m_c_e_f_e_DisplayErrorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayErrorPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_d_s_XmlResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default extends Factory<XmlResourceTypeDefinition> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_e_GuvnorDefaultEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<GuvnorDefaultEditorPresenter> { }
  public abstract class Type_factory__o_u_c_w_p_i_TemplatedWorkbenchPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<TemplatedWorkbenchPanelView> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_c_CardView__quals__j_e_i_Any_j_e_i_Default extends Factory<CardView> { }
  public abstract class Type_factory__o_u_s_c_a_AuthorizationManagerHelper__quals__j_e_i_Any_j_e_i_Default extends Factory<AuthorizationManagerHelper> { }
  public abstract class Type_factory__o_k_w_c_s_h_c_HomeEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<HomeEntryPoint> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_m_ProjectMenu__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectMenu> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_n_t_ServerTemplatePresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ServerTemplatePresenter> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_d_DroolsDataObjectEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DroolsDataObjectEditor> { }
  public abstract class Type_factory__o_j_e_u_n_c_l_TransitionAnchorProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<TransitionAnchorProvider> { }
  public abstract class Type_factory__o_j_d_r_c_p_ProcessDashboard__quals__j_e_i_Any_j_e_i_Default extends Factory<ProcessDashboard> { }
  public abstract class Type_factory__o_u_c_v_p_m_UserMenu__quals__j_e_i_Any_j_e_i_Default extends Factory<UserMenu> { }
  public abstract class Type_factory__o_u_c_v_p_d_CompassWidgetImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<CompassWidgetImpl> { }
  public abstract class Type_factory__o_d_r_g_c_GoogleBarChartDisplayerView__quals__j_e_i_Any_j_e_i_Default extends Factory<GoogleBarChartDisplayerView> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_u_UserAssignedRolesEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<UserAssignedRolesEditor> { }
  public abstract class Type_factory__o_u_e_p_c_p_e_PerspectiveEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<PerspectiveEditorPresenter> { }
  public abstract class Type_factory__o_u_e_p_c_w_p_GeneralPluginEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<GeneralPluginEditor> { }
  public abstract class Type_factory__o_k_w_c_w_c_m_RepositoryMenu__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoryMenu> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_CreateEntityView__quals__j_e_i_Any_j_e_i_Default extends Factory<CreateEntityView> { }
  public abstract class Type_factory__o_k_w_c_s_j_c_t_JavaResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<JavaResourceType> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_ActionWorkItemInsertFactColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionWorkItemInsertFactColumnSynchronizer> { }
  public abstract class Type_factory__o_u_c_w_w_t_WorkbenchToolBarPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchToolBarPresenter> { }
  public abstract class Type_factory__o_k_w_c_p_M2RepoPerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<M2RepoPerspective> { }
  public abstract class Type_factory__o_u_e_p_c_t_EditorPluginResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<EditorPluginResourceType> { }
  public abstract class Type_factory__o_d_d_c_w_RendererSelectorListBoxView__quals__j_e_i_Any_j_e_i_Default extends Factory<RendererSelectorListBoxView> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_AdvancedDataObjectEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<AdvancedDataObjectEditorViewImpl> { }
  public abstract class Type_factory__o_j_c_n_p_c_e_i_s_ProcessInstanceSignalPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ProcessInstanceSignalPresenter> { }
  public abstract class Type_factory__o_u_e_p_c_e_EditorPlugInEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<EditorPlugInEditorView> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_ExplorerMenu__quals__j_e_i_Any_j_e_i_Default extends Factory<ExplorerMenu> { }
  public abstract class Type_factory__o_j_e_s_c_l_c_BasicUserCacheImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<BasicUserCacheImpl> { }
  public abstract class Type_factory__o_d_w_s_d_c_e_DecisionTableXLSEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DecisionTableXLSEditorViewImpl> { }
  public abstract class Type_factory__o_u_e_p_c_w_m_MediaLibraryWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<MediaLibraryWidget> { }
  public abstract class Type_factory__o_g_a_m_c_e_r_w_CreateRepositoryWizardModel__quals__j_e_i_Any_j_e_i_Default extends Factory<CreateRepositoryWizardModel> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_m_ViewMenuBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<ViewMenuBuilder> { }
  public abstract class Type_factory__o_u_c_e_EditorJSExporter__quals__j_e_i_Any_j_e_i_Default extends Factory<EditorJSExporter> { }
  public abstract class Type_factory__o_d_w_s_g_r_c_t_GuidedRuleDRLResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedRuleDRLResourceType> { }
  public abstract class Producer_factory__o_g_s_c_e_r_RepositoryPreferences__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoryPreferences> { }
  public abstract class Type_factory__o_u_e_w_c_c_t_SimpleTable__quals__j_e_i_Any_j_e_i_Default extends Factory<SimpleTable> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_w_POMWizardPage__quals__j_e_i_Any_j_e_i_Default extends Factory<POMWizardPage> { }
  public abstract class ExtensionProvided_factory__c_g_g_u_c_u_Label__quals__j_e_i_Any_j_e_i_Default extends Factory<Label> { }
  public abstract class Type_factory__o_d_d_c_RendererManager__quals__j_e_i_Any_j_e_i_Default extends Factory<RendererManager> { }
  public abstract class Type_factory__o_j_e_s_c_l_n_SecurityContextHoldingSingleton__quals__j_e_i_Any_j_e_i_Default extends Factory<SecurityContextHoldingSingleton> { }
  public abstract class Type_factory__o_d_w_s_w_t_WorkItemsTypeDefinition__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkItemsTypeDefinition> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_u_UserAssignedRolesExplorer__quals__j_e_i_Any_j_e_i_Default extends Factory<UserAssignedRolesExplorer> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_c_s_ContainerRemoteStatusPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ContainerRemoteStatusPresenter> { }
  public abstract class Type_factory__o_j_c_n_b_c_p_DeploymentListPerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<DeploymentListPerspective> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_p_ConfirmBox__quals__j_e_i_Any_j_e_i_Default extends Factory<ConfirmBox> { }
  public abstract class Type_factory__o_j_f_e_c_e_FormModelerPanelViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<FormModelerPanelViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_s_h_c_h_SocialHomePageSideView__quals__j_e_i_Any_j_e_i_Default extends Factory<SocialHomePageSideView> { }
  public abstract class Type_factory__o_j_f_e_c_h_NewFormDefinitionHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<NewFormDefinitionHandler> { }
  public abstract class Type_factory__o_j_c_n_d_c_l_b_DataSetQueryHelper__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetQueryHelper> { }
  public abstract class Type_factory__o_o_w_s_s_c_e_TerminationTreeItemContentViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<TerminationTreeItemContentViewImpl> { }
  public abstract class Type_factory__o_u_c_m_ActivityManagerImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ActivityManagerImpl> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_e_NewFieldPopupViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<NewFieldPopupViewImpl> { }
  public abstract class Type_factory__o_d_w_s_g_c_e_GlobalsEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<GlobalsEditorPresenterActivity> { }
  public abstract class Type_factory__o_u_e_s_m_c_e_r_RoleEditorDriver__quals__j_e_i_Any_j_e_i_Default extends Factory<RoleEditorDriver> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_n_PermissionSwitchView__quals__j_e_i_Any_j_e_i_Default extends Factory<PermissionSwitchView> { }
  public abstract class Type_factory__o_o_w_s_s_c_e_SolverEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<SolverEditorPresenter> { }
  public abstract class Type_factory__o_g_a_m_c_e_p_s_w_RepositoryStructureDataViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoryStructureDataViewImpl> { }
  public abstract class Type_factory__o_k_w_c_w_m_c_w_OverviewWidgetViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<OverviewWidgetViewImpl> { }
  public abstract class Type_factory__o_d_c_w_d_e_e_ElasticSearchDataSetDefAttributesEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<ElasticSearchDataSetDefAttributesEditorView> { }
  public abstract class Type_factory__o_d_c_w_d_e_d_DataSetEditorDriverFactory__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetEditorDriverFactory> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_c_c_p_ContainerProcessConfigPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ContainerProcessConfigPresenter> { }
  public abstract class Type_factory__o_u_c_e_PerspectiveJSExporter__quals__j_e_i_Any_j_e_i_Default extends Factory<PerspectiveJSExporter> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_p_PackageSelector__quals__j_e_i_Any_j_e_i_Default extends Factory<PackageSelector> { }
  public abstract class Type_factory__o_d_c_w_d_e_b_BeanDataSetEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<BeanDataSetEditor> { }
  public abstract class Type_factory__o_d_w_s_w_c_e_WorkItemsEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkItemsEditorPresenter> { }
  public abstract class Type_factory__o_d_w_s_d_c_DRLEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<DRLEditorEntryPoint> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_CRUDListBox__quals__j_e_i_Any_j_e_i_Default extends Factory<CRUDListBox> { }
  public abstract class Type_factory__o_g_o_m_c_e_OrganizationalUnitManagerViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<OrganizationalUnitManagerViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_m_MainDataObjectEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<MainDataObjectEditor> { }
  public abstract class ExtensionProvided_factory__o_u_e_w_c_c_a_AceEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<AceEditor> { }
  public abstract class ExtensionProvided_factory__o_g_c_u_Well__quals__j_e_i_Any_j_e_i_Default extends Factory<Well> { }
  public abstract class Type_factory__o_u_e_w_c_c_d_PerspectiveDropDown__quals__j_e_i_Any_j_e_i_Default extends Factory<PerspectiveDropDown> { }
  public abstract class Type_factory__o_d_c_w_d_e_DataSetDefPreviewTable__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefPreviewTable> { }
  public abstract class Type_factory__o_k_w_c_w_c_h_NewResourcesMenu__quals__j_e_i_Any_j_e_i_Default extends Factory<NewResourcesMenu> { }
  public abstract class Type_factory__o_d_r_g_c_GoogleMeterChartDisplayerView__quals__j_e_i_Any_j_e_i_Default extends Factory<GoogleMeterChartDisplayerView> { }
  public abstract class Type_factory__o_k_w_c_s_s_h_c_h_h_HeaderPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<org.kie.workbench.common.screens.social.hp.client.homepage.header.HeaderPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_n_t_c_CopyPopupPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<CopyPopupPresenter> { }
  public abstract class Type_factory__o_j_e_s_c_l_c_DefaultBusSecurityErrorCallback__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultBusSecurityErrorCallback> { }
  public abstract class Type_factory__o_k_w_c_s_s_h_c_h_SocialHomePageSidePresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<SocialHomePageSidePresenterActivity> { }
  public abstract class Type_factory__o_d_c_w_d_e_a_DataSetDefCacheAttributesEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefCacheAttributesEditorViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_c_t_LinkTitleView__quals__j_e_i_Any_j_e_i_Default extends Factory<LinkTitleView> { }
  public abstract class Type_factory__o_g_c_s_p_c_r_ConflictingRepositoriesPopupViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ConflictingRepositoriesPopupViewImpl> { }
  public abstract class Type_factory__o_u_e_w_c_c_p_ContainersGroup__quals__j_e_i_Any_j_e_i_Default extends Factory<ContainersGroup> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_h_j_JPADomainHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<JPADomainHandler> { }
  public abstract class Type_factory__o_j_c_n_w_c_e_d_d_t_DDResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<DDResourceType> { }
  public abstract class Type_factory__o_u_e_w_c_t_c_p_WiresTreesPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<WiresTreesPerspectiveActivity> { }
  public abstract class Type_factory__o_d_w_s_t_c_ScenarioEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ScenarioEditorPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_d_DependencyListWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<DependencyListWidget> { }
  public abstract class Type_factory__o_k_w_c_s_s_c_m_SearchMenuBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<SearchMenuBuilder> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_ExplorerPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<ExplorerPresenterActivity> { }
  public abstract class Type_factory__o_g_s_c_s_RepositoryTreeProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoryTreeProvider> { }
  public abstract class Type_factory__o_d_w_s_t_c_s_TestRuntimeReportingService__quals__j_e_i_Any_j_e_i_Default extends Factory<TestRuntimeReportingService> { }
  public abstract class Type_factory__o_u_e_w_c_c_s_i_IFrameScreenPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<IFrameScreenPresenter> { }
  public abstract class Type_factory__o_d_d_c_w_f_LikeToFunctionEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<LikeToFunctionEditor> { }
  public abstract class ExtensionProvided_factory__o_j_e_c_c_d_Button__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<org.jboss.errai.common.client.dom.Button> { }
  public abstract class Type_factory__o_d_d_c_w_f_NumberParameterEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<NumberParameterEditorView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_GridWidgetColumnFactoryImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<GridWidgetColumnFactoryImpl> { }
  public abstract class Type_factory__o_d_w_s_d_c_h_NewDrlTextHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<NewDrlTextHandler> { }
  public abstract class Type_factory__o_u_e_s_m_c_ResourceBundleEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<ResourceBundleEntryPoint> { }
  public abstract class Type_factory__o_g_a_m_c_e_f_r_ReviewPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ReviewPresenter> { }
  public abstract class Type_factory__o_d_d_c_w_f_TimeAmountEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<org.dashbuilder.displayer.client.widgets.filter.TimeAmountEditor> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_e_GuvnorDefaultEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<GuvnorDefaultEditorPresenterActivity> { }
  public abstract class Type_factory__o_j_c_n_g_f_c_d_v_GenericFormDisplayView__quals__j_e_i_Any_j_e_i_Default extends Factory<GenericFormDisplayView> { }
  public abstract class Type_factory__o_u_c_w_p_i_LayoutPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<LayoutPanelView> { }
  public abstract class Type_factory__o_g_a_m_c_e_r_ReleaseConfigurationViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ReleaseConfigurationViewImpl> { }
  private static void addLookups_0() {
    CDIEventTypeLookup.get().addLookup("org.guvnor.common.services.project.events.DeleteProjectEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.uberfire.ext.properties.editor.model.PropertyEditorChangeEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.guvnor.structure.repositories.NewBranchEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.dashbuilder.dataset.events.DataSetModifiedEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.server.management.client.events.AddNewServerTemplate", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.guvnor.common.services.project.events.NewProjectEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.server.management.client.events.ContainerSpecSelected", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.uberfire.workbench.events.ResourceUpdatedEvent", "org.uberfire.workbench.events.ResourceEvent");
    CDIEventTypeLookup.get().addLookup("org.uberfire.workbench.events.ResourceUpdatedEvent", "org.uberfire.workbench.events.ResourceUpdated");
    CDIEventTypeLookup.get().addLookup("org.uberfire.workbench.events.ResourceUpdatedEvent", "org.uberfire.workbench.events.UberFireEvent");
    CDIEventTypeLookup.get().addLookup("org.uberfire.workbench.events.ResourceUpdatedEvent", "org.uberfire.workbench.events.ResourceChange");
    CDIEventTypeLookup.get().addLookup("org.uberfire.workbench.events.ResourceUpdatedEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.guvnor.structure.repositories.RepositoryRemovedEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.uberfire.workbench.events.ResourceBatchChangesEvent", "org.uberfire.workbench.events.UberFireEvent");
    CDIEventTypeLookup.get().addLookup("org.uberfire.workbench.events.ResourceBatchChangesEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.kie.server.controller.api.model.events.RuleConfigUpdated", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.datamodeller.events.DataObjectDeletedEvent", "org.kie.workbench.common.screens.datamodeller.events.DataModelerEvent");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.datamodeller.events.DataObjectDeletedEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.guvnor.structure.organizationalunit.RepoAddedToOrganizationalUnitEvent", "org.guvnor.structure.organizationalunit.OrganizationalUnitEventBase");
    CDIEventTypeLookup.get().addLookup("org.guvnor.structure.organizationalunit.RepoAddedToOrganizationalUnitEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.uberfire.workbench.events.ResourceAddedEvent", "org.uberfire.workbench.events.ResourceEvent");
    CDIEventTypeLookup.get().addLookup("org.uberfire.workbench.events.ResourceAddedEvent", "org.uberfire.workbench.events.ResourceAdded");
    CDIEventTypeLookup.get().addLookup("org.uberfire.workbench.events.ResourceAddedEvent", "org.uberfire.workbench.events.UberFireEvent");
    CDIEventTypeLookup.get().addLookup("org.uberfire.workbench.events.ResourceAddedEvent", "org.uberfire.workbench.events.ResourceChange");
    CDIEventTypeLookup.get().addLookup("org.uberfire.workbench.events.ResourceAddedEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.social.hp.client.homepage.events.UserHomepageSelectedEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.server.management.client.events.ServerInstanceSelected", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.kie.uberfire.social.activities.model.SocialFileSelectedEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.datamodeller.client.context.DataModelerWorkbenchFocusEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.uberfire.backend.vfs.impl.LockInfo", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.guvnor.structure.organizationalunit.RepoRemovedFromOrganizationalUnitEvent", "org.guvnor.structure.organizationalunit.OrganizationalUnitEventBase");
    CDIEventTypeLookup.get().addLookup("org.guvnor.structure.organizationalunit.RepoRemovedFromOrganizationalUnitEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.uberfire.client.workbench.events.PerspectiveChange", "org.uberfire.workbench.events.UberFireEvent");
    CDIEventTypeLookup.get().addLookup("org.uberfire.client.workbench.events.PerspectiveChange", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.uberfire.workbench.events.ResourceRenamedEvent", "org.uberfire.workbench.events.ResourceEvent");
    CDIEventTypeLookup.get().addLookup("org.uberfire.workbench.events.ResourceRenamedEvent", "org.uberfire.workbench.events.ResourceRenamed");
    CDIEventTypeLookup.get().addLookup("org.uberfire.workbench.events.ResourceRenamedEvent", "org.uberfire.workbench.events.UberFireEvent");
    CDIEventTypeLookup.get().addLookup("org.uberfire.workbench.events.ResourceRenamedEvent", "org.uberfire.workbench.events.ResourceChange");
    CDIEventTypeLookup.get().addLookup("org.uberfire.workbench.events.ResourceRenamedEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.uberfire.workbench.events.ResourceCopiedEvent", "org.uberfire.workbench.events.ResourceEvent");
    CDIEventTypeLookup.get().addLookup("org.uberfire.workbench.events.ResourceCopiedEvent", "org.uberfire.workbench.events.ResourceCopied");
    CDIEventTypeLookup.get().addLookup("org.uberfire.workbench.events.ResourceCopiedEvent", "org.uberfire.workbench.events.UberFireEvent");
    CDIEventTypeLookup.get().addLookup("org.uberfire.workbench.events.ResourceCopiedEvent", "org.uberfire.workbench.events.ResourceChange");
    CDIEventTypeLookup.get().addLookup("org.uberfire.workbench.events.ResourceCopiedEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.social.hp.client.homepage.events.LoadUserPageEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.uberfire.client.workbench.events.PlaceHiddenEvent", "org.uberfire.client.workbench.events.AbstractPlaceEvent");
    CDIEventTypeLookup.get().addLookup("org.uberfire.client.workbench.events.PlaceHiddenEvent", "org.uberfire.workbench.events.UberFireEvent");
    CDIEventTypeLookup.get().addLookup("org.uberfire.client.workbench.events.PlaceHiddenEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.social.hp.client.homepage.events.UserEditedEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.kie.server.controller.api.model.events.ServerInstanceUpdated", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.datamodeller.events.DataObjectFieldDeletedEvent", "org.kie.workbench.common.screens.datamodeller.events.DataModelerEvent");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.datamodeller.events.DataObjectFieldDeletedEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.server.management.client.events.ServerTemplateSelected", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.datamodeller.events.DataObjectFieldSelectedEvent", "org.kie.workbench.common.screens.datamodeller.events.DataModelerEvent");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.datamodeller.events.DataObjectFieldSelectedEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.guvnor.structure.repositories.RepositoryEnvironmentUpdatedEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.server.management.client.events.RefreshRemoteServers", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.datamodeller.events.DataObjectSelectedEvent", "org.kie.workbench.common.screens.datamodeller.events.DataModelerEvent");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.datamodeller.events.DataObjectSelectedEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.server.management.client.events.DependencyPathSelectedEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.uberfire.ext.editor.commons.version.events.RestoreEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.datamodeller.events.DataObjectFieldCreatedEvent", "org.kie.workbench.common.screens.datamodeller.events.DataModelerEvent");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.datamodeller.events.DataObjectFieldCreatedEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.guvnor.common.services.project.events.NewPackageEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.datamodeller.events.DataObjectFieldChangeEvent", "org.kie.workbench.common.screens.datamodeller.events.DataModelerValueChangeEvent");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.datamodeller.events.DataObjectFieldChangeEvent", "org.kie.workbench.common.screens.datamodeller.events.DataModelerEvent");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.datamodeller.events.DataObjectFieldChangeEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.guvnor.structure.organizationalunit.RemoveOrganizationalUnitEvent", "org.guvnor.structure.organizationalunit.OrganizationalUnitEventBase");
    CDIEventTypeLookup.get().addLookup("org.guvnor.structure.organizationalunit.RemoveOrganizationalUnitEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.guvnor.common.services.project.context.ProjectContextChangeEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.kie.server.controller.api.model.events.ServerTemplateDeleted", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.kie.server.controller.api.model.events.ServerTemplateUpdated", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.explorer.client.widgets.ActiveOptionsChangedEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.server.management.client.events.ServerTemplateListRefresh", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.widgets.client.search.SetSearchTextEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.explorer.client.widgets.tagSelector.TagChangedEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.widgets.client.search.ClearSearchEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.guvnor.structure.organizationalunit.NewOrganizationalUnitEvent", "org.guvnor.structure.organizationalunit.OrganizationalUnitEventBase");
    CDIEventTypeLookup.get().addLookup("org.guvnor.structure.organizationalunit.NewOrganizationalUnitEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.server.management.client.events.AddNewContainer", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.uberfire.workbench.events.ResourceDeletedEvent", "org.uberfire.workbench.events.ResourceEvent");
    CDIEventTypeLookup.get().addLookup("org.uberfire.workbench.events.ResourceDeletedEvent", "org.uberfire.workbench.events.ResourceDeleted");
    CDIEventTypeLookup.get().addLookup("org.uberfire.workbench.events.ResourceDeletedEvent", "org.uberfire.workbench.events.UberFireEvent");
    CDIEventTypeLookup.get().addLookup("org.uberfire.workbench.events.ResourceDeletedEvent", "org.uberfire.workbench.events.ResourceChange");
    CDIEventTypeLookup.get().addLookup("org.uberfire.workbench.events.ResourceDeletedEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.guvnor.structure.config.SystemRepositoryChangedEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.datamodeller.client.context.DataModelerWorkbenchContextChangeEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.kie.server.controller.api.model.events.ServerInstanceDeleted", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.server.management.model.ContainerSpecData", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.datamodeller.events.DataObjectChangeEvent", "org.kie.workbench.common.screens.datamodeller.events.DataModelerValueChangeEvent");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.datamodeller.events.DataObjectChangeEvent", "org.kie.workbench.common.screens.datamodeller.events.DataModelerEvent");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.datamodeller.events.DataObjectChangeEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.uberfire.client.workbench.docks.UberfireDockReadyEvent", "org.uberfire.workbench.events.UberFireEvent");
    CDIEventTypeLookup.get().addLookup("org.uberfire.client.workbench.docks.UberfireDockReadyEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.guvnor.common.services.project.events.RenameProjectEvent", "java.lang.Object");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.datamodeller.events.DataObjectCreatedEvent", "org.kie.workbench.common.screens.datamodeller.events.DataModelerEvent");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.datamodeller.events.DataObjectCreatedEvent", "java.lang.Object");
  }

  private void registerFactories0(final Context org_jboss_errai_ioc_client_container_ApplicationScopedContext_context, final Context org_jboss_errai_ioc_client_container_DependentScopeContext_context) {
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<MessageConsoleScreen>) GWT.create(Type_factory__o_g_m_c_c_MessageConsoleScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GroupsExplorer>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_GroupsExplorer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CheckboxInput>) GWT.create(ExtensionProvided_factory__o_j_e_c_c_d_CheckboxInput__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProcessBreadCrumbView>) GWT.create(Type_factory__o_j_d_r_c_p_w_ProcessBreadCrumbView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DeploymentListPerspectiveActivity>) GWT.create(Type_factory__o_j_c_n_b_c_p_DeploymentListPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ChangePasswordView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_ChangePasswordView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SolverEditorPresenterActivity>) GWT.create(Type_factory__o_o_w_s_s_c_e_SolverEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SearchMenuView>) GWT.create(Type_factory__o_k_w_c_s_s_c_m_SearchMenuView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GroupEditorScreen>) GWT.create(Type_factory__o_u_e_s_m_c_s_e_GroupEditorScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DisplayerEditorStatus>) GWT.create(Type_factory__o_d_d_c_w_DisplayerEditorStatus__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SolverEditorViewImpl>) GWT.create(Type_factory__o_o_w_s_s_c_e_SolverEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SearchAnnotationPage>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_a_SearchAnnotationPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedRuleTemplateDataViewImpl>) GWT.create(Type_factory__o_d_w_s_g_t_c_e_GuidedRuleTemplateDataViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<TestScenarioResourceTypeDefinition>) GWT.create(Type_factory__o_d_w_s_t_t_TestScenarioResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ServerEmptyView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_e_ServerEmptyView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TransitionAnchorFactory>) GWT.create(ContextualProvider_factory__o_j_e_u_n_c_l_TransitionAnchorFactory__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefColumnsFilterEditorView>) GWT.create(Type_factory__o_d_c_w_d_e_DataSetDefColumnsFilterEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<Workbench>) GWT.create(Type_factory__o_u_c_w_Workbench__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TaskAssignmentsPresenter>) GWT.create(Type_factory__o_j_c_n_h_c_e_t_TaskAssignmentsPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WorkItemsEditorViewImpl>) GWT.create(Type_factory__o_d_w_s_w_c_e_WorkItemsEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WorkItemsEditorPresenterActivity>) GWT.create(Type_factory__o_d_w_s_w_c_e_WorkItemsEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RoleEditor>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_r_RoleEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AdvancedDataObjectEditor>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_AdvancedDataObjectEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MultiListWorkbenchPanelPresenter>) GWT.create(Type_factory__o_u_c_w_p_i_MultiListWorkbenchPanelPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EntitiesListView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_l_EntitiesListView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SearchEntryPoint>) GWT.create(Type_factory__o_k_w_c_s_s_c_SearchEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EnhancedDependenciesManager>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_d_EnhancedDependenciesManager__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ActivityBeansInfo>) GWT.create(Type_factory__o_u_c_m_ActivityBeansInfo__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SQLDataSetBasicAttributesWorkflow>) GWT.create(Type_factory__o_d_c_w_d_e_w_c_SQLDataSetBasicAttributesWorkflow__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GroupEditorView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_g_GroupEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UnanchoredWorkbenchPartView>) GWT.create(Type_factory__o_u_c_w_p_u_p_UnanchoredWorkbenchPartView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserEditorScreen>) GWT.create(Type_factory__o_u_e_s_m_c_s_e_UserEditorScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WiresGridsDemoPresenter>) GWT.create(Type_factory__o_u_e_w_c_g_c_d_WiresGridsDemoPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MapEditorView>) GWT.create(Type_factory__o_d_c_c_e_m_MapEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BreadcrumbNavigator>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_n_BreadcrumbNavigator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TerminationConfigForm>) GWT.create(Type_factory__o_o_w_s_s_c_e_TerminationConfigForm__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuvnorDefaultEditorViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_e_GuvnorDefaultEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TaskDetailsMultiViewImpl>) GWT.create(Type_factory__o_j_c_n_h_c_e_t_TaskDetailsMultiViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MultiplePermissionNodeViewerView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_n_MultiplePermissionNodeViewerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProjectModulesViewImpl>) GWT.create(Type_factory__o_g_a_m_c_e_p_s_w_ProjectModulesViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DSLEditorViewImpl>) GWT.create(Type_factory__o_d_w_s_d_c_e_DSLEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProcessDefinitionsPerspectiveActivity>) GWT.create(Type_factory__o_j_c_n_p_c_p_ProcessDefinitionsPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FormRendererWidget>) GWT.create(Type_factory__o_j_f_r_c_FormRendererWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DroolsDomainScreenActivity>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_d_DroolsDomainScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EditorPlugInEditorPresenter>) GWT.create(Type_factory__o_u_e_p_c_e_EditorPlugInEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ValuePairEditorPage>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_a_ValuePairEditorPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WiresGridsDemoViewImpl>) GWT.create(Type_factory__o_u_e_w_c_g_c_d_WiresGridsDemoViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedScoreCardEditorPresenter>) GWT.create(Type_factory__o_d_w_s_g_s_c_e_GuidedScoreCardEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ImportsWidgetViewImpl>) GWT.create(Type_factory__o_k_w_c_w_c_c_w_b_ImportsWidgetViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GoogleTableDisplayerView>) GWT.create(Type_factory__o_d_r_g_c_GoogleTableDisplayerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GroupEditorWorkflow>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_g_w_GroupEditorWorkflow__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SecurityManagementPerspective>) GWT.create(Type_factory__o_u_e_s_m_c_p_SecurityManagementPerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ProjectTreeProvider>) GWT.create(Type_factory__o_g_c_s_p_c_s_ProjectTreeProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PackageNameWhiteListResourceTypeDefinition>) GWT.create(Type_factory__o_k_w_c_s_d_s_PackageNameWhiteListResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkbenchConfigurationMenuBuilder>) GWT.create(Type_factory__o_k_w_c_w_c_m_WorkbenchConfigurationMenuBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GoogleBarChartDisplayer>) GWT.create(Type_factory__o_d_r_g_c_GoogleBarChartDisplayer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RepositoryStructurePresenter>) GWT.create(Type_factory__o_g_a_m_c_e_r_s_RepositoryStructurePresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GuidedRuleTemplateResourceType>) GWT.create(Type_factory__o_d_w_s_g_t_c_t_GuidedRuleTemplateResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Container>) GWT.create(ExtensionProvided_factory__o_g_c_u_Container__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ProjectConfigScreenEntryPoint>) GWT.create(Type_factory__o_k_w_c_s_p_c_ProjectConfigScreenEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetTasksListGridPresenter>) GWT.create(Type_factory__o_j_c_n_h_c_e_t_g_d_DataSetTasksListGridPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PriorityDropDown>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_PriorityDropDown__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SocialHomePagePerspective>) GWT.create(Type_factory__o_k_w_c_s_s_h_c_h_SocialHomePagePerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefEditorPresenterActivity>) GWT.create(Type_factory__o_d_d_e_c_s_DataSetDefEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Event>) GWT.create(ContextualProvider_factory__j_e_e_Event__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<QuickNewJobPopup>) GWT.create(Type_factory__o_j_c_n_e_c_e_q_QuickNewJobPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FormRendererPanelIncluderPresenter>) GWT.create(Type_factory__o_j_f_r_i_FormRendererPanelIncluderPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<KieWorkbenchEntryPoint>) GWT.create(Type_factory__o_k_w_c_KieWorkbenchEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ConflictingRepositoriesPopup>) GWT.create(Type_factory__o_g_c_s_p_c_r_ConflictingRepositoriesPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PermissionWidgetFactory>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_n_PermissionWidgetFactory__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PropertyEditorAdaptorsCache>) GWT.create(Type_factory__o_u_e_w_c_c_p_PropertyEditorAdaptorsCache__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FactPatternConstraintsPage>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_p_FactPatternConstraintsPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ListBox>) GWT.create(ExtensionProvided_factory__o_g_c_u_ListBox__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserCreationWorkflow>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_u_w_UserCreationWorkflow__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<POMEditorPanelViewImpl>) GWT.create(Type_factory__o_g_c_s_p_c_POMEditorPanelViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GuvnorStructureContext>) GWT.create(Type_factory__o_g_s_c_e_c_GuvnorStructureContext__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisplayerTypeSelector>) GWT.create(Type_factory__o_d_d_c_w_DisplayerTypeSelector__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<VersionRecordManager>) GWT.create(Type_factory__o_u_e_e_c_c_h_VersionRecordManager__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<EnumResourceTypeDefinition>) GWT.create(Type_factory__o_d_w_s_e_t_EnumResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ValueBoxEditorView>) GWT.create(Type_factory__o_d_c_c_e_ValueBoxEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<StaticWorkbenchPanelPresenter>) GWT.create(Type_factory__o_u_c_w_p_i_StaticWorkbenchPanelPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewProjectWizard>) GWT.create(Type_factory__o_k_w_c_s_p_c_w_NewProjectWizard__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MultipleNumberParameterEditorView>) GWT.create(Type_factory__o_d_d_c_w_f_MultipleNumberParameterEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ConfigurationComboBoxItemWidget>) GWT.create(Type_factory__o_k_w_c_w_c_h_w_c_ConfigurationComboBoxItemWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<AboutMenuBuilder>) GWT.create(Type_factory__o_k_w_c_w_c_m_AboutMenuBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<InboxEntryPoint>) GWT.create(Type_factory__o_g_i_c_InboxEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<TableEntryPoint>) GWT.create(Type_factory__o_u_e_w_t_c_TableEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DefaultFileEditorPresenter>) GWT.create(Type_factory__o_u_e_w_c_c_e_d_DefaultFileEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GlobalsEditorEntryPoint>) GWT.create(Type_factory__o_d_w_s_g_c_GlobalsEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DeploymentUnitsListPresenterActivity>) GWT.create(Type_factory__o_j_c_n_b_c_e_d_l_DeploymentUnitsListPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ValuePairEditorProvider>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_v_ValuePairEditorProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AddImportPopup>) GWT.create(ExtensionProvided_factory__o_k_w_c_w_c_c_w_b_AddImportPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataIOEditorNameTextBox>) GWT.create(Type_factory__o_j_d_c_u_DataIOEditorNameTextBox__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FindFormActivity>) GWT.create(Type_factory__o_k_w_c_s_s_c_FindFormActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ReleaseConfigurationPresenter>) GWT.create(Type_factory__o_g_a_m_c_e_r_ReleaseConfigurationPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PerspectiveEditorGenerator>) GWT.create(Type_factory__o_u_e_p_c_p_e_g_PerspectiveEditorGenerator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NumberInput>) GWT.create(ExtensionProvided_factory__o_j_e_c_c_d_NumberInput__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ScoreCardXLSEditorViewImpl>) GWT.create(Type_factory__o_d_w_s_s_c_e_ScoreCardXLSEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<JobListPerspective>) GWT.create(Type_factory__o_j_c_n_e_c_p_JobListPerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BatchCaller>) GWT.create(Provider_factory__o_j_e_c_c_a_BatchCaller__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SimpleWorkbenchPanelPresenter>) GWT.create(Type_factory__o_u_c_w_p_i_SimpleWorkbenchPanelPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<StandaloneTaskFormDisplayPresenter>) GWT.create(Type_factory__o_j_c_n_h_f_c_d_s_StandaloneTaskFormDisplayPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GoogleBubbleChartDisplayerView>) GWT.create(Type_factory__o_d_r_g_c_GoogleBubbleChartDisplayerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<OrganizationalUnitTreeProvider>) GWT.create(Type_factory__o_g_s_c_s_OrganizationalUnitTreeProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NotificationPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_c_b_n_NotificationPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DropDownImageListEditor>) GWT.create(Type_factory__o_d_c_c_e_l_DropDownImageListEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TaskAdminViewImpl>) GWT.create(Type_factory__o_j_c_n_h_c_e_t_TaskAdminViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<UserHomePageSideView>) GWT.create(Type_factory__o_k_w_c_s_s_h_c_u_UserHomePageSideView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TextEditorWorkbenchEditor>) GWT.create(Type_factory__o_u_e_w_c_c_e_t_TextEditorWorkbenchEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<HumanTaskFormDisplayProviderImpl>) GWT.create(Type_factory__o_j_c_n_h_f_c_d_p_HumanTaskFormDisplayProviderImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContributorsScreen>) GWT.create(Type_factory__o_k_w_c_s_c_c_s_ContributorsScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GooglePieChartDisplayer>) GWT.create(Type_factory__o_d_r_g_c_GooglePieChartDisplayer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ReleaseConfigurationPresenterActivity>) GWT.create(Type_factory__o_g_a_m_c_e_r_ReleaseConfigurationPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HTMLLayoutDragComponent>) GWT.create(Type_factory__o_u_e_p_c_p_e_l_e_HTMLLayoutDragComponent__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefColumnsEditor>) GWT.create(Type_factory__o_d_c_w_d_e_c_DataSetDefColumnsEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkbenchBackendEntryPoint>) GWT.create(Type_factory__o_u_c_WorkbenchBackendEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WiresCanvas>) GWT.create(Type_factory__o_u_e_w_c_c_c_WiresCanvas__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WiresGridsDemoPresenterActivity>) GWT.create(Type_factory__o_u_e_w_c_g_c_d_WiresGridsDemoPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ExamplesWizard>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_ExamplesWizard__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DefaultPermissionManager>) GWT.create(Type_factory__o_u_s_i_a_DefaultPermissionManager__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<VFSServiceProxyBackendImpl>) GWT.create(Type_factory__o_u_c_VFSServiceProxyBackendImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BooleanField>) GWT.create(Type_factory__o_u_e_p_e_c_f_BooleanField__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<Navigation>) GWT.create(Type_factory__o_j_e_u_n_c_l_Navigation__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ListenersPanel>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_ListenersPanel__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ActionInsertNodeFactory>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_f_ActionInsertNodeFactory__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TaskLogsViewImpl>) GWT.create(Type_factory__o_j_c_n_h_c_e_t_TaskLogsViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SocialUserImageProviderImpl>) GWT.create(Type_factory__o_k_u_s_a_c_u_SocialUserImageProviderImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActivityNotFoundPresenterActivity>) GWT.create(Type_factory__o_u_e_w_c_c_w_w_p_a_n_ActivityNotFoundPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FormDisplayPerspectiveActivity>) GWT.create(Type_factory__o_j_c_n_g_f_c_d_s_FormDisplayPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataColumnDefDriver>) GWT.create(Producer_factory__o_d_c_w_d_e_d_DataColumnDefDriver__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SQLDataSetEditor>) GWT.create(Type_factory__o_d_c_w_d_e_s_SQLDataSetEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkbenchMenuStandardNavBarView>) GWT.create(Type_factory__o_u_c_v_p_m_WorkbenchMenuStandardNavBarView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SecurityContextImpl>) GWT.create(Type_factory__o_j_e_s_c_l_c_SecurityContextImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ClientDataSetManager>) GWT.create(Type_factory__o_d_d_c_ClientDataSetManager__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewUserAttributeEditorView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_u_NewUserAttributeEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefWizardScreenActivity>) GWT.create(Type_factory__o_d_d_e_c_s_DataSetDefWizardScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<TransitionToRoleProvider>) GWT.create(Type_factory__o_j_e_u_n_c_l_TransitionToRoleProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ServerManagementPerspectiveActivity>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_ServerManagementPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BeanDataSetDefDriver>) GWT.create(Producer_factory__o_d_c_w_d_e_d_BeanDataSetDefDriver__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefRefreshAttributesEditorView>) GWT.create(Type_factory__o_d_c_w_d_e_a_DataSetDefRefreshAttributesEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TimeInstantEditorView>) GWT.create(Type_factory__o_d_d_c_w_f_TimeInstantEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ElasticSearchDataSetDefAttributesDriver>) GWT.create(Producer_factory__o_d_c_w_d_e_d_ElasticSearchDataSetDefAttributesDriver__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<HomePerspective>) GWT.create(Type_factory__o_k_w_c_s_h_c_p_HomePerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<EditMenuBuilder>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_m_EditMenuBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RepositoriesPresenter>) GWT.create(Type_factory__o_g_s_c_e_r_l_RepositoriesPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JPADataObjectFieldEditor>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_j_JPADataObjectFieldEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MavenRepositoryPagedJarTable>) GWT.create(Type_factory__o_g_m_c_e_MavenRepositoryPagedJarTable__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ScoreCardXLSEditorPresenter>) GWT.create(Type_factory__o_d_w_s_s_c_e_ScoreCardXLSEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DefaultBeanFactory>) GWT.create(Type_factory__o_u_c_w_DefaultBeanFactory__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LoadingBoxView>) GWT.create(Type_factory__o_d_c_w_c_LoadingBoxView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DeploymentDescriptorViewImpl>) GWT.create(Type_factory__o_j_c_n_w_c_e_d_d_DeploymentDescriptorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RepositoryConfigurationPresenter>) GWT.create(Type_factory__o_g_a_m_c_e_c_RepositoryConfigurationPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ColumnDetailsEditor>) GWT.create(Type_factory__o_d_d_c_w_g_ColumnDetailsEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SelectDocumentPopup>) GWT.create(Type_factory__o_k_w_c_w_m_c_p_SelectDocumentPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GroupCreationWorkflow>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_g_w_GroupCreationWorkflow__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PermissionExceptionSwitchView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_n_PermissionExceptionSwitchView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PropertiesScreenActivity>) GWT.create(Type_factory__o_u_e_w_c_c_p_PropertiesScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DecisionTableXLSResourceType>) GWT.create(Type_factory__o_d_w_s_d_c_t_DecisionTableXLSResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SocialHomePagePerspectiveActivity>) GWT.create(Type_factory__o_k_w_c_s_s_h_c_h_SocialHomePagePerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AssignedEntitiesExplorerView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_AssignedEntitiesExplorerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TextArea>) GWT.create(ExtensionProvided_factory__c_g_g_u_c_u_TextArea__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ProjectController>) GWT.create(Type_factory__o_g_c_s_p_c_s_ProjectController__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ScoreCardXLSEditorPresenterActivity>) GWT.create(Type_factory__o_d_w_s_s_c_e_ScoreCardXLSEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PathLabel>) GWT.create(Type_factory__o_k_w_c_w_c_h_PathLabel__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TaskProcessContextViewImpl>) GWT.create(Type_factory__o_j_c_n_h_c_e_t_TaskProcessContextViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PartManager>) GWT.create(Type_factory__o_u_c_w_p_s_PartManager__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefRefreshIntervalEditorView>) GWT.create(Type_factory__o_d_c_w_d_e_a_DataSetDefRefreshIntervalEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RepositoryStructureTitle>) GWT.create(Type_factory__o_g_a_m_c_e_r_s_RepositoryStructureTitle__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetAuthoringHomeView>) GWT.create(Type_factory__o_d_d_e_c_s_DataSetAuthoringHomeView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TaskAssignmentsViewImpl>) GWT.create(Type_factory__o_j_c_n_h_c_e_t_TaskAssignmentsViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RowContextMenuViewImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_m_RowContextMenuViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BasicProcessDefDetailsViewImpl>) GWT.create(Type_factory__o_j_c_n_p_c_e_d_d_b_BasicProcessDefDetailsViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TransitionTo>) GWT.create(ContextualProvider_factory__o_j_e_u_n_c_l_TransitionTo__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MessageConsoleScreenActivity>) GWT.create(Type_factory__o_g_m_c_c_MessageConsoleScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GoogleBubbleChartDisplayer>) GWT.create(Type_factory__o_d_r_g_c_GoogleBubbleChartDisplayer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RepositoryEditorPresenter>) GWT.create(Type_factory__o_g_s_c_e_r_e_RepositoryEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AdvancedViewProcessDefDetailsViewImpl>) GWT.create(Type_factory__o_j_c_n_p_c_e_d_d_a_AdvancedViewProcessDefDetailsViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<StructureEntryPoint>) GWT.create(Type_factory__o_g_s_c_StructureEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EnumEditorViewImpl>) GWT.create(Type_factory__o_d_w_s_e_c_e_EnumEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JSONCommitsReader>) GWT.create(Type_factory__o_g_a_m_c_e_f_p_u_JSONCommitsReader__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<VFSLockServiceProxyClientImpl>) GWT.create(Type_factory__o_u_c_w_VFSLockServiceProxyClientImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KSessionSelectorViewImpl>) GWT.create(Type_factory__o_k_w_c_w_c_w_KSessionSelectorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RemoteStatusPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_r_RemoteStatusPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<AdvancedDomainScreen>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_AdvancedDomainScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProjectImportsScreenPresenterActivity>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_ProjectImportsScreenPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProcessInstanceSignalViewImpl>) GWT.create(Type_factory__o_j_c_n_p_c_e_i_s_ProcessInstanceSignalViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<KieWorkbenchWidgetsCommonEntryPoint>) GWT.create(Type_factory__o_k_w_c_w_c_KieWorkbenchWidgetsCommonEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PluginExplorerScreen>) GWT.create(Type_factory__o_u_e_p_c_e_PluginExplorerScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ConditionCell>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_p_c_ConditionCell__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PartContextMenusView>) GWT.create(Type_factory__o_u_c_v_p_m_PartContextMenusView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ResizeTabPanel>) GWT.create(Type_factory__o_u_c_v_p_t_ResizeTabPanel__quals__j_e_i_Any_o_u_c_v_p_t_Resize.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GuidedDTableResourceType>) GWT.create(Type_factory__o_d_w_s_g_d_c_t_GuidedDTableResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetExplorerView>) GWT.create(Type_factory__o_d_c_w_d_e_DataSetExplorerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewPackagePopupViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_p_NewPackagePopupViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ScoreCardXLSResourceType>) GWT.create(Type_factory__o_d_w_s_s_c_t_ScoreCardXLSResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.kie.workbench.common.widgets.configresource.client.widget.unbound.ImportsWidgetViewImpl>) GWT.create(Type_factory__o_k_w_c_w_c_c_w_u_ImportsWidgetViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DependencyGrid>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_d_DependencyGrid__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewContainerFormView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_c_NewContainerFormView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ColumnTypeEditor>) GWT.create(Type_factory__o_d_c_w_d_e_c_ColumnTypeEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UnanchoredStaticWorkbenchPanelPresenter>) GWT.create(Type_factory__o_u_c_w_p_i_UnanchoredStaticWorkbenchPanelPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UnorderedList>) GWT.create(ExtensionProvided_factory__o_j_e_c_c_d_UnorderedList__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AttributeColumnConverter>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_AttributeColumnConverter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GroupsList>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_l_GroupsList__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PerspectiveLayoutPluginResourceType>) GWT.create(Type_factory__o_u_e_p_c_t_PerspectiveLayoutPluginResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.kie.workbench.common.widgets.configresource.client.widget.unbound.AddImportPopup>) GWT.create(ExtensionProvided_factory__o_k_w_c_w_c_c_w_u_AddImportPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HelpBlock>) GWT.create(ExtensionProvided_factory__o_g_c_u_HelpBlock__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TimeInstantEditor>) GWT.create(Type_factory__o_d_d_c_w_f_TimeInstantEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ConstructionHeuristicForm>) GWT.create(Type_factory__o_o_w_s_s_c_e_ConstructionHeuristicForm__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NumberParameterEditor>) GWT.create(Type_factory__o_d_d_c_w_f_NumberParameterEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FullTextSearchFormView>) GWT.create(Type_factory__o_k_w_c_s_s_c_FullTextSearchFormView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetAuthoringHomePresenterActivity>) GWT.create(Type_factory__o_d_d_e_c_s_DataSetAuthoringHomePresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GroupEditorDriver>) GWT.create(Type_factory__o_u_e_s_m_c_e_g_GroupEditorDriver__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DRLEditorPresenter>) GWT.create(Type_factory__o_d_w_s_d_c_e_DRLEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GAVEditor>) GWT.create(Type_factory__o_g_c_s_p_c_GAVEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CreateRepositoryWizard>) GWT.create(Type_factory__o_g_a_m_c_e_r_w_CreateRepositoryWizard__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RuntimeLogPresenter>) GWT.create(Type_factory__o_j_c_n_p_c_e_i_l_RuntimeLogPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewPackagePopup>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_p_NewPackagePopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SplashEditorView>) GWT.create(Type_factory__o_u_e_p_c_e_SplashEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WorkbenchViewModeSwitcherView>) GWT.create(Type_factory__o_u_c_v_p_m_WorkbenchViewModeSwitcherView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PerspectiveTreeProvider>) GWT.create(Type_factory__o_u_c_a_PerspectiveTreeProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WiresTreesPerspective>) GWT.create(Type_factory__o_u_e_w_c_t_c_p_WiresTreesPerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PartContextMenusPresenter>) GWT.create(Type_factory__o_u_c_w_w_m_PartContextMenusPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewWorkItemHandler>) GWT.create(Type_factory__o_d_w_s_w_c_h_NewWorkItemHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FormRendererPanelIncluderPresenterActivity>) GWT.create(Type_factory__o_j_f_r_i_FormRendererPanelIncluderPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AdvancedProcessDefDetailsMultiViewImpl>) GWT.create(Type_factory__o_j_c_n_p_c_e_d_d_m_a_AdvancedProcessDefDetailsMultiViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetGroupDateEditor>) GWT.create(Type_factory__o_d_d_c_w_g_DataSetGroupDateEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KieEditorWrapperViewImpl>) GWT.create(Type_factory__o_k_w_c_w_m_c_KieEditorWrapperViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ColumnDetailsEditorView>) GWT.create(Type_factory__o_d_d_c_w_g_ColumnDetailsEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TaskDashboard>) GWT.create(Type_factory__o_j_d_r_c_p_TaskDashboard__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FixedShapesGroup>) GWT.create(Type_factory__o_u_e_w_c_c_p_FixedShapesGroup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ACLEditor>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_ACLEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ScreenPluginResourceType>) GWT.create(Type_factory__o_u_e_p_c_t_ScreenPluginResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BootstrapLayoutGenerator>) GWT.create(Type_factory__o_u_e_l_e_c_g_BootstrapLayoutGenerator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProcessVariableListPresenter>) GWT.create(Type_factory__o_j_c_n_p_c_e_v_l_ProcessVariableListPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewDependencyPopupViewImpl>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_d_NewDependencyPopupViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PluginNameValidator>) GWT.create(Type_factory__o_u_e_p_c_v_PluginNameValidator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KSessionsPanel>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_KSessionsPanel__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionInsertFactFieldsPage>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_p_ActionInsertFactFieldsPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DependencyLoader>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_d_DependencyLoader__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DefaultRestSecurityErrorCallback>) GWT.create(Type_factory__o_j_e_s_c_l_c_DefaultRestSecurityErrorCallback__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewGuidedScoreCardHandler>) GWT.create(Type_factory__o_d_w_s_g_s_c_h_NewGuidedScoreCardHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MultiTabWorkbenchPanelView>) GWT.create(Type_factory__o_u_c_v_p_t_MultiTabWorkbenchPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RegisteredDocumentsMenuBuilder>) GWT.create(Type_factory__o_k_w_c_w_m_c_m_RegisteredDocumentsMenuBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DSLEditorEntryPoint>) GWT.create(Type_factory__o_d_w_s_d_c_DSLEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PlannerDataObjectEditorViewImpl>) GWT.create(Type_factory__o_o_w_s_d_c_w_p_PlannerDataObjectEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ScenarioEditorViewImpl>) GWT.create(Type_factory__o_d_w_s_t_c_ScenarioEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RemoteEmptyPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_r_e_RemoteEmptyPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GoogleRenderer>) GWT.create(Type_factory__o_d_r_g_c_GoogleRenderer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<HistoryTokenFactory>) GWT.create(Type_factory__o_j_e_u_n_c_l_HistoryTokenFactory__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewProjectHandlerViewImpl>) GWT.create(Type_factory__o_k_w_c_s_p_c_h_NewProjectHandlerViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.jbpm.console.ng.df.client.popup.filter.TimeInstantEditor>) GWT.create(Type_factory__o_j_c_n_d_c_p_f_TimeInstantEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SocialHomePageMainPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_h_c_h_SocialHomePageMainPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DashboardScreen>) GWT.create(Type_factory__o_j_d_r_c_p_DashboardScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SecurityExplorerView>) GWT.create(Type_factory__o_u_e_s_m_c_s_e_SecurityExplorerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WorkbenchConfigurationPopup>) GWT.create(Type_factory__o_k_w_c_w_c_c_p_WorkbenchConfigurationPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DataModelChangeNotifier>) GWT.create(Type_factory__o_k_w_c_s_d_c_c_DataModelChangeNotifier__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CardPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_c_CardPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GroupUsersAssignment>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_g_GroupUsersAssignment__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DataSetProcessInstancesWithVariablesPerspective>) GWT.create(Type_factory__o_j_c_n_p_c_p_DataSetProcessInstancesWithVariablesPerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<InitBallotProvider>) GWT.create(Type_factory__o_j_e_i_c_a_b_InitBallotProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RepositoryStructureViewImpl>) GWT.create(Type_factory__o_g_a_m_c_e_r_s_RepositoryStructureViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PlannerDataObjectFieldEditor>) GWT.create(Type_factory__o_o_w_s_d_c_w_p_PlannerDataObjectFieldEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProcessConfigView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_c_p_ProcessConfigView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DDResourceTypeDefinition>) GWT.create(Type_factory__o_j_c_n_w_d_t_DDResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PersistenceUnitPropertyGridViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_p_PersistenceUnitPropertyGridViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefEditorPresenter>) GWT.create(Type_factory__o_d_d_e_c_s_DataSetDefEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<OUPageViewImpl>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_p_o_OUPageViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NotificationView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_c_b_n_NotificationView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RuntimePluginsServiceProxyBackendImpl>) GWT.create(Type_factory__o_u_c_RuntimePluginsServiceProxyBackendImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CSVDataSetDefDriver>) GWT.create(Producer_factory__o_d_c_w_d_e_d_CSVDataSetDefDriver__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LocaleListBox>) GWT.create(Type_factory__o_j_e_u_c_w_LocaleListBox__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KSessionForm>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_KSessionForm__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SplashEditorPresenterActivity>) GWT.create(Type_factory__o_u_e_p_c_e_SplashEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FormLabel>) GWT.create(ExtensionProvided_factory__o_g_c_u_FormLabel__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LiveSearchDropDownView>) GWT.create(Type_factory__o_u_e_w_c_c_d_LiveSearchDropDownView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<UtilityMenuBarPresenter>) GWT.create(Type_factory__o_u_c_w_w_m_UtilityMenuBarPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TextField>) GWT.create(Type_factory__o_u_e_p_e_c_f_TextField__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WiresGridsDemoPerspectiveActivity>) GWT.create(Type_factory__o_u_e_w_c_g_c_p_WiresGridsDemoPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ProjectEditorEntryPoint>) GWT.create(Type_factory__o_k_w_c_s_p_c_ProjectEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ServerManagementEntryPoint>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_ServerManagementEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ContextualSearch>) GWT.create(Type_factory__o_k_w_c_w_c_s_ContextualSearch__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataModelerScreenPresenter>) GWT.create(Type_factory__o_k_w_c_s_d_c_DataModelerScreenPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TestRunnerReportingScreenActivity>) GWT.create(Type_factory__o_d_w_s_t_c_r_TestRunnerReportingScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RepositoryPage>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_p_r_RepositoryPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PromoteScreenPopupViewImpl>) GWT.create(Type_factory__o_g_a_m_c_e_r_s_p_PromoteScreenPopupViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<StencilActionBuilder>) GWT.create(Type_factory__o_u_e_w_c_c_a_StencilActionBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TreeNavigator>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_n_TreeNavigator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GlobalResourceTypeDefinition>) GWT.create(Type_factory__o_d_w_s_g_t_GlobalResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PhaseConfigForm>) GWT.create(Type_factory__o_o_w_s_s_c_e_PhaseConfigForm__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RepositoryStructureMenu>) GWT.create(Type_factory__o_g_a_m_c_e_r_s_RepositoryStructureMenu__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ElasticSearchDataSetDefValidator>) GWT.create(Type_factory__o_d_v_d_ElasticSearchDataSetDefValidator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FactPatternsPageViewImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_p_FactPatternsPageViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewUserAttributeEditor>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_u_NewUserAttributeEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JPADomainScreenViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_j_JPADomainScreenViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MultiListWorkbenchPanelView>) GWT.create(Type_factory__o_u_c_w_p_i_MultiListWorkbenchPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ColumnWithComponentsView>) GWT.create(Type_factory__o_u_e_l_e_c_c_c_ColumnWithComponentsView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<IntervalBuilderFixedDate>) GWT.create(Type_factory__o_d_d_e_g_IntervalBuilderFixedDate__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<JavaFileNameValidator>) GWT.create(Type_factory__o_k_w_c_s_d_c_v_JavaFileNameValidator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserEditorWorkflow>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_u_w_UserEditorWorkflow__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LockDemandDetector>) GWT.create(Type_factory__o_u_c_m_LockDemandDetector__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ColorField>) GWT.create(Type_factory__o_u_e_p_e_c_f_ColorField__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PaletteScreenActivity>) GWT.create(Type_factory__o_u_e_w_c_c_p_PaletteScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DroolsDataObjectEditorViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_d_DroolsDataObjectEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RendererSelectorRadioListView>) GWT.create(Type_factory__o_d_d_c_w_RendererSelectorRadioListView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FormLabelHelp>) GWT.create(ExtensionProvided_factory__o_u_c_v_p_w_FormLabelHelp__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<CommonsEntryPoint>) GWT.create(Type_factory__o_u_e_w_c_c_CommonsEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TimeAmountEditorView>) GWT.create(Type_factory__o_d_d_c_w_f_TimeAmountEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DesignerViewImpl>) GWT.create(Type_factory__o_j_d_c_DesignerViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DataSetDefType>) GWT.create(Type_factory__o_d_d_e_c_s_DataSetDefType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContainerRulesConfigPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_c_c_r_ContainerRulesConfigPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ServerNavigationView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_n_ServerNavigationView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SecurityManagementHomeScreen>) GWT.create(Type_factory__o_u_e_s_m_c_s_h_SecurityManagementHomeScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SimpleWorkbenchPanelView>) GWT.create(Type_factory__o_u_c_w_p_i_SimpleWorkbenchPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedRuleTemplateEditorPresenter>) GWT.create(Type_factory__o_d_w_s_g_t_c_e_GuidedRuleTemplateEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DescriptionColumnConverter>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_DescriptionColumnConverter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RoleEditorScreen>) GWT.create(Type_factory__o_u_e_s_m_c_s_e_RoleEditorScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetProcessInstanceWithVariablesListViewImpl>) GWT.create(Type_factory__o_j_c_n_p_c_e_i_l_v_d_DataSetProcessInstanceWithVariablesListViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<JavaResourceTypeDefinition>) GWT.create(Type_factory__o_k_w_c_s_j_t_JavaResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActivityDataIOEditorViewImpl>) GWT.create(Type_factory__o_j_d_c_p_ActivityDataIOEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SecurityManagementHomeView>) GWT.create(Type_factory__o_u_e_s_m_c_s_h_SecurityManagementHomeView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisplayerError>) GWT.create(Type_factory__o_d_d_c_w_DisplayerError__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DateParameterEditorView>) GWT.create(Type_factory__o_d_d_c_w_f_DateParameterEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DesignerPresenter>) GWT.create(Type_factory__o_j_d_c_DesignerPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TaskCommentsViewImpl>) GWT.create(Type_factory__o_j_c_n_h_c_e_t_TaskCommentsViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EntityWorkflowViewImpl>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_w_EntityWorkflowViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ClientRuntimeErrorPopupPresenter>) GWT.create(Type_factory__o_d_c_w_c_ClientRuntimeErrorPopupPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Instance>) GWT.create(ContextualProvider_factory__j_e_i_Instance__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HeaderPanel>) GWT.create(ExtensionProvided_factory__c_g_g_u_c_u_HeaderPanel__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ElasticSearchDataSetDefDriver>) GWT.create(Producer_factory__o_d_c_w_d_e_d_ElasticSearchDataSetDefDriver__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<EventBus>) GWT.create(Producer_factory__c_g_w_b_e_s_EventBus__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ScreenEditorView>) GWT.create(Type_factory__o_u_e_p_c_e_ScreenEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DataModelCommandBuilder>) GWT.create(Type_factory__o_k_w_c_s_d_c_c_DataModelCommandBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ProcessDefinitionsPerspective>) GWT.create(Type_factory__o_j_c_n_p_c_p_ProcessDefinitionsPerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<POMEditorPanel>) GWT.create(Type_factory__o_g_c_s_p_c_POMEditorPanel__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MultiPageEditorViewImpl>) GWT.create(Type_factory__o_u_c_v_p_m_MultiPageEditorViewImpl__quals__j_e_i_Any_o_u_c_w_w_m_Multiple.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TableDisplayer>) GWT.create(Type_factory__o_d_r_c_t_TableDisplayer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MultiplePermissionNodeEditorView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_n_MultiplePermissionNodeEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GuidedRuleTemplateResourceTypeDefinition>) GWT.create(Type_factory__o_d_w_s_g_t_t_GuidedRuleTemplateResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<RepositoryController>) GWT.create(Type_factory__o_g_s_c_s_RepositoryController__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EditUserForm>) GWT.create(Type_factory__o_k_w_c_s_s_h_c_u_s_EditUserForm__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PerspectiveCoordinator>) GWT.create(Type_factory__o_d_d_c_PerspectiveCoordinator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GoogleAreaChartDisplayerView>) GWT.create(Type_factory__o_d_r_g_c_GoogleAreaChartDisplayerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContainerStatusEmptyPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_c_s_e_ContainerStatusEmptyPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<CallerProvider>) GWT.create(Type_factory__o_j_e_i_c_a_b_CallerProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PermissionTreeI18NImpl>) GWT.create(Type_factory__o_u_c_r_i_PermissionTreeI18NImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisplayerSettingsEditor>) GWT.create(Type_factory__o_d_d_c_w_DisplayerSettingsEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DesignerPopUpPresenter>) GWT.create(Type_factory__o_j_d_c_DesignerPopUpPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KieMetaDataEditorPresenter>) GWT.create(Type_factory__o_k_w_c_s_d_c_e_KieMetaDataEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ProjectImportsResourceType>) GWT.create(Type_factory__o_k_w_c_s_p_c_t_ProjectImportsResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MultipleTextParameterEditor>) GWT.create(Type_factory__o_d_d_c_w_f_MultipleTextParameterEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<CookieStorageHandlerProvider>) GWT.create(Type_factory__o_j_e_s_c_l_s_CookieStorageHandlerProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<UserHomePageMainPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_h_c_u_UserHomePageMainPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Span>) GWT.create(ExtensionProvided_factory__o_j_e_c_c_d_Span__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionWorkItemSetFieldColumnConverter>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_ActionWorkItemSetFieldColumnConverter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TaskCommentsPresenter>) GWT.create(Type_factory__o_j_c_n_h_c_e_t_TaskCommentsPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ObservablePathImpl>) GWT.create(Type_factory__o_u_b_v_i_ObservablePathImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AdvancedDomainEditor>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_AdvancedDomainEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionSetFieldsPageViewImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_p_ActionSetFieldsPageViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WiresGridsDemoPerspective>) GWT.create(Type_factory__o_u_e_w_c_g_c_p_WiresGridsDemoPerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DashboardScreenActivity>) GWT.create(Type_factory__o_j_d_r_c_p_DashboardScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DecisionTableXLSEditorPresenterActivity>) GWT.create(Type_factory__o_d_w_s_d_c_e_DecisionTableXLSEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ProjectImportsResourceTypeDefinition>) GWT.create(Type_factory__o_k_w_c_s_p_t_ProjectImportsResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DocumentMenuItemImpl>) GWT.create(Type_factory__o_k_w_c_w_m_c_m_DocumentMenuItemImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CreateAnnotationWizard>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_a_CreateAnnotationWizard__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PlugInAuthoringPerspective>) GWT.create(Type_factory__o_u_e_p_c_p_PlugInAuthoringPerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<KModuleResourceTypeDefinition>) GWT.create(Type_factory__o_k_w_c_s_p_t_KModuleResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MapEditor>) GWT.create(Type_factory__o_d_c_c_e_m_MapEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UberTabPanel>) GWT.create(Type_factory__o_u_c_v_p_t_UberTabPanel__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LinkTitlePresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_c_t_LinkTitlePresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GoogleMeterChartDisplayer>) GWT.create(Type_factory__o_d_r_g_c_GoogleMeterChartDisplayer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FileExplorerViewImpl>) GWT.create(Type_factory__o_g_s_c_e_f_FileExplorerViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EditorPlugInEditorPresenterActivity>) GWT.create(Type_factory__o_u_e_p_c_e_EditorPlugInEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DomainHandlerRegistry>) GWT.create(Type_factory__o_k_w_c_s_d_c_h_DomainHandlerRegistry__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SecurityEntryPoint>) GWT.create(Type_factory__o_u_s_c_SecurityEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JSNativeSplashScreen>) GWT.create(Type_factory__o_u_c_s_JSNativeSplashScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BeanDataSetDefAttributesDriver>) GWT.create(Producer_factory__o_d_c_w_d_e_d_BeanDataSetDefAttributesDriver__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserHomePageMainPresenterActivity>) GWT.create(Type_factory__o_k_w_c_s_s_h_c_u_UserHomePageMainPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DataSetClientServices>) GWT.create(Type_factory__o_d_d_c_DataSetClientServices__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SecurityRolesConstraintPage>) GWT.create(Type_factory__o_j_e_s_c_l_c_SecurityContextImpl_SecurityRolesConstraintPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.guvnor.structure.client.advnavigator.TreeNavigator>) GWT.create(Type_factory__o_g_s_c_a_TreeNavigator__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RepositoryStructurePage>) GWT.create(Type_factory__o_g_a_m_c_e_r_w_p_RepositoryStructurePage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UsersExplorer>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_UsersExplorer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ListComponentProvider>) GWT.create(Type_factory__o_j_e_d_c_ListComponentProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FindForm>) GWT.create(Type_factory__o_k_w_c_s_s_c_FindForm__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SaveAllMenuBuilder>) GWT.create(Type_factory__o_k_w_c_w_m_c_m_SaveAllMenuBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PerspectiveEditorView>) GWT.create(Type_factory__o_u_e_p_c_p_e_PerspectiveEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ServerEmptyPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_e_ServerEmptyPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ScenarioEditorPresenterActivity>) GWT.create(Type_factory__o_d_w_s_t_c_ScenarioEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefWizardScreen>) GWT.create(Type_factory__o_d_d_e_c_s_DataSetDefWizardScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BRLActionVariableColumnConverter>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_BRLActionVariableColumnConverter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DefaultPermissionTypeRegistry>) GWT.create(Type_factory__o_u_s_i_a_DefaultPermissionTypeRegistry__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JsTypeEventObserver>) GWT.create(JsType_factory__o_j_e_e_c_c_JsTypeEventObserver__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ClientDateFormatterImpl>) GWT.create(Type_factory__o_d_d_c_e_ClientDateFormatterImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PluginJSExporter>) GWT.create(Type_factory__o_u_c_e_PluginJSExporter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedDecisionTableOptions>) GWT.create(ExtensionProvided_factory__o_d_w_s_g_d_c_h_GuidedDecisionTableOptions__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LimitedEntryBRLConditionColumnSynchronizer>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_LimitedEntryBRLConditionColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TimeFrameEditor>) GWT.create(Type_factory__o_d_d_c_w_f_TimeFrameEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DefaultPatternCell>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_p_c_DefaultPatternCell__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProjectScreenPresenterActivity>) GWT.create(Type_factory__o_k_w_c_s_p_c_e_ProjectScreenPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ColumnExpansionPageViewImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_p_ColumnExpansionPageViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<TestRunnerReportingScreen>) GWT.create(Type_factory__o_d_w_s_t_c_r_TestRunnerReportingScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KModuleEditorPanelViewImpl>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_KModuleEditorPanelViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetEditorWorkflowFactory>) GWT.create(Type_factory__o_d_c_w_d_e_w_DataSetEditorWorkflowFactory__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BasicProcessDefDetailsMultiViewImpl>) GWT.create(Type_factory__o_j_c_n_p_c_e_d_d_m_b_BasicProcessDefDetailsMultiViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<URLPatternMatcher>) GWT.create(Producer_factory__o_j_e_u_n_c_l_URLPatternMatcher__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Paragraph>) GWT.create(ExtensionProvided_factory__o_g_c_u_h_Paragraph__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<UberfireDocksImpl>) GWT.create(Type_factory__o_u_c_d_UberfireDocksImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefFilterEditor>) GWT.create(Type_factory__o_d_c_w_d_e_DataSetDefFilterEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FTLTaskDisplayerImpl>) GWT.create(Type_factory__o_j_c_n_h_f_c_d_d_t_FTLTaskDisplayerImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SimpleDnDWorkbenchPanelPresenter>) GWT.create(Type_factory__o_u_c_w_p_i_SimpleDnDWorkbenchPanelPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Frame>) GWT.create(ExtensionProvided_factory__c_g_g_u_c_u_Frame__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GoogleLineChartDisplayerView>) GWT.create(Type_factory__o_d_r_g_c_GoogleLineChartDisplayerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<Bpmn2Type>) GWT.create(Type_factory__o_j_d_c_t_Bpmn2Type__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FileUploadEditor>) GWT.create(Type_factory__o_d_c_c_e_f_FileUploadEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LiveSearchDropDown>) GWT.create(Type_factory__o_u_e_w_c_c_d_LiveSearchDropDown__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisplayErrorPresenterActivity>) GWT.create(Type_factory__o_g_a_m_c_e_f_e_DisplayErrorPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SecurityManagementHomeScreenActivity>) GWT.create(Type_factory__o_u_e_s_m_c_s_h_SecurityManagementHomeScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ServerContainerEmptyView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_c_e_ServerContainerEmptyView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DRLResourceType>) GWT.create(Type_factory__o_d_w_s_d_c_t_DRLResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedDecisionTableModellerViewImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_GuidedDecisionTableModellerViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ExplorerViewImpl>) GWT.create(Type_factory__o_k_w_c_s_e_c_ExplorerViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionSetFieldsPage>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_p_ActionSetFieldsPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ValidatorProvider>) GWT.create(Type_factory__o_j_e_v_c_ValidatorProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DeploymentUnitsListPresenter>) GWT.create(Type_factory__o_j_c_n_b_c_e_d_l_DeploymentUnitsListPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DependencyGridViewImpl>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_d_DependencyGridViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MultiTabWorkbenchPanelPresenter>) GWT.create(Type_factory__o_u_c_w_p_i_MultiTabWorkbenchPanelPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AssetManagementPerspectiveActivity>) GWT.create(Type_factory__o_g_a_m_c_p_AssetManagementPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KieMetaDataEditorPresenterActivity>) GWT.create(Type_factory__o_k_w_c_s_d_c_e_KieMetaDataEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TimeAmountEditor>) GWT.create(Type_factory__o_j_c_n_d_c_p_f_TimeAmountEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<AsyncPackageDataModelOracleFactory>) GWT.create(Type_factory__o_k_w_c_w_c_d_AsyncPackageDataModelOracleFactory__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisplayerScreenPresenterActivity>) GWT.create(Type_factory__o_d_d_c_DisplayerScreenPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Disposer>) GWT.create(ContextualProvider_factory__o_j_e_i_c_a_Disposer__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ErrorBox>) GWT.create(Type_factory__o_u_e_s_m_c_w_p_ErrorBox__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GenericValuePairEditorViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_v_g_GenericValuePairEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ListComponent>) GWT.create(ContextualProvider_factory__o_j_e_d_c_c_ListComponent__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SplitLayoutPanelView>) GWT.create(Type_factory__o_u_c_w_p_i_SplitLayoutPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BasicFileMenuBuilderImpl>) GWT.create(Type_factory__o_u_e_e_c_c_m_BasicFileMenuBuilderImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DSLResourceTypeDefinition>) GWT.create(Type_factory__o_d_w_s_d_t_DSLResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<UserHomePagePerspective>) GWT.create(Type_factory__o_k_w_c_s_s_h_c_u_UserHomePagePerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ValuePairEditorPopupViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_v_ValuePairEditorPopupViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MainDataObjectFieldEditorViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_m_MainDataObjectFieldEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActivityNotFoundView>) GWT.create(Type_factory__o_u_e_w_c_c_w_w_p_a_n_ActivityNotFoundView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ElasticSearchDataSetEditor>) GWT.create(Type_factory__o_d_c_w_d_e_e_ElasticSearchDataSetEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SocialHomePageEntryPoint>) GWT.create(Type_factory__o_k_w_c_s_s_h_c_SocialHomePageEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PlaceHistoryHandler>) GWT.create(Type_factory__o_u_c_m_PlaceHistoryHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NumericTextBox>) GWT.create(ExtensionProvided_factory__o_k_w_c_s_s_m_c_w_NumericTextBox__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Select>) GWT.create(ExtensionProvided_factory__o_j_e_c_c_d_Select__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<FormDisplayPerspective>) GWT.create(Type_factory__o_j_c_n_g_f_c_d_s_FormDisplayPerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PackageNameFormPopupViewImpl>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_PackageNameFormPopupViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DefaultSocialLinkCommandGenerator>) GWT.create(Type_factory__o_k_w_c_s_s_h_c_h_DefaultSocialLinkCommandGenerator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ComponentColumn>) GWT.create(Type_factory__o_u_e_l_e_c_c_c_ComponentColumn__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TransitionToRole>) GWT.create(ContextualProvider_factory__o_j_e_u_n_c_l_TransitionToRole__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContributorsViewImpl>) GWT.create(Type_factory__o_k_w_c_s_c_c_s_ContributorsViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MetaDataColumnSynchronizer>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_MetaDataColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Document>) GWT.create(Producer_factory__o_j_e_c_c_d_Document__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefBasicAttributesDriver>) GWT.create(Producer_factory__o_d_c_w_d_e_d_DataSetDefBasicAttributesDriver__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AssignedEntitiesInlineEditorView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_AssignedEntitiesInlineEditorView__quals__j_e_i_Any_o_u_e_s_m_c_w_m_e_AssignedEntitiesInlineEditor.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewContainerFormPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_c_NewContainerFormPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LimitedEntryBRLActionColumnSynchronizer>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_LimitedEntryBRLActionColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Button>) GWT.create(ExtensionProvided_factory__c_g_g_u_c_u_Button__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DragHelperComponentColumn>) GWT.create(Type_factory__o_u_e_l_e_c_i_DragHelperComponentColumn__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AlertPopupViewImpl>) GWT.create(Type_factory__o_k_w_c_w_c_p_a_AlertPopupViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WindowInjectionContext>) GWT.create(Type_factory__o_j_e_i_c_WindowInjectionContext__quals__j_e_i_Any_j_e_i_Default.class));
    windowContext.addBeanProvider("org.jboss.errai.ioc.client.WindowInjectionContext", new JsTypeProvider<WindowInjectionContext>() {
      public WindowInjectionContext getInstance() {
        return (WindowInjectionContext) contextManager.getInstance("Type_factory__o_j_e_i_c_WindowInjectionContext__quals__j_e_i_Any_j_e_i_Default");
      }
      public String getName() {
        return null;
      }
      public String getFactoryName() {
        return "Type_factory__o_j_e_i_c_WindowInjectionContext__quals__j_e_i_Any_j_e_i_Default";
      }
      public JsArray<String> getQualifiers() {
        return new JsArray<String>(new String[] { "javax.enterprise.inject.Any", "javax.enterprise.inject.Default" });
      }
    });
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Anchor>) GWT.create(ExtensionProvided_factory__o_j_e_c_c_d_Anchor__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PropertyEditorWidget>) GWT.create(Type_factory__o_u_e_p_e_c_PropertyEditorWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DroolsAuthoringNoContextNavigationPerspective>) GWT.create(Type_factory__o_k_w_c_p_DroolsAuthoringNoContextNavigationPerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LimitedEntryColumnConverter>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_LimitedEntryColumnConverter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BRLActionColumnSynchronizer>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_BRLActionColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ModelSynchronizerImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_ModelSynchronizerImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserHomePageSidePresenterActivity>) GWT.create(Type_factory__o_k_w_c_s_s_h_c_u_UserHomePageSidePresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserMenuViewImpl>) GWT.create(Type_factory__o_u_c_v_p_m_UserMenuViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewDslTextHandler>) GWT.create(Type_factory__o_d_w_s_d_c_h_NewDslTextHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GoogleAreaChartDisplayer>) GWT.create(Type_factory__o_d_r_g_c_GoogleAreaChartDisplayer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AssignedEntitiesModalEditorView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_AssignedEntitiesModalEditorView__quals__j_e_i_Any_o_u_e_s_m_c_w_m_e_AssignedEntitiesModalEditor.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AddGlobalPopup>) GWT.create(ExtensionProvided_factory__o_d_w_s_g_c_e_AddGlobalPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GoogleLineChartDisplayer>) GWT.create(Type_factory__o_d_r_g_c_GoogleLineChartDisplayer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HelpIcon>) GWT.create(ExtensionProvided_factory__o_u_c_v_p_w_HelpIcon__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LayoutPanelPresenter>) GWT.create(Type_factory__o_u_c_w_p_i_LayoutPanelPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedDecisionTreeWidget>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_GuidedDecisionTreeWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DroolsAuthoringPerspective>) GWT.create(Type_factory__o_k_w_c_p_DroolsAuthoringPerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetProcessInstanceWithVariablesListPresenterActivity>) GWT.create(Type_factory__o_j_c_n_p_c_e_i_l_v_d_DataSetProcessInstanceWithVariablesListPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DefaultWorkbenchController>) GWT.create(Type_factory__o_u_c_a_DefaultWorkbenchController__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Logger>) GWT.create(ExtensionProvided_factory__o_s_Logger__quals__Universal_2.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Logger>) GWT.create(ExtensionProvided_factory__o_s_Logger__quals__Universal_1.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Logger>) GWT.create(ExtensionProvided_factory__o_s_Logger__quals__Universal_4.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Logger>) GWT.create(ExtensionProvided_factory__o_s_Logger__quals__Universal_3.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Logger>) GWT.create(ExtensionProvided_factory__o_s_Logger__quals__Universal_6.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Logger>) GWT.create(ExtensionProvided_factory__o_s_Logger__quals__Universal_5.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Logger>) GWT.create(ExtensionProvided_factory__o_s_Logger__quals__Universal_8.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Logger>) GWT.create(ExtensionProvided_factory__o_s_Logger__quals__Universal_7.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Logger>) GWT.create(ExtensionProvided_factory__o_s_Logger__quals__Universal_9.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DataSetAuthoringPerspective>) GWT.create(Type_factory__o_d_d_e_c_p_DataSetAuthoringPerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<StandaloneProcessFormDisplayScreen>) GWT.create(Type_factory__o_j_c_n_p_f_c_d_s_StandaloneProcessFormDisplayScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MultiplePermissionNodeEditor>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_n_MultiplePermissionNodeEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ServerNavigationPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_n_ServerNavigationPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Logger>) GWT.create(ExtensionProvided_factory__o_s_Logger__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PlaceRequestHistoryMapperImpl>) GWT.create(Type_factory__o_u_c_m_PlaceRequestHistoryMapperImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LinkedGroup>) GWT.create(ExtensionProvided_factory__o_g_c_u_LinkedGroup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AdvancedProcessDefDetailsMultiPresenterActivity>) GWT.create(Type_factory__o_j_c_n_p_c_e_d_d_m_a_AdvancedProcessDefDetailsMultiPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DroolsTasksListPerspective>) GWT.create(Type_factory__o_j_c_n_h_c_p_DroolsTasksListPerspective__quals__j_e_i_Any_j_e_i_Default.class));
  }

  private void registerFactories1(final Context org_jboss_errai_ioc_client_container_ApplicationScopedContext_context, final Context org_jboss_errai_ioc_client_container_DependentScopeContext_context) {
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<RowContextMenu>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_m_RowContextMenu__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LogoWidgetView>) GWT.create(Type_factory__o_k_w_c_n_LogoWidgetView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ListWidgetProvider>) GWT.create(Type_factory__o_j_e_u_c_w_ListWidgetProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<IFrameScreenView>) GWT.create(Type_factory__o_u_e_w_c_c_s_i_IFrameScreenView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<StencilPaletteBuilder>) GWT.create(Type_factory__o_u_e_w_c_c_p_StencilPaletteBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewGuidedDecisionTableWizard>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_NewGuidedDecisionTableWizard__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<IFrameScreenPresenterActivity>) GWT.create(Type_factory__o_u_e_w_c_c_s_i_IFrameScreenPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DoubleValidator>) GWT.create(Type_factory__o_u_e_w_c_c_p_DoubleValidator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Bs3Modal>) GWT.create(Type_factory__o_u_c_v_p_m_Bs3Modal__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RestoreUtil>) GWT.create(Type_factory__o_u_e_e_c_c_f_RestoreUtil__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ColumnFunctionEditorView>) GWT.create(Type_factory__o_d_d_c_w_g_ColumnFunctionEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContributorsScreenActivity>) GWT.create(Type_factory__o_k_w_c_s_c_c_s_ContributorsScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContainerView>) GWT.create(Type_factory__o_u_e_l_e_c_c_c_ContainerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<JPACommandBuilder>) GWT.create(Type_factory__o_k_w_c_s_d_c_h_j_c_JPACommandBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DecisionTableXLSEditorPresenter>) GWT.create(Type_factory__o_d_w_s_d_c_e_DecisionTableXLSEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SearchAnnotationPageViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_a_SearchAnnotationPageViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HorizImageListEditorView>) GWT.create(Type_factory__o_d_c_c_e_l_HorizImageListEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RequiresReworkViewImpl>) GWT.create(Type_factory__o_g_a_m_c_e_f_r_RequiresReworkViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Validator>) GWT.create(Provider_factory__j_v_Validator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EditMenuViewImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_m_EditMenuViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<LayoutSelection>) GWT.create(Type_factory__o_u_c_w_LayoutSelection__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.kie.workbench.common.screens.server.management.client.container.ContainerView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_c_ContainerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PomEditorScreenPresenterActivity>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_PomEditorScreenPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WiresTreesPaletteScreen>) GWT.create(Type_factory__o_u_e_w_c_t_c_p_WiresTreesPaletteScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisplayerEditor>) GWT.create(Type_factory__o_d_d_c_w_DisplayerEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FormModelerPanelPresenter>) GWT.create(Type_factory__o_j_f_e_c_e_FormModelerPanelPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<UserHomePageSidePresenter>) GWT.create(Type_factory__o_k_w_c_s_s_h_c_u_UserHomePageSidePresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<CoreEntryPoint>) GWT.create(Type_factory__o_u_e_w_c_c_CoreEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SecretTextField>) GWT.create(Type_factory__o_u_e_p_e_c_f_SecretTextField__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<VersionMenuDropDownButtonViewImpl>) GWT.create(Type_factory__o_u_e_e_c_c_h_VersionMenuDropDownButtonViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<VersionHistoryPresenterViewImpl>) GWT.create(Type_factory__o_u_e_e_c_c_h_VersionHistoryPresenterViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ScoreCardXLSResourceTypeDefinition>) GWT.create(Type_factory__o_d_w_s_s_t_ScoreCardXLSResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TaskDetailsViewImpl>) GWT.create(Type_factory__o_j_c_n_h_c_e_t_TaskDetailsViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefFilterEditorView>) GWT.create(Type_factory__o_d_c_w_d_e_DataSetDefFilterEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProjectScreenPresenter>) GWT.create(Type_factory__o_k_w_c_s_p_c_e_ProjectScreenPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<IOCBeanManagerProvider>) GWT.create(Type_factory__o_j_e_i_c_a_b_IOCBeanManagerProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DDParametersPopup>) GWT.create(ExtensionProvided_factory__o_j_c_n_w_c_e_d_d_DDParametersPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ResizeFlowPanel>) GWT.create(ExtensionProvided_factory__o_u_c_w_w_l_ResizeFlowPanel__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<VariableHistoryPopup>) GWT.create(Type_factory__o_j_c_n_p_c_e_v_h_VariableHistoryPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WorkItemHandlersPanel>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_WorkItemHandlersPanel__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ErrorBoxView>) GWT.create(Type_factory__o_u_e_s_m_c_w_p_ErrorBoxView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FormModellerStartProcessDisplayerImpl>) GWT.create(Type_factory__o_j_c_n_h_f_m_c_e_t_d_FormModellerStartProcessDisplayerImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JSNativeEditor>) GWT.create(Type_factory__o_u_c_e_JSNativeEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionWorkItemColumnConverter>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_ActionWorkItemColumnConverter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BRLConditionColumnSynchronizer>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_BRLConditionColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KieTextEditorViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_e_KieTextEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MainPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_h_c_h_m_MainPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActivityDataIOEditorWidgetViewImpl>) GWT.create(Type_factory__o_j_d_c_p_ActivityDataIOEditorWidgetViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HomePerspectiveActivity>) GWT.create(Type_factory__o_k_w_c_s_h_c_p_HomePerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GoogleTableDisplayer>) GWT.create(Type_factory__o_d_r_g_c_GoogleTableDisplayer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewPackageHandler>) GWT.create(Type_factory__o_k_w_c_s_p_c_h_NewPackageHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SaveAllMenuViewImpl>) GWT.create(Type_factory__o_k_w_c_w_m_c_m_SaveAllMenuViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProcessConfigPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_c_p_ProcessConfigPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedDecisionTableEditorViewImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_GuidedDecisionTableEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<MessageConsoleWhiteListImpl>) GWT.create(Type_factory__o_k_w_c_s_s_m_MessageConsoleWhiteListImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ActivityLifecycleErrorHandler>) GWT.create(Type_factory__o_u_c_m_ActivityLifecycleErrorHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SideUserInfoPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_h_c_u_s_SideUserInfoPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TextInput>) GWT.create(ExtensionProvided_factory__o_j_e_c_c_d_TextInput__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JPADataObjectEditor>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_j_JPADataObjectEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<RequestDispatcherProvider>) GWT.create(Type_factory__o_j_e_i_s_b_c_RequestDispatcherProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetEditorWorkflowView>) GWT.create(Type_factory__o_d_c_w_d_e_w_DataSetEditorWorkflowView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ComboField>) GWT.create(Type_factory__o_u_e_p_e_c_f_ComboField__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DefaultPermissionTreeFactory>) GWT.create(Type_factory__o_u_s_c_a_t_i_DefaultPermissionTreeFactory__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ActivityBeansCache>) GWT.create(Type_factory__o_u_c_m_ActivityBeansCache__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<KiePOMDefaultOptions>) GWT.create(Type_factory__o_k_w_c_s_p_c_u_KiePOMDefaultOptions__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CopyPopupView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_n_t_c_CopyPopupView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataColumnDefEditorView>) GWT.create(Type_factory__o_d_c_w_d_e_c_DataColumnDefEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DefaultEditorNewFileUpload>) GWT.create(ExtensionProvided_factory__o_u_e_w_c_c_e_d_DefaultEditorNewFileUpload__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GuidedScoreCardResourceType>) GWT.create(Type_factory__o_d_w_s_g_s_c_t_GuidedScoreCardResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<KModuleResourceType>) GWT.create(Type_factory__o_k_w_c_s_p_c_t_KModuleResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DesignerEditorParametersPublisherViewImpl>) GWT.create(Type_factory__o_j_d_c_p_DesignerEditorParametersPublisherViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewPluginPopUpViewImpl>) GWT.create(Type_factory__o_u_e_p_c_w_p_NewPluginPopUpViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ImportsWidgetPresenter>) GWT.create(Type_factory__o_k_w_c_w_c_c_w_u_ImportsWidgetPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewGuidedRuleTemplateHandler>) GWT.create(Type_factory__o_d_w_s_g_t_c_h_NewGuidedRuleTemplateHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<MessageBusProvider>) GWT.create(Type_factory__o_j_e_i_s_b_c_MessageBusProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MultiPageEditorImpl>) GWT.create(Type_factory__o_u_c_v_p_m_MultiPageEditorImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ExperimentalPagingPerspective>) GWT.create(Type_factory__o_j_c_n_g_c_p_ExperimentalPagingPerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SenderProvider>) GWT.create(Type_factory__o_j_e_i_s_b_c_SenderProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProjectPageViewImpl>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_p_p_ProjectPageViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<LayoutDragComponentHelper>) GWT.create(Type_factory__o_u_e_l_e_c_i_LayoutDragComponentHelper__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<InfoTitleView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_c_t_InfoTitleView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GuidedDTreeResourceType>) GWT.create(Type_factory__o_d_w_s_g_d_c_t_GuidedDTreeResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PlaceManagerFormActivitySearcher>) GWT.create(Type_factory__o_j_c_n_g_f_c_d_d_u_PlaceManagerFormActivitySearcher__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DefaultGuidedDecisionTableLinkManager>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_l_i_DefaultGuidedDecisionTableLinkManager__quals__j_e_i_Any_o_d_w_s_g_d_c_GuidedDecisionTable.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LayoutEditorView>) GWT.create(Type_factory__o_u_e_l_e_c_LayoutEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ListBarWidgetImpl>) GWT.create(Type_factory__o_u_c_v_p_l_ListBarWidgetImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ValuePairEditorPageViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_a_ValuePairEditorPageViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WorkbenchViewModeSwitcherPresenter>) GWT.create(Type_factory__o_u_c_m_WorkbenchViewModeSwitcherPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<POMResourceType>) GWT.create(Type_factory__o_g_c_s_p_c_t_POMResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DRLEditorPresenterActivity>) GWT.create(Type_factory__o_d_w_s_d_c_e_DRLEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<AssetManagementPerspective>) GWT.create(Type_factory__o_g_a_m_c_p_AssetManagementPerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetAuthoringHomePresenter>) GWT.create(Type_factory__o_d_d_e_c_s_DataSetAuthoringHomePresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.gwtbootstrap3.client.ui.html.Span>) GWT.create(ExtensionProvided_factory__o_g_c_u_h_Span__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SQLDataSetDefAttributesDriver>) GWT.create(Producer_factory__o_d_c_w_d_e_d_SQLDataSetDefAttributesDriver__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EditOrganizationalUnitPopup>) GWT.create(ExtensionProvided_factory__o_g_o_m_c_e_p_EditOrganizationalUnitPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetFilterEditorView>) GWT.create(Type_factory__o_d_d_c_w_f_DataSetFilterEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<AppsHomePresenter>) GWT.create(Type_factory__o_u_e_a_c_h_AppsHomePresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RepositoryStructureDataPresenter>) GWT.create(Type_factory__o_g_a_m_c_e_p_s_w_RepositoryStructureDataPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FilterPagedTable>) GWT.create(Type_factory__o_u_e_w_c_c_t_FilterPagedTable__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SolverResourceType>) GWT.create(Type_factory__o_o_w_s_s_c_t_SolverResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<UtilityMenuBarView>) GWT.create(Type_factory__o_u_c_v_p_m_UtilityMenuBarView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<AdvancedDomainHandler>) GWT.create(Type_factory__o_k_w_c_s_d_c_h_a_AdvancedDomainHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KModuleEditorPanel>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_KModuleEditorPanel__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetLookupEditor>) GWT.create(Type_factory__o_d_d_c_w_DataSetLookupEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<RemotePresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_r_RemotePresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ListWidget>) GWT.create(ContextualProvider_factory__o_j_e_u_c_w_ListWidget__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserEditorView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_u_UserEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UploadFormPresenter>) GWT.create(Type_factory__o_g_m_c_u_UploadFormPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SocialHomePageMainView>) GWT.create(Type_factory__o_k_w_c_s_s_h_c_h_SocialHomePageMainView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AlertPanelView>) GWT.create(Type_factory__o_d_c_c_w_AlertPanelView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AddOrganizationalUnitPopup>) GWT.create(ExtensionProvided_factory__o_g_o_m_c_e_p_AddOrganizationalUnitPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ListenersPanelViewImpl>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_ListenersPanelViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<M2RepoEditorPresenter>) GWT.create(Type_factory__o_g_m_c_M2RepoEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedScoreCardEditorViewImpl>) GWT.create(Type_factory__o_d_w_s_g_s_c_e_GuidedScoreCardEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SecurityExplorerScreenActivity>) GWT.create(Type_factory__o_u_e_s_m_c_s_e_SecurityExplorerScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FilterSettingsJSONMarshaller>) GWT.create(Type_factory__o_j_c_n_d_c_f_FilterSettingsJSONMarshaller__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SelectDocumentPopupViewImpl>) GWT.create(Type_factory__o_k_w_c_w_m_c_p_SelectDocumentPopupViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<QuickNewProcessInstancePopup>) GWT.create(Type_factory__o_j_c_n_p_f_c_e_q_QuickNewProcessInstancePopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DSLRResourceTypeDefinition>) GWT.create(Type_factory__o_d_w_s_d_t_DSLRResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LeafPermissionNodeViewerView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_n_LeafPermissionNodeViewerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CSVDataSetDefAttributesEditorView>) GWT.create(Type_factory__o_d_c_w_d_e_c_CSVDataSetDefAttributesEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetProcessInstancesWithVariablesPerspectiveActivity>) GWT.create(Type_factory__o_j_c_n_p_c_p_DataSetProcessInstancesWithVariablesPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SplitLayoutPanelPresenter>) GWT.create(Type_factory__o_u_c_w_p_i_SplitLayoutPanelPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DroolsTasksListGridPresenterActivity>) GWT.create(Type_factory__o_j_c_n_h_c_e_t_g_DroolsTasksListGridPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AdvancedAnnotationListEditor>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_a_AdvancedAnnotationListEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DefaultFileEditorView>) GWT.create(Type_factory__o_u_e_w_c_c_e_d_DefaultFileEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DroolsDomainEditor>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_d_DroolsDomainEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ElasticSearchDataSetDefAttributesEditor>) GWT.create(Type_factory__o_d_c_w_d_e_e_ElasticSearchDataSetDefAttributesEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KieTextEditorScreenPresenter>) GWT.create(Type_factory__o_k_w_c_s_d_c_e_KieTextEditorScreenPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisplayerSettingsJSONMarshaller>) GWT.create(Type_factory__o_d_d_j_DisplayerSettingsJSONMarshaller__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProcessInstanceDetailsMultiPresenterActivity>) GWT.create(Type_factory__o_j_c_n_p_c_e_i_d_m_ProcessInstanceDetailsMultiPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WindowEventObservers>) GWT.create(JsType_factory__o_j_e_e_c_c_WindowEventObservers__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LeafPermissionNodeViewer>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_n_LeafPermissionNodeViewer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.kie.workbench.common.screens.social.hp.client.userpage.main.MainPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_h_c_u_m_MainPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkbenchPickupDragController>) GWT.create(Type_factory__o_u_c_w_w_d_WorkbenchPickupDragController__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ComboBox>) GWT.create(Type_factory__o_j_d_c_u_ComboBox__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DropDownImageListEditorView>) GWT.create(Type_factory__o_d_c_c_e_l_DropDownImageListEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HomeViewImpl>) GWT.create(Type_factory__o_k_w_c_s_h_c_w_h_HomeViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ImportsPageViewImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_p_ImportsPageViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AppsPerspectiveActivity>) GWT.create(Type_factory__o_u_e_a_c_AppsPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefProviderTypeEditor>) GWT.create(Type_factory__o_d_c_w_d_e_DataSetDefProviderTypeEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<TextResourceType>) GWT.create(Type_factory__o_u_e_w_c_c_e_t_TextResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ExplorerPresenter>) GWT.create(Type_factory__o_k_w_c_s_e_c_ExplorerPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.kie.workbench.common.widgets.configresource.client.widget.bound.ImportsWidgetPresenter>) GWT.create(Type_factory__o_k_w_c_w_c_c_w_b_ImportsWidgetPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TaskFormPresenter>) GWT.create(Type_factory__o_j_c_n_h_c_e_t_TaskFormPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetLookupEditorView>) GWT.create(Type_factory__o_d_d_c_w_DataSetLookupEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BasicProcessDefDetailsMultiPresenterActivity>) GWT.create(Type_factory__o_j_c_n_p_c_e_d_d_m_b_BasicProcessDefDetailsMultiPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DroolsDomainHandler>) GWT.create(Type_factory__o_k_w_c_s_d_c_h_d_DroolsDomainHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ScoreDirectorFactoryFormViewImpl>) GWT.create(Type_factory__o_o_w_s_s_c_e_ScoreDirectorFactoryFormViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SelectorDisplayer>) GWT.create(Type_factory__o_d_r_c_s_SelectorDisplayer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JavaSourceViewImpl>) GWT.create(Type_factory__o_k_w_c_s_j_c_e_JavaSourceViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GroupEditor>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_g_GroupEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewPluginPopUp>) GWT.create(Type_factory__o_u_e_p_c_w_p_NewPluginPopUp__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RowNumberColumnConverter>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_RowNumberColumnConverter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TaskAdminPresenter>) GWT.create(Type_factory__o_j_c_n_h_c_e_t_TaskAdminPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PerspectiveEditorPresenterActivity>) GWT.create(Type_factory__o_u_e_p_c_p_e_PerspectiveEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BuildConfigurationPresenterActivity>) GWT.create(Type_factory__o_g_a_m_c_e_b_BuildConfigurationPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Div>) GWT.create(ExtensionProvided_factory__o_j_e_c_c_d_Div__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProcessDocumentListPresenter>) GWT.create(Type_factory__o_j_c_n_p_c_e_d_l_ProcessDocumentListPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ExplorerEntryPoint>) GWT.create(Type_factory__o_k_w_c_s_e_c_ExplorerEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FileMenuBuilderImpl>) GWT.create(Type_factory__o_k_w_c_w_c_m_FileMenuBuilderImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JavaEditorPresenter>) GWT.create(Type_factory__o_k_w_c_s_j_c_e_JavaEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RelationshipField>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_j_p_RelationshipField__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ElasticSearchDataSetEditWorkflow>) GWT.create(Type_factory__o_d_c_w_d_e_w_e_ElasticSearchDataSetEditWorkflow__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefColumnsFilterEditor>) GWT.create(Type_factory__o_d_c_w_d_e_DataSetDefColumnsFilterEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<OverviewWidgetPresenter>) GWT.create(Type_factory__o_k_w_c_w_m_c_w_OverviewWidgetPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ClientIntervalBuilderDynamicDate>) GWT.create(Type_factory__o_d_d_c_e_ClientIntervalBuilderDynamicDate__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Legend>) GWT.create(ExtensionProvided_factory__o_g_c_u_Legend__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProcessInstanceDetailsPresenter>) GWT.create(Type_factory__o_j_c_n_p_c_e_i_d_ProcessInstanceDetailsPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RepositoriesWidgetPresenter>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_r_RepositoriesWidgetPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<JSEntryPoint>) GWT.create(Type_factory__o_u_c_JSEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<OUPage>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_p_o_OUPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewGlobalHandler>) GWT.create(Type_factory__o_d_w_s_g_c_h_NewGlobalHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContributorsPerspectiveActivity>) GWT.create(Type_factory__o_k_w_c_s_c_c_p_ContributorsPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<User>) GWT.create(Producer_factory__o_j_e_s_s_a_i_User__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RepositoryPageViewImpl>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_p_r_RepositoryPageViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DataBinderProvider>) GWT.create(Type_factory__o_j_e_d_c_DataBinderProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PageTransitionProvider>) GWT.create(Type_factory__o_j_e_u_n_c_l_PageTransitionProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WorkbenchPartPresenterDefault>) GWT.create(Type_factory__o_u_c_w_p_n_p_WorkbenchPartPresenterDefault__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<AppsPerspective>) GWT.create(Type_factory__o_u_e_a_c_AppsPerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JPADataObjectFieldEditorViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_j_JPADataObjectFieldEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TestRunnerReportingViewImpl>) GWT.create(Type_factory__o_d_w_s_t_c_r_TestRunnerReportingViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkbenchMenuCompactNavBarView>) GWT.create(Type_factory__o_u_c_v_p_m_WorkbenchMenuCompactNavBarView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ServerTemplateView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_n_t_ServerTemplateView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<TechnicalViewWidget>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_t_TechnicalViewWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.gwtbootstrap3.client.ui.TextArea>) GWT.create(ExtensionProvided_factory__o_g_c_u_TextArea__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DisplayerPrototypes>) GWT.create(Type_factory__o_d_d_c_p_DisplayerPrototypes__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PromoteChangesPresenter>) GWT.create(Type_factory__o_g_a_m_c_e_p_PromoteChangesPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProjectPage>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_p_p_ProjectPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PopupViewImpl>) GWT.create(Type_factory__o_u_c_v_p_p_PopupViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GuidedRuleTemplateEntryPoint>) GWT.create(Type_factory__o_d_w_s_g_t_c_GuidedRuleTemplateEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JsTypeEventObserver>) GWT.create(Type_factory__o_j_e_e_c_c_JsTypeEventObserver__quals__j_e_i_Any_j_e_i_Default.class));
    windowContext.addBeanProvider("org.jboss.errai.enterprise.client.cdi.JsTypeEventObserver", new JsTypeProvider<JsTypeEventObserver>() {
      public JsTypeEventObserver getInstance() {
        return (JsTypeEventObserver) contextManager.getInstance("Type_factory__o_j_e_e_c_c_JsTypeEventObserver__quals__j_e_i_Any_j_e_i_Default");
      }
      public String getName() {
        return null;
      }
      public String getFactoryName() {
        return "Type_factory__o_j_e_e_c_c_JsTypeEventObserver__quals__j_e_i_Any_j_e_i_Default";
      }
      public JsArray<String> getQualifiers() {
        return new JsArray<String>(new String[] { "javax.enterprise.inject.Any", "javax.enterprise.inject.Default" });
      }
    });
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ColumnWithComponents>) GWT.create(Type_factory__o_u_e_l_e_c_c_c_ColumnWithComponents__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ContextualView>) GWT.create(Type_factory__o_k_w_c_w_c_c_ContextualView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<EnumEditorEntryPoint>) GWT.create(Type_factory__o_d_w_s_e_c_EnumEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProjectScreenMenuItem>) GWT.create(Type_factory__o_k_w_c_s_e_c_ProjectScreenMenuItem__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DataSetTasksListPerspective>) GWT.create(Type_factory__o_j_c_n_h_c_p_DataSetTasksListPerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HTML>) GWT.create(ExtensionProvided_factory__c_g_g_u_c_u_HTML__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PackageNameFormPopup>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_PackageNameFormPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DecisionTableXLSResourceTypeDefinition>) GWT.create(Type_factory__o_d_w_s_d_t_DecisionTableXLSResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataObjectBrowser>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_e_DataObjectBrowser__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewTemplateView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_t_NewTemplateView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefScreenViewImpl>) GWT.create(Type_factory__o_d_d_e_c_s_DataSetDefScreenViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<RuntimePluginsEntryPoint>) GWT.create(Type_factory__o_u_e_p_c_RuntimePluginsEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkbenchConfigurationMenu>) GWT.create(Type_factory__o_k_w_c_w_c_h_w_c_WorkbenchConfigurationMenu__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WindowEventObservers>) GWT.create(Type_factory__o_j_e_e_c_c_WindowEventObservers__quals__j_e_i_Any_j_e_i_Default.class));
    windowContext.addBeanProvider("org.jboss.errai.enterprise.client.cdi.WindowEventObservers", new JsTypeProvider<WindowEventObservers>() {
      public WindowEventObservers getInstance() {
        return (WindowEventObservers) contextManager.getInstance("Type_factory__o_j_e_e_c_c_WindowEventObservers__quals__j_e_i_Any_j_e_i_Default");
      }
      public String getName() {
        return null;
      }
      public String getFactoryName() {
        return "Type_factory__o_j_e_e_c_c_WindowEventObservers__quals__j_e_i_Any_j_e_i_Default";
      }
      public JsArray<String> getQualifiers() {
        return new JsArray<String>(new String[] { "javax.enterprise.inject.Any", "javax.enterprise.inject.Default" });
      }
    });
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DataSetDefValidator>) GWT.create(Type_factory__o_d_v_d_DataSetDefValidator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FullTextSearchFormPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_c_FullTextSearchFormPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ImportsPage>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_p_ImportsPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BusyIndicatorView>) GWT.create(Type_factory__o_u_e_w_c_c_c_BusyIndicatorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FetchRepositoryViewImpl>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_p_p_FetchRepositoryViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetFilterEditor>) GWT.create(Type_factory__o_j_c_n_d_c_p_f_DataSetFilterEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RequestListPresenter>) GWT.create(Type_factory__o_j_c_n_e_c_e_r_RequestListPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserHomePagePerspectiveActivity>) GWT.create(Type_factory__o_k_w_c_s_s_h_c_u_UserHomePagePerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisplayerSettingsJSONSourceViewer>) GWT.create(Type_factory__o_d_d_c_w_DisplayerSettingsJSONSourceViewer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GuidedRuleDSLRResourceTypeDefinition>) GWT.create(Type_factory__o_d_w_s_g_r_t_GuidedRuleDSLRResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WindowInjectionContext>) GWT.create(JsType_factory__o_j_e_i_c_WindowInjectionContext__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CSVDataSetEditor>) GWT.create(Type_factory__o_d_c_w_d_e_c_CSVDataSetEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NavigationPanelProvider>) GWT.create(Type_factory__o_j_e_u_n_c_l_NavigationPanelProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserBoxView>) GWT.create(Type_factory__o_k_u_s_a_c_w_u_UserBoxView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JsArray>) GWT.create(JsType_factory__o_j_e_i_c_JsArray__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.dashbuilder.displayer.client.widgets.filter.DataSetFilterEditor>) GWT.create(Type_factory__o_d_d_c_w_f_DataSetFilterEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ValidatorService>) GWT.create(Type_factory__o_k_w_c_s_d_c_v_ValidatorService__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RemoteView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_r_RemoteView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionRetractFactColumnConverter>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_ActionRetractFactColumnConverter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KieMultipleDocumentEditorWrapperViewImpl>) GWT.create(Type_factory__o_k_w_c_w_m_c_KieMultipleDocumentEditorWrapperViewImpl__quals__j_e_i_Any_o_k_w_c_w_m_c_KieMultipleDocumentEditorQualifier.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KieTextEditorScreenPresenterActivity>) GWT.create(Type_factory__o_k_w_c_s_d_c_e_KieTextEditorScreenPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<VersionMenuDropDownButton>) GWT.create(Type_factory__o_u_e_e_c_c_h_VersionMenuDropDownButton__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GAVEditorViewImpl>) GWT.create(Type_factory__o_g_c_s_p_c_GAVEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PermissionTreeSetup>) GWT.create(Type_factory__o_k_w_c_w_c_a_PermissionTreeSetup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<KieMultipleDocumentEditorEntryPoint>) GWT.create(Type_factory__o_k_w_c_w_m_c_KieMultipleDocumentEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefBasicAttributesEditor>) GWT.create(Type_factory__o_d_c_w_d_e_a_DataSetDefBasicAttributesEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<M2RepoPerspectiveActivity>) GWT.create(Type_factory__o_k_w_c_p_M2RepoPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TemplatedWorkbenchPanelPresenter>) GWT.create(Type_factory__o_u_c_w_p_i_TemplatedWorkbenchPanelPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TextBoxFormPopupViewImpl>) GWT.create(Type_factory__o_k_w_c_w_c_p_t_TextBoxFormPopupViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<StateChangeImpl>) GWT.create(Type_factory__o_j_e_i_c_l_i_StateChangeImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RequestDispatcher>) GWT.create(Provider_factory__o_j_e_b_c_a_m_RequestDispatcher__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UploadFormViewImpl>) GWT.create(Type_factory__o_g_m_c_u_UploadFormViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FormControlStatic>) GWT.create(ExtensionProvided_factory__o_g_c_u_FormControlStatic__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FactPatternsPage>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_p_FactPatternsPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetProcessInstanceWithVariablesListPresenter>) GWT.create(Type_factory__o_j_c_n_p_c_e_i_l_v_d_DataSetProcessInstanceWithVariablesListPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<HomeProducer>) GWT.create(Type_factory__o_k_w_c_h_HomeProducer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProjectClassListViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_p_ProjectClassListViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<TranslationServiceProvider>) GWT.create(Type_factory__o_j_e_u_c_l_s_TranslationServiceProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<VFSJSExporter>) GWT.create(Type_factory__o_u_c_e_VFSJSExporter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ColumnFunctionEditor>) GWT.create(Type_factory__o_d_d_c_w_g_ColumnFunctionEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TaskLogsPresenter>) GWT.create(Type_factory__o_j_c_n_h_c_e_t_TaskLogsPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContainerRulesConfigView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_c_c_r_ContainerRulesConfigView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AdaptiveWorkbenchPanelPresenter>) GWT.create(Type_factory__o_u_c_w_p_i_AdaptiveWorkbenchPanelPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JobServiceSettingsPopup>) GWT.create(Type_factory__o_j_c_n_e_c_e_s_JobServiceSettingsPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GroupEditorScreenActivity>) GWT.create(Type_factory__o_u_e_s_m_c_s_e_GroupEditorScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AdvancedDataObjectFieldEditor>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_AdvancedDataObjectFieldEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.gwtbootstrap3.extras.select.client.ui.Select>) GWT.create(ExtensionProvided_factory__o_g_e_s_c_u_Select__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PermissionExceptionSwitch>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_n_PermissionExceptionSwitch__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GuidedDTreeResourceTypeDefinition>) GWT.create(Type_factory__o_d_w_s_g_d_t_GuidedDTreeResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PluginConfigService>) GWT.create(Type_factory__o_u_e_p_c_c_PluginConfigService__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FileExplorerPresenter>) GWT.create(Type_factory__o_g_s_c_e_f_FileExplorerPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContributorsPerspective>) GWT.create(Type_factory__o_k_w_c_s_c_c_p_ContributorsPerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedRuleTemplateEditorViewImpl>) GWT.create(Type_factory__o_d_w_s_g_t_c_e_GuidedRuleTemplateEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MainDataObjectFieldEditor>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_m_MainDataObjectFieldEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MainView>) GWT.create(Type_factory__o_k_w_c_s_s_h_c_u_m_MainView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MetaDataColumnConverter>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_MetaDataColumnConverter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.kie.workbench.common.screens.social.hp.client.homepage.main.MainView>) GWT.create(Type_factory__o_k_w_c_s_s_h_c_h_m_MainView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UnanchoredWorkbenchPartPresenter>) GWT.create(Type_factory__o_u_c_w_p_u_p_UnanchoredWorkbenchPartPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.kie.workbench.common.screens.server.management.client.widget.Div>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_Div__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MultipleNumberParameterEditor>) GWT.create(Type_factory__o_d_d_c_w_f_MultipleNumberParameterEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FileUploadEditorView>) GWT.create(Type_factory__o_d_c_c_e_f_FileUploadEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedRuleTemplateEditorPresenterActivity>) GWT.create(Type_factory__o_d_w_s_g_t_c_e_GuidedRuleTemplateEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SyncBeanManager>) GWT.create(Producer_factory__o_j_e_i_c_c_SyncBeanManager__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RepositoryStructurePresenterActivity>) GWT.create(Type_factory__o_g_a_m_c_e_r_s_RepositoryStructurePresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Row>) GWT.create(Type_factory__o_u_e_l_e_c_c_r_Row__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GuidedDecisionTableEditorEntryPoint>) GWT.create(Type_factory__o_d_w_s_g_d_c_GuidedDecisionTableEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetAuthoringPerspectiveActivity>) GWT.create(Type_factory__o_d_d_e_c_p_DataSetAuthoringPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WizardViewImpl>) GWT.create(Type_factory__o_u_e_w_c_c_w_WizardViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<StaticFocusedResizePanel>) GWT.create(ExtensionProvided_factory__o_u_c_w_w_p_StaticFocusedResizePanel__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DecisionTableXLSXResourceTypeDefinition>) GWT.create(Type_factory__o_d_w_s_d_t_DecisionTableXLSXResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WorkbenchPartView>) GWT.create(Type_factory__o_u_c_w_p_n_p_WorkbenchPartView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TranslationService>) GWT.create(Provider_factory__o_j_e_u_c_l_s_TranslationService__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TaskProcessContextPresenter>) GWT.create(Type_factory__o_j_c_n_h_c_e_t_TaskProcessContextPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ACLViewer>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_ACLViewer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ArtifactListWidgetView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_a_ArtifactListWidgetView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<Bootstrap>) GWT.create(Type_factory__o_j_d_c_Bootstrap__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<VFSLockServiceProxyBackendImpl>) GWT.create(Type_factory__o_u_c_VFSLockServiceProxyBackendImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataObjectBrowserViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_e_DataObjectBrowserViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NavigationPanel>) GWT.create(Provider_factory__o_j_e_u_n_c_l_NavigationPanel__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ComponentColumnView>) GWT.create(Type_factory__o_u_e_l_e_c_c_c_ComponentColumnView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProcessInstanceDetailsMultiPresenter>) GWT.create(Type_factory__o_j_c_n_p_c_e_i_d_m_ProcessInstanceDetailsMultiPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserAttributesEditorView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_u_UserAttributesEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Caller>) GWT.create(ContextualProvider_factory__o_j_e_c_c_a_Caller__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ClientMessageBus>) GWT.create(Producer_factory__o_j_e_b_c_a_ClientMessageBus__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefProviderTypeEditorView>) GWT.create(Type_factory__o_d_c_w_d_e_DataSetDefProviderTypeEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FieldSet>) GWT.create(ExtensionProvided_factory__o_g_c_u_FieldSet__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ReleaseScreenPopupViewImpl>) GWT.create(Type_factory__o_g_a_m_c_e_r_s_r_ReleaseScreenPopupViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JobListPerspectiveActivity>) GWT.create(Type_factory__o_j_c_n_e_c_p_JobListPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<VFSServiceProxyClientImpl>) GWT.create(Type_factory__o_u_c_w_VFSServiceProxyClientImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<LayoutEditorEntryPoint>) GWT.create(Type_factory__o_u_e_l_e_c_LayoutEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DRLResourceTypeDefinition>) GWT.create(Type_factory__o_d_w_s_d_t_DRLResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<OrganizationalUnitManagerPresenterImpl>) GWT.create(Type_factory__o_g_o_m_c_e_OrganizationalUnitManagerPresenterImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CSVDataSetDefAttributesEditor>) GWT.create(Type_factory__o_d_c_w_d_e_c_CSVDataSetDefAttributesEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<CSVDataSetDefValidator>) GWT.create(Type_factory__o_d_v_d_CSVDataSetDefValidator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<IntervalBuilderDynamicLabel>) GWT.create(Type_factory__o_d_d_e_g_IntervalBuilderDynamicLabel__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PlaceManagerTaskDisplayerImpl>) GWT.create(Type_factory__o_j_c_n_h_f_c_d_d_t_PlaceManagerTaskDisplayerImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<StandaloneTaskFormDisplayPresenterActivity>) GWT.create(Type_factory__o_j_c_n_h_f_c_d_s_StandaloneTaskFormDisplayPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<RepositoryPreferencesProducer>) GWT.create(Type_factory__o_k_w_c_RepositoryPreferencesProducer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.gwtbootstrap3.client.ui.Row>) GWT.create(ExtensionProvided_factory__o_g_c_u_Row__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewGuidedDecisionTreeHandler>) GWT.create(Type_factory__o_d_w_s_g_d_c_h_NewGuidedDecisionTreeHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WiresTreesScreenActivity>) GWT.create(Type_factory__o_u_e_w_c_t_c_c_WiresTreesScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ACLEditorView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_ACLEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ToggleSwitchEditorView>) GWT.create(Type_factory__o_d_c_c_e_ToggleSwitchEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<InsertMenuViewImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_m_InsertMenuViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<Bpmn2TypeDefinition>) GWT.create(Type_factory__o_j_d_t_Bpmn2TypeDefinition__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JSNIHelper>) GWT.create(Type_factory__o_j_c_n_g_f_c_d_d_u_JSNIHelper__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ColumnExpansionPage>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_p_ColumnExpansionPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetSummaryView>) GWT.create(Type_factory__o_d_c_w_d_e_DataSetSummaryView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TaskDetailsMultiPresenterActivity>) GWT.create(Type_factory__o_j_c_n_h_c_e_t_TaskDetailsMultiPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GuidedScoreCardResourceTypeDefinition>) GWT.create(Type_factory__o_d_w_s_g_s_t_GuidedScoreCardResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WiresGridsDemoEntryPoint>) GWT.create(Type_factory__o_u_e_w_c_g_c_d_WiresGridsDemoEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EmbeddedFormDisplayView>) GWT.create(Type_factory__o_j_c_n_g_f_c_d_v_EmbeddedFormDisplayView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AdvancedViewProcessDefDetailsPresenter>) GWT.create(Type_factory__o_j_c_n_p_c_e_d_d_a_AdvancedViewProcessDefDetailsPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SelectAssetsToPromotePresenterActivity>) GWT.create(Type_factory__o_g_a_m_c_e_f_p_SelectAssetsToPromotePresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewEnumHandler>) GWT.create(Type_factory__o_d_w_s_e_c_h_NewEnumHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserGroupsExplorer>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_UserGroupsExplorer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ActiveContextOptions>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_ActiveContextOptions__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ArtifactListViewImpl>) GWT.create(Type_factory__o_g_m_c_w_ArtifactListViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GuidedDTableResourceTypeDefinition>) GWT.create(Type_factory__o_d_w_s_g_d_t_GuidedDTableResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AdaptiveWorkbenchPanelView>) GWT.create(Type_factory__o_u_c_w_p_i_AdaptiveWorkbenchPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedDecisionTablePresenter>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_GuidedDecisionTablePresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ConfigureScreenPopupViewImpl>) GWT.create(Type_factory__o_g_a_m_c_e_r_s_c_ConfigureScreenPopupViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PlannerDomainScreenActivity>) GWT.create(Type_factory__o_o_w_s_d_c_w_p_PlannerDomainScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DroolsTasksListPerspectiveActivity>) GWT.create(Type_factory__o_j_c_n_h_c_p_DroolsTasksListPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WorkItemHandlersPanelViewImpl>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_WorkItemHandlersPanelViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefExplorerScreen>) GWT.create(Type_factory__o_d_d_e_c_s_DataSetDefExplorerScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkbenchDragAndDropManager>) GWT.create(Type_factory__o_u_c_w_w_d_WorkbenchDragAndDropManager__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserHomePageMainView>) GWT.create(Type_factory__o_k_w_c_s_s_h_c_u_UserHomePageMainView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<POMResourceTypeDefinition>) GWT.create(Type_factory__o_g_c_s_p_e_t_POMResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MainDomainEditor>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_m_MainDomainEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LockManagerImpl>) GWT.create(Type_factory__o_u_c_m_LockManagerImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ApproveOperationPresenterActivity>) GWT.create(Type_factory__o_g_a_m_c_e_f_a_ApproveOperationPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NoRepositoryURLViewImpl>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_p_p_NoRepositoryURLViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PerspectiveManagerImpl>) GWT.create(Type_factory__o_u_c_m_PerspectiveManagerImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DefaultClipboard>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_c_i_DefaultClipboard__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ServerManagementPerspective>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_ServerManagementPerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkingSetManager>) GWT.create(Type_factory__o_g_c_s_w_c_WorkingSetManager__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ClientSecurityRoleInterceptor>) GWT.create(Type_factory__o_j_e_s_c_l_i_ClientSecurityRoleInterceptor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<StandaloneEditorPerspective>) GWT.create(Type_factory__o_u_c_w_StandaloneEditorPerspective__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<InitBallot>) GWT.create(ContextualProvider_factory__o_j_e_i_c_a_InitBallot__quals__Universal.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<BeanDataSetDefValidator>) GWT.create(Type_factory__o_d_v_d_BeanDataSetDefValidator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<BusinessViewWidget>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_b_BusinessViewWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ToggleSwitchEditor>) GWT.create(Type_factory__o_d_c_c_e_ToggleSwitchEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BodyView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_c_b_BodyView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedDecisionTreeEditorPresenter>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_GuidedDecisionTreeEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProcessDashboardView>) GWT.create(Type_factory__o_j_d_r_c_p_ProcessDashboardView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ExplorerMenuViewImpl>) GWT.create(Type_factory__o_k_w_c_s_e_c_ExplorerMenuViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<LogoWidgetPresenter>) GWT.create(Type_factory__o_k_w_c_n_LogoWidgetPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Input>) GWT.create(ExtensionProvided_factory__o_j_e_c_c_d_Input__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetProviderTypeWorkflow>) GWT.create(Type_factory__o_d_c_w_d_e_w_c_DataSetProviderTypeWorkflow__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ClientUUIDGenerator>) GWT.create(Type_factory__o_d_d_c_u_ClientUUIDGenerator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContainerStatusEmptyView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_c_s_e_ContainerStatusEmptyView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ClientUserSystemManager>) GWT.create(Type_factory__o_u_e_s_m_c_ClientUserSystemManager__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RemoteEmptyView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_r_e_RemoteEmptyView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AppsHomePresenterActivity>) GWT.create(Type_factory__o_u_e_a_c_h_AppsHomePresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SelectAssetsToPromoteViewImpl>) GWT.create(Type_factory__o_g_a_m_c_e_f_p_SelectAssetsToPromoteViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetTasksListGridPresenterActivity>) GWT.create(Type_factory__o_j_c_n_h_c_e_t_g_d_DataSetTasksListGridPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TabPanelWithDropdowns>) GWT.create(Type_factory__o_u_c_v_p_t_TabPanelWithDropdowns__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RowView>) GWT.create(Type_factory__o_u_e_l_e_c_c_r_RowView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AdvancedDomainScreenViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_AdvancedDomainScreenViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PromoteChangesViewImpl>) GWT.create(Type_factory__o_g_a_m_c_e_p_PromoteChangesViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProjectImportsScreenPresenter>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_ProjectImportsScreenPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ApproveOperationViewImpl>) GWT.create(Type_factory__o_g_a_m_c_e_f_a_ApproveOperationViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProcessInstanceDetailsViewImpl>) GWT.create(Type_factory__o_j_c_n_p_c_e_i_d_ProcessInstanceDetailsViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<UberfireJSAPIExporter>) GWT.create(Type_factory__o_u_c_e_UberfireJSAPIExporter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProjectImportsScreenViewImpl>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_ProjectImportsScreenViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserAssignedGroupsExplorer>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_u_UserAssignedGroupsExplorer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RequiresReworkPresenterActivity>) GWT.create(Type_factory__o_g_a_m_c_e_f_r_RequiresReworkPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RenamePopupViewImpl>) GWT.create(Type_factory__o_u_e_e_c_c_f_RenamePopupViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PackageSelectorViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_p_PackageSelectorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetExplorer>) GWT.create(Type_factory__o_d_c_w_d_e_DataSetExplorer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TaskDetailsPresenter>) GWT.create(Type_factory__o_j_c_n_h_c_e_t_TaskDetailsPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KSessionFormViewImpl>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_KSessionFormViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RepositoriesWidgetViewImpl>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_r_RepositoriesWidgetViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<LanguageConfigurationHandler>) GWT.create(Type_factory__o_k_w_c_w_c_h_w_c_LanguageConfigurationHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ServerManagementBrowserPresenterActivity>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_ServerManagementBrowserPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EditJavaSourceWidget>) GWT.create(ExtensionProvided_factory__o_k_w_c_s_j_c_w_EditJavaSourceWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ActionRetractNodeFactory>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_f_ActionRetractNodeFactory__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TransitionAnchor>) GWT.create(ContextualProvider_factory__o_j_e_u_n_c_l_TransitionAnchor__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefRefreshAttributesEditor>) GWT.create(Type_factory__o_d_c_w_d_e_a_DataSetDefRefreshAttributesEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SecurityExplorerScreen>) GWT.create(Type_factory__o_u_e_s_m_c_s_e_SecurityExplorerScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<XMLViewerImpl>) GWT.create(Type_factory__o_o_w_s_s_c_e_XMLViewerImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DeploymentUnitsListViewImpl>) GWT.create(Type_factory__o_j_c_n_b_c_e_d_l_DeploymentUnitsListViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RepositoryManagedStatusUpdater>) GWT.create(Type_factory__o_g_a_m_c_e_r_s_RepositoryManagedStatusUpdater__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.uberfire.ext.layout.editor.client.components.container.Container>) GWT.create(Type_factory__o_u_e_l_e_c_c_c_Container__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DateParameterEditor>) GWT.create(Type_factory__o_j_c_n_d_c_p_f_DateParameterEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedDecisionTableModellerPresenter>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_GuidedDecisionTableModellerPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedDecisionTableEditorPresenter>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_GuidedDecisionTableEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<InboxPresenter>) GWT.create(Type_factory__o_g_i_c_InboxPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DroolsDataObjectFieldEditor>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_d_DroolsDataObjectFieldEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefClientCacheAttributesEditor>) GWT.create(Type_factory__o_d_c_w_d_e_a_DataSetDefClientCacheAttributesEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EmptyDropRowView>) GWT.create(Type_factory__o_u_e_l_e_c_c_r_EmptyDropRowView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DesignerWidgetView>) GWT.create(ExtensionProvided_factory__o_j_d_c_DesignerWidgetView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DocksEntryPoint>) GWT.create(Type_factory__o_u_c_DocksEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<TypeNodeFactory>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_f_TypeNodeFactory__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DynamicMenuEditorView>) GWT.create(Type_factory__o_u_e_p_c_e_DynamicMenuEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DeploymentDescriptorEditorPresenterActivity>) GWT.create(Type_factory__o_j_c_n_w_c_e_d_d_DeploymentDescriptorEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<BatchCallerProvider>) GWT.create(Type_factory__o_j_e_i_s_b_c_BatchCallerProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewDeploymentPopup>) GWT.create(Type_factory__o_j_c_n_b_c_e_d_n_NewDeploymentPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RepositoryEditorView>) GWT.create(Type_factory__o_g_s_c_e_r_e_RepositoryEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActiveContextManager>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_ActiveContextManager__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PluginsInfo>) GWT.create(Type_factory__o_u_e_p_c_i_PluginsInfo__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AuditLog>) GWT.create(ExtensionProvided_factory__o_d_w_s_t_c_AuditLog__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PlannerDataObjectFieldEditorViewImpl>) GWT.create(Type_factory__o_o_w_s_d_c_w_p_PlannerDataObjectFieldEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefPreviewTableView>) GWT.create(Type_factory__o_d_c_w_d_e_DataSetDefPreviewTableView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WizardPageTitle>) GWT.create(Type_factory__o_u_e_w_c_c_w_WizardPageTitle__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<M2RepoEditorPresenterActivity>) GWT.create(Type_factory__o_g_m_c_M2RepoEditorPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SaveButton>) GWT.create(Type_factory__o_u_e_e_c_c_h_SaveButton__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FormListPopupViewImpl>) GWT.create(Type_factory__o_k_w_c_w_c_p_l_FormListPopupViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GenericValuePairEditor>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_v_g_GenericValuePairEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkbenchMenuBarPresenter>) GWT.create(Type_factory__o_u_c_w_w_m_WorkbenchMenuBarPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FooterView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_c_f_FooterView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WorkbenchServicesProxyBackendImpl>) GWT.create(Type_factory__o_u_c_WorkbenchServicesProxyBackendImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SelectorDisplayerView>) GWT.create(Type_factory__o_d_r_c_s_SelectorDisplayerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KSessionModelOptionsPopUpViewImpl>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_KSessionModelOptionsPopUpViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FormListPopup>) GWT.create(Type_factory__o_k_w_c_w_c_p_l_FormListPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JPANewResourceOptions>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_j_o_JPANewResourceOptions__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ClientIntervalBuilderLocator>) GWT.create(Type_factory__o_d_d_c_e_ClientIntervalBuilderLocator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.jbpm.console.ng.df.client.popup.filter.NumberParameterEditor>) GWT.create(Type_factory__o_j_c_n_d_c_p_f_NumberParameterEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ActivityNotFoundPresenter>) GWT.create(Type_factory__o_u_e_w_c_c_w_w_p_a_n_ActivityNotFoundPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AccessImpl>) GWT.create(Type_factory__o_j_e_i_c_l_i_AccessImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PluginExplorerScreenActivity>) GWT.create(Type_factory__o_u_e_p_c_e_PluginExplorerScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FixtureLayout>) GWT.create(Type_factory__o_d_w_s_t_c_FixtureLayout__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ConstraintNodeFactory>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_f_ConstraintNodeFactory__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WorkbenchToolBarView>) GWT.create(Type_factory__o_u_c_v_p_t_WorkbenchToolBarView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<AppNavBar>) GWT.create(Type_factory__o_k_w_c_n_AppNavBar__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RegisteredDocumentsMenuViewImpl>) GWT.create(Type_factory__o_k_w_c_w_m_c_m_RegisteredDocumentsMenuViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AdministrationPerspectiveActivity>) GWT.create(Type_factory__o_k_w_c_p_AdministrationPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BeanDataSetDefAttributesEditorView>) GWT.create(Type_factory__o_d_c_w_d_e_b_BeanDataSetDefAttributesEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SQLDataSetDefValidator>) GWT.create(Type_factory__o_d_v_d_SQLDataSetDefValidator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<IdGeneratorField>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_j_p_IdGeneratorField__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DSLEditorPresenter>) GWT.create(Type_factory__o_d_w_s_d_c_e_DSLEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AsyncPackageDataModelOracleImpl>) GWT.create(Type_factory__o_k_w_c_w_c_d_AsyncPackageDataModelOracleImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PagedTable>) GWT.create(Type_factory__o_u_e_w_c_c_t_PagedTable__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<XMLViewer>) GWT.create(ExtensionProvided_factory__o_k_w_c_s_d_c_p_XMLViewer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RepositoryConfigurationPresenterActivity>) GWT.create(Type_factory__o_g_a_m_c_e_c_RepositoryConfigurationPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisplayerSettingsEditorView>) GWT.create(Type_factory__o_d_d_c_w_DisplayerSettingsEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionRetractFactColumnSynchronizer>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_ActionRetractFactColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionWorkItemColumnSynchronizer>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_ActionWorkItemColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionsScreenActivity>) GWT.create(Type_factory__o_u_e_w_c_c_a_ActionsScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RepositoryStructurePageViewImpl>) GWT.create(Type_factory__o_g_a_m_c_e_r_w_p_RepositoryStructurePageViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<TechnicalViewPresenter>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_t_TechnicalViewPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.uberfire.client.views.pfly.notfound.ActivityNotFoundView>) GWT.create(Type_factory__o_u_c_v_p_n_ActivityNotFoundView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActivityDataIOEditorWidget>) GWT.create(Type_factory__o_j_d_c_p_ActivityDataIOEditorWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SplashScreenJSExporter>) GWT.create(Type_factory__o_u_c_e_SplashScreenJSExporter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ShapeFactoryCache>) GWT.create(Type_factory__o_u_e_w_c_c_f_ShapeFactoryCache__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HorizImageListEditor>) GWT.create(Type_factory__o_d_c_c_e_l_HorizImageListEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetPanelView>) GWT.create(Type_factory__o_d_c_w_d_e_DataSetPanelView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SplashModalFooter>) GWT.create(Type_factory__o_u_c_v_p_s_SplashModalFooter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JavaEditorPresenterActivity>) GWT.create(Type_factory__o_k_w_c_s_j_c_e_JavaEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DefaultFileEditorPresenterActivity>) GWT.create(Type_factory__o_u_e_w_c_c_e_d_DefaultFileEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DesignerPopUpPresenterActivity>) GWT.create(Type_factory__o_j_d_c_DesignerPopUpPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<M2RepoEditorEntryPoint>) GWT.create(Type_factory__o_g_m_c_M2RepoEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<LoadingBox>) GWT.create(Type_factory__o_d_c_w_c_LoadingBox__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewResourcePresenter>) GWT.create(Type_factory__o_k_w_c_w_c_h_NewResourcePresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionWorkItemSetFieldColumnSynchronizer>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_ActionWorkItemSetFieldColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BodyPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_c_b_BodyPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DynamicMenuResourceType>) GWT.create(Type_factory__o_u_e_p_c_t_DynamicMenuResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SolverResourceTypeDefinition>) GWT.create(Type_factory__o_o_w_s_s_t_SolverResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.gwtbootstrap3.client.ui.Anchor>) GWT.create(ExtensionProvided_factory__o_g_c_u_Anchor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TableDisplayerView>) GWT.create(Type_factory__o_d_r_c_t_TableDisplayerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AuthoringWorkbenchDocks>) GWT.create(Type_factory__o_k_w_c_w_c_d_AuthoringWorkbenchDocks__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserEditorDriver>) GWT.create(Type_factory__o_u_e_s_m_c_e_u_UserEditorDriver__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DecisionTableXLSXResourceType>) GWT.create(Type_factory__o_d_w_s_d_c_t_DecisionTableXLSXResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkItemMetaDataLoader>) GWT.create(Type_factory__o_d_w_s_w_c_w_WorkItemMetaDataLoader__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<HTML5DndSeleniumSupport>) GWT.create(Type_factory__o_u_c_e_HTML5DndSeleniumSupport__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RootPanel>) GWT.create(Provider_factory__c_g_g_u_c_u_RootPanel__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<MainDomainHandler>) GWT.create(Type_factory__o_k_w_c_s_d_c_h_m_MainDomainHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionsGroup>) GWT.create(Type_factory__o_u_e_w_c_c_a_ActionsGroup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<StaticWorkbenchPanelView>) GWT.create(Type_factory__o_u_c_w_p_i_StaticWorkbenchPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<BusinessViewPresenter>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_b_BusinessViewPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<OrganizationalUnitController>) GWT.create(Type_factory__o_g_s_c_s_OrganizationalUnitController__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ConditionColumnSynchronizer>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_ConditionColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JPADataObjectEditorViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_j_JPADataObjectEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ActiveContextItems>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_ActiveContextItems__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FooterPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_c_f_FooterPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProcessDocumentListViewImpl>) GWT.create(Type_factory__o_j_c_n_p_c_e_d_l_ProcessDocumentListViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SplashScreenMenuView>) GWT.create(Type_factory__o_u_c_v_p_m_SplashScreenMenuView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DestructionImpl>) GWT.create(Type_factory__o_j_e_i_c_l_i_DestructionImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<StartProcessFormDisplayProviderImpl>) GWT.create(Type_factory__o_j_c_n_p_f_c_d_p_StartProcessFormDisplayProviderImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DRLEditorViewImpl>) GWT.create(Type_factory__o_d_w_s_d_c_e_DRLEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<JPADomainScreen>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_j_JPADomainScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CompassDropController>) GWT.create(Type_factory__o_u_c_w_w_d_CompassDropController__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ConstructionHeuristicFormViewImpl>) GWT.create(Type_factory__o_o_w_s_s_c_e_ConstructionHeuristicFormViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetPanel>) GWT.create(Type_factory__o_d_c_w_d_e_DataSetPanel__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ExampleTreeNode1Factory>) GWT.create(Type_factory__o_u_e_w_c_t_c_f_ExampleTreeNode1Factory__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HeaderView>) GWT.create(Type_factory__o_k_w_c_s_s_h_c_u_m_h_HeaderView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ServerContainerEmptyPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_c_e_ServerContainerEmptyPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserGroupsExplorerView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_UserGroupsExplorerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PersistenceDescriptorEditorPresenter>) GWT.create(Type_factory__o_k_w_c_s_d_c_PersistenceDescriptorEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PersistenceDescriptorType>) GWT.create(Type_factory__o_k_w_c_s_d_c_t_PersistenceDescriptorType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BeanDataSetDefAttributesEditor>) GWT.create(Type_factory__o_d_c_w_d_e_b_BeanDataSetDefAttributesEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SocialRelationsWidget>) GWT.create(Type_factory__o_k_u_s_a_c_w_r_SocialRelationsWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UsersList>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_l_UsersList__quals__j_e_i_Any_j_e_i_Default.class));
  }

  private void registerFactories2(final Context org_jboss_errai_ioc_client_container_ApplicationScopedContext_context, final Context org_jboss_errai_ioc_client_container_DependentScopeContext_context) {
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AdvancedProcessDefDetailsMultiPresenter>) GWT.create(Type_factory__o_j_c_n_p_c_e_d_d_m_a_AdvancedProcessDefDetailsMultiPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<QuickNewTaskPopup>) GWT.create(Type_factory__o_j_c_n_h_c_e_q_QuickNewTaskPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActivityDataIOEditor>) GWT.create(Type_factory__o_j_d_c_p_ActivityDataIOEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SecurityManagementPerspectiveActivity>) GWT.create(Type_factory__o_u_e_s_m_c_p_SecurityManagementPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ClientRequiredRolesExtractorImpl>) GWT.create(Type_factory__o_j_e_s_c_l_r_ClientRequiredRolesExtractorImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ColumnFilterEditor>) GWT.create(Type_factory__o_d_d_c_w_f_ColumnFilterEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<VariableEditPopup>) GWT.create(Type_factory__o_j_c_n_p_c_e_v_e_VariableEditPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BeanDataSetBasicAttributesWorkflow>) GWT.create(Type_factory__o_d_c_w_d_e_w_c_BeanDataSetBasicAttributesWorkflow__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BranchSelector>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_b_BranchSelector__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PersistenceDescriptorEditorViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_PersistenceDescriptorEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ValueFormatterRegistry>) GWT.create(Type_factory__o_d_d_c_f_ValueFormatterRegistry__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DependencySelectorPopupViewImpl>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_d_DependencySelectorPopupViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ReviewPresenterActivity>) GWT.create(Type_factory__o_g_a_m_c_e_f_r_ReviewPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CellContextMenuViewImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_m_CellContextMenuViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<IssuePresenterViewImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_a_p_IssuePresenterViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefBackendCacheAttributesEditor>) GWT.create(Type_factory__o_d_c_w_d_e_a_DataSetDefBackendCacheAttributesEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DataModelerWorkbenchContext>) GWT.create(Type_factory__o_k_w_c_s_d_c_c_DataModelerWorkbenchContext__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FileExplorerPresenterActivity>) GWT.create(Type_factory__o_g_s_c_e_f_FileExplorerPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MetaFileEditorPresenterActivity>) GWT.create(Type_factory__o_u_e_w_c_c_e_m_MetaFileEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RendererSelectorTabListView>) GWT.create(Type_factory__o_d_d_c_w_RendererSelectorTabListView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ComboBoxViewImpl>) GWT.create(Type_factory__o_j_d_c_u_ComboBoxViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisplayerViewer>) GWT.create(Type_factory__o_d_d_c_w_DisplayerViewer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ArtifactListPresenterImpl>) GWT.create(Type_factory__o_g_m_c_w_ArtifactListPresenterImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RepositoriesViewImpl>) GWT.create(Type_factory__o_g_s_c_e_r_l_RepositoriesViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TextParameterEditor>) GWT.create(Type_factory__o_j_c_n_d_c_p_f_TextParameterEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BranchSelectorViewImpl>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_b_BranchSelectorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<MessageConsoleViewImpl>) GWT.create(Type_factory__o_g_m_c_c_MessageConsoleViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BasicProcessDefDetailsPresenter>) GWT.create(Type_factory__o_j_c_n_p_c_e_d_d_b_BasicProcessDefDetailsPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PlannerDomainHandler>) GWT.create(Type_factory__o_o_w_s_d_c_h_p_PlannerDomainHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DefaultRenderer>) GWT.create(Type_factory__o_d_r_c_DefaultRenderer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FactPatternConstraintsPageViewImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_p_FactPatternConstraintsPageViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KModuleEditorScreenPresenterActivity>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_KModuleEditorScreenPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DiscussionWidgetViewImpl>) GWT.create(Type_factory__o_k_w_c_w_c_d_DiscussionWidgetViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DesignerWidgetPresenter>) GWT.create(Type_factory__o_j_d_c_DesignerWidgetPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<TestScenarioEditorEntryPoint>) GWT.create(Type_factory__o_d_w_s_t_c_TestScenarioEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ModelUtils>) GWT.create(Type_factory__o_k_w_c_s_h_m_ModelUtils__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewProcessHandler>) GWT.create(Type_factory__o_j_d_c_h_NewProcessHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ResetPerspectivesMenuBuilder>) GWT.create(Type_factory__o_k_w_c_w_c_m_ResetPerspectivesMenuBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<org.uberfire.client.workbench.widgets.notfound.ActivityNotFoundPresenter>) GWT.create(Type_factory__o_u_c_w_w_n_ActivityNotFoundPresenter__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<InboxWidget>) GWT.create(Type_factory__o_g_i_c_InboxWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DashboardFactory>) GWT.create(Type_factory__o_j_d_r_c_p_DashboardFactory__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionSetFieldColumnSynchronizer>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_ActionSetFieldColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DependencySelectorPopup>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_d_DependencySelectorPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ReviewViewImpl>) GWT.create(Type_factory__o_g_a_m_c_e_f_r_ReviewViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KSessionModelOptionsPopUp>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_KSessionModelOptionsPopUp__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<OrganizationalUnitManagerPresenterImplActivity>) GWT.create(Type_factory__o_g_o_m_c_e_OrganizationalUnitManagerPresenterImplActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EnumEditorPresenter>) GWT.create(Type_factory__o_d_w_s_e_c_e_EnumEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ClientTypeRegistryImpl>) GWT.create(Type_factory__o_u_c_w_t_i_ClientTypeRegistryImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewServerTemplateWizard>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_NewServerTemplateWizard__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JPADomainEditor>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_j_JPADomainEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AdvancedDomainScreenActivity>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_AdvancedDomainScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisplayerTypeSelectorView>) GWT.create(Type_factory__o_d_d_c_w_DisplayerTypeSelectorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ClosableSimpleWorkbenchPanelPresenter>) GWT.create(Type_factory__o_u_c_w_p_i_ClosableSimpleWorkbenchPanelPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataModelerScreenViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_DataModelerScreenViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<RoleStyleBindingProvider>) GWT.create(Type_factory__o_j_e_s_c_l_s_RoleStyleBindingProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ACLSettingsView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_ACLSettingsView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UTCTimeBox>) GWT.create(ExtensionProvided_factory__o_j_c_n_g_c_u_UTCTimeBox__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<EnumResourceType>) GWT.create(Type_factory__o_d_w_s_e_c_t_EnumResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DashboardView>) GWT.create(Type_factory__o_j_d_r_c_p_DashboardView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JsTypeProvider>) GWT.create(JsType_factory__o_j_e_i_c_c_JsTypeProvider__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SimpleDnDWorkbenchPanelView>) GWT.create(Type_factory__o_u_c_w_p_i_SimpleDnDWorkbenchPanelView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionInsertFactFieldCell>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_p_c_ActionInsertFactFieldCell__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GuidedRuleDRLResourceTypeDefinition>) GWT.create(Type_factory__o_d_w_s_g_r_t_GuidedRuleDRLResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BeanDataSetEditWorkflow>) GWT.create(Type_factory__o_d_c_w_d_e_w_e_BeanDataSetEditWorkflow__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DeploymentScreenPopupViewImpl>) GWT.create(Type_factory__o_k_w_c_s_p_c_e_DeploymentScreenPopupViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SolverEditorEntryPoint>) GWT.create(Type_factory__o_o_w_s_s_c_SolverEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkbenchMenuBarView>) GWT.create(Type_factory__o_u_c_v_p_m_WorkbenchMenuBarView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionColumnSynchronizer>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_ActionColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<EventProvider>) GWT.create(Type_factory__o_j_e_e_c_c_EventProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataModelerScreenPresenterActivity>) GWT.create(Type_factory__o_k_w_c_s_d_c_DataModelerScreenPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ProjectContext>) GWT.create(Type_factory__o_g_c_s_p_c_ProjectContext__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewProjectHandler>) GWT.create(Type_factory__o_k_w_c_s_p_c_h_NewProjectHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PlannerDataObjectEditor>) GWT.create(Type_factory__o_o_w_s_d_c_w_p_PlannerDataObjectEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DSLEditorPresenterActivity>) GWT.create(Type_factory__o_d_w_s_d_c_e_DSLEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedDecisionTreeEditorPresenterActivity>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_GuidedDecisionTreeEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PackageNameWhiteListResourceType>) GWT.create(Type_factory__o_k_w_c_s_d_c_e_PackageNameWhiteListResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MultipleTextParameterEditorView>) GWT.create(Type_factory__o_d_d_c_w_f_MultipleTextParameterEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PlaceManagerJSExporter>) GWT.create(Type_factory__o_u_c_e_PlaceManagerJSExporter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RowSynchronizer>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_RowSynchronizer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<FormDefinitionResourceType>) GWT.create(Type_factory__o_j_f_e_c_t_FormDefinitionResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RoleEditorView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_r_RoleEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PlaceManagerStartProcessDisplayerImpl>) GWT.create(Type_factory__o_j_c_n_p_f_c_d_d_p_PlaceManagerStartProcessDisplayerImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedDecisionTableEditorPresenterActivity>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_GuidedDecisionTableEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AnalysisReportScreenActivity>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_a_p_AnalysisReportScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserEditor>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_u_UserEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<IconLocator>) GWT.create(Type_factory__o_k_w_c_s_s_h_c_u_IconLocator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TagSelectorViewImpl>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_t_TagSelectorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedDecisionTableModellerContextMenuSupport>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_GuidedDecisionTableModellerContextMenuSupport__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionsScreen>) GWT.create(Type_factory__o_u_e_w_c_c_a_ActionsScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ColumnListEditorView>) GWT.create(Type_factory__o_d_c_w_d_e_c_ColumnListEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SplashEditorPresenter>) GWT.create(Type_factory__o_u_e_p_c_e_SplashEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DSLResourceType>) GWT.create(Type_factory__o_d_w_s_d_c_t_DSLResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ClosableSimpleWorkbenchPanelView>) GWT.create(Type_factory__o_u_c_w_p_i_ClosableSimpleWorkbenchPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FormModellerTaskDisplayerImpl>) GWT.create(Type_factory__o_j_c_n_h_f_m_c_e_t_d_FormModellerTaskDisplayerImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionInsertFactColumnSynchronizer>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_ActionInsertFactColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.uberfire.ext.security.management.client.widgets.popup.LoadingBox>) GWT.create(Type_factory__o_u_e_s_m_c_w_p_LoadingBox__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DroolsAuthoringNoContextNavigationPerspectiveActivity>) GWT.create(Type_factory__o_k_w_c_p_DroolsAuthoringNoContextNavigationPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GoogleMapDisplayerView>) GWT.create(Type_factory__o_d_r_g_c_GoogleMapDisplayerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkbenchConfigurationViewImpl>) GWT.create(Type_factory__o_k_w_c_w_c_h_w_c_WorkbenchConfigurationViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DynamicMenuEditorPresenterActivity>) GWT.create(Type_factory__o_u_e_p_c_e_DynamicMenuEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewJavaFileTextHandler>) GWT.create(Type_factory__o_k_w_c_s_d_c_h_NewJavaFileTextHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FullTextSearchFormPresenterActivity>) GWT.create(Type_factory__o_k_w_c_s_s_c_FullTextSearchFormPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<CellContextMenu>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_m_CellContextMenu__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SideUserInfoView>) GWT.create(Type_factory__o_k_w_c_s_s_h_c_u_s_SideUserInfoView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProjectItemViewImpl>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_p_p_ProjectItemViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ElasticSearchDataSetBasicAttributesWorkflow>) GWT.create(Type_factory__o_d_c_w_d_e_w_c_ElasticSearchDataSetBasicAttributesWorkflow__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisplayerDragComponent>) GWT.create(Type_factory__o_d_c_e_DisplayerDragComponent__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GuidedRuleDSLRResourceType>) GWT.create(Type_factory__o_d_w_s_g_r_c_t_GuidedRuleDSLRResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PlannerDomainEditor>) GWT.create(Type_factory__o_o_w_s_d_c_w_p_PlannerDomainEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<InsertMenuBuilder>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_m_InsertMenuBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProcessVariableListViewImpl>) GWT.create(Type_factory__o_j_c_n_p_c_e_v_l_ProcessVariableListViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<LocaleSelector>) GWT.create(Type_factory__o_j_e_u_c_w_LocaleSelector__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionInsertFactFieldsPageViewImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_p_ActionInsertFactFieldsPageViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewDecisionTableXLSHandler>) GWT.create(Type_factory__o_d_w_s_d_c_h_NewDecisionTableXLSHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GuidedRuleEditorEntryPoint>) GWT.create(Type_factory__o_d_w_s_g_r_c_GuidedRuleEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CreationImpl>) GWT.create(Type_factory__o_j_e_i_c_l_i_CreationImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<POMWizardPageViewImpl>) GWT.create(Type_factory__o_k_w_c_s_p_c_w_POMWizardPageViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionInsertFactColumnConverter>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_ActionInsertFactColumnConverter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DroolsDomainScreenViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_d_DroolsDomainScreenViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedRuleEditorPresenterActivity>) GWT.create(Type_factory__o_d_w_s_g_r_c_e_GuidedRuleEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HomePresenterActivity>) GWT.create(Type_factory__o_k_w_c_s_h_c_w_h_HomePresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RequiresReworkPresenter>) GWT.create(Type_factory__o_g_a_m_c_e_f_r_RequiresReworkPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DesignerNotificationPopupsManager>) GWT.create(Type_factory__o_j_d_c_n_DesignerNotificationPopupsManager__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PersistenceUnitPropertyGrid>) GWT.create(Type_factory__o_k_w_c_s_d_c_p_PersistenceUnitPropertyGrid__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LayoutEditorPluginImpl>) GWT.create(Type_factory__o_u_e_l_e_c_LayoutEditorPluginImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CloneRepositoryViewImpl>) GWT.create(Type_factory__o_g_s_c_e_r_c_CloneRepositoryViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SplashViewImpl>) GWT.create(Type_factory__o_u_c_v_p_s_SplashViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkbenchLayoutImpl>) GWT.create(Type_factory__o_u_c_w_WorkbenchLayoutImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AssignmentListItemWidgetViewImpl>) GWT.create(Type_factory__o_j_d_c_p_AssignmentListItemWidgetViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DecoratedGridEntryPoint>) GWT.create(Type_factory__o_k_w_c_w_d_c_DecoratedGridEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionSetFieldPatternCell>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_p_c_ActionSetFieldPatternCell__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TagSelector>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_t_TagSelector__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RepositoryConfigurationViewImpl>) GWT.create(Type_factory__o_g_a_m_c_e_c_RepositoryConfigurationViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CRUDListBoxViewImpl>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_CRUDListBoxViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefExplorerScreenActivity>) GWT.create(Type_factory__o_d_d_e_c_s_DataSetDefExplorerScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PackageListBox>) GWT.create(Type_factory__o_k_w_c_w_c_h_PackageListBox__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GuidedDecisionTreeStencilPaletteBuilder>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_p_GuidedDecisionTreeStencilPaletteBuilder__quals__j_e_i_Any_o_d_w_s_g_d_c_w_p_GuidedDecisionTree.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PomEditorScreenPresenter>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_PomEditorScreenPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UTCDateBox>) GWT.create(ExtensionProvided_factory__o_j_c_n_g_c_u_UTCDateBox__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DataSetPrototypes>) GWT.create(Type_factory__o_d_d_c_p_DataSetPrototypes__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContainerCardPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_c_s_c_ContainerCardPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AnalysisReportScreenViewImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_a_p_AnalysisReportScreenViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<LifecycleListenerRegistrarImpl>) GWT.create(Type_factory__o_j_e_i_c_l_i_LifecycleListenerRegistrarImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<IssuePresenter>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_a_p_IssuePresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProcessBreadCrumb>) GWT.create(Type_factory__o_j_d_r_c_p_w_ProcessBreadCrumb__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetGroupDateEditorView>) GWT.create(Type_factory__o_d_d_c_w_g_DataSetGroupDateEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisplayerSubtypeSelectorView>) GWT.create(Type_factory__o_d_d_c_w_DisplayerSubtypeSelectorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RepositoryInfoPageViewImpl>) GWT.create(Type_factory__o_g_a_m_c_e_r_w_p_RepositoryInfoPageViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GridWidgetCellFactoryImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_GridWidgetCellFactoryImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EntitiesExplorerViewImpl>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_EntitiesExplorerViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProcessInstanceSignalPresenterActivity>) GWT.create(Type_factory__o_j_c_n_p_c_e_i_s_ProcessInstanceSignalPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HTMLElement>) GWT.create(ContextualProvider_factory__o_j_e_c_c_d_HTMLElement__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MainDataObjectEditorViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_m_MainDataObjectEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<AppsEntryPoint>) GWT.create(Type_factory__o_u_e_a_c_AppsEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RepositoryEditorPresenterActivity>) GWT.create(Type_factory__o_g_s_c_e_r_e_RepositoryEditorPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ExperimentalPagingPerspectiveActivity>) GWT.create(Type_factory__o_j_c_n_g_c_p_ExperimentalPagingPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ArtifactListWidgetPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_a_ArtifactListWidgetPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ClientSettings>) GWT.create(Type_factory__o_d_d_c_ClientSettings__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<VersionHistoryPresenter>) GWT.create(Type_factory__o_u_e_e_c_c_h_VersionHistoryPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetEditorView>) GWT.create(Type_factory__o_d_c_w_d_e_DataSetEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ConditionColumnConverter>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_ConditionColumnConverter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ExampleTreeNode2Factory>) GWT.create(Type_factory__o_u_e_w_c_t_c_f_ExampleTreeNode2Factory__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ErrorPopupView>) GWT.create(Type_factory__o_u_c_v_p_m_ErrorPopupView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<Classifier>) GWT.create(Type_factory__o_k_w_c_s_e_c_u_Classifier__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TreeNodesGroup>) GWT.create(Type_factory__o_u_e_w_c_t_c_p_TreeNodesGroup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisplayerSubtypeSelector>) GWT.create(Type_factory__o_d_d_c_w_DisplayerSubtypeSelector__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FTLStartProcessDisplayerImpl>) GWT.create(Type_factory__o_j_c_n_p_f_c_d_d_p_FTLStartProcessDisplayerImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RolesExplorer>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_RolesExplorer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BasicProcessDefDetailsMultiPresenter>) GWT.create(Type_factory__o_j_c_n_p_c_e_d_d_m_b_BasicProcessDefDetailsMultiPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DisplayerLocator>) GWT.create(Type_factory__o_d_d_c_DisplayerLocator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.jbpm.console.ng.df.client.popup.filter.ColumnFilterEditor>) GWT.create(Type_factory__o_j_c_n_d_c_p_f_ColumnFilterEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LikeToFunctionEditorView>) GWT.create(Type_factory__o_d_d_c_w_f_LikeToFunctionEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<AnyResourceType>) GWT.create(Type_factory__o_u_c_w_t_AnyResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NotificationManager>) GWT.create(Type_factory__o_u_c_w_w_n_NotificationManager__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetTasksListPerspectiveActivity>) GWT.create(Type_factory__o_j_c_n_h_c_p_DataSetTasksListPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KModuleEditorScreenPresenter>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_KModuleEditorScreenPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<StencilLayerBuilder>) GWT.create(Type_factory__o_u_e_w_c_c_l_StencilLayerBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RestoreVersionCommandProvider>) GWT.create(Type_factory__o_u_e_e_c_c_m_RestoreVersionCommandProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GoogleMapDisplayer>) GWT.create(Type_factory__o_d_r_g_c_GoogleMapDisplayer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DefaultWorkbenchFeaturesMenusHelper>) GWT.create(Type_factory__o_k_w_c_w_c_m_DefaultWorkbenchFeaturesMenusHelper__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PlannerDomainScreen>) GWT.create(Type_factory__o_o_w_s_d_c_w_p_PlannerDomainScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MultiplePermissionNodeViewer>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_n_MultiplePermissionNodeViewer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LayoutEditorPresenter>) GWT.create(Type_factory__o_u_e_l_e_c_LayoutEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ColumnListEditor>) GWT.create(Type_factory__o_d_c_w_d_e_c_ColumnListEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KBaseFormViewImpl>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_KBaseFormViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DeploymentDescriptorEditorPresenter>) GWT.create(Type_factory__o_j_c_n_w_c_e_d_d_DeploymentDescriptorEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DotResourceType>) GWT.create(Type_factory__o_u_c_w_t_DotResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TextBoxFormPopup>) GWT.create(Type_factory__o_k_w_c_w_c_p_t_TextBoxFormPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewTestScenarioHandler>) GWT.create(Type_factory__o_d_w_s_t_c_h_NewTestScenarioHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AggregateFunctionManagerImpl>) GWT.create(Type_factory__o_d_d_e_f_AggregateFunctionManagerImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserStorageHandler>) GWT.create(Provider_factory__o_j_e_s_c_l_s_UserStorageHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PlannerDomainScreenViewImpl>) GWT.create(Type_factory__o_o_w_s_d_c_w_p_PlannerDomainScreenViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ManagedInstance>) GWT.create(ContextualProvider_factory__o_j_e_i_c_a_ManagedInstance__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionInsertFactFieldPatternCell>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_p_c_ActionInsertFactFieldPatternCell__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.uberfire.ext.security.management.client.widgets.popup.LoadingBoxView>) GWT.create(Type_factory__o_u_e_s_m_c_w_p_LoadingBoxView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CopyPopupViewImpl>) GWT.create(Type_factory__o_u_e_e_c_c_f_CopyPopupViewImpl__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionSetFieldColumnConverter>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_ActionSetFieldColumnConverter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JSNativePerspective>) GWT.create(Type_factory__o_u_c_p_JSNativePerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<AdministrationPerspective>) GWT.create(Type_factory__o_k_w_c_p_AdministrationPerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PopupFormDisplayerView>) GWT.create(Type_factory__o_j_c_n_p_f_c_d_v_PopupFormDisplayerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RepositoriesPresenterActivity>) GWT.create(Type_factory__o_g_s_c_e_r_l_RepositoriesPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PermissionSwitch>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_n_PermissionSwitch__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserAssignedGroupsEditor>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_u_UserAssignedGroupsEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefRefreshIntervalEditor>) GWT.create(Type_factory__o_d_c_w_d_e_a_DataSetDefRefreshIntervalEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedDecisionTreeEditorViewImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_GuidedDecisionTreeEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FormModelerPanelPresenterActivity>) GWT.create(Type_factory__o_j_f_e_c_e_FormModelerPanelPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SummaryPageViewImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_p_SummaryPageViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DropDownMenu>) GWT.create(ExtensionProvided_factory__o_g_c_u_DropDownMenu__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContainerRemoteStatusView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_c_s_ContainerRemoteStatusView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HomeModel>) GWT.create(Producer_factory__o_k_w_c_s_h_m_HomeModel__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefBasicAttributesEditorView>) GWT.create(Type_factory__o_d_c_w_d_e_a_DataSetDefBasicAttributesEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TextParameterEditorView>) GWT.create(Type_factory__o_d_d_c_w_f_TextParameterEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProcessDefinitionListPresenter>) GWT.create(Type_factory__o_j_c_n_p_c_e_d_l_ProcessDefinitionListPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewDependencyPopup>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_d_NewDependencyPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JSNativeScreen>) GWT.create(Type_factory__o_u_c_s_JSNativeScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ServerManagementBrowserView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_ServerManagementBrowserView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CopyPopupWithPackageViewImpl>) GWT.create(Type_factory__o_k_w_c_w_c_p_c_CopyPopupWithPackageViewImpl__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataBinder>) GWT.create(ContextualProvider_factory__o_j_e_d_c_a_DataBinder__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewTabFilterPopup>) GWT.create(Type_factory__o_u_e_w_c_c_t_p_NewTabFilterPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionWorkItemInsertFactColumnConverter>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_ActionWorkItemInsertFactColumnConverter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RepositoryItemViewImpl>) GWT.create(Type_factory__o_g_s_c_e_r_l_RepositoryItemViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedRuleEditorPresenter>) GWT.create(Type_factory__o_d_w_s_g_r_c_e_GuidedRuleEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DesignerPresenterActivity>) GWT.create(Type_factory__o_j_d_c_DesignerPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RestorePopup>) GWT.create(Type_factory__o_u_e_e_c_c_f_RestorePopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DynamicMenuEditorPresenter>) GWT.create(Type_factory__o_u_e_p_c_e_DynamicMenuEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewSolverHandler>) GWT.create(Type_factory__o_o_w_s_s_c_h_NewSolverHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WorkItemDefinitionElementsBrowser>) GWT.create(Type_factory__o_d_w_s_w_c_w_WorkItemDefinitionElementsBrowser__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisplayerEditorPopup>) GWT.create(Type_factory__o_d_d_c_w_DisplayerEditorPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<StandaloneProcessFormDisplayScreenActivity>) GWT.create(Type_factory__o_j_c_n_p_f_c_d_s_StandaloneProcessFormDisplayScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<RootPanelProvider>) GWT.create(Type_factory__o_j_e_i_c_a_b_RootPanelProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AdvancedDataObjectFieldEditorViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_AdvancedDataObjectFieldEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EnumEditorPresenterActivity>) GWT.create(Type_factory__o_d_w_s_e_c_e_EnumEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NavigationGraph>) GWT.create(Producer_factory__o_j_e_u_n_c_l_s_NavigationGraph__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KBaseForm>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_KBaseForm__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedDecisionTreePalette>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_p_GuidedDecisionTreePalette__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContainerPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_c_ContainerPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TextEditorWorkbenchEditorActivity>) GWT.create(Type_factory__o_u_e_w_c_c_e_t_TextEditorWorkbenchEditorActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GenericFormsClientEntryPoint>) GWT.create(Type_factory__o_j_c_n_g_f_c_GenericFormsClientEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ScreenEditorPresenterActivity>) GWT.create(Type_factory__o_u_e_p_c_e_ScreenEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MetaFileEditorPresenter>) GWT.create(Type_factory__o_u_e_w_c_c_e_m_MetaFileEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.dashbuilder.displayer.client.widgets.filter.DateParameterEditor>) GWT.create(Type_factory__o_d_d_c_w_f_DateParameterEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ProjectNameValidator>) GWT.create(Type_factory__o_k_w_c_s_p_c_v_ProjectNameValidator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<URLPatternMatcherProvider>) GWT.create(Type_factory__o_j_e_u_n_c_l_URLPatternMatcherProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DroolsTasksListGridPresenter>) GWT.create(Type_factory__o_j_c_n_h_c_e_t_g_DroolsTasksListGridPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisplayerCoordinator>) GWT.create(Type_factory__o_d_d_c_DisplayerCoordinator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.dashbuilder.displayer.client.widgets.filter.TextParameterEditor>) GWT.create(Type_factory__o_d_d_c_w_f_TextParameterEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ShapesGroup>) GWT.create(Type_factory__o_u_e_w_c_c_p_ShapesGroup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProcessConfigPagePresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_c_p_ProcessConfigPagePresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetEditorManager>) GWT.create(Type_factory__o_j_c_n_d_c_l_b_DataSetEditorManager__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<TestScenarioResourceType>) GWT.create(Type_factory__o_d_w_s_t_c_t_TestScenarioResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<RadarMenuBuilder>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_m_RadarMenuBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WiresTreesPaletteScreenActivity>) GWT.create(Type_factory__o_u_e_w_c_t_c_p_WiresTreesPaletteScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PluginController>) GWT.create(Type_factory__o_u_e_p_c_s_PluginController__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RoleEditorWorkflow>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_r_w_RoleEditorWorkflow__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SearchMenuPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_c_m_SearchMenuPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ServerManagementBrowserPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_ServerManagementBrowserPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RepositoryItemPresenter>) GWT.create(Type_factory__o_g_s_c_e_r_l_RepositoryItemPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetTasksListGridViewImpl>) GWT.create(Type_factory__o_j_c_n_h_c_e_t_g_d_DataSetTasksListGridViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ScenarioWidgetComponentCreator>) GWT.create(Type_factory__o_d_w_s_t_c_ScenarioWidgetComponentCreator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DSLRResourceType>) GWT.create(Type_factory__o_d_w_s_d_c_t_DSLRResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkbenchLayoutInfoImpl>) GWT.create(Type_factory__o_u_c_w_WorkbenchLayoutInfoImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewFileUploader>) GWT.create(Type_factory__o_k_w_c_s_d_c_e_NewFileUploader__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WiresTreesDefaultLayout>) GWT.create(Type_factory__o_u_e_w_c_t_c_l_WiresTreesDefaultLayout__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DashboardPerspectiveActivity>) GWT.create(Type_factory__o_j_d_r_c_p_DashboardPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SocialHomePageMainPresenterActivity>) GWT.create(Type_factory__o_k_w_c_s_s_h_c_h_SocialHomePageMainPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RequestListViewImpl>) GWT.create(Type_factory__o_j_c_n_e_c_e_r_RequestListViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<InfoTitlePresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_c_t_InfoTitlePresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ACLViewerView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_ACLViewerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CSVDataSetEditWorkflow>) GWT.create(Type_factory__o_d_c_w_d_e_w_e_CSVDataSetEditWorkflow__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PersistenceDescriptorEditorPresenterActivity>) GWT.create(Type_factory__o_k_w_c_s_d_c_PersistenceDescriptorEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ServerTemplateProvider>) GWT.create(Type_factory__o_j_e_u_s_ServerTemplateProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RuntimeLogViewImpl>) GWT.create(Type_factory__o_j_c_n_p_c_e_i_l_RuntimeLogViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.gwtbootstrap3.client.ui.Button>) GWT.create(ExtensionProvided_factory__o_g_c_u_Button__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<FormResourceTypeDefinition>) GWT.create(Type_factory__o_j_f_e_t_FormResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PromoteChangesPresenterActivity>) GWT.create(Type_factory__o_g_a_m_c_e_p_PromoteChangesPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserEditorScreenActivity>) GWT.create(Type_factory__o_u_e_s_m_c_s_e_UserEditorScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ScenarioKSessionSelector>) GWT.create(Type_factory__o_d_w_s_t_c_ScenarioKSessionSelector__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GlobalResourceType>) GWT.create(Type_factory__o_d_w_s_g_c_t_GlobalResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CSVDataSetDefAttributesDriver>) GWT.create(Producer_factory__o_d_c_w_d_e_d_CSVDataSetDefAttributesDriver__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PlaceManagerImpl>) GWT.create(Type_factory__o_u_c_m_PlaceManagerImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<CustomSplashHelp>) GWT.create(Type_factory__o_u_c_m_CustomSplashHelp__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LeafPermissionNodeEditorView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_n_LeafPermissionNodeEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CloneRepositoryPresenter>) GWT.create(Type_factory__o_g_s_c_e_r_c_CloneRepositoryPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TaskDetailsMultiPresenter>) GWT.create(Type_factory__o_j_c_n_h_c_e_t_TaskDetailsMultiPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<AnalysisReportScreen>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_a_p_AnalysisReportScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkbenchConfigurationPresenter>) GWT.create(Type_factory__o_k_w_c_w_c_h_w_c_WorkbenchConfigurationPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WiresTreesScreen>) GWT.create(Type_factory__o_u_e_w_c_t_c_c_WiresTreesScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FormRendererPanelIncluderViewImpl>) GWT.create(Type_factory__o_j_f_r_i_FormRendererPanelIncluderViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DefaultAuthorizationManager>) GWT.create(Type_factory__o_u_s_i_a_DefaultAuthorizationManager__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PlugInAuthoringPerspectiveActivity>) GWT.create(Type_factory__o_u_e_p_c_p_PlugInAuthoringPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkItemsEditorEntryPoint>) GWT.create(Type_factory__o_d_w_s_w_c_WorkItemsEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkItemsResourceType>) GWT.create(Type_factory__o_d_w_s_w_c_t_WorkItemsResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DesignerEditorParametersPublisher>) GWT.create(Type_factory__o_j_d_c_p_DesignerEditorParametersPublisher__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ScreenEditorPresenter>) GWT.create(Type_factory__o_u_e_p_c_e_ScreenEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.jbpm.console.ng.df.client.popup.filter.TimeFrameEditor>) GWT.create(Type_factory__o_j_c_n_d_c_p_f_TimeFrameEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SaveOperationNotifier>) GWT.create(Type_factory__o_u_e_e_c_c_f_SaveOperationService_SaveOperationNotifier__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BRLConditionVariableColumnConverter>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_BRLConditionVariableColumnConverter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ViewDRLSourceWidget>) GWT.create(ExtensionProvided_factory__o_k_w_c_w_c_s_ViewDRLSourceWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GlobalsEditorPresenter>) GWT.create(Type_factory__o_d_w_s_g_c_e_GlobalsEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AlertPanel>) GWT.create(Type_factory__o_d_c_c_w_AlertPanel__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<TransitionAnchorFactoryProvider>) GWT.create(Type_factory__o_j_e_u_n_c_l_TransitionAnchorFactoryProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CreateEntity>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_CreateEntity__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ChangePassword>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_ChangePassword__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkbenchTreeProvider>) GWT.create(Type_factory__o_k_w_c_w_c_a_WorkbenchTreeProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<MessageConsoleService>) GWT.create(Type_factory__o_g_m_c_c_MessageConsoleService__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WorkbenchViewModeSwitcherMenuBuilder>) GWT.create(Type_factory__o_u_c_m_WorkbenchViewModeSwitcherMenuBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedDecisionTableLockManagerImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_l_GuidedDecisionTableLockManagerImpl__quals__j_e_i_Any_o_d_w_s_g_d_c_GuidedDecisionTable.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UnanchoredStaticWorkbenchPanelView>) GWT.create(Type_factory__o_u_c_w_p_i_UnanchoredStaticWorkbenchPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SocialHomePageSidePresenter>) GWT.create(Type_factory__o_k_w_c_s_s_h_c_h_SocialHomePageSidePresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DnDManager>) GWT.create(Type_factory__o_u_e_l_e_c_i_DnDManager__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RemoteStatusView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_r_RemoteStatusView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HomePresenter>) GWT.create(Type_factory__o_k_w_c_s_h_c_w_h_HomePresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<InboxPresenterActivity>) GWT.create(Type_factory__o_g_i_c_InboxPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PropertiesScreen>) GWT.create(Type_factory__o_u_e_w_c_c_p_PropertiesScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserAttributesEditor>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_u_UserAttributesEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewResourceView>) GWT.create(Type_factory__o_k_w_c_w_c_h_NewResourceView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SequenceGeneratorField>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_j_p_SequenceGeneratorField__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SQLDataSetEditWorkflow>) GWT.create(Type_factory__o_d_c_w_d_e_w_e_SQLDataSetEditWorkflow__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisplayerEditorView>) GWT.create(Type_factory__o_d_d_c_w_DisplayerEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ExamplesScreenEntryPoint>) GWT.create(Type_factory__o_k_w_c_s_e_c_ExamplesScreenEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DocksBars>) GWT.create(Type_factory__o_u_c_d_v_DocksBars__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DroolsDomainScreen>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_d_DroolsDomainScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DisposerProvider>) GWT.create(Type_factory__o_j_e_i_c_a_b_DisposerProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TerminationTreeItemContent>) GWT.create(Type_factory__o_o_w_s_s_c_e_TerminationTreeItemContent__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RendererSelector>) GWT.create(Type_factory__o_d_d_c_w_RendererSelector__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LayersScreenActivity>) GWT.create(Type_factory__o_u_e_w_c_c_l_LayersScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DynamicMenuResourceTypeDefinition>) GWT.create(Type_factory__o_u_e_p_t_DynamicMenuResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Icon>) GWT.create(ExtensionProvided_factory__o_g_c_u_Icon__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ClientChronometer>) GWT.create(Type_factory__o_d_d_c_e_ClientChronometer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KSessionsPanelViewImpl>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_KSessionsPanelViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SelectAssetsToPromotePresenter>) GWT.create(Type_factory__o_g_a_m_c_e_f_p_SelectAssetsToPromotePresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AttributeColumnSynchronizer>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_AttributeColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AppsHomeView>) GWT.create(Type_factory__o_u_e_a_c_h_AppsHomeView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EmptyDropRow>) GWT.create(Type_factory__o_u_e_l_e_c_c_r_EmptyDropRow__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ManagedInstanceProvider>) GWT.create(Type_factory__o_j_e_i_c_a_b_ManagedInstanceProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CSVDataSetBasicAttributesWorkflow>) GWT.create(Type_factory__o_d_c_w_d_e_w_c_CSVDataSetBasicAttributesWorkflow__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ActionUpdateNodeFactory>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_f_ActionUpdateNodeFactory__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FilterEditorPopup>) GWT.create(Type_factory__o_j_c_n_d_c_f_FilterEditorPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ExampleTreeNode3DynamicFactory>) GWT.create(Type_factory__o_u_e_w_c_t_c_f_ExampleTreeNode3DynamicFactory__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DashboardPerspective>) GWT.create(Type_factory__o_j_d_r_c_p_DashboardPerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ConnectorsGroup>) GWT.create(Type_factory__o_u_e_w_c_c_p_ConnectorsGroup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SQLDataSetDefAttributesEditor>) GWT.create(Type_factory__o_d_c_w_d_e_s_SQLDataSetDefAttributesEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetSummary>) GWT.create(Type_factory__o_d_c_w_d_e_DataSetSummary__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AuthenticationServiceInterceptor>) GWT.create(Type_factory__o_j_e_s_c_l_i_AuthenticationServiceInterceptor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DroolsAuthoringPerspectiveActivity>) GWT.create(Type_factory__o_k_w_c_p_DroolsAuthoringPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ScreenLayoutDragComponent>) GWT.create(Type_factory__o_u_e_p_c_p_e_l_e_ScreenLayoutDragComponent__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BuildConfigurationViewImpl>) GWT.create(Type_factory__o_g_a_m_c_e_b_BuildConfigurationViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionSetFieldCell>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_p_c_ActionSetFieldCell__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HTMLElementProvider>) GWT.create(Type_factory__o_j_e_u_c_l_p_HTMLElementProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BuildConfigurationPresenter>) GWT.create(Type_factory__o_g_a_m_c_e_b_BuildConfigurationPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PhaseConfigFormViewImpl>) GWT.create(Type_factory__o_o_w_s_s_c_e_PhaseConfigFormViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewGuidedDecisionTableHandler>) GWT.create(Type_factory__o_d_w_s_g_d_c_h_NewGuidedDecisionTableHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RolesList>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_l_RolesList__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DefaultFileNameValidator>) GWT.create(Type_factory__o_u_e_e_c_c_v_DefaultFileNameValidator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefProviderTypeDriver>) GWT.create(Producer_factory__o_d_c_w_d_e_d_DataSetDefProviderTypeDriver__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<MenuBuilder>) GWT.create(Type_factory__o_u_c_d_v_m_MenuBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ViewSourceViewImpl>) GWT.create(Type_factory__o_k_w_c_w_c_s_ViewSourceViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SQLDataSetDefDriver>) GWT.create(Producer_factory__o_d_c_w_d_e_d_SQLDataSetDefDriver__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.kie.workbench.common.screens.social.hp.client.homepage.header.HeaderView>) GWT.create(Type_factory__o_k_w_c_s_s_h_c_h_h_HeaderView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ValuePairEditorPopup>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_v_ValuePairEditorPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewFilterPopup>) GWT.create(Type_factory__o_u_e_w_c_c_t_p_NewFilterPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ConfirmBoxView>) GWT.create(Type_factory__o_u_e_s_m_c_w_p_ConfirmBoxView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GooglePieChartDisplayerView>) GWT.create(Type_factory__o_d_r_g_c_GooglePieChartDisplayerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DroolsDataObjectFieldEditorViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_d_DroolsDataObjectFieldEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<OrganizationalUnitManagerEntryPoint>) GWT.create(Type_factory__o_g_o_m_c_OrganizationalUnitManagerEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BaseScreenView>) GWT.create(Type_factory__o_u_e_s_m_c_s_BaseScreenView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JPADomainScreenActivity>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_j_JPADomainScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SessionInfo>) GWT.create(Producer_factory__o_u_r_SessionInfo__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RoleEditorScreenActivity>) GWT.create(Type_factory__o_u_e_s_m_c_s_e_RoleEditorScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PaletteScreen>) GWT.create(Type_factory__o_u_e_w_c_c_p_PaletteScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContainerProcessConfigView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_c_c_p_ContainerProcessConfigView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewScoreCardXLSHandler>) GWT.create(Type_factory__o_d_w_s_s_c_h_NewScoreCardXLSHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ViewMenuViewImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_m_ViewMenuViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Logger>) GWT.create(ExtensionProvided_factory__o_s_Logger__quals__Universal_11.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Logger>) GWT.create(ExtensionProvided_factory__o_s_Logger__quals__Universal_10.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GlobalsEditorViewImpl>) GWT.create(Type_factory__o_d_w_s_g_c_e_GlobalsEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TagWidgetViewImpl>) GWT.create(Type_factory__o_k_w_c_w_m_c_w_TagWidgetViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RepositoryInfoPage>) GWT.create(Type_factory__o_g_a_m_c_e_r_w_p_RepositoryInfoPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ScoreDirectorFactoryForm>) GWT.create(Type_factory__o_o_w_s_s_c_e_ScoreDirectorFactoryForm__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Logger>) GWT.create(ExtensionProvided_factory__o_s_Logger__quals__Universal_13.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Logger>) GWT.create(ExtensionProvided_factory__o_s_Logger__quals__Universal_12.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataColumnDefEditor>) GWT.create(Type_factory__o_d_c_w_d_e_c_DataColumnDefEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AdvancedAnnotationListEditorViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_a_AdvancedAnnotationListEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<InstanceProvider>) GWT.create(Type_factory__o_j_e_e_c_c_InstanceProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ApproveOperationPresenter>) GWT.create(Type_factory__o_g_a_m_c_e_f_a_ApproveOperationPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KSessionSelector>) GWT.create(Type_factory__o_k_w_c_w_c_w_KSessionSelector__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SummaryPage>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_p_SummaryPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisplayErrorViewImpl>) GWT.create(Type_factory__o_g_a_m_c_e_f_e_DisplayErrorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RadarMenuViewImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_m_RadarMenuViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RequestListPresenterActivity>) GWT.create(Type_factory__o_j_c_n_e_c_e_r_RequestListPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NotificationPopupsManagerView>) GWT.create(Type_factory__o_u_c_v_p_n_NotificationPopupsManagerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProcessDefinitionListPresenterActivity>) GWT.create(Type_factory__o_j_c_n_p_c_e_d_l_ProcessDefinitionListPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ConditionPatternCell>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_p_c_ConditionPatternCell__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ScoreCardXLSEntryPoint>) GWT.create(Type_factory__o_d_w_s_s_c_ScoreCardXLSEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JobDetailsPopup>) GWT.create(Type_factory__o_j_c_n_e_c_e_j_JobDetailsPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ColumnFilterEditorView>) GWT.create(Type_factory__o_d_d_c_w_f_ColumnFilterEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DiscussionWidgetPresenter>) GWT.create(Type_factory__o_k_w_c_w_c_d_DiscussionWidgetPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ForceUnlockEventObserver>) GWT.create(Type_factory__o_u_c_m_ForceUnlockEventObserver__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Tree>) GWT.create(ExtensionProvided_factory__c_g_g_u_c_u_Tree__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.kie.workbench.common.screens.server.management.client.remote.card.ContainerCardPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_r_c_ContainerCardPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PanelManagerImpl>) GWT.create(Type_factory__o_u_c_w_PanelManagerImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SplashPluginResourceType>) GWT.create(Type_factory__o_u_e_p_c_t_SplashPluginResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContainerCardView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_c_s_c_ContainerCardView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SelectableDocumentImpl>) GWT.create(Type_factory__o_k_w_c_w_m_c_p_SelectableDocumentImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewContainerWizard>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_NewContainerWizard__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewTemplatePresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_t_NewTemplatePresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewGuidedRuleHandler>) GWT.create(Type_factory__o_d_w_s_g_r_c_h_NewGuidedRuleHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CheckBox>) GWT.create(ExtensionProvided_factory__o_g_c_u_CheckBox__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Sender>) GWT.create(ContextualProvider_factory__o_j_e_i_s_b_c_Sender__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PluginNavList>) GWT.create(Type_factory__o_u_e_p_c_w_n_PluginNavList__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProcessInstanceDetailsMultiViewImpl>) GWT.create(Type_factory__o_j_c_n_p_c_e_i_d_m_ProcessInstanceDetailsMultiViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LayersScreen>) GWT.create(Type_factory__o_u_e_w_c_c_l_LayersScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LeafPermissionNodeEditor>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_n_LeafPermissionNodeEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DecisionTableXLSEntryPoint>) GWT.create(Type_factory__o_d_w_s_d_c_DecisionTableXLSEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProjectClassList>) GWT.create(Type_factory__o_k_w_c_s_d_c_p_ProjectClassList__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProjectScreenViewImpl>) GWT.create(Type_factory__o_k_w_c_s_p_c_e_ProjectScreenViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SplashScreenMenuPresenter>) GWT.create(Type_factory__o_u_c_m_SplashScreenMenuPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ACLSettings>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_ACLSettings__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TerminationConfigFormViewImpl>) GWT.create(Type_factory__o_o_w_s_s_c_e_TerminationConfigFormViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ValueBoxEditor>) GWT.create(Type_factory__o_d_c_c_e_ValueBoxEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ViewJavaSourceWidget>) GWT.create(ExtensionProvided_factory__o_k_w_c_s_j_c_w_ViewJavaSourceWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewFieldPopup>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_e_NewFieldPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TaskDashboardView>) GWT.create(Type_factory__o_j_d_r_c_p_TaskDashboardView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TaskFormViewImpl>) GWT.create(Type_factory__o_j_c_n_h_c_e_t_TaskFormViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<XmlResourceType>) GWT.create(Type_factory__o_k_w_c_s_d_c_e_XmlResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedScoreCardEditorPresenterActivity>) GWT.create(Type_factory__o_d_w_s_g_s_c_e_GuidedScoreCardEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GenericFormDisplayPresenter>) GWT.create(Type_factory__o_j_c_n_g_f_c_d_v_GenericFormDisplayPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedRuleEditorViewImpl>) GWT.create(Type_factory__o_d_w_s_g_r_c_e_GuidedRuleEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LayersGroup>) GWT.create(Type_factory__o_u_e_w_c_c_l_LayersGroup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TextEditorView>) GWT.create(Type_factory__o_u_e_w_c_c_e_t_TextEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TimeFrameEditorView>) GWT.create(Type_factory__o_d_d_c_w_f_TimeFrameEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProcessDefinitionListViewImpl>) GWT.create(Type_factory__o_j_c_n_p_c_e_d_l_ProcessDefinitionListViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HeaderPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_h_c_u_m_h_HeaderPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisplayerScreenPresenter>) GWT.create(Type_factory__o_d_d_c_DisplayerScreenPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SQLDataSetDefAttributesEditorView>) GWT.create(Type_factory__o_d_c_w_d_e_s_SQLDataSetDefAttributesEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisplayErrorPresenter>) GWT.create(Type_factory__o_g_a_m_c_e_f_e_DisplayErrorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<XmlResourceTypeDefinition>) GWT.create(Type_factory__o_k_w_c_s_d_s_XmlResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuvnorDefaultEditorPresenter>) GWT.create(Type_factory__o_k_w_c_s_d_c_e_GuvnorDefaultEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TemplatedWorkbenchPanelView>) GWT.create(Type_factory__o_u_c_w_p_i_TemplatedWorkbenchPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CardView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_c_CardView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<AuthorizationManagerHelper>) GWT.create(Type_factory__o_u_s_c_a_AuthorizationManagerHelper__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<HomeEntryPoint>) GWT.create(Type_factory__o_k_w_c_s_h_c_HomeEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ProjectMenu>) GWT.create(Type_factory__o_k_w_c_s_p_c_m_ProjectMenu__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ServerTemplatePresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_n_t_ServerTemplatePresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DroolsDataObjectEditor>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_d_DroolsDataObjectEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<TransitionAnchorProvider>) GWT.create(Type_factory__o_j_e_u_n_c_l_TransitionAnchorProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProcessDashboard>) GWT.create(Type_factory__o_j_d_r_c_p_ProcessDashboard__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserMenu>) GWT.create(Type_factory__o_u_c_v_p_m_UserMenu__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<CompassWidgetImpl>) GWT.create(Type_factory__o_u_c_v_p_d_CompassWidgetImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GoogleBarChartDisplayerView>) GWT.create(Type_factory__o_d_r_g_c_GoogleBarChartDisplayerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserAssignedRolesEditor>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_u_UserAssignedRolesEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PerspectiveEditorPresenter>) GWT.create(Type_factory__o_u_e_p_c_p_e_PerspectiveEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GeneralPluginEditor>) GWT.create(Type_factory__o_u_e_p_c_w_p_GeneralPluginEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<RepositoryMenu>) GWT.create(Type_factory__o_k_w_c_w_c_m_RepositoryMenu__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CreateEntityView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_CreateEntityView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<JavaResourceType>) GWT.create(Type_factory__o_k_w_c_s_j_c_t_JavaResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionWorkItemInsertFactColumnSynchronizer>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_ActionWorkItemInsertFactColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkbenchToolBarPresenter>) GWT.create(Type_factory__o_u_c_w_w_t_WorkbenchToolBarPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<M2RepoPerspective>) GWT.create(Type_factory__o_k_w_c_p_M2RepoPerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<EditorPluginResourceType>) GWT.create(Type_factory__o_u_e_p_c_t_EditorPluginResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RendererSelectorListBoxView>) GWT.create(Type_factory__o_d_d_c_w_RendererSelectorListBoxView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AdvancedDataObjectEditorViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_AdvancedDataObjectEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProcessInstanceSignalPresenter>) GWT.create(Type_factory__o_j_c_n_p_c_e_i_s_ProcessInstanceSignalPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EditorPlugInEditorView>) GWT.create(Type_factory__o_u_e_p_c_e_EditorPlugInEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ExplorerMenu>) GWT.create(Type_factory__o_k_w_c_s_e_c_ExplorerMenu__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<BasicUserCacheImpl>) GWT.create(Type_factory__o_j_e_s_c_l_c_BasicUserCacheImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DecisionTableXLSEditorViewImpl>) GWT.create(Type_factory__o_d_w_s_d_c_e_DecisionTableXLSEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MediaLibraryWidget>) GWT.create(Type_factory__o_u_e_p_c_w_m_MediaLibraryWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CreateRepositoryWizardModel>) GWT.create(Type_factory__o_g_a_m_c_e_r_w_CreateRepositoryWizardModel__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ViewMenuBuilder>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_m_ViewMenuBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<EditorJSExporter>) GWT.create(Type_factory__o_u_c_e_EditorJSExporter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GuidedRuleDRLResourceType>) GWT.create(Type_factory__o_d_w_s_g_r_c_t_GuidedRuleDRLResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RepositoryPreferences>) GWT.create(Producer_factory__o_g_s_c_e_r_RepositoryPreferences__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SimpleTable>) GWT.create(Type_factory__o_u_e_w_c_c_t_SimpleTable__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<POMWizardPage>) GWT.create(Type_factory__o_k_w_c_s_p_c_w_POMWizardPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Label>) GWT.create(ExtensionProvided_factory__c_g_g_u_c_u_Label__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<RendererManager>) GWT.create(Type_factory__o_d_d_c_RendererManager__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SecurityContextHoldingSingleton>) GWT.create(Type_factory__o_j_e_s_c_l_n_SecurityContextHoldingSingleton__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkItemsTypeDefinition>) GWT.create(Type_factory__o_d_w_s_w_t_WorkItemsTypeDefinition__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserAssignedRolesExplorer>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_u_UserAssignedRolesExplorer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContainerRemoteStatusPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_c_s_ContainerRemoteStatusPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DeploymentListPerspective>) GWT.create(Type_factory__o_j_c_n_b_c_p_DeploymentListPerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ConfirmBox>) GWT.create(Type_factory__o_u_e_s_m_c_w_p_ConfirmBox__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FormModelerPanelViewImpl>) GWT.create(Type_factory__o_j_f_e_c_e_FormModelerPanelViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SocialHomePageSideView>) GWT.create(Type_factory__o_k_w_c_s_s_h_c_h_SocialHomePageSideView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewFormDefinitionHandler>) GWT.create(Type_factory__o_j_f_e_c_h_NewFormDefinitionHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetQueryHelper>) GWT.create(Type_factory__o_j_c_n_d_c_l_b_DataSetQueryHelper__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TerminationTreeItemContentViewImpl>) GWT.create(Type_factory__o_o_w_s_s_c_e_TerminationTreeItemContentViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ActivityManagerImpl>) GWT.create(Type_factory__o_u_c_m_ActivityManagerImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewFieldPopupViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_e_NewFieldPopupViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GlobalsEditorPresenterActivity>) GWT.create(Type_factory__o_d_w_s_g_c_e_GlobalsEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RoleEditorDriver>) GWT.create(Type_factory__o_u_e_s_m_c_e_r_RoleEditorDriver__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PermissionSwitchView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_n_PermissionSwitchView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SolverEditorPresenter>) GWT.create(Type_factory__o_o_w_s_s_c_e_SolverEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RepositoryStructureDataViewImpl>) GWT.create(Type_factory__o_g_a_m_c_e_p_s_w_RepositoryStructureDataViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<OverviewWidgetViewImpl>) GWT.create(Type_factory__o_k_w_c_w_m_c_w_OverviewWidgetViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ElasticSearchDataSetDefAttributesEditorView>) GWT.create(Type_factory__o_d_c_w_d_e_e_ElasticSearchDataSetDefAttributesEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DataSetEditorDriverFactory>) GWT.create(Type_factory__o_d_c_w_d_e_d_DataSetEditorDriverFactory__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContainerProcessConfigPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_c_c_p_ContainerProcessConfigPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PerspectiveJSExporter>) GWT.create(Type_factory__o_u_c_e_PerspectiveJSExporter__quals__j_e_i_Any_j_e_i_Default.class));
  }

  private void registerFactories3(final Context org_jboss_errai_ioc_client_container_ApplicationScopedContext_context, final Context org_jboss_errai_ioc_client_container_DependentScopeContext_context) {
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PackageSelector>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_p_PackageSelector__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BeanDataSetEditor>) GWT.create(Type_factory__o_d_c_w_d_e_b_BeanDataSetEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WorkItemsEditorPresenter>) GWT.create(Type_factory__o_d_w_s_w_c_e_WorkItemsEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DRLEditorEntryPoint>) GWT.create(Type_factory__o_d_w_s_d_c_DRLEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CRUDListBox>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_CRUDListBox__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<OrganizationalUnitManagerViewImpl>) GWT.create(Type_factory__o_g_o_m_c_e_OrganizationalUnitManagerViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MainDataObjectEditor>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_m_MainDataObjectEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AceEditor>) GWT.create(ExtensionProvided_factory__o_u_e_w_c_c_a_AceEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Well>) GWT.create(ExtensionProvided_factory__o_g_c_u_Well__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PerspectiveDropDown>) GWT.create(Type_factory__o_u_e_w_c_c_d_PerspectiveDropDown__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefPreviewTable>) GWT.create(Type_factory__o_d_c_w_d_e_DataSetDefPreviewTable__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewResourcesMenu>) GWT.create(Type_factory__o_k_w_c_w_c_h_NewResourcesMenu__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GoogleMeterChartDisplayerView>) GWT.create(Type_factory__o_d_r_g_c_GoogleMeterChartDisplayerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.kie.workbench.common.screens.social.hp.client.homepage.header.HeaderPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_h_c_h_h_HeaderPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<CopyPopupPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_n_t_c_CopyPopupPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DefaultBusSecurityErrorCallback>) GWT.create(Type_factory__o_j_e_s_c_l_c_DefaultBusSecurityErrorCallback__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SocialHomePageSidePresenterActivity>) GWT.create(Type_factory__o_k_w_c_s_s_h_c_h_SocialHomePageSidePresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefCacheAttributesEditorViewImpl>) GWT.create(Type_factory__o_d_c_w_d_e_a_DataSetDefCacheAttributesEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LinkTitleView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_c_t_LinkTitleView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ConflictingRepositoriesPopupViewImpl>) GWT.create(Type_factory__o_g_c_s_p_c_r_ConflictingRepositoriesPopupViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContainersGroup>) GWT.create(Type_factory__o_u_e_w_c_c_p_ContainersGroup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<JPADomainHandler>) GWT.create(Type_factory__o_k_w_c_s_d_c_h_j_JPADomainHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DDResourceType>) GWT.create(Type_factory__o_j_c_n_w_c_e_d_d_t_DDResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WiresTreesPerspectiveActivity>) GWT.create(Type_factory__o_u_e_w_c_t_c_p_WiresTreesPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ScenarioEditorPresenter>) GWT.create(Type_factory__o_d_w_s_t_c_ScenarioEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DependencyListWidget>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_d_DependencyListWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SearchMenuBuilder>) GWT.create(Type_factory__o_k_w_c_s_s_c_m_SearchMenuBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ExplorerPresenterActivity>) GWT.create(Type_factory__o_k_w_c_s_e_c_ExplorerPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<RepositoryTreeProvider>) GWT.create(Type_factory__o_g_s_c_s_RepositoryTreeProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<TestRuntimeReportingService>) GWT.create(Type_factory__o_d_w_s_t_c_s_TestRuntimeReportingService__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<IFrameScreenPresenter>) GWT.create(Type_factory__o_u_e_w_c_c_s_i_IFrameScreenPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LikeToFunctionEditor>) GWT.create(Type_factory__o_d_d_c_w_f_LikeToFunctionEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.jboss.errai.common.client.dom.Button>) GWT.create(ExtensionProvided_factory__o_j_e_c_c_d_Button__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NumberParameterEditorView>) GWT.create(Type_factory__o_d_d_c_w_f_NumberParameterEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GridWidgetColumnFactoryImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_GridWidgetColumnFactoryImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewDrlTextHandler>) GWT.create(Type_factory__o_d_w_s_d_c_h_NewDrlTextHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ResourceBundleEntryPoint>) GWT.create(Type_factory__o_u_e_s_m_c_ResourceBundleEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ReviewPresenter>) GWT.create(Type_factory__o_g_a_m_c_e_f_r_ReviewPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.dashbuilder.displayer.client.widgets.filter.TimeAmountEditor>) GWT.create(Type_factory__o_d_d_c_w_f_TimeAmountEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuvnorDefaultEditorPresenterActivity>) GWT.create(Type_factory__o_k_w_c_s_d_c_e_GuvnorDefaultEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GenericFormDisplayView>) GWT.create(Type_factory__o_j_c_n_g_f_c_d_v_GenericFormDisplayView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LayoutPanelView>) GWT.create(Type_factory__o_u_c_w_p_i_LayoutPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ReleaseConfigurationViewImpl>) GWT.create(Type_factory__o_g_a_m_c_e_r_ReleaseConfigurationViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
  }

  private void registerFactories(final Context org_jboss_errai_ioc_client_container_ApplicationScopedContext_context, final Context org_jboss_errai_ioc_client_container_DependentScopeContext_context) {
    registerFactories0(org_jboss_errai_ioc_client_container_ApplicationScopedContext_context, org_jboss_errai_ioc_client_container_DependentScopeContext_context);
    registerFactories1(org_jboss_errai_ioc_client_container_ApplicationScopedContext_context, org_jboss_errai_ioc_client_container_DependentScopeContext_context);
    registerFactories2(org_jboss_errai_ioc_client_container_ApplicationScopedContext_context, org_jboss_errai_ioc_client_container_DependentScopeContext_context);
    registerFactories3(org_jboss_errai_ioc_client_container_ApplicationScopedContext_context, org_jboss_errai_ioc_client_container_DependentScopeContext_context);
  }

  // The main IOC bootstrap method.
  public ContextManager bootstrapContainer() {
    final Context org_jboss_errai_ioc_client_container_ApplicationScopedContext_context = new ApplicationScopedContext();
    final Context org_jboss_errai_ioc_client_container_DependentScopeContext_context = new DependentScopeContext();
    logger.debug("Registering factories with contexts.");
    long start = System.currentTimeMillis();
    registerFactories(org_jboss_errai_ioc_client_container_ApplicationScopedContext_context, org_jboss_errai_ioc_client_container_DependentScopeContext_context);
    logger.debug("Registered 1543 factories in {}ms", System.currentTimeMillis() - start);
    logger.debug("Adding contexts to context manager...");
    start = System.currentTimeMillis();
    contextManager.addContext(org_jboss_errai_ioc_client_container_ApplicationScopedContext_context);
    contextManager.addContext(org_jboss_errai_ioc_client_container_DependentScopeContext_context);
    logger.debug("Added 2 contexts in {}ms", System.currentTimeMillis() - start);
    logger.debug("Calling finishInit on ContextManager");
    start = System.currentTimeMillis();
    contextManager.finishInit();
    logger.debug("ContextManager#finishInit ran in {}ms", System.currentTimeMillis() - start);
    return contextManager;
  }
}