package org.jboss.errai.marshalling.client.api;

import com.google.gwt.core.shared.GWT;
import java.util.AbstractMap;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.SortedMap;
import java.util.TreeMap;
import javax.enterprise.context.Dependent;
import org.jboss.errai.marshalling.client.marshallers.BigDecimalMarshaller;
import org.jboss.errai.marshalling.client.marshallers.BigIntegerMarshaller;
import org.jboss.errai.marshalling.client.marshallers.BooleanMarshaller;
import org.jboss.errai.marshalling.client.marshallers.ByteMarshaller;
import org.jboss.errai.marshalling.client.marshallers.CharacterMarshaller;
import org.jboss.errai.marshalling.client.marshallers.DateMarshaller;
import org.jboss.errai.marshalling.client.marshallers.DoubleMarshaller;
import org.jboss.errai.marshalling.client.marshallers.FloatMarshaller;
import org.jboss.errai.marshalling.client.marshallers.IntegerMarshaller;
import org.jboss.errai.marshalling.client.marshallers.LinkedHashSetMarshaller;
import org.jboss.errai.marshalling.client.marshallers.LinkedListMarshaller;
import org.jboss.errai.marshalling.client.marshallers.LinkedMapMarshaller;
import org.jboss.errai.marshalling.client.marshallers.ListMarshaller;
import org.jboss.errai.marshalling.client.marshallers.LongMarshaller;
import org.jboss.errai.marshalling.client.marshallers.MapMarshaller;
import org.jboss.errai.marshalling.client.marshallers.ObjectMarshaller;
import org.jboss.errai.marshalling.client.marshallers.PriorityQueueMarshaller;
import org.jboss.errai.marshalling.client.marshallers.QualifyingMarshallerWrapper;
import org.jboss.errai.marshalling.client.marshallers.QueueMarshaller;
import org.jboss.errai.marshalling.client.marshallers.SQLDateMarshaller;
import org.jboss.errai.marshalling.client.marshallers.SetMarshaller;
import org.jboss.errai.marshalling.client.marshallers.ShortMarshaller;
import org.jboss.errai.marshalling.client.marshallers.SortedMapMarshaller;
import org.jboss.errai.marshalling.client.marshallers.SortedSetMarshaller;
import org.jboss.errai.marshalling.client.marshallers.StringBufferMarshaller;
import org.jboss.errai.marshalling.client.marshallers.StringBuilderMarshaller;
import org.jboss.errai.marshalling.client.marshallers.StringMarshaller;
import org.jboss.errai.marshalling.client.marshallers.TimeMarshaller;
import org.jboss.errai.marshalling.client.marshallers.TimestampMarshaller;
import org.jbpm.designer.client.shared.AssignmentDataMarshaller;
import org.uberfire.rpc.impl.SessionInfoMarshalller;
@Dependent public class MarshallerFactoryImpl implements MarshallerFactory {
  private Map<String, Marshaller> marshallers = new HashMap<String, Marshaller>();
  abstract class Marshaller_for_java_lang_Throwable implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_lang_ArithmeticException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_io_IOException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_lang_IllegalArgumentException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_util_EmptyStackException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_lang_ArrayStoreException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_lang_ClassCastException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_util_ConcurrentModificationException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_lang_IndexOutOfBoundsException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_lang_NegativeArraySizeException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_lang_NullPointerException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_lang_StringIndexOutOfBoundsException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_lang_UnsupportedOperationException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_lang_AssertionError implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_lang_RuntimeException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jboss_errai_security_shared_exception_SecurityException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jboss_errai_security_shared_exception_UnauthenticatedException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jboss_errai_security_shared_exception_UnauthorizedException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jboss_errai_security_shared_exception_AuthenticationException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_lang_StackTraceElement implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_ActionInsertFactCol52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_asset_management_social_ProcessStartEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_ObjectPropertyImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_Module implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_event_MediaAdded implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_filter_LogicalExprFilter implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataprovider_BeanProviderType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_explorer_model_URIStructureExplorerModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_spec_ProcessConfig implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_ChangeType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_util_NamingUtils implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_ActionSetFieldCol52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceUpdatedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_social_hp_model_HomePageTypes implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_event_NewPluginRegistered implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_model_Notification_erraiD_State implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_valueterms_ValueRuleAttributeIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_organizationalunit_impl_OrganizationalUnitImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_formModeler_api_events_FormRenderEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_NotDirectoryException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_kmodule_QualifierModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_spec_ContainerSpecList implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_mvp_impl_ForcedPlaceRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_api_CapabilityStatus implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_EditorModelContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_organizationalunit_RepoRemovedFromOrganizationalUnitEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_FromEntryPointFactPattern implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_properties_editor_model_PropertyEditorFieldInfo implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_designer_service_DesignerContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceRenamedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_guided_dtable_model_GuidedDecisionTableEditorContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_DeleteColumnAuditLogEntry implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_source_SourceGenerationFailedException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataModelerEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_kmodule_ConsoleLogger implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_oracle_Annotation implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_oracle_OperatorsOracle implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_DSLSentence implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_asset_management_model_ExecuteOperationEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_search_model_SearchPageRow implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_model_impl_PartDefinitionImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionRetractFact implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_inbox_model_InboxPageRow implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_pr_model_ProcessInstanceKey implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jboss_errai_security_shared_exception_FailedAuthenticationException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_persistence_CachingType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_ActionInsertFactFieldsPattern implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_BRLConditionColumn implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_AttributeColumnDetails implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_es_model_ErrorSummary implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_persistence_PersistenceUnitModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_ActionWorkItemInsertFactColumnDetails implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_services_shared_preferences_UserPreference implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionFieldVariable implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_model_ContextDisplayMode implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_ActionWorkItemSetFieldColumnDetails implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_event_PluginUnregistered implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_events_DataSetStaleEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_DecisionTableAuditEvents implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_formModeler_api_client_FormRenderContext implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_layout_editor_api_editor_LayoutTemplate implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_service_DeploymentMode implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_services_shared_preferences_GridPreferencesStore implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_ElementType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceChangeType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_events_DataSetDefRegisteredEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_globals_model_GlobalsEditorContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_kmodule_ListenerModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableBooleanParameterDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_impl_SearchResponseImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_index_terms_JavaTypeNameIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_security_authz_AuthorizationResult implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_spec_ServerTemplate implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_FactAssignmentField implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_valueterms_ValueTypeIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_organizationalunit_NewOrganizationalUnitEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_formModeler_api_events_FormSubmitFailEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_security_impl_authz_DefaultAuthorizationPolicy implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_events_DataSetDefModifiedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_examples_model_ExampleOrganizationalUnit implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_EnvironmentParameters implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_designer_notification_DesignerNotificationEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_mvp_impl_PathPlaceRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_RuntimePlugin implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionVariable implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_events_DataSetPushOkEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_explorer_service_ProjectExplorerContentQuery implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_BigIntegerValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_LayoutEditorModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_RepositoryInfo implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_VerifyFact implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jboss_errai_security_shared_exception_AlreadyLoggedInException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_events_DeleteProjectEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_GuidedDecisionTree implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_Language implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_pr_model_UserTaskSummary implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_builder_model_IncrementalBuildResults implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_pr_model_NodeInstanceSummary implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_AnnotationParseRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_events_DataSetModifiedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_spec_RuleConfig implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_index_terms_JavaTypeParentIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_pr_model_events_ProcessInstancesWithDetailsRequestEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_oracle_MethodInfo implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_navigator_DataContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_oracle_ModelField_erraiD_FIELD_erraiU_CLASS_erraiU_TYPE implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_RepositoryRemovedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_explorer_service_ActiveOptions implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_ht_model_events_NewTaskEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_exception_PluginAlreadyExists implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_security_ProjectResourceType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_ShortValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_BuilderResultLine implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_examples_model_ExamplesModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_DTColumnConfig52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_uberfire_social_activities_model_SocialFileSelectedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_backend_vfs_impl_LockInfo implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_index_terms_FieldNameIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_asset_management_model_ConfigureRepositoryEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_asset_management_social_ProjectBuiltEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_m2repo_model_JarListPageRow implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_enums_model_EnumModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_nodes_impl_ConstraintNodeImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_ht_model_events_TaskRefreshedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_FloatValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_RuleIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_pr_model_ProcessInstanceVariableSummary implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_def_DataColumnDef implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_DataObjectImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_UnsupportedIActionParserMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_SingleFieldConstraintEBLeftSide implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_ActionRetractFactCol52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_inbox_model_InboxPageRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_GuidedDecisionTable52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_workingset_client_model_WorkingSetConfigData implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_wi_dd_model_Parameter implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_RepositoryEnvironmentConfigurations implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_pr_model_events_ProcessDefStyleEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_FromCollectCompositeFactPattern implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_impl_UserManagerSettingsImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_FileAlreadyExistsException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_LongValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_Plugin implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_valueterms_ValuePackageNameIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionUpdateField implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_messageconsole_events_SystemMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_drltext_model_DrlModelContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_MetadataCol52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_WorkItemHandlerModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_pr_model_ProcessVariableKey implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_guided_rule_model_GuidedEditorContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_scorecard_shared_Characteristic implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_CallFixtureMap implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_CallMethod implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_events_NewPackageEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_bd_model_DeploymentUnitSummary implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_asset_management_model_ReleaseProjectEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_globals_model_Global implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataModelSaved implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_workitems_model_WorkItemDefinitionElements implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_Plugin implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_ga_model_PortableQueryFilter implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceUpdated implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_events_ServerTemplateDeleted implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_events_ServerTemplateUpdated implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_ht_model_CommentSummary implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_valueterms_ValueProjectRootPathIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_index_terms_JavaTypeInterfaceIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_factmodel_model_AnnotationMetaModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_persistence_TransactionType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodel_model_PackageDataModelOracleBaselinePayload implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionCallMethod implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_uberfire_social_activities_model_SocialActivitiesEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_BRLConditionVariableColumn implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_nodes_impl_ActionUpdateNodeImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_UnsupportedFieldNatureTypeParserMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_pr_model_events_ProcessInstanceStyleEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_AnnotationSourceResponse implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_ga_forms_model_events_FormLoadedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_events_ServerInstanceDisconnected implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_FixtureList implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_shared_metadata_model_DiscussionRecord implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_backend_vfs_FileSystemFactory_erraiD_FileSystemImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_uberfire_social_activities_model_SocialUser implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_scorecard_shared_ScoreCardModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_spec_ContainerSpec implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_DynamicMenuItem implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_properties_editor_model_validators_TextValidator implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_api_model_Message implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_RuleAttribute implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_persistence_PersistenceDescriptorEditorContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_api_model_Severity implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionWorkItemFieldValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodel_model_PackageDataModelOracleIncrementalPayload implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_spec_ServerTemplateList implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jboss_errai_security_shared_api_RoleImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_uberfire_social_activities_model_SocialActivitiesEvent_erraiD_LINK_erraiU_TYPE implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_testscenario_model_TestScenarioResult implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableFloatParameterDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_kmodule_FileLogger implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_asset_management_model_BuildProjectStructureEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_project_KieProject implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_builder_events_InvalidateDMOPackageCacheEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_FieldIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_query_RefactoringPathPageRow implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceOpenedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_m2repo_model_JarListPageRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_asset_management_social_ProcessEndEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_filter_CoreFunctionFilter implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataObjectDeletedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_organizationalunit_RepoAddedToOrganizationalUnitEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_date_TimeAmount implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_asset_management_model_PromoteChangesEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_shared_validation_model_ValidationMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_VerifyRuleFired implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_scorecard_shared_Attribute implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_asset_management_social_AssetsPromotedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_explorer_model_FolderItemType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_api_exception_EntityAlreadyExistsException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_discussion_CommentAddedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_conversion_ConversionMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_DefaultParserMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_ga_model_process_DummyProcessPath implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_ht_model_TaskDefSummary implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_displayer_DisplayerSettings implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_impl_GroupManagerSettingsImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_conversion_ConversionMessageType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_conversion_ConversionResult implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_FieldData implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jboss_errai_common_client_PageRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_pr_model_events_ProcessDefinitionsSearchEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_bd_model_KModuleDeploymentUnitSummary implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_CollectionFieldData implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_LimitedEntryBRLConditionColumn implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_AttributeCol52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_event_PluginSaved implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_organizationalunit_OrganizationalUnitEventBase implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_BooleanValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_whitelist_WhiteList implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_dtablexls_service_DecisionTableXLSContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_formModeler_editor_model_FormModelerContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_asset_management_social_ProjectDeployedEvent_erraiD_DeployType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataObjectSelectedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_backend_vfs_impl_DirectoryStreamImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionMethodParameter implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_oracle_DataType_erraiD_DataTypes implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_CompositeFactPattern implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_oracle_ModelField_erraiD_FIELD_erraiU_ORIGIN implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_es_model_RequestSummary implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_paging_PageRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_UnsupportedIPatternParserMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_ActionSetFieldColumnDetails implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_valueterms_ValueRuleAttributeValueIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_explorer_model_ProjectExplorerContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_PackageNameIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_impl_DataColumnImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_CallFieldValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_impl_UserAttributeImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_oracle_TypeSource implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataObjectFieldChangeEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_LimitedEntryBRLActionColumn implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_builder_model_BuildMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_ActionWorkItemInsertFactCol52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_ActionWorkItemCol52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_model_impl_PanelDefinitionImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataprovider_StaticProviderType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_DSLVariableValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_DataModelImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_messageconsole_events_PublishBatchMessagesEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_server_management_model_RuntimeStrategy implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_service_PackageAlreadyExistsException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_projecteditor_model_ProjectScreenModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_UnsupportedFieldConstraintTypeParserMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jboss_errai_security_shared_api_identity_UserImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_query_RefactoringStringPageRow implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_asset_management_model_RepositoryStructureModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_ActionInsertFactColumnDetails implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_backend_EditDataSetDef implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_FieldPlaceHolder implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_model_Notification implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_POM implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_es_model_events_RequestSelectionEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_bd_exception_DeploymentException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_valueterms_ValueRuleIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_MavenRepositorySource implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionMethod implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_GuidedDecisionTreeParserError implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_def_SQLDataSetDef implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_WorkItemColumnParameterValueDiffImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_LimitedEntryConditionColumnDetails implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_oracle_ModelField implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_group_Interval implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceRenamed implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_explorer_model_FolderItemOperation implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionMethodParameterDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_persistence_PersistenceDescriptorModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_messageconsole_events_PublishBaseEvent_erraiD_Place implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_wi_dd_model_ItemObjectModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_formModeler_api_model_Form implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_VerifyField implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_AnnotationSourceRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_workingset_client_model_WorkingSetSettings implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_ht_model_TaskEventKey implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_bd_model_RuntimeSummary implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_DynamicMenu implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_PluginSimpleContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_FixturesMap implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_bd_model_RuleNotificationSummary implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_ht_model_User implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_ht_model_events_TaskSelectionEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_spec_ContainerConfig implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_pr_model_ProcessDefinitionKey implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_apps_api_Directory implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_InsertRowAuditLogEntry implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_nodes_impl_ActionRetractNodeImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_auditlog_AuditLog implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_AnnotationDefinitionResponse implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_FreeFormLine implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_search_model_SearchTermPageRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_screens_solver_model_ScoreDirectorFactoryConfigModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_ProjectImports implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_DecisionTableAuditLogFilter implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_RuleModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_scorecardxls_service_ScoreCardXLSContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_bd_model_KieSessionSummary implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_displayer_impl_TableDisplayerSettingsBuilderImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_inbox_model_InboxIncomingPageRow implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataModelerValueChangeEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_TypeIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_LimitedEntryActionSetFieldCol52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_Repository implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_group_DateIntervalType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_DescriptionCol52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_editor_commons_version_impl_PortableVersionRecord implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_index_terms_valueterms_ValueFieldNameIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionFieldFunction implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jboss_errai_security_shared_api_GroupImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_PropertyTypeImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_server_management_model_MergeMode implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_context_ProjectContextChangeEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_index_terms_valueterms_ValueJavaTypeParentIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_def_ElasticSearchDataSetDef implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_screens_solver_model_TerminationConfigModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_Build implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_kmodule_KSessionModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_services_shared_preferences_GridColumnPreference implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_UnsupportedFieldConstraintParserMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_ht_model_TaskKey implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_event_PluginDeleted implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_RowNumberCol52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_GAV implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableObjectParameterDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceDeletedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_search_model_QueryMetadataPageRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_JavaClassImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_examples_model_ExampleTargetRepository implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_FactPattern implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_ClosedWatchServiceException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_asset_management_social_ProjectDeployedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableIntegerParameterDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_UpdateColumnAuditLogEntry implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_events_ServerInstanceDeleted implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_es_model_events_RequestChangedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_model_CompassPosition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataObjectCreatedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_sort_DataSetSort implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionFormLine implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_MavenRepositoryMetadata implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_ga_forms_model_events_PaletteItemAddedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableStringParameterDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_formModeler_api_client_FormRenderContextTO implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_model_NamedPosition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_navigator_NavigatorContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_api_exception_UserNotFoundException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_spec_ContainerSpecKey implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_DriverError implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_DataTypeNotFoundParserMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_Fact implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_pr_model_events_ProcessInstanceSelectionEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_events_NewProjectEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_Dependency implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_RuleAttributeIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_LimitedEntryConditionCol52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_AnnotationRetention implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_BindingNotFoundParserMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_group_ColumnGroup implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_kmodule_ListenerModel_erraiD_Kind implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_events_ServerInstanceConnected implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_date_Month implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_template_shared_TemplateModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_impl_RoleManagerSettingsImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_service_ServiceException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_uberfire_social_activities_model_SocialPaged implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_MetadataColumnDetails implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_conversion_ConversionAsset implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_ProjectRootPathIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_spec_ServerConfig implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_ht_model_TasksPerDaySummary implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_spec_ServerTemplateKey implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_group_AggregateFunctionType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_layout_editor_api_editor_LayoutComponent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_PluginContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_social_hp_predicate_UserTimeLineOnlyUserActivityPredicate implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_AnnotationValuePairDefinitionImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_date_Quarter implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionInsertFact implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ConnectiveConstraint implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_DataTypeConversionErrorParserMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionText implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_filter_CoreFunctionType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_FileSystemAlreadyExistsException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_oracle_DataType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionCollectionIndex implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_event_PluginAdded implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_SingleScenarioResult implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_BRLRuleModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_DoubleValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionGlobalVariable implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_FileSystemNotFoundException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_RepositoryEnvironmentUpdatedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_ObjectSource implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_pr_model_events_ProcessInstancesUpdateEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_bd_model_DomainSummary implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_FromAccumulateCompositeFactPattern implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_examples_model_ExampleRepository implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_security_RepositoryResourceType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_BigDecimalValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_explorer_model_FolderItem implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_ActionWorkItemColumnDetails implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_dependencies_TransitiveEnhancedDependency implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_ColumnDetails implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_AnnotationDefinitionImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_Package implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataModelStatusChangeEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_pr_model_ProcessInstanceSummary implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_project_ProjectImportsContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_explorer_service_Option implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_examples_model_ExamplesMetaData implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_screens_solver_model_ConstructionHeuristicTypeModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_index_terms_valueterms_ValueJavaTypeIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_valueterms_ValueFieldIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_AnnotationParseResponse implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_LimitedEntryActionSetFieldColumnDetails implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_uberfire_social_activities_model_DefaultTypes implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_shared_metadata_model_Overview implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_runtime_ContainerKey implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_server_management_model_ContainerSpecData implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_DirectoryNotEmptyException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_screens_solver_model_TerminationConfigOption implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_date_TimeFrame implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_CEPWindow implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_RuleAttributeValueIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_security_OrgUnitResourceType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_JavaTypeInfoImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_EnumValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionCollection implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_nodes_impl_ActionFieldValueImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_oracle_FieldAccessorsAndMutators implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataprovider_SQLProviderType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_CodeType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_uberfire_social_activities_events_SocialUserFollowedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_nodes_impl_TypeNodeImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_ht_model_TaskSummary implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableWorkDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_Visibility implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_runtime_ServerInstance implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_FromCompositeFactPattern implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_ConditionColumnDetails implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_impl_SettingsImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionSetField implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_model_impl_ContextDefinitionImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_events_RuleConfigUpdated implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceAdded implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_backend_vfs_impl_LockResult implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_ht_model_events_EditPanelEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_ht_model_TypeRole implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_uberfire_social_activities_events_SocialUserUnFollowedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_services_shared_preferences_UserWorkbenchPreferences implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_formModeler_api_events_FormSubmittedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_defaulteditor_service_DefaultEditorContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_factmodel_model_FactModels implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_InvalidPathException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_visitors_RuleModelVisitor implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_ga_model_DataMockSummary implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_layout_editor_api_editor_LayoutColumn implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_LimitedEntryActionInsertFactCol52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_index_terms_FieldTypeIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_RepositoryAlreadyExistsException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_def_DataSetDef implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_screens_solver_model_ConstructionHeuristicPhaseConfigModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_index_terms_valueterms_ValueJavaTypeNameIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionGlobalCollectionAdd implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_FactData implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_formModeler_api_events_ResizeFormcontainerEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionField implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_bd_model_RuntimeLogSummary implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_kmodule_KModuleModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_NoSuchFileException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_asset_management_social_AssetManagementEventTypes implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataObjectFieldSelectedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_events_DataSetPushingEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_def_BeanDataSetDef implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_factmodel_model_FactMetaModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_impl_DataSetBuilderImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_ht_model_IdentitySummary implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_InvalidRootParserMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_auditlog_DefaultAuditLogFilter implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_factmodel_model_FieldMetaModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_model_impl_SplashScreenFilterImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_globals_model_GlobalsModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_shared_metadata_model_Metadata implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_oracle_DropDownData implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_kmodule_KBaseModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_visitors_CopyExpressionVisitor implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_BRLActionColumn implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_ht_model_events_TaskCalendarEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_InterpolationVariable implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_organizationalunit_UpdatedOrganizationalUnitEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_organizationalunit_RemoveOrganizationalUnitEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_pr_model_events_ProcessInstancesSearchEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_index_terms_JavaTypeIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_RuleMetadata implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_imports_Import implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_NotLinkException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionFieldValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_kmodule_EventProcessingOption implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_ht_model_Day implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_guided_dtree_model_GuidedDecisionTreeEditorContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_persistence_ValidationMode implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_bd_model_OrganizationSummary implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_shared_exceptions_GenericPortableException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataprovider_ELSProviderType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_builder_model_BuildResults implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_pr_model_events_ProcessDefSelectionEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_ModelDriverResult implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_formModeler_editor_model_FormEditorContextTO implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_kmodule_AssertBehaviorOption implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_uberfire_social_activities_model_SocialPaged_erraiD_Direction implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_impl_DefaultPublicURI implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_paging_PageResponse implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_examples_model_ExampleProject implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataObjectChangeEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_ProviderNotFoundException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_Media implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_builder_events_InvalidateDMOProjectCacheEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_events_RenameProjectEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_DeleteRowAuditLogEntry implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_wi_dd_model_DeploymentDescriptorModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_sort_ColumnSort implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_ProjectRepositories implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_group_DataSetGroup implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_shared_test_TestResultMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_index_terms_JavaTypeIndexTerm_erraiD_JAVA_erraiU_TYPE implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_JavaInterfaceImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_Pattern52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_PatternSyntaxException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_runtime_Container implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_uberfire_social_activities_model_PagedSocialQuery implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataModelReload implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceAddedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionInsertLogicalFact implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_StringValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_query_RefactoringPageRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_ExecutionTrace implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_ht_model_Group implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_guided_scorecard_model_ScoreCardModelContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_bd_model_events_DeployedUnitChangedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_LimitedEntryActionRetractFactCol52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_IntegerValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_ht_model_TaskEventSummary implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_ByteValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_RetractFact implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_ga_forms_model_events_FormRenderedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_impl_DataSetMetadataImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_pr_model_ProcessVariableSummary implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceCopiedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_IOException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataObjectFieldDeletedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_properties_editor_model_validators_LongValidator implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_def_StaticDataSetDef implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_testscenario_model_TestScenarioModelContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_screens_solver_model_TerminationCompositionStyleModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_screens_solver_model_ScoreDefinitionTypeModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_pr_model_DocumentKey implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_ScenarioRunResult implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_event_PluginRenamed implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_editor_commons_readonly_ReadOnlyPathPlaceRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_filter_DataSetFilter implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_impl_git_GitRepository implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_DateValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_adaptors_ConditionCol52FieldConstraintAdaptor implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_imports_Imports implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_security_impl_authz_DefaultPermissionCollection implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_ActionWorkItemSetFieldCol52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_RepositoryEnvironmentConfiguration implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_date_DayOfWeek implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_runtime_ServerInstanceKey implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_DSLComplexVariableValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_dependencies_NormalEnhancedDependency implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_DataSetLookup implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_mvp_impl_DefaultPlaceRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_sort_SortedList implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceDeleted implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_impl_DataSetImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_Dependencies implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_screens_solver_model_SolverConfigModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_spec_Capability implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_messageconsole_events_UnpublishMessagesEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_events_DataSetDefRemovedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_api_model_KieContainerStatus implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_explorer_model_FolderListing implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_SingleFieldConstraint implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceCopied implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_security_impl_authz_DotNamedPermission implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_api_exception_NoImplementationAvailableException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_api_exception_SecurityManagementException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionUnboundFact implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_social_OrganizationalUnitEventType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_adaptors_ActionInsertFactCol52ActionInsertFactAdaptor implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_GenerationResult implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_asset_management_social_AssetManagementEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_persistence_Property implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_NewRepositoryEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodel_model_LazyModelField implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_index_terms_valueterms_ValueFieldTypeIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_PluginType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_ModelFactoryImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_PropertyTypeFactoryImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_guided_template_model_GuidedTemplateEditorContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_enums_model_EnumModelContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_NewBranchEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_group_GroupStrategy implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_AmbiguousRootParserMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_adaptors_ActionInsertFactCol52ActionInsertLogicalFactAdaptor implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_impl_DataSetLookupBuilderImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_JavaTypeKind implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_FileSystemException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_DTCellValue52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_api_Capability implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_shared_test_Failure implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_LimitedEntryActionInsertFactColumnDetails implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceBatchChangesEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_properties_editor_model_validators_ColorValidator implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_ht_model_TaskAssignmentSummary implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_filter_LogicalExprType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_AccessDeniedException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_social_hp_predicate_UserTimeLineFileChangesPredicate implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_screens_solver_model_SolverModelContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_api_model_ReleaseId implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_workitems_model_WorkItemsModelContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_TypeInfoResult implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_BaseSingleFieldConstraint implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_ProjectRepositories_erraiD_ProjectRepository implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_model_impl_PerspectiveDefinitionImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_service_GAVAlreadyExistsException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_api_exception_GroupNotFoundException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_adaptors_Pattern52FactPatternAdaptor implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataprovider_CSVProviderType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_dependencies_EnhancedDependencies implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_displayer_ColumnSettings implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_event_MediaDeleted implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_AnnotationSource implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_DataModelerError implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_es_model_RequestDetails implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionExecuteWorkItem implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_messageconsole_events_PublishMessagesEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_properties_editor_model_PropertyEditorCategory implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_dsltext_model_DSLTextEditorContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_AtomicMoveNotSupportedException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_events_ServerInstanceUpdated implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_BRLActionVariableColumn implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_AnnotationImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_ActionCol52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_backend_vfs_PathFactory_erraiD_PathImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_ConditionCol52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_ColumnType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_Activity implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_layout_editor_api_editor_LayoutRow implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_services_shared_preferences_MultiGridPreferencesStore implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_ActivateRuleFlowGroup implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_shared_message_Level implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_api_exception_OperationFailedException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_impl_SearchRequestImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_kmodule_ClockTypeOption implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_ht_model_AuditTaskSummary implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataObjectFieldCreatedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_backend_vfs_impl_ObservablePathImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_BaseColumnFieldDiffImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableListParameterDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_Framework implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_nodes_impl_ActionInsertNodeImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_es_model_RequestParameterSummary implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_pr_model_events_NewProcessInstanceEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_group_GroupFunction implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_social_ProjectEventType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_Project implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_api_exception_UnsupportedServiceCapabilityException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_DriverRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_def_CSVDataSetDef implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_pr_model_DocumentSummary implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jbpm_console_ng_pr_model_ProcessSummary implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_InsertColumnAuditLogEntry implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_DriverResponse implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_AnnotationDefinitionRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableEnumParameterDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_exception_DataSetLookupException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_CompositeFieldConstraint implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_config_SystemRepositoryChangedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_security_impl_authz_DefaultAuthorizationEntry implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_services_shared_preferences_GridGlobalPreferences implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_date_TimeInstant implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_apps_api_DirectoryBreadCrumb implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_index_terms_valueterms_ValueJavaTypeInterfaceIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_Scenario implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_properties_editor_model_PropertyEditorType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_services_shared_preferences_UserPreferencesType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_NotificationEvent_erraiD_NotificationType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_api_model_KieScannerStatus implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_GuidedDecisionTable52_erraiD_TableFormat implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_AnnotationValuePairDefinition_erraiD_ValuePairType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_kmodule_DeclarativeAgendaOption implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_sort_SortOrder implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_date_TimeInstant_erraiD_TimeMode implements GeneratedMarshaller { }
  public MarshallerFactoryImpl() {
    final ObjectMarshaller java_lang_Object = new ObjectMarshaller();
    marshallers.put("java.lang.Object", java_lang_Object);
    final BigDecimalMarshaller java_math_BigDecimal = new BigDecimalMarshaller();
    marshallers.put("java.math.BigDecimal", java_math_BigDecimal);
    final QualifyingMarshallerWrapper<Map> java_util_Map = new QualifyingMarshallerWrapper(new MapMarshaller(), MapMarshaller.class);
    marshallers.put("java.util.Map", java_util_Map);
    marshallers.put("java.util.AbstractMap", java_util_Map);
    marshallers.put("java.util.HashMap", java_util_Map);
    marshallers.put("java.util.Collections$SynchronizedMap", java_util_Map);
    marshallers.put("java.util.Collections$EmptyMap", java_util_Map);
    marshallers.put("java.util.Collections$UnmodifiableMap", java_util_Map);
    marshallers.put("java.util.Collections$SingletonMap", java_util_Map);
    final QualifyingMarshallerWrapper<AbstractMap> java_util_AbstractMap = new QualifyingMarshallerWrapper(new MapMarshaller(), MapMarshaller.class);
    marshallers.put("java.util.AbstractMap", java_util_AbstractMap);
    final QualifyingMarshallerWrapper<HashMap> java_util_HashMap = new QualifyingMarshallerWrapper(new MapMarshaller(), MapMarshaller.class);
    marshallers.put("java.util.HashMap", java_util_HashMap);
    final BooleanMarshaller java_lang_Boolean = new BooleanMarshaller();
    marshallers.put("java.lang.Boolean", java_lang_Boolean);
    final DateMarshaller java_util_Date = new DateMarshaller();
    marshallers.put("java.util.Date", java_util_Date);
    final FloatMarshaller java_lang_Float = new FloatMarshaller();
    marshallers.put("java.lang.Float", java_lang_Float);
    final ByteMarshaller java_lang_Byte = new ByteMarshaller();
    marshallers.put("java.lang.Byte", java_lang_Byte);
    final QualifyingMarshallerWrapper<SortedMap> java_util_SortedMap = new QualifyingMarshallerWrapper(new SortedMapMarshaller(), SortedMapMarshaller.class);
    marshallers.put("java.util.SortedMap", java_util_SortedMap);
    marshallers.put("java.util.TreeMap", java_util_SortedMap);
    marshallers.put("java.util.Collections$SynchronizedSortedMap", java_util_SortedMap);
    marshallers.put("java.util.Collections$UnmodifiableSortedMap", java_util_SortedMap);
    final QualifyingMarshallerWrapper<TreeMap> java_util_TreeMap = new QualifyingMarshallerWrapper(new SortedMapMarshaller(), SortedMapMarshaller.class);
    marshallers.put("java.util.TreeMap", java_util_TreeMap);
    final QualifyingMarshallerWrapper<LinkedHashMap> java_util_LinkedHashMap = new QualifyingMarshallerWrapper(new LinkedMapMarshaller(), LinkedMapMarshaller.class);
    marshallers.put("java.util.LinkedHashMap", java_util_LinkedHashMap);
    final BigIntegerMarshaller java_math_BigInteger = new BigIntegerMarshaller();
    marshallers.put("java.math.BigInteger", java_math_BigInteger);
    final DoubleMarshaller java_lang_Double = new DoubleMarshaller();
    marshallers.put("java.lang.Double", java_lang_Double);
    final SQLDateMarshaller java_sql_Date = new SQLDateMarshaller();
    marshallers.put("java.sql.Date", java_sql_Date);
    final StringMarshaller java_lang_String = new StringMarshaller();
    marshallers.put("java.lang.String", java_lang_String);
    final SessionInfoMarshalller org_uberfire_rpc_SessionInfo = new SessionInfoMarshalller();
    marshallers.put("org.uberfire.rpc.SessionInfo", org_uberfire_rpc_SessionInfo);
    final LinkedHashSetMarshaller java_util_LinkedHashSet = new LinkedHashSetMarshaller();
    marshallers.put("java.util.LinkedHashSet", java_util_LinkedHashSet);
    final StringBuilderMarshaller java_lang_StringBuilder = new StringBuilderMarshaller();
    marshallers.put("java.lang.StringBuilder", java_lang_StringBuilder);
    final IntegerMarshaller java_lang_Integer = new IntegerMarshaller();
    marshallers.put("java.lang.Integer", java_lang_Integer);
    final TimestampMarshaller java_sql_Timestamp = new TimestampMarshaller();
    marshallers.put("java.sql.Timestamp", java_sql_Timestamp);
    final SetMarshaller java_util_Set = new SetMarshaller();
    marshallers.put("java.util.Set", java_util_Set);
    marshallers.put("java.util.AbstractSet", java_util_Set);
    marshallers.put("java.util.HashSet", java_util_Set);
    marshallers.put("java.util.Collections$SynchronizedSet", java_util_Set);
    marshallers.put("java.util.Collections$UnmodifiableSet", java_util_Set);
    marshallers.put("java.util.Collections$SingletonSet", java_util_Set);
    marshallers.put("java.util.Collections$EmptySet", java_util_Set);
    final SetMarshaller java_util_AbstractSet = new SetMarshaller();
    marshallers.put("java.util.AbstractSet", java_util_AbstractSet);
    final SetMarshaller java_util_HashSet = new SetMarshaller();
    marshallers.put("java.util.HashSet", java_util_HashSet);
    final LinkedListMarshaller java_util_LinkedList = new LinkedListMarshaller();
    marshallers.put("java.util.LinkedList", java_util_LinkedList);
    final LongMarshaller java_lang_Long = new LongMarshaller();
    marshallers.put("java.lang.Long", java_lang_Long);
    final ListMarshaller java_util_List = new ListMarshaller();
    marshallers.put("java.util.List", java_util_List);
    marshallers.put("java.util.AbstractList", java_util_List);
    marshallers.put("java.util.ArrayList", java_util_List);
    marshallers.put("java.util.Vector", java_util_List);
    marshallers.put("java.util.Stack", java_util_List);
    marshallers.put("java.util.Collections$SynchronizedRandomAccessList", java_util_List);
    marshallers.put("java.util.Collections$SynchronizedList", java_util_List);
    marshallers.put("java.util.Collections$SingletonList", java_util_List);
    marshallers.put("java.util.Collections$EmptyList", java_util_List);
    marshallers.put("java.util.Collections$UnmodifiableRandomAccessList", java_util_List);
    marshallers.put("java.util.Collections$UnmodifiableList", java_util_List);
    marshallers.put("java.util.Arrays$ArrayList", java_util_List);
    final ListMarshaller java_util_AbstractList = new ListMarshaller();
    marshallers.put("java.util.AbstractList", java_util_AbstractList);
    final ListMarshaller java_util_ArrayList = new ListMarshaller();
    marshallers.put("java.util.ArrayList", java_util_ArrayList);
    final ListMarshaller java_util_Vector = new ListMarshaller();
    marshallers.put("java.util.Vector", java_util_Vector);
    final ListMarshaller java_util_Stack = new ListMarshaller();
    marshallers.put("java.util.Stack", java_util_Stack);
    final QueueMarshaller java_util_Queue = new QueueMarshaller();
    marshallers.put("java.util.Queue", java_util_Queue);
    marshallers.put("java.util.AbstractQueue", java_util_Queue);
    final QueueMarshaller java_util_AbstractQueue = new QueueMarshaller();
    marshallers.put("java.util.AbstractQueue", java_util_AbstractQueue);
    final ShortMarshaller java_lang_Short = new ShortMarshaller();
    marshallers.put("java.lang.Short", java_lang_Short);
    final CharacterMarshaller java_lang_Character = new CharacterMarshaller();
    marshallers.put("java.lang.Character", java_lang_Character);
    final StringBufferMarshaller java_lang_StringBuffer = new StringBufferMarshaller();
    marshallers.put("java.lang.StringBuffer", java_lang_StringBuffer);
    final TimeMarshaller java_sql_Time = new TimeMarshaller();
    marshallers.put("java.sql.Time", java_sql_Time);
    final AssignmentDataMarshaller org_jbpm_designer_client_shared_AssignmentData = new AssignmentDataMarshaller();
    marshallers.put("org.jbpm.designer.client.shared.AssignmentData", org_jbpm_designer_client_shared_AssignmentData);
    final SortedSetMarshaller java_util_SortedSet = new SortedSetMarshaller();
    marshallers.put("java.util.SortedSet", java_util_SortedSet);
    marshallers.put("java.util.TreeSet", java_util_SortedSet);
    marshallers.put("java.util.Collections$UnmodifiableSortedSet", java_util_SortedSet);
    marshallers.put("java.util.Collections$SynchronizedSortedSet", java_util_SortedSet);
    final SortedSetMarshaller java_util_TreeSet = new SortedSetMarshaller();
    marshallers.put("java.util.TreeSet", java_util_TreeSet);
    final PriorityQueueMarshaller java_util_PriorityQueue = new PriorityQueueMarshaller();
    marshallers.put("java.util.PriorityQueue", java_util_PriorityQueue);
  }

  private boolean putIfNotNull(String fqcn, Marshaller m) {
    if (m != null) {
      marshallers.put(fqcn, m);
      return true;
    } else {
      return false;
    }
  }

  private boolean loadMarshaller0(String a0) {
    Marshaller m = null;
    if ("java.lang.Throwable".equals(a0)) {
      m = GWT.create(Marshaller_for_java_lang_Throwable.class);
    } else if ("java.lang.ArithmeticException".equals(a0)) {
      m = GWT.create(Marshaller_for_java_lang_ArithmeticException.class);
    } else if ("java.io.IOException".equals(a0)) {
      m = GWT.create(Marshaller_for_java_io_IOException.class);
    } else if ("java.lang.IllegalArgumentException".equals(a0)) {
      m = GWT.create(Marshaller_for_java_lang_IllegalArgumentException.class);
    } else if ("java.util.EmptyStackException".equals(a0)) {
      m = GWT.create(Marshaller_for_java_util_EmptyStackException.class);
    } else if ("java.lang.ArrayStoreException".equals(a0)) {
      m = GWT.create(Marshaller_for_java_lang_ArrayStoreException.class);
    } else if ("java.lang.ClassCastException".equals(a0)) {
      m = GWT.create(Marshaller_for_java_lang_ClassCastException.class);
    } else if ("java.util.ConcurrentModificationException".equals(a0)) {
      m = GWT.create(Marshaller_for_java_util_ConcurrentModificationException.class);
    } else if ("java.lang.IndexOutOfBoundsException".equals(a0)) {
      m = GWT.create(Marshaller_for_java_lang_IndexOutOfBoundsException.class);
    } else if ("java.lang.NegativeArraySizeException".equals(a0)) {
      m = GWT.create(Marshaller_for_java_lang_NegativeArraySizeException.class);
    } else if ("java.lang.NullPointerException".equals(a0)) {
      m = GWT.create(Marshaller_for_java_lang_NullPointerException.class);
    } else if ("java.lang.StringIndexOutOfBoundsException".equals(a0)) {
      m = GWT.create(Marshaller_for_java_lang_StringIndexOutOfBoundsException.class);
    } else if ("java.lang.UnsupportedOperationException".equals(a0)) {
      m = GWT.create(Marshaller_for_java_lang_UnsupportedOperationException.class);
    } else if ("java.lang.AssertionError".equals(a0)) {
      m = GWT.create(Marshaller_for_java_lang_AssertionError.class);
    } else if ("java.lang.RuntimeException".equals(a0)) {
      m = GWT.create(Marshaller_for_java_lang_RuntimeException.class);
    } else if ("org.jboss.errai.security.shared.exception.SecurityException".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jboss_errai_security_shared_exception_SecurityException.class);
    } else if ("org.jboss.errai.security.shared.exception.UnauthenticatedException".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jboss_errai_security_shared_exception_UnauthenticatedException.class);
    } else if ("org.jboss.errai.security.shared.exception.UnauthorizedException".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jboss_errai_security_shared_exception_UnauthorizedException.class);
    } else if ("org.jboss.errai.security.shared.exception.AuthenticationException".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jboss_errai_security_shared_exception_AuthenticationException.class);
    } else if ("java.lang.StackTraceElement".equals(a0)) {
      m = GWT.create(Marshaller_for_java_lang_StackTraceElement.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.model.ActionInsertFactCol52".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_ActionInsertFactCol52.class);
    } else if ("org.guvnor.asset.management.social.ProcessStartEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_asset_management_social_ProcessStartEvent.class);
    } else if ("org.kie.workbench.common.services.datamodeller.core.impl.ObjectPropertyImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_ObjectPropertyImpl.class);
    } else if ("org.guvnor.common.services.project.model.Module".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_project_model_Module.class);
    } else if ("org.uberfire.ext.plugin.event.MediaAdded".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_plugin_event_MediaAdded.class);
    } else if ("org.dashbuilder.dataset.filter.LogicalExprFilter".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_filter_LogicalExprFilter.class);
    } else if ("org.dashbuilder.dataprovider.BeanProviderType".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataprovider_BeanProviderType.class);
    } else if ("org.kie.workbench.common.screens.explorer.model.URIStructureExplorerModel".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_explorer_model_URIStructureExplorerModel.class);
    } else if ("org.kie.server.controller.api.model.spec.ProcessConfig".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_server_controller_api_model_spec_ProcessConfig.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.events.ChangeType".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_ChangeType.class);
    } else if ("org.kie.workbench.common.services.datamodeller.util.NamingUtils".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_util_NamingUtils.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.model.ActionSetFieldCol52".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_ActionSetFieldCol52.class);
    } else if ("org.uberfire.workbench.events.ResourceUpdatedEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceUpdatedEvent.class);
    } else if ("org.kie.workbench.common.screens.social.hp.model.HomePageTypes".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_social_hp_model_HomePageTypes.class);
    } else if ("org.uberfire.ext.plugin.event.NewPluginRegistered".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_plugin_event_NewPluginRegistered.class);
    } else if ("org.uberfire.workbench.model.Notification$State".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_workbench_model_Notification_erraiD_State.class);
    } else if ("org.kie.workbench.common.services.refactoring.model.index.terms.valueterms.ValueRuleAttributeIndexTerm".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_valueterms_ValueRuleAttributeIndexTerm.class);
    } else if ("org.guvnor.structure.organizationalunit.impl.OrganizationalUnitImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_structure_organizationalunit_impl_OrganizationalUnitImpl.class);
    } else if ("org.jbpm.formModeler.api.events.FormRenderEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_formModeler_api_events_FormRenderEvent.class);
    } else if ("org.uberfire.java.nio.file.NotDirectoryException".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_java_nio_file_NotDirectoryException.class);
    } else if ("org.kie.workbench.common.services.shared.kmodule.QualifierModel".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_kmodule_QualifierModel.class);
    } else if ("org.kie.server.controller.api.model.spec.ContainerSpecList".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_server_controller_api_model_spec_ContainerSpecList.class);
    } else if ("org.uberfire.mvp.impl.ForcedPlaceRequest".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_mvp_impl_ForcedPlaceRequest.class);
    } else if ("org.uberfire.ext.security.management.api.CapabilityStatus".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_security_management_api_CapabilityStatus.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.model.EditorModelContent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_EditorModelContent.class);
    } else if ("org.guvnor.structure.organizationalunit.RepoRemovedFromOrganizationalUnitEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_structure_organizationalunit_RepoRemovedFromOrganizationalUnitEvent.class);
    } else if ("org.drools.workbench.models.datamodel.rule.FromEntryPointFactPattern".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_FromEntryPointFactPattern.class);
    } else if ("org.uberfire.ext.properties.editor.model.PropertyEditorFieldInfo".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_properties_editor_model_PropertyEditorFieldInfo.class);
    } else if ("org.jbpm.designer.service.DesignerContent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_designer_service_DesignerContent.class);
    } else if ("org.uberfire.workbench.events.ResourceRenamedEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceRenamedEvent.class);
    } else if ("org.drools.workbench.screens.guided.dtable.model.GuidedDecisionTableEditorContent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_screens_guided_dtable_model_GuidedDecisionTableEditorContent.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.auditlog.DeleteColumnAuditLogEntry".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_DeleteColumnAuditLogEntry.class);
    } else if ("org.kie.workbench.common.services.shared.source.SourceGenerationFailedException".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_source_SourceGenerationFailedException.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.events.DataModelerEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataModelerEvent.class);
    } else if ("org.kie.workbench.common.services.shared.kmodule.ConsoleLogger".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_kmodule_ConsoleLogger.class);
    } else if ("org.drools.workbench.models.datamodel.oracle.Annotation".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_oracle_Annotation.class);
    } else if ("org.drools.workbench.models.datamodel.oracle.OperatorsOracle".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_oracle_OperatorsOracle.class);
    } else if ("org.drools.workbench.models.datamodel.rule.DSLSentence".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_DSLSentence.class);
    } else if ("org.guvnor.asset.management.model.ExecuteOperationEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_asset_management_model_ExecuteOperationEvent.class);
    } else if ("org.kie.workbench.common.screens.search.model.SearchPageRow".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_search_model_SearchPageRow.class);
    } else if ("org.uberfire.workbench.model.impl.PartDefinitionImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_workbench_model_impl_PartDefinitionImpl.class);
    } else if ("org.drools.workbench.models.datamodel.rule.ActionRetractFact".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionRetractFact.class);
    } else if ("org.guvnor.inbox.model.InboxPageRow".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_inbox_model_InboxPageRow.class);
    } else if ("org.jbpm.console.ng.pr.model.ProcessInstanceKey".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_pr_model_ProcessInstanceKey.class);
    } else if ("org.jboss.errai.security.shared.exception.FailedAuthenticationException".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jboss_errai_security_shared_exception_FailedAuthenticationException.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.model.persistence.CachingType".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_persistence_CachingType.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.model.ActionInsertFactFieldsPattern".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_ActionInsertFactFieldsPattern.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.model.BRLConditionColumn".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_BRLConditionColumn.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.auditlog.AttributeColumnDetails".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_AttributeColumnDetails.class);
    } else if ("org.jbpm.console.ng.es.model.ErrorSummary".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_es_model_ErrorSummary.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.model.persistence.PersistenceUnitModel".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_persistence_PersistenceUnitModel.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.auditlog.ActionWorkItemInsertFactColumnDetails".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_ActionWorkItemInsertFactColumnDetails.class);
    } else if ("org.uberfire.ext.services.shared.preferences.UserPreference".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_services_shared_preferences_UserPreference.class);
    } else if ("org.drools.workbench.models.datamodel.rule.ExpressionFieldVariable".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionFieldVariable.class);
    } else if ("org.uberfire.workbench.model.ContextDisplayMode".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_workbench_model_ContextDisplayMode.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.auditlog.ActionWorkItemSetFieldColumnDetails".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_ActionWorkItemSetFieldColumnDetails.class);
    } else if ("org.uberfire.ext.plugin.event.PluginUnregistered".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_plugin_event_PluginUnregistered.class);
    } else if ("org.dashbuilder.dataset.events.DataSetStaleEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_events_DataSetStaleEvent.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.auditlog.DecisionTableAuditEvents".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_DecisionTableAuditEvents.class);
    } else if ("org.jbpm.formModeler.api.client.FormRenderContext".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_formModeler_api_client_FormRenderContext.class);
    } else if ("org.uberfire.ext.layout.editor.api.editor.LayoutTemplate".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_layout_editor_api_editor_LayoutTemplate.class);
    } else if ("org.guvnor.common.services.project.service.DeploymentMode".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_project_service_DeploymentMode.class);
    } else if ("org.uberfire.ext.services.shared.preferences.GridPreferencesStore".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_services_shared_preferences_GridPreferencesStore.class);
    } else if ("org.kie.workbench.common.services.datamodeller.core.ElementType".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_ElementType.class);
    } else if ("org.uberfire.workbench.events.ResourceChangeType".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceChangeType.class);
    } else if ("org.dashbuilder.dataset.events.DataSetDefRegisteredEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_events_DataSetDefRegisteredEvent.class);
    } else if ("org.drools.workbench.screens.globals.model.GlobalsEditorContent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_screens_globals_model_GlobalsEditorContent.class);
    } else if ("org.kie.workbench.common.services.shared.kmodule.ListenerModel".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_kmodule_ListenerModel.class);
    } else if ("org.drools.workbench.models.datamodel.workitems.PortableBooleanParameterDefinition".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableBooleanParameterDefinition.class);
    } else if ("org.uberfire.ext.security.management.impl.SearchResponseImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_security_management_impl_SearchResponseImpl.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.model.index.terms.JavaTypeNameIndexTerm".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_index_terms_JavaTypeNameIndexTerm.class);
    } else if ("org.uberfire.security.authz.AuthorizationResult".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_security_authz_AuthorizationResult.class);
    } else if ("org.kie.server.controller.api.model.spec.ServerTemplate".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_server_controller_api_model_spec_ServerTemplate.class);
    } else if ("org.drools.workbench.models.testscenarios.shared.FactAssignmentField".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_FactAssignmentField.class);
    } else if ("org.kie.workbench.common.services.refactoring.model.index.terms.valueterms.ValueTypeIndexTerm".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_valueterms_ValueTypeIndexTerm.class);
    } else if ("org.guvnor.structure.organizationalunit.NewOrganizationalUnitEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_structure_organizationalunit_NewOrganizationalUnitEvent.class);
    } else if ("org.jbpm.formModeler.api.events.FormSubmitFailEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_formModeler_api_events_FormSubmitFailEvent.class);
    } else if ("org.uberfire.security.impl.authz.DefaultAuthorizationPolicy".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_security_impl_authz_DefaultAuthorizationPolicy.class);
    } else if ("org.dashbuilder.dataset.events.DataSetDefModifiedEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_events_DataSetDefModifiedEvent.class);
    } else if ("org.kie.workbench.common.screens.examples.model.ExampleOrganizationalUnit".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_examples_model_ExampleOrganizationalUnit.class);
    }
    return putIfNotNull(a0, m);
  }

  private boolean loadMarshaller1(String a0) {
    Marshaller m = null;
    if ("org.guvnor.structure.repositories.EnvironmentParameters".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_structure_repositories_EnvironmentParameters.class);
    } else if ("org.jbpm.designer.notification.DesignerNotificationEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_designer_notification_DesignerNotificationEvent.class);
    } else if ("org.uberfire.mvp.impl.PathPlaceRequest".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_mvp_impl_PathPlaceRequest.class);
    } else if ("org.uberfire.ext.plugin.model.RuntimePlugin".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_RuntimePlugin.class);
    } else if ("org.drools.workbench.models.datamodel.rule.ExpressionVariable".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionVariable.class);
    } else if ("org.dashbuilder.dataset.events.DataSetPushOkEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_events_DataSetPushOkEvent.class);
    } else if ("org.kie.workbench.common.screens.explorer.service.ProjectExplorerContentQuery".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_explorer_service_ProjectExplorerContentQuery.class);
    } else if ("org.drools.workbench.models.guided.dtree.shared.model.values.impl.BigIntegerValue".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_BigIntegerValue.class);
    } else if ("org.uberfire.ext.plugin.model.LayoutEditorModel".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_LayoutEditorModel.class);
    } else if ("org.guvnor.structure.repositories.RepositoryInfo".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_structure_repositories_RepositoryInfo.class);
    } else if ("org.drools.workbench.models.testscenarios.shared.VerifyFact".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_VerifyFact.class);
    } else if ("org.jboss.errai.security.shared.exception.AlreadyLoggedInException".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jboss_errai_security_shared_exception_AlreadyLoggedInException.class);
    } else if ("org.guvnor.common.services.project.events.DeleteProjectEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_project_events_DeleteProjectEvent.class);
    } else if ("org.drools.workbench.models.guided.dtree.shared.model.GuidedDecisionTree".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_GuidedDecisionTree.class);
    } else if ("org.uberfire.ext.plugin.model.Language".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_Language.class);
    } else if ("org.jbpm.console.ng.pr.model.UserTaskSummary".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_pr_model_UserTaskSummary.class);
    } else if ("org.guvnor.common.services.project.builder.model.IncrementalBuildResults".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_project_builder_model_IncrementalBuildResults.class);
    } else if ("org.jbpm.console.ng.pr.model.NodeInstanceSummary".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_pr_model_NodeInstanceSummary.class);
    } else if ("org.kie.workbench.common.services.datamodeller.driver.model.AnnotationParseRequest".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_AnnotationParseRequest.class);
    } else if ("org.dashbuilder.dataset.events.DataSetModifiedEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_events_DataSetModifiedEvent.class);
    } else if ("org.kie.server.controller.api.model.spec.RuleConfig".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_server_controller_api_model_spec_RuleConfig.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.model.index.terms.JavaTypeParentIndexTerm".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_index_terms_JavaTypeParentIndexTerm.class);
    } else if ("org.jbpm.console.ng.pr.model.events.ProcessInstancesWithDetailsRequestEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_pr_model_events_ProcessInstancesWithDetailsRequestEvent.class);
    } else if ("org.drools.workbench.models.datamodel.oracle.MethodInfo".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_oracle_MethodInfo.class);
    } else if ("org.guvnor.structure.navigator.DataContent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_structure_navigator_DataContent.class);
    } else if ("org.drools.workbench.models.datamodel.oracle.ModelField$FIELD_CLASS_TYPE".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_oracle_ModelField_erraiD_FIELD_erraiU_CLASS_erraiU_TYPE.class);
    } else if ("org.guvnor.structure.repositories.RepositoryRemovedEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_structure_repositories_RepositoryRemovedEvent.class);
    } else if ("org.kie.workbench.common.screens.explorer.service.ActiveOptions".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_explorer_service_ActiveOptions.class);
    } else if ("org.jbpm.console.ng.ht.model.events.NewTaskEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_ht_model_events_NewTaskEvent.class);
    } else if ("org.uberfire.ext.plugin.exception.PluginAlreadyExists".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_plugin_exception_PluginAlreadyExists.class);
    } else if ("org.guvnor.common.services.project.security.ProjectResourceType".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_project_security_ProjectResourceType.class);
    } else if ("org.drools.workbench.models.guided.dtree.shared.model.values.impl.ShortValue".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_ShortValue.class);
    } else if ("org.drools.workbench.models.testscenarios.shared.BuilderResultLine".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_BuilderResultLine.class);
    } else if ("org.kie.workbench.common.screens.examples.model.ExamplesModel".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_examples_model_ExamplesModel.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.model.DTColumnConfig52".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_DTColumnConfig52.class);
    } else if ("org.kie.uberfire.social.activities.model.SocialFileSelectedEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_uberfire_social_activities_model_SocialFileSelectedEvent.class);
    } else if ("org.uberfire.backend.vfs.impl.LockInfo".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_backend_vfs_impl_LockInfo.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.model.index.terms.FieldNameIndexTerm".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_index_terms_FieldNameIndexTerm.class);
    } else if ("org.guvnor.asset.management.model.ConfigureRepositoryEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_asset_management_model_ConfigureRepositoryEvent.class);
    } else if ("org.guvnor.asset.management.social.ProjectBuiltEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_asset_management_social_ProjectBuiltEvent.class);
    } else if ("org.guvnor.m2repo.model.JarListPageRow".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_m2repo_model_JarListPageRow.class);
    } else if ("org.drools.workbench.screens.enums.model.EnumModel".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_screens_enums_model_EnumModel.class);
    } else if ("org.drools.workbench.models.guided.dtree.shared.model.nodes.impl.ConstraintNodeImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_nodes_impl_ConstraintNodeImpl.class);
    } else if ("org.jbpm.console.ng.ht.model.events.TaskRefreshedEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_ht_model_events_TaskRefreshedEvent.class);
    } else if ("org.drools.workbench.models.guided.dtree.shared.model.values.impl.FloatValue".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_FloatValue.class);
    } else if ("org.kie.workbench.common.services.refactoring.model.index.terms.RuleIndexTerm".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_RuleIndexTerm.class);
    } else if ("org.jbpm.console.ng.pr.model.ProcessInstanceVariableSummary".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_pr_model_ProcessInstanceVariableSummary.class);
    } else if ("org.dashbuilder.dataset.def.DataColumnDef".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_def_DataColumnDef.class);
    } else if ("org.kie.workbench.common.services.datamodeller.core.impl.DataObjectImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_DataObjectImpl.class);
    } else if ("org.drools.workbench.models.guided.dtree.shared.model.parser.messages.UnsupportedIActionParserMessage".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_UnsupportedIActionParserMessage.class);
    } else if ("org.drools.workbench.models.datamodel.rule.SingleFieldConstraintEBLeftSide".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_SingleFieldConstraintEBLeftSide.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.model.ActionRetractFactCol52".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_ActionRetractFactCol52.class);
    } else if ("org.guvnor.inbox.model.InboxPageRequest".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_inbox_model_InboxPageRequest.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.model.GuidedDecisionTable52".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_GuidedDecisionTable52.class);
    } else if ("org.guvnor.common.services.workingset.client.model.WorkingSetConfigData".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_workingset_client_model_WorkingSetConfigData.class);
    } else if ("org.jbpm.console.ng.wi.dd.model.Parameter".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_wi_dd_model_Parameter.class);
    } else if ("org.guvnor.structure.repositories.RepositoryEnvironmentConfigurations".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_structure_repositories_RepositoryEnvironmentConfigurations.class);
    } else if ("org.jbpm.console.ng.pr.model.events.ProcessDefStyleEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_pr_model_events_ProcessDefStyleEvent.class);
    } else if ("org.drools.workbench.models.datamodel.rule.FromCollectCompositeFactPattern".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_FromCollectCompositeFactPattern.class);
    } else if ("org.uberfire.ext.security.management.impl.UserManagerSettingsImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_security_management_impl_UserManagerSettingsImpl.class);
    } else if ("org.uberfire.java.nio.file.FileAlreadyExistsException".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_java_nio_file_FileAlreadyExistsException.class);
    } else if ("org.drools.workbench.models.guided.dtree.shared.model.values.impl.LongValue".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_LongValue.class);
    } else if ("org.uberfire.ext.plugin.model.Plugin".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_Plugin.class);
    } else if ("org.kie.workbench.common.services.refactoring.model.index.terms.valueterms.ValuePackageNameIndexTerm".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_valueterms_ValuePackageNameIndexTerm.class);
    } else if ("org.drools.workbench.models.datamodel.rule.ActionUpdateField".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionUpdateField.class);
    } else if ("org.guvnor.messageconsole.events.SystemMessage".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_messageconsole_events_SystemMessage.class);
    } else if ("org.drools.workbench.screens.drltext.model.DrlModelContent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_screens_drltext_model_DrlModelContent.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.model.MetadataCol52".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_MetadataCol52.class);
    } else if ("org.guvnor.common.services.project.model.WorkItemHandlerModel".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_project_model_WorkItemHandlerModel.class);
    } else if ("org.jbpm.console.ng.pr.model.ProcessVariableKey".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_pr_model_ProcessVariableKey.class);
    } else if ("org.drools.workbench.screens.guided.rule.model.GuidedEditorContent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_screens_guided_rule_model_GuidedEditorContent.class);
    } else if ("org.drools.workbench.models.guided.scorecard.shared.Characteristic".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_scorecard_shared_Characteristic.class);
    } else if ("org.drools.workbench.models.testscenarios.shared.CallFixtureMap".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_CallFixtureMap.class);
    } else if ("org.drools.workbench.models.testscenarios.shared.CallMethod".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_CallMethod.class);
    } else if ("org.guvnor.common.services.project.events.NewPackageEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_project_events_NewPackageEvent.class);
    } else if ("org.jbpm.console.ng.bd.model.DeploymentUnitSummary".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_bd_model_DeploymentUnitSummary.class);
    } else if ("org.guvnor.asset.management.model.ReleaseProjectEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_asset_management_model_ReleaseProjectEvent.class);
    } else if ("org.drools.workbench.screens.globals.model.Global".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_screens_globals_model_Global.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.events.DataModelSaved".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataModelSaved.class);
    } else if ("org.drools.workbench.screens.workitems.model.WorkItemDefinitionElements".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_screens_workitems_model_WorkItemDefinitionElements.class);
    } else if ("org.guvnor.common.services.project.model.Plugin".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_project_model_Plugin.class);
    } else if ("org.jbpm.console.ng.ga.model.PortableQueryFilter".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_ga_model_PortableQueryFilter.class);
    } else if ("org.uberfire.workbench.events.ResourceUpdated".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceUpdated.class);
    } else if ("org.kie.server.controller.api.model.events.ServerTemplateDeleted".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_server_controller_api_model_events_ServerTemplateDeleted.class);
    } else if ("org.kie.server.controller.api.model.events.ServerTemplateUpdated".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_server_controller_api_model_events_ServerTemplateUpdated.class);
    } else if ("org.jbpm.console.ng.ht.model.CommentSummary".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_ht_model_CommentSummary.class);
    } else if ("org.kie.workbench.common.services.refactoring.model.index.terms.valueterms.ValueProjectRootPathIndexTerm".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_valueterms_ValueProjectRootPathIndexTerm.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.model.index.terms.JavaTypeInterfaceIndexTerm".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_index_terms_JavaTypeInterfaceIndexTerm.class);
    } else if ("org.drools.workbench.screens.factmodel.model.AnnotationMetaModel".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_screens_factmodel_model_AnnotationMetaModel.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.model.persistence.TransactionType".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_persistence_TransactionType.class);
    } else if ("org.kie.workbench.common.services.datamodel.model.PackageDataModelOracleBaselinePayload".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodel_model_PackageDataModelOracleBaselinePayload.class);
    } else if ("org.drools.workbench.models.datamodel.rule.ActionCallMethod".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionCallMethod.class);
    } else if ("org.kie.uberfire.social.activities.model.SocialActivitiesEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_uberfire_social_activities_model_SocialActivitiesEvent.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.model.BRLConditionVariableColumn".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_BRLConditionVariableColumn.class);
    } else if ("org.drools.workbench.models.guided.dtree.shared.model.nodes.impl.ActionUpdateNodeImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_nodes_impl_ActionUpdateNodeImpl.class);
    } else if ("org.drools.workbench.models.guided.dtree.shared.model.parser.messages.UnsupportedFieldNatureTypeParserMessage".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_UnsupportedFieldNatureTypeParserMessage.class);
    } else if ("org.jbpm.console.ng.pr.model.events.ProcessInstanceStyleEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_pr_model_events_ProcessInstanceStyleEvent.class);
    } else if ("org.kie.workbench.common.services.datamodeller.driver.model.AnnotationSourceResponse".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_AnnotationSourceResponse.class);
    } else if ("org.jbpm.console.ng.ga.forms.model.events.FormLoadedEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_ga_forms_model_events_FormLoadedEvent.class);
    } else if ("org.kie.server.controller.api.model.events.ServerInstanceDisconnected".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_server_controller_api_model_events_ServerInstanceDisconnected.class);
    }
    return putIfNotNull(a0, m);
  }

  private boolean loadMarshaller2(String a0) {
    Marshaller m = null;
    if ("org.drools.workbench.models.testscenarios.shared.FixtureList".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_FixtureList.class);
    } else if ("org.guvnor.common.services.shared.metadata.model.DiscussionRecord".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_shared_metadata_model_DiscussionRecord.class);
    } else if ("org.uberfire.backend.vfs.FileSystemFactory$FileSystemImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_backend_vfs_FileSystemFactory_erraiD_FileSystemImpl.class);
    } else if ("org.kie.uberfire.social.activities.model.SocialUser".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_uberfire_social_activities_model_SocialUser.class);
    } else if ("org.drools.workbench.models.guided.scorecard.shared.ScoreCardModel".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_scorecard_shared_ScoreCardModel.class);
    } else if ("org.kie.server.controller.api.model.spec.ContainerSpec".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_server_controller_api_model_spec_ContainerSpec.class);
    } else if ("org.uberfire.ext.plugin.model.DynamicMenuItem".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_DynamicMenuItem.class);
    } else if ("org.uberfire.ext.properties.editor.model.validators.TextValidator".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_properties_editor_model_validators_TextValidator.class);
    } else if ("org.kie.server.api.model.Message".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_server_api_model_Message.class);
    } else if ("org.drools.workbench.models.datamodel.rule.RuleAttribute".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_RuleAttribute.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.model.persistence.PersistenceDescriptorEditorContent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_persistence_PersistenceDescriptorEditorContent.class);
    } else if ("org.kie.server.api.model.Severity".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_server_api_model_Severity.class);
    } else if ("org.drools.workbench.models.datamodel.rule.ActionWorkItemFieldValue".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionWorkItemFieldValue.class);
    } else if ("org.kie.workbench.common.services.datamodel.model.PackageDataModelOracleIncrementalPayload".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodel_model_PackageDataModelOracleIncrementalPayload.class);
    } else if ("org.kie.server.controller.api.model.spec.ServerTemplateList".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_server_controller_api_model_spec_ServerTemplateList.class);
    } else if ("org.jboss.errai.security.shared.api.RoleImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jboss_errai_security_shared_api_RoleImpl.class);
    } else if ("org.kie.uberfire.social.activities.model.SocialActivitiesEvent$LINK_TYPE".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_uberfire_social_activities_model_SocialActivitiesEvent_erraiD_LINK_erraiU_TYPE.class);
    } else if ("org.drools.workbench.screens.testscenario.model.TestScenarioResult".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_screens_testscenario_model_TestScenarioResult.class);
    } else if ("org.drools.workbench.models.datamodel.workitems.PortableFloatParameterDefinition".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableFloatParameterDefinition.class);
    } else if ("org.kie.workbench.common.services.shared.kmodule.FileLogger".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_kmodule_FileLogger.class);
    } else if ("org.guvnor.asset.management.model.BuildProjectStructureEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_asset_management_model_BuildProjectStructureEvent.class);
    } else if ("org.kie.workbench.common.services.shared.project.KieProject".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_project_KieProject.class);
    } else if ("org.guvnor.common.services.project.builder.events.InvalidateDMOPackageCacheEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_project_builder_events_InvalidateDMOPackageCacheEvent.class);
    } else if ("org.kie.workbench.common.services.refactoring.model.index.terms.FieldIndexTerm".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_FieldIndexTerm.class);
    } else if ("org.kie.workbench.common.services.refactoring.model.query.RefactoringPathPageRow".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_query_RefactoringPathPageRow.class);
    } else if ("org.uberfire.workbench.events.ResourceOpenedEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceOpenedEvent.class);
    } else if ("org.guvnor.m2repo.model.JarListPageRequest".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_m2repo_model_JarListPageRequest.class);
    } else if ("org.guvnor.asset.management.social.ProcessEndEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_asset_management_social_ProcessEndEvent.class);
    } else if ("org.dashbuilder.dataset.filter.CoreFunctionFilter".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_filter_CoreFunctionFilter.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.events.DataObjectDeletedEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataObjectDeletedEvent.class);
    } else if ("org.guvnor.structure.organizationalunit.RepoAddedToOrganizationalUnitEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_structure_organizationalunit_RepoAddedToOrganizationalUnitEvent.class);
    } else if ("org.dashbuilder.dataset.date.TimeAmount".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_date_TimeAmount.class);
    } else if ("org.guvnor.asset.management.model.PromoteChangesEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_asset_management_model_PromoteChangesEvent.class);
    } else if ("org.guvnor.common.services.shared.validation.model.ValidationMessage".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_shared_validation_model_ValidationMessage.class);
    } else if ("org.drools.workbench.models.testscenarios.shared.VerifyRuleFired".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_VerifyRuleFired.class);
    } else if ("org.drools.workbench.models.guided.scorecard.shared.Attribute".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_scorecard_shared_Attribute.class);
    } else if ("org.guvnor.asset.management.social.AssetsPromotedEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_asset_management_social_AssetsPromotedEvent.class);
    } else if ("org.kie.workbench.common.screens.explorer.model.FolderItemType".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_explorer_model_FolderItemType.class);
    } else if ("org.uberfire.ext.security.management.api.exception.EntityAlreadyExistsException".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_security_management_api_exception_EntityAlreadyExistsException.class);
    } else if ("org.kie.workbench.common.services.shared.discussion.CommentAddedEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_discussion_CommentAddedEvent.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.conversion.ConversionMessage".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_conversion_ConversionMessage.class);
    } else if ("org.drools.workbench.models.guided.dtree.shared.model.parser.messages.DefaultParserMessage".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_DefaultParserMessage.class);
    } else if ("org.jbpm.console.ng.ga.model.process.DummyProcessPath".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_ga_model_process_DummyProcessPath.class);
    } else if ("org.jbpm.console.ng.ht.model.TaskDefSummary".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_ht_model_TaskDefSummary.class);
    } else if ("org.dashbuilder.displayer.DisplayerSettings".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_displayer_DisplayerSettings.class);
    } else if ("org.uberfire.ext.security.management.impl.GroupManagerSettingsImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_security_management_impl_GroupManagerSettingsImpl.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.conversion.ConversionMessageType".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_conversion_ConversionMessageType.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.conversion.ConversionResult".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_conversion_ConversionResult.class);
    } else if ("org.drools.workbench.models.testscenarios.shared.FieldData".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_FieldData.class);
    } else if ("org.jboss.errai.common.client.PageRequest".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jboss_errai_common_client_PageRequest.class);
    } else if ("org.jbpm.console.ng.pr.model.events.ProcessDefinitionsSearchEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_pr_model_events_ProcessDefinitionsSearchEvent.class);
    } else if ("org.jbpm.console.ng.bd.model.KModuleDeploymentUnitSummary".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_bd_model_KModuleDeploymentUnitSummary.class);
    } else if ("org.drools.workbench.models.testscenarios.shared.CollectionFieldData".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_CollectionFieldData.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.model.LimitedEntryBRLConditionColumn".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_LimitedEntryBRLConditionColumn.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.model.AttributeCol52".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_AttributeCol52.class);
    } else if ("org.uberfire.ext.plugin.event.PluginSaved".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_plugin_event_PluginSaved.class);
    } else if ("org.guvnor.structure.organizationalunit.OrganizationalUnitEventBase".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_structure_organizationalunit_OrganizationalUnitEventBase.class);
    } else if ("org.drools.workbench.models.guided.dtree.shared.model.values.impl.BooleanValue".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_BooleanValue.class);
    } else if ("org.kie.workbench.common.services.shared.whitelist.WhiteList".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_whitelist_WhiteList.class);
    } else if ("org.drools.workbench.screens.dtablexls.service.DecisionTableXLSContent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_screens_dtablexls_service_DecisionTableXLSContent.class);
    } else if ("org.jbpm.formModeler.editor.model.FormModelerContent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_formModeler_editor_model_FormModelerContent.class);
    } else if ("org.guvnor.asset.management.social.ProjectDeployedEvent$DeployType".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_asset_management_social_ProjectDeployedEvent_erraiD_DeployType.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.events.DataObjectSelectedEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataObjectSelectedEvent.class);
    } else if ("org.uberfire.backend.vfs.impl.DirectoryStreamImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_backend_vfs_impl_DirectoryStreamImpl.class);
    } else if ("org.drools.workbench.models.datamodel.rule.ExpressionMethodParameter".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionMethodParameter.class);
    } else if ("org.drools.workbench.models.datamodel.oracle.DataType$DataTypes".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_oracle_DataType_erraiD_DataTypes.class);
    } else if ("org.drools.workbench.models.datamodel.rule.CompositeFactPattern".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_CompositeFactPattern.class);
    } else if ("org.drools.workbench.models.datamodel.oracle.ModelField$FIELD_ORIGIN".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_oracle_ModelField_erraiD_FIELD_erraiU_ORIGIN.class);
    } else if ("org.jbpm.console.ng.es.model.RequestSummary".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_es_model_RequestSummary.class);
    } else if ("org.uberfire.paging.PageRequest".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_paging_PageRequest.class);
    } else if ("org.drools.workbench.models.guided.dtree.shared.model.parser.messages.UnsupportedIPatternParserMessage".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_UnsupportedIPatternParserMessage.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.auditlog.ActionSetFieldColumnDetails".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_ActionSetFieldColumnDetails.class);
    } else if ("org.kie.workbench.common.services.refactoring.model.index.terms.valueterms.ValueRuleAttributeValueIndexTerm".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_valueterms_ValueRuleAttributeValueIndexTerm.class);
    } else if ("org.kie.workbench.common.screens.explorer.model.ProjectExplorerContent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_explorer_model_ProjectExplorerContent.class);
    } else if ("org.kie.workbench.common.services.refactoring.model.index.terms.PackageNameIndexTerm".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_PackageNameIndexTerm.class);
    } else if ("org.dashbuilder.dataset.impl.DataColumnImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_impl_DataColumnImpl.class);
    } else if ("org.drools.workbench.models.testscenarios.shared.CallFieldValue".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_CallFieldValue.class);
    } else if ("org.uberfire.ext.security.management.impl.UserAttributeImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_security_management_impl_UserAttributeImpl.class);
    } else if ("org.drools.workbench.models.datamodel.oracle.TypeSource".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_oracle_TypeSource.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.events.DataObjectFieldChangeEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataObjectFieldChangeEvent.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.model.LimitedEntryBRLActionColumn".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_LimitedEntryBRLActionColumn.class);
    } else if ("org.guvnor.common.services.project.builder.model.BuildMessage".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_project_builder_model_BuildMessage.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.model.ActionWorkItemInsertFactCol52".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_ActionWorkItemInsertFactCol52.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.model.ActionWorkItemCol52".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_ActionWorkItemCol52.class);
    } else if ("org.uberfire.workbench.model.impl.PanelDefinitionImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_workbench_model_impl_PanelDefinitionImpl.class);
    } else if ("org.dashbuilder.dataprovider.StaticProviderType".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataprovider_StaticProviderType.class);
    } else if ("org.drools.workbench.models.datamodel.rule.DSLVariableValue".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_DSLVariableValue.class);
    } else if ("org.kie.workbench.common.services.datamodeller.core.impl.DataModelImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_DataModelImpl.class);
    } else if ("org.guvnor.messageconsole.events.PublishBatchMessagesEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_messageconsole_events_PublishBatchMessagesEvent.class);
    } else if ("org.kie.workbench.common.screens.server.management.model.RuntimeStrategy".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_server_management_model_RuntimeStrategy.class);
    } else if ("org.guvnor.common.services.project.service.PackageAlreadyExistsException".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_project_service_PackageAlreadyExistsException.class);
    } else if ("org.kie.workbench.common.screens.projecteditor.model.ProjectScreenModel".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_projecteditor_model_ProjectScreenModel.class);
    } else if ("org.drools.workbench.models.guided.dtree.shared.model.parser.messages.UnsupportedFieldConstraintTypeParserMessage".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_UnsupportedFieldConstraintTypeParserMessage.class);
    } else if ("org.jboss.errai.security.shared.api.identity.UserImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jboss_errai_security_shared_api_identity_UserImpl.class);
    } else if ("org.kie.workbench.common.services.refactoring.model.query.RefactoringStringPageRow".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_query_RefactoringStringPageRow.class);
    } else if ("org.guvnor.asset.management.model.RepositoryStructureModel".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_asset_management_model_RepositoryStructureModel.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.auditlog.ActionInsertFactColumnDetails".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_ActionInsertFactColumnDetails.class);
    } else if ("org.dashbuilder.dataset.backend.EditDataSetDef".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_backend_EditDataSetDef.class);
    } else if ("org.drools.workbench.models.testscenarios.shared.FieldPlaceHolder".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_FieldPlaceHolder.class);
    } else if ("org.uberfire.workbench.model.Notification".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_workbench_model_Notification.class);
    }
    return putIfNotNull(a0, m);
  }

  private boolean loadMarshaller3(String a0) {
    Marshaller m = null;
    if ("org.guvnor.common.services.project.model.POM".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_project_model_POM.class);
    } else if ("org.jbpm.console.ng.es.model.events.RequestSelectionEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_es_model_events_RequestSelectionEvent.class);
    } else if ("org.jbpm.console.ng.bd.exception.DeploymentException".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_bd_exception_DeploymentException.class);
    } else if ("org.kie.workbench.common.services.refactoring.model.index.terms.valueterms.ValueRuleIndexTerm".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_valueterms_ValueRuleIndexTerm.class);
    } else if ("org.guvnor.common.services.project.model.MavenRepositorySource".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_project_model_MavenRepositorySource.class);
    } else if ("org.drools.workbench.models.datamodel.rule.ExpressionMethod".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionMethod.class);
    } else if ("org.drools.workbench.models.guided.dtree.shared.model.parser.GuidedDecisionTreeParserError".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_GuidedDecisionTreeParserError.class);
    } else if ("org.dashbuilder.dataset.def.SQLDataSetDef".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_def_SQLDataSetDef.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.model.WorkItemColumnParameterValueDiffImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_WorkItemColumnParameterValueDiffImpl.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.auditlog.LimitedEntryConditionColumnDetails".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_LimitedEntryConditionColumnDetails.class);
    } else if ("org.drools.workbench.models.datamodel.oracle.ModelField".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_oracle_ModelField.class);
    } else if ("org.dashbuilder.dataset.group.Interval".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_group_Interval.class);
    } else if ("org.uberfire.workbench.events.ResourceRenamed".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceRenamed.class);
    } else if ("org.kie.workbench.common.screens.explorer.model.FolderItemOperation".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_explorer_model_FolderItemOperation.class);
    } else if ("org.drools.workbench.models.datamodel.rule.ExpressionMethodParameterDefinition".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionMethodParameterDefinition.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.model.persistence.PersistenceDescriptorModel".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_persistence_PersistenceDescriptorModel.class);
    } else if ("org.guvnor.messageconsole.events.PublishBaseEvent$Place".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_messageconsole_events_PublishBaseEvent_erraiD_Place.class);
    } else if ("org.jbpm.console.ng.wi.dd.model.ItemObjectModel".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_wi_dd_model_ItemObjectModel.class);
    } else if ("org.jbpm.formModeler.api.model.Form".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_formModeler_api_model_Form.class);
    } else if ("org.drools.workbench.models.testscenarios.shared.VerifyField".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_VerifyField.class);
    } else if ("org.kie.workbench.common.services.datamodeller.driver.model.AnnotationSourceRequest".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_AnnotationSourceRequest.class);
    } else if ("org.guvnor.common.services.workingset.client.model.WorkingSetSettings".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_workingset_client_model_WorkingSetSettings.class);
    } else if ("org.jbpm.console.ng.ht.model.TaskEventKey".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_ht_model_TaskEventKey.class);
    } else if ("org.jbpm.console.ng.bd.model.RuntimeSummary".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_bd_model_RuntimeSummary.class);
    } else if ("org.uberfire.ext.plugin.model.DynamicMenu".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_DynamicMenu.class);
    } else if ("org.uberfire.ext.plugin.model.PluginSimpleContent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_PluginSimpleContent.class);
    } else if ("org.drools.workbench.models.testscenarios.shared.FixturesMap".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_FixturesMap.class);
    } else if ("org.jbpm.console.ng.bd.model.RuleNotificationSummary".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_bd_model_RuleNotificationSummary.class);
    } else if ("org.jbpm.console.ng.ht.model.User".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_ht_model_User.class);
    } else if ("org.jbpm.console.ng.ht.model.events.TaskSelectionEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_ht_model_events_TaskSelectionEvent.class);
    } else if ("org.kie.server.controller.api.model.spec.ContainerConfig".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_server_controller_api_model_spec_ContainerConfig.class);
    } else if ("org.jbpm.console.ng.pr.model.ProcessDefinitionKey".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_pr_model_ProcessDefinitionKey.class);
    } else if ("org.uberfire.ext.apps.api.Directory".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_apps_api_Directory.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.auditlog.InsertRowAuditLogEntry".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_InsertRowAuditLogEntry.class);
    } else if ("org.drools.workbench.models.guided.dtree.shared.model.nodes.impl.ActionRetractNodeImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_nodes_impl_ActionRetractNodeImpl.class);
    } else if ("org.drools.workbench.models.datamodel.auditlog.AuditLog".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_auditlog_AuditLog.class);
    } else if ("org.kie.workbench.common.services.datamodeller.driver.model.AnnotationDefinitionResponse".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_AnnotationDefinitionResponse.class);
    } else if ("org.drools.workbench.models.datamodel.rule.FreeFormLine".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_FreeFormLine.class);
    } else if ("org.kie.workbench.common.screens.search.model.SearchTermPageRequest".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_search_model_SearchTermPageRequest.class);
    } else if ("org.optaplanner.workbench.screens.solver.model.ScoreDirectorFactoryConfigModel".equals(a0)) {
      m = GWT.create(Marshaller_for_org_optaplanner_workbench_screens_solver_model_ScoreDirectorFactoryConfigModel.class);
    } else if ("org.guvnor.common.services.project.model.ProjectImports".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_project_model_ProjectImports.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.auditlog.DecisionTableAuditLogFilter".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_DecisionTableAuditLogFilter.class);
    } else if ("org.drools.workbench.models.datamodel.rule.RuleModel".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_RuleModel.class);
    } else if ("org.drools.workbench.screens.scorecardxls.service.ScoreCardXLSContent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_screens_scorecardxls_service_ScoreCardXLSContent.class);
    } else if ("org.jbpm.console.ng.bd.model.KieSessionSummary".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_bd_model_KieSessionSummary.class);
    } else if ("org.dashbuilder.displayer.impl.TableDisplayerSettingsBuilderImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_displayer_impl_TableDisplayerSettingsBuilderImpl.class);
    } else if ("org.guvnor.inbox.model.InboxIncomingPageRow".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_inbox_model_InboxIncomingPageRow.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.events.DataModelerValueChangeEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataModelerValueChangeEvent.class);
    } else if ("org.kie.workbench.common.services.refactoring.model.index.terms.TypeIndexTerm".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_TypeIndexTerm.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.model.LimitedEntryActionSetFieldCol52".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_LimitedEntryActionSetFieldCol52.class);
    } else if ("org.guvnor.common.services.project.model.Repository".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_project_model_Repository.class);
    } else if ("org.dashbuilder.dataset.group.DateIntervalType".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_group_DateIntervalType.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.model.DescriptionCol52".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_DescriptionCol52.class);
    } else if ("org.uberfire.ext.editor.commons.version.impl.PortableVersionRecord".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_editor_commons_version_impl_PortableVersionRecord.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.model.index.terms.valueterms.ValueFieldNameIndexTerm".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_index_terms_valueterms_ValueFieldNameIndexTerm.class);
    } else if ("org.drools.workbench.models.datamodel.rule.ActionFieldFunction".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionFieldFunction.class);
    } else if ("org.jboss.errai.security.shared.api.GroupImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jboss_errai_security_shared_api_GroupImpl.class);
    } else if ("org.kie.workbench.common.services.datamodeller.core.impl.PropertyTypeImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_PropertyTypeImpl.class);
    } else if ("org.kie.workbench.common.screens.server.management.model.MergeMode".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_server_management_model_MergeMode.class);
    } else if ("org.guvnor.common.services.project.context.ProjectContextChangeEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_project_context_ProjectContextChangeEvent.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.model.index.terms.valueterms.ValueJavaTypeParentIndexTerm".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_index_terms_valueterms_ValueJavaTypeParentIndexTerm.class);
    } else if ("org.dashbuilder.dataset.def.ElasticSearchDataSetDef".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_def_ElasticSearchDataSetDef.class);
    } else if ("org.optaplanner.workbench.screens.solver.model.TerminationConfigModel".equals(a0)) {
      m = GWT.create(Marshaller_for_org_optaplanner_workbench_screens_solver_model_TerminationConfigModel.class);
    } else if ("org.guvnor.common.services.project.model.Build".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_project_model_Build.class);
    } else if ("org.kie.workbench.common.services.shared.kmodule.KSessionModel".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_kmodule_KSessionModel.class);
    } else if ("org.uberfire.ext.services.shared.preferences.GridColumnPreference".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_services_shared_preferences_GridColumnPreference.class);
    } else if ("org.drools.workbench.models.guided.dtree.shared.model.parser.messages.UnsupportedFieldConstraintParserMessage".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_UnsupportedFieldConstraintParserMessage.class);
    } else if ("org.jbpm.console.ng.ht.model.TaskKey".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_ht_model_TaskKey.class);
    } else if ("org.uberfire.ext.plugin.event.PluginDeleted".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_plugin_event_PluginDeleted.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.model.RowNumberCol52".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_RowNumberCol52.class);
    } else if ("org.guvnor.common.services.project.model.GAV".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_project_model_GAV.class);
    } else if ("org.drools.workbench.models.datamodel.workitems.PortableObjectParameterDefinition".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableObjectParameterDefinition.class);
    } else if ("org.uberfire.workbench.events.ResourceDeletedEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceDeletedEvent.class);
    } else if ("org.kie.workbench.common.screens.search.model.QueryMetadataPageRequest".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_search_model_QueryMetadataPageRequest.class);
    } else if ("org.kie.workbench.common.services.datamodeller.core.impl.JavaClassImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_JavaClassImpl.class);
    } else if ("org.kie.workbench.common.screens.examples.model.ExampleTargetRepository".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_examples_model_ExampleTargetRepository.class);
    } else if ("org.drools.workbench.models.datamodel.rule.FactPattern".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_FactPattern.class);
    } else if ("org.uberfire.java.nio.file.ClosedWatchServiceException".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_java_nio_file_ClosedWatchServiceException.class);
    } else if ("org.guvnor.asset.management.social.ProjectDeployedEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_asset_management_social_ProjectDeployedEvent.class);
    } else if ("org.drools.workbench.models.datamodel.workitems.PortableIntegerParameterDefinition".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableIntegerParameterDefinition.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.auditlog.UpdateColumnAuditLogEntry".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_UpdateColumnAuditLogEntry.class);
    } else if ("org.kie.server.controller.api.model.events.ServerInstanceDeleted".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_server_controller_api_model_events_ServerInstanceDeleted.class);
    } else if ("org.jbpm.console.ng.es.model.events.RequestChangedEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_es_model_events_RequestChangedEvent.class);
    } else if ("org.uberfire.workbench.model.CompassPosition".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_workbench_model_CompassPosition.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.events.DataObjectCreatedEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataObjectCreatedEvent.class);
    } else if ("org.dashbuilder.dataset.sort.DataSetSort".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_sort_DataSetSort.class);
    } else if ("org.drools.workbench.models.datamodel.rule.ExpressionFormLine".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionFormLine.class);
    } else if ("org.guvnor.common.services.project.model.MavenRepositoryMetadata".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_project_model_MavenRepositoryMetadata.class);
    } else if ("org.jbpm.console.ng.ga.forms.model.events.PaletteItemAddedEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_ga_forms_model_events_PaletteItemAddedEvent.class);
    } else if ("org.drools.workbench.models.datamodel.workitems.PortableStringParameterDefinition".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableStringParameterDefinition.class);
    } else if ("org.jbpm.formModeler.api.client.FormRenderContextTO".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_formModeler_api_client_FormRenderContextTO.class);
    } else if ("org.uberfire.workbench.model.NamedPosition".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_workbench_model_NamedPosition.class);
    } else if ("org.guvnor.structure.navigator.NavigatorContent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_structure_navigator_NavigatorContent.class);
    } else if ("org.uberfire.ext.security.management.api.exception.UserNotFoundException".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_security_management_api_exception_UserNotFoundException.class);
    } else if ("org.kie.server.controller.api.model.spec.ContainerSpecKey".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_server_controller_api_model_spec_ContainerSpecKey.class);
    } else if ("org.kie.workbench.common.services.datamodeller.driver.model.DriverError".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_DriverError.class);
    } else if ("org.drools.workbench.models.guided.dtree.shared.model.parser.messages.DataTypeNotFoundParserMessage".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_DataTypeNotFoundParserMessage.class);
    } else if ("org.drools.workbench.models.testscenarios.shared.Fact".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_Fact.class);
    } else if ("org.jbpm.console.ng.pr.model.events.ProcessInstanceSelectionEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_pr_model_events_ProcessInstanceSelectionEvent.class);
    } else if ("org.guvnor.common.services.project.events.NewProjectEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_project_events_NewProjectEvent.class);
    }
    return putIfNotNull(a0, m);
  }

  private boolean loadMarshaller4(String a0) {
    Marshaller m = null;
    if ("org.guvnor.common.services.project.model.Dependency".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_project_model_Dependency.class);
    } else if ("org.kie.workbench.common.services.refactoring.model.index.terms.RuleAttributeIndexTerm".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_RuleAttributeIndexTerm.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.model.LimitedEntryConditionCol52".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_LimitedEntryConditionCol52.class);
    } else if ("org.kie.workbench.common.services.datamodeller.core.AnnotationRetention".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_AnnotationRetention.class);
    } else if ("org.drools.workbench.models.guided.dtree.shared.model.parser.messages.BindingNotFoundParserMessage".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_BindingNotFoundParserMessage.class);
    } else if ("org.dashbuilder.dataset.group.ColumnGroup".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_group_ColumnGroup.class);
    } else if ("org.kie.workbench.common.services.shared.kmodule.ListenerModel$Kind".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_kmodule_ListenerModel_erraiD_Kind.class);
    } else if ("org.kie.server.controller.api.model.events.ServerInstanceConnected".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_server_controller_api_model_events_ServerInstanceConnected.class);
    } else if ("org.dashbuilder.dataset.date.Month".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_date_Month.class);
    } else if ("org.drools.workbench.models.guided.template.shared.TemplateModel".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_template_shared_TemplateModel.class);
    } else if ("org.uberfire.ext.security.management.impl.RoleManagerSettingsImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_security_management_impl_RoleManagerSettingsImpl.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.service.ServiceException".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_service_ServiceException.class);
    } else if ("org.kie.uberfire.social.activities.model.SocialPaged".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_uberfire_social_activities_model_SocialPaged.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.auditlog.MetadataColumnDetails".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_MetadataColumnDetails.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.conversion.ConversionAsset".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_conversion_ConversionAsset.class);
    } else if ("org.kie.workbench.common.services.refactoring.model.index.terms.ProjectRootPathIndexTerm".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_ProjectRootPathIndexTerm.class);
    } else if ("org.kie.server.controller.api.model.spec.ServerConfig".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_server_controller_api_model_spec_ServerConfig.class);
    } else if ("org.jbpm.console.ng.ht.model.TasksPerDaySummary".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_ht_model_TasksPerDaySummary.class);
    } else if ("org.kie.server.controller.api.model.spec.ServerTemplateKey".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_server_controller_api_model_spec_ServerTemplateKey.class);
    } else if ("org.dashbuilder.dataset.group.AggregateFunctionType".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_group_AggregateFunctionType.class);
    } else if ("org.uberfire.ext.layout.editor.api.editor.LayoutComponent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_layout_editor_api_editor_LayoutComponent.class);
    } else if ("org.uberfire.ext.plugin.model.PluginContent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_PluginContent.class);
    } else if ("org.kie.workbench.common.screens.social.hp.predicate.UserTimeLineOnlyUserActivityPredicate".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_social_hp_predicate_UserTimeLineOnlyUserActivityPredicate.class);
    } else if ("org.kie.workbench.common.services.datamodeller.core.impl.AnnotationValuePairDefinitionImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_AnnotationValuePairDefinitionImpl.class);
    } else if ("org.dashbuilder.dataset.date.Quarter".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_date_Quarter.class);
    } else if ("org.drools.workbench.models.datamodel.rule.ActionInsertFact".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionInsertFact.class);
    } else if ("org.drools.workbench.models.datamodel.rule.ConnectiveConstraint".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ConnectiveConstraint.class);
    } else if ("org.drools.workbench.models.guided.dtree.shared.model.parser.messages.DataTypeConversionErrorParserMessage".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_DataTypeConversionErrorParserMessage.class);
    } else if ("org.drools.workbench.models.datamodel.rule.ExpressionText".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionText.class);
    } else if ("org.dashbuilder.dataset.filter.CoreFunctionType".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_filter_CoreFunctionType.class);
    } else if ("org.uberfire.java.nio.file.FileSystemAlreadyExistsException".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_java_nio_file_FileSystemAlreadyExistsException.class);
    } else if ("org.drools.workbench.models.datamodel.oracle.DataType".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_oracle_DataType.class);
    } else if ("org.drools.workbench.models.datamodel.rule.ExpressionCollectionIndex".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionCollectionIndex.class);
    } else if ("org.uberfire.ext.plugin.event.PluginAdded".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_plugin_event_PluginAdded.class);
    } else if ("org.drools.workbench.models.testscenarios.shared.SingleScenarioResult".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_SingleScenarioResult.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.model.BRLRuleModel".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_BRLRuleModel.class);
    } else if ("org.drools.workbench.models.guided.dtree.shared.model.values.impl.DoubleValue".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_DoubleValue.class);
    } else if ("org.drools.workbench.models.datamodel.rule.ExpressionGlobalVariable".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionGlobalVariable.class);
    } else if ("org.uberfire.java.nio.file.FileSystemNotFoundException".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_java_nio_file_FileSystemNotFoundException.class);
    } else if ("org.guvnor.structure.repositories.RepositoryEnvironmentUpdatedEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_structure_repositories_RepositoryEnvironmentUpdatedEvent.class);
    } else if ("org.kie.workbench.common.services.datamodeller.core.ObjectSource".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_ObjectSource.class);
    } else if ("org.jbpm.console.ng.pr.model.events.ProcessInstancesUpdateEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_pr_model_events_ProcessInstancesUpdateEvent.class);
    } else if ("org.jbpm.console.ng.bd.model.DomainSummary".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_bd_model_DomainSummary.class);
    } else if ("org.drools.workbench.models.datamodel.rule.FromAccumulateCompositeFactPattern".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_FromAccumulateCompositeFactPattern.class);
    } else if ("org.kie.workbench.common.screens.examples.model.ExampleRepository".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_examples_model_ExampleRepository.class);
    } else if ("org.guvnor.structure.security.RepositoryResourceType".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_structure_security_RepositoryResourceType.class);
    } else if ("org.drools.workbench.models.guided.dtree.shared.model.values.impl.BigDecimalValue".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_BigDecimalValue.class);
    } else if ("org.kie.workbench.common.screens.explorer.model.FolderItem".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_explorer_model_FolderItem.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.auditlog.ActionWorkItemColumnDetails".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_ActionWorkItemColumnDetails.class);
    } else if ("org.kie.workbench.common.services.shared.dependencies.TransitiveEnhancedDependency".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_dependencies_TransitiveEnhancedDependency.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.auditlog.ColumnDetails".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_ColumnDetails.class);
    } else if ("org.kie.workbench.common.services.datamodeller.core.impl.AnnotationDefinitionImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_AnnotationDefinitionImpl.class);
    } else if ("org.guvnor.common.services.project.model.Package".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_project_model_Package.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.events.DataModelStatusChangeEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataModelStatusChangeEvent.class);
    } else if ("org.jbpm.console.ng.pr.model.ProcessInstanceSummary".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_pr_model_ProcessInstanceSummary.class);
    } else if ("org.kie.workbench.common.services.shared.project.ProjectImportsContent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_project_ProjectImportsContent.class);
    } else if ("org.kie.workbench.common.screens.explorer.service.Option".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_explorer_service_Option.class);
    } else if ("org.kie.workbench.common.screens.examples.model.ExamplesMetaData".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_examples_model_ExamplesMetaData.class);
    } else if ("org.optaplanner.workbench.screens.solver.model.ConstructionHeuristicTypeModel".equals(a0)) {
      m = GWT.create(Marshaller_for_org_optaplanner_workbench_screens_solver_model_ConstructionHeuristicTypeModel.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.model.index.terms.valueterms.ValueJavaTypeIndexTerm".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_index_terms_valueterms_ValueJavaTypeIndexTerm.class);
    } else if ("org.kie.workbench.common.services.refactoring.model.index.terms.valueterms.ValueFieldIndexTerm".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_valueterms_ValueFieldIndexTerm.class);
    } else if ("org.kie.workbench.common.services.datamodeller.driver.model.AnnotationParseResponse".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_AnnotationParseResponse.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.auditlog.LimitedEntryActionSetFieldColumnDetails".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_LimitedEntryActionSetFieldColumnDetails.class);
    } else if ("org.kie.uberfire.social.activities.model.DefaultTypes".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_uberfire_social_activities_model_DefaultTypes.class);
    } else if ("org.guvnor.common.services.shared.metadata.model.Overview".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_shared_metadata_model_Overview.class);
    } else if ("org.kie.server.controller.api.model.runtime.ContainerKey".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_server_controller_api_model_runtime_ContainerKey.class);
    } else if ("org.kie.workbench.common.screens.server.management.model.ContainerSpecData".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_server_management_model_ContainerSpecData.class);
    } else if ("org.uberfire.java.nio.file.DirectoryNotEmptyException".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_java_nio_file_DirectoryNotEmptyException.class);
    } else if ("org.optaplanner.workbench.screens.solver.model.TerminationConfigOption".equals(a0)) {
      m = GWT.create(Marshaller_for_org_optaplanner_workbench_screens_solver_model_TerminationConfigOption.class);
    } else if ("org.dashbuilder.dataset.date.TimeFrame".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_date_TimeFrame.class);
    } else if ("org.drools.workbench.models.datamodel.rule.CEPWindow".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_CEPWindow.class);
    } else if ("org.kie.workbench.common.services.refactoring.model.index.terms.RuleAttributeValueIndexTerm".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_RuleAttributeValueIndexTerm.class);
    } else if ("org.guvnor.structure.security.OrgUnitResourceType".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_structure_security_OrgUnitResourceType.class);
    } else if ("org.kie.workbench.common.services.datamodeller.core.impl.JavaTypeInfoImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_JavaTypeInfoImpl.class);
    } else if ("org.drools.workbench.models.guided.dtree.shared.model.values.impl.EnumValue".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_EnumValue.class);
    } else if ("org.drools.workbench.models.datamodel.rule.ExpressionCollection".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionCollection.class);
    } else if ("org.drools.workbench.models.guided.dtree.shared.model.nodes.impl.ActionFieldValueImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_nodes_impl_ActionFieldValueImpl.class);
    } else if ("org.drools.workbench.models.datamodel.oracle.FieldAccessorsAndMutators".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_oracle_FieldAccessorsAndMutators.class);
    } else if ("org.dashbuilder.dataprovider.SQLProviderType".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataprovider_SQLProviderType.class);
    } else if ("org.uberfire.ext.plugin.model.CodeType".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_CodeType.class);
    } else if ("org.kie.uberfire.social.activities.events.SocialUserFollowedEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_uberfire_social_activities_events_SocialUserFollowedEvent.class);
    } else if ("org.drools.workbench.models.guided.dtree.shared.model.nodes.impl.TypeNodeImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_nodes_impl_TypeNodeImpl.class);
    } else if ("org.jbpm.console.ng.ht.model.TaskSummary".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_ht_model_TaskSummary.class);
    } else if ("org.drools.workbench.models.datamodel.workitems.PortableWorkDefinition".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableWorkDefinition.class);
    } else if ("org.kie.workbench.common.services.datamodeller.core.Visibility".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_Visibility.class);
    } else if ("org.kie.server.controller.api.model.runtime.ServerInstance".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_server_controller_api_model_runtime_ServerInstance.class);
    } else if ("org.drools.workbench.models.datamodel.rule.FromCompositeFactPattern".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_FromCompositeFactPattern.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.auditlog.ConditionColumnDetails".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_ConditionColumnDetails.class);
    } else if ("org.uberfire.ext.security.management.impl.SettingsImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_security_management_impl_SettingsImpl.class);
    } else if ("org.drools.workbench.models.datamodel.rule.ActionSetField".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionSetField.class);
    } else if ("org.uberfire.workbench.model.impl.ContextDefinitionImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_workbench_model_impl_ContextDefinitionImpl.class);
    } else if ("org.kie.server.controller.api.model.events.RuleConfigUpdated".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_server_controller_api_model_events_RuleConfigUpdated.class);
    } else if ("org.uberfire.workbench.events.ResourceAdded".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceAdded.class);
    } else if ("org.uberfire.backend.vfs.impl.LockResult".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_backend_vfs_impl_LockResult.class);
    } else if ("org.jbpm.console.ng.ht.model.events.EditPanelEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_ht_model_events_EditPanelEvent.class);
    } else if ("org.jbpm.console.ng.ht.model.TypeRole".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_ht_model_TypeRole.class);
    } else if ("org.kie.uberfire.social.activities.events.SocialUserUnFollowedEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_uberfire_social_activities_events_SocialUserUnFollowedEvent.class);
    } else if ("org.uberfire.ext.services.shared.preferences.UserWorkbenchPreferences".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_services_shared_preferences_UserWorkbenchPreferences.class);
    } else if ("org.jbpm.formModeler.api.events.FormSubmittedEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_formModeler_api_events_FormSubmittedEvent.class);
    } else if ("org.kie.workbench.common.screens.defaulteditor.service.DefaultEditorContent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_defaulteditor_service_DefaultEditorContent.class);
    }
    return putIfNotNull(a0, m);
  }

  private boolean loadMarshaller5(String a0) {
    Marshaller m = null;
    if ("org.drools.workbench.screens.factmodel.model.FactModels".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_screens_factmodel_model_FactModels.class);
    } else if ("org.uberfire.java.nio.file.InvalidPathException".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_java_nio_file_InvalidPathException.class);
    } else if ("org.drools.workbench.models.datamodel.rule.visitors.RuleModelVisitor".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_visitors_RuleModelVisitor.class);
    } else if ("org.jbpm.console.ng.ga.model.DataMockSummary".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_ga_model_DataMockSummary.class);
    } else if ("org.uberfire.ext.layout.editor.api.editor.LayoutColumn".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_layout_editor_api_editor_LayoutColumn.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.model.LimitedEntryActionInsertFactCol52".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_LimitedEntryActionInsertFactCol52.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.model.index.terms.FieldTypeIndexTerm".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_index_terms_FieldTypeIndexTerm.class);
    } else if ("org.guvnor.structure.repositories.RepositoryAlreadyExistsException".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_structure_repositories_RepositoryAlreadyExistsException.class);
    } else if ("org.dashbuilder.dataset.def.DataSetDef".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_def_DataSetDef.class);
    } else if ("org.optaplanner.workbench.screens.solver.model.ConstructionHeuristicPhaseConfigModel".equals(a0)) {
      m = GWT.create(Marshaller_for_org_optaplanner_workbench_screens_solver_model_ConstructionHeuristicPhaseConfigModel.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.model.index.terms.valueterms.ValueJavaTypeNameIndexTerm".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_index_terms_valueterms_ValueJavaTypeNameIndexTerm.class);
    } else if ("org.drools.workbench.models.datamodel.rule.ActionGlobalCollectionAdd".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionGlobalCollectionAdd.class);
    } else if ("org.drools.workbench.models.testscenarios.shared.FactData".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_FactData.class);
    } else if ("org.jbpm.formModeler.api.events.ResizeFormcontainerEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_formModeler_api_events_ResizeFormcontainerEvent.class);
    } else if ("org.drools.workbench.models.datamodel.rule.ExpressionField".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionField.class);
    } else if ("org.jbpm.console.ng.bd.model.RuntimeLogSummary".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_bd_model_RuntimeLogSummary.class);
    } else if ("org.kie.workbench.common.services.shared.kmodule.KModuleModel".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_kmodule_KModuleModel.class);
    } else if ("org.uberfire.java.nio.file.NoSuchFileException".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_java_nio_file_NoSuchFileException.class);
    } else if ("org.guvnor.asset.management.social.AssetManagementEventTypes".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_asset_management_social_AssetManagementEventTypes.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.events.DataObjectFieldSelectedEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataObjectFieldSelectedEvent.class);
    } else if ("org.dashbuilder.dataset.events.DataSetPushingEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_events_DataSetPushingEvent.class);
    } else if ("org.dashbuilder.dataset.def.BeanDataSetDef".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_def_BeanDataSetDef.class);
    } else if ("org.drools.workbench.screens.factmodel.model.FactMetaModel".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_screens_factmodel_model_FactMetaModel.class);
    } else if ("org.dashbuilder.dataset.impl.DataSetBuilderImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_impl_DataSetBuilderImpl.class);
    } else if ("org.jbpm.console.ng.ht.model.IdentitySummary".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_ht_model_IdentitySummary.class);
    } else if ("org.drools.workbench.models.guided.dtree.shared.model.parser.messages.InvalidRootParserMessage".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_InvalidRootParserMessage.class);
    } else if ("org.drools.workbench.models.datamodel.auditlog.DefaultAuditLogFilter".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_auditlog_DefaultAuditLogFilter.class);
    } else if ("org.drools.workbench.screens.factmodel.model.FieldMetaModel".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_screens_factmodel_model_FieldMetaModel.class);
    } else if ("org.uberfire.workbench.model.impl.SplashScreenFilterImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_workbench_model_impl_SplashScreenFilterImpl.class);
    } else if ("org.drools.workbench.screens.globals.model.GlobalsModel".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_screens_globals_model_GlobalsModel.class);
    } else if ("org.guvnor.common.services.shared.metadata.model.Metadata".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_shared_metadata_model_Metadata.class);
    } else if ("org.drools.workbench.models.datamodel.oracle.DropDownData".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_oracle_DropDownData.class);
    } else if ("org.kie.workbench.common.services.shared.kmodule.KBaseModel".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_kmodule_KBaseModel.class);
    } else if ("org.drools.workbench.models.datamodel.rule.visitors.CopyExpressionVisitor".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_visitors_CopyExpressionVisitor.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.model.BRLActionColumn".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_BRLActionColumn.class);
    } else if ("org.jbpm.console.ng.ht.model.events.TaskCalendarEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_ht_model_events_TaskCalendarEvent.class);
    } else if ("org.drools.workbench.models.datamodel.rule.InterpolationVariable".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_InterpolationVariable.class);
    } else if ("org.guvnor.structure.organizationalunit.UpdatedOrganizationalUnitEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_structure_organizationalunit_UpdatedOrganizationalUnitEvent.class);
    } else if ("org.guvnor.structure.organizationalunit.RemoveOrganizationalUnitEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_structure_organizationalunit_RemoveOrganizationalUnitEvent.class);
    } else if ("org.jbpm.console.ng.pr.model.events.ProcessInstancesSearchEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_pr_model_events_ProcessInstancesSearchEvent.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.model.index.terms.JavaTypeIndexTerm".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_index_terms_JavaTypeIndexTerm.class);
    } else if ("org.drools.workbench.models.datamodel.rule.RuleMetadata".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_RuleMetadata.class);
    } else if ("org.drools.workbench.models.datamodel.imports.Import".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_imports_Import.class);
    } else if ("org.uberfire.java.nio.file.NotLinkException".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_java_nio_file_NotLinkException.class);
    } else if ("org.drools.workbench.models.datamodel.rule.ActionFieldValue".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionFieldValue.class);
    } else if ("org.kie.workbench.common.services.shared.kmodule.EventProcessingOption".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_kmodule_EventProcessingOption.class);
    } else if ("org.jbpm.console.ng.ht.model.Day".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_ht_model_Day.class);
    } else if ("org.drools.workbench.screens.guided.dtree.model.GuidedDecisionTreeEditorContent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_screens_guided_dtree_model_GuidedDecisionTreeEditorContent.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.model.persistence.ValidationMode".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_persistence_ValidationMode.class);
    } else if ("org.jbpm.console.ng.bd.model.OrganizationSummary".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_bd_model_OrganizationSummary.class);
    } else if ("org.guvnor.common.services.shared.exceptions.GenericPortableException".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_shared_exceptions_GenericPortableException.class);
    } else if ("org.dashbuilder.dataprovider.ELSProviderType".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataprovider_ELSProviderType.class);
    } else if ("org.guvnor.common.services.project.builder.model.BuildResults".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_project_builder_model_BuildResults.class);
    } else if ("org.jbpm.console.ng.pr.model.events.ProcessDefSelectionEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_pr_model_events_ProcessDefSelectionEvent.class);
    } else if ("org.kie.workbench.common.services.datamodeller.driver.model.ModelDriverResult".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_ModelDriverResult.class);
    } else if ("org.jbpm.formModeler.editor.model.FormEditorContextTO".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_formModeler_editor_model_FormEditorContextTO.class);
    } else if ("org.kie.workbench.common.services.shared.kmodule.AssertBehaviorOption".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_kmodule_AssertBehaviorOption.class);
    } else if ("org.kie.uberfire.social.activities.model.SocialPaged$Direction".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_uberfire_social_activities_model_SocialPaged_erraiD_Direction.class);
    } else if ("org.guvnor.structure.repositories.impl.DefaultPublicURI".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_structure_repositories_impl_DefaultPublicURI.class);
    } else if ("org.uberfire.paging.PageResponse".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_paging_PageResponse.class);
    } else if ("org.kie.workbench.common.screens.examples.model.ExampleProject".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_examples_model_ExampleProject.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.events.DataObjectChangeEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataObjectChangeEvent.class);
    } else if ("org.uberfire.java.nio.file.ProviderNotFoundException".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_java_nio_file_ProviderNotFoundException.class);
    } else if ("org.uberfire.ext.plugin.model.Media".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_Media.class);
    } else if ("org.guvnor.common.services.project.builder.events.InvalidateDMOProjectCacheEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_project_builder_events_InvalidateDMOProjectCacheEvent.class);
    } else if ("org.guvnor.common.services.project.events.RenameProjectEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_project_events_RenameProjectEvent.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.auditlog.DeleteRowAuditLogEntry".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_DeleteRowAuditLogEntry.class);
    } else if ("org.jbpm.console.ng.wi.dd.model.DeploymentDescriptorModel".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_wi_dd_model_DeploymentDescriptorModel.class);
    } else if ("org.dashbuilder.dataset.sort.ColumnSort".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_sort_ColumnSort.class);
    } else if ("org.guvnor.common.services.project.model.ProjectRepositories".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_project_model_ProjectRepositories.class);
    } else if ("org.dashbuilder.dataset.group.DataSetGroup".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_group_DataSetGroup.class);
    } else if ("org.guvnor.common.services.shared.test.TestResultMessage".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_shared_test_TestResultMessage.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.model.index.terms.JavaTypeIndexTerm$JAVA_TYPE".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_index_terms_JavaTypeIndexTerm_erraiD_JAVA_erraiU_TYPE.class);
    } else if ("org.kie.workbench.common.services.datamodeller.core.impl.JavaInterfaceImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_JavaInterfaceImpl.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.model.Pattern52".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_Pattern52.class);
    } else if ("org.uberfire.java.nio.file.PatternSyntaxException".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_java_nio_file_PatternSyntaxException.class);
    } else if ("org.kie.server.controller.api.model.runtime.Container".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_server_controller_api_model_runtime_Container.class);
    } else if ("org.kie.uberfire.social.activities.model.PagedSocialQuery".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_uberfire_social_activities_model_PagedSocialQuery.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.events.DataModelReload".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataModelReload.class);
    } else if ("org.uberfire.workbench.events.ResourceAddedEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceAddedEvent.class);
    } else if ("org.drools.workbench.models.datamodel.rule.ActionInsertLogicalFact".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionInsertLogicalFact.class);
    } else if ("org.drools.workbench.models.guided.dtree.shared.model.values.impl.StringValue".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_StringValue.class);
    } else if ("org.kie.workbench.common.services.refactoring.model.query.RefactoringPageRequest".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_query_RefactoringPageRequest.class);
    } else if ("org.drools.workbench.models.testscenarios.shared.ExecutionTrace".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_ExecutionTrace.class);
    } else if ("org.jbpm.console.ng.ht.model.Group".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_ht_model_Group.class);
    } else if ("org.drools.workbench.screens.guided.scorecard.model.ScoreCardModelContent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_screens_guided_scorecard_model_ScoreCardModelContent.class);
    } else if ("org.jbpm.console.ng.bd.model.events.DeployedUnitChangedEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_bd_model_events_DeployedUnitChangedEvent.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.model.LimitedEntryActionRetractFactCol52".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_LimitedEntryActionRetractFactCol52.class);
    } else if ("org.drools.workbench.models.guided.dtree.shared.model.values.impl.IntegerValue".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_IntegerValue.class);
    } else if ("org.jbpm.console.ng.ht.model.TaskEventSummary".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_ht_model_TaskEventSummary.class);
    } else if ("org.drools.workbench.models.guided.dtree.shared.model.values.impl.ByteValue".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_ByteValue.class);
    } else if ("org.drools.workbench.models.testscenarios.shared.RetractFact".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_RetractFact.class);
    } else if ("org.jbpm.console.ng.ga.forms.model.events.FormRenderedEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_ga_forms_model_events_FormRenderedEvent.class);
    } else if ("org.dashbuilder.dataset.impl.DataSetMetadataImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_impl_DataSetMetadataImpl.class);
    } else if ("org.jbpm.console.ng.pr.model.ProcessVariableSummary".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_pr_model_ProcessVariableSummary.class);
    } else if ("org.uberfire.workbench.events.ResourceCopiedEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceCopiedEvent.class);
    } else if ("org.uberfire.java.nio.IOException".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_java_nio_IOException.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.events.DataObjectFieldDeletedEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataObjectFieldDeletedEvent.class);
    } else if ("org.uberfire.ext.properties.editor.model.validators.LongValidator".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_properties_editor_model_validators_LongValidator.class);
    } else if ("org.dashbuilder.dataset.def.StaticDataSetDef".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_def_StaticDataSetDef.class);
    }
    return putIfNotNull(a0, m);
  }

  private boolean loadMarshaller6(String a0) {
    Marshaller m = null;
    if ("org.drools.workbench.screens.testscenario.model.TestScenarioModelContent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_screens_testscenario_model_TestScenarioModelContent.class);
    } else if ("org.optaplanner.workbench.screens.solver.model.TerminationCompositionStyleModel".equals(a0)) {
      m = GWT.create(Marshaller_for_org_optaplanner_workbench_screens_solver_model_TerminationCompositionStyleModel.class);
    } else if ("org.optaplanner.workbench.screens.solver.model.ScoreDefinitionTypeModel".equals(a0)) {
      m = GWT.create(Marshaller_for_org_optaplanner_workbench_screens_solver_model_ScoreDefinitionTypeModel.class);
    } else if ("org.jbpm.console.ng.pr.model.DocumentKey".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_pr_model_DocumentKey.class);
    } else if ("org.drools.workbench.models.testscenarios.shared.ScenarioRunResult".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_ScenarioRunResult.class);
    } else if ("org.uberfire.ext.plugin.event.PluginRenamed".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_plugin_event_PluginRenamed.class);
    } else if ("org.uberfire.ext.editor.commons.readonly.ReadOnlyPathPlaceRequest".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_editor_commons_readonly_ReadOnlyPathPlaceRequest.class);
    } else if ("org.dashbuilder.dataset.filter.DataSetFilter".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_filter_DataSetFilter.class);
    } else if ("org.guvnor.structure.repositories.impl.git.GitRepository".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_structure_repositories_impl_git_GitRepository.class);
    } else if ("org.drools.workbench.models.guided.dtree.shared.model.values.impl.DateValue".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_DateValue.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.model.adaptors.ConditionCol52FieldConstraintAdaptor".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_adaptors_ConditionCol52FieldConstraintAdaptor.class);
    } else if ("org.drools.workbench.models.datamodel.imports.Imports".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_imports_Imports.class);
    } else if ("org.uberfire.security.impl.authz.DefaultPermissionCollection".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_security_impl_authz_DefaultPermissionCollection.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.model.ActionWorkItemSetFieldCol52".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_ActionWorkItemSetFieldCol52.class);
    } else if ("org.guvnor.structure.repositories.RepositoryEnvironmentConfiguration".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_structure_repositories_RepositoryEnvironmentConfiguration.class);
    } else if ("org.dashbuilder.dataset.date.DayOfWeek".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_date_DayOfWeek.class);
    } else if ("org.kie.server.controller.api.model.runtime.ServerInstanceKey".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_server_controller_api_model_runtime_ServerInstanceKey.class);
    } else if ("org.drools.workbench.models.datamodel.rule.DSLComplexVariableValue".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_DSLComplexVariableValue.class);
    } else if ("org.kie.workbench.common.services.shared.dependencies.NormalEnhancedDependency".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_dependencies_NormalEnhancedDependency.class);
    } else if ("org.dashbuilder.dataset.DataSetLookup".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_DataSetLookup.class);
    } else if ("org.uberfire.mvp.impl.DefaultPlaceRequest".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_mvp_impl_DefaultPlaceRequest.class);
    } else if ("org.dashbuilder.dataset.sort.SortedList".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_sort_SortedList.class);
    } else if ("org.uberfire.workbench.events.ResourceDeleted".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceDeleted.class);
    } else if ("org.dashbuilder.dataset.impl.DataSetImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_impl_DataSetImpl.class);
    } else if ("org.guvnor.common.services.project.model.Dependencies".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_project_model_Dependencies.class);
    } else if ("org.optaplanner.workbench.screens.solver.model.SolverConfigModel".equals(a0)) {
      m = GWT.create(Marshaller_for_org_optaplanner_workbench_screens_solver_model_SolverConfigModel.class);
    } else if ("org.kie.server.controller.api.model.spec.Capability".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_server_controller_api_model_spec_Capability.class);
    } else if ("org.guvnor.messageconsole.events.UnpublishMessagesEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_messageconsole_events_UnpublishMessagesEvent.class);
    } else if ("org.dashbuilder.dataset.events.DataSetDefRemovedEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_events_DataSetDefRemovedEvent.class);
    } else if ("org.kie.server.api.model.KieContainerStatus".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_server_api_model_KieContainerStatus.class);
    } else if ("org.kie.workbench.common.screens.explorer.model.FolderListing".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_explorer_model_FolderListing.class);
    } else if ("org.drools.workbench.models.datamodel.rule.SingleFieldConstraint".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_SingleFieldConstraint.class);
    } else if ("org.uberfire.workbench.events.ResourceCopied".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceCopied.class);
    } else if ("org.uberfire.security.impl.authz.DotNamedPermission".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_security_impl_authz_DotNamedPermission.class);
    } else if ("org.uberfire.ext.security.management.api.exception.NoImplementationAvailableException".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_security_management_api_exception_NoImplementationAvailableException.class);
    } else if ("org.uberfire.ext.security.management.api.exception.SecurityManagementException".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_security_management_api_exception_SecurityManagementException.class);
    } else if ("org.drools.workbench.models.datamodel.rule.ExpressionUnboundFact".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionUnboundFact.class);
    } else if ("org.guvnor.structure.social.OrganizationalUnitEventType".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_structure_social_OrganizationalUnitEventType.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.model.adaptors.ActionInsertFactCol52ActionInsertFactAdaptor".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_adaptors_ActionInsertFactCol52ActionInsertFactAdaptor.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.model.GenerationResult".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_GenerationResult.class);
    } else if ("org.guvnor.asset.management.social.AssetManagementEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_asset_management_social_AssetManagementEvent.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.model.persistence.Property".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_persistence_Property.class);
    } else if ("org.guvnor.structure.repositories.NewRepositoryEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_structure_repositories_NewRepositoryEvent.class);
    } else if ("org.kie.workbench.common.services.datamodel.model.LazyModelField".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodel_model_LazyModelField.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.model.index.terms.valueterms.ValueFieldTypeIndexTerm".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_index_terms_valueterms_ValueFieldTypeIndexTerm.class);
    } else if ("org.uberfire.ext.plugin.model.PluginType".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_PluginType.class);
    } else if ("org.kie.workbench.common.services.datamodeller.core.impl.ModelFactoryImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_ModelFactoryImpl.class);
    } else if ("org.kie.workbench.common.services.datamodeller.core.impl.PropertyTypeFactoryImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_PropertyTypeFactoryImpl.class);
    } else if ("org.drools.workbench.screens.guided.template.model.GuidedTemplateEditorContent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_screens_guided_template_model_GuidedTemplateEditorContent.class);
    } else if ("org.drools.workbench.screens.enums.model.EnumModelContent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_screens_enums_model_EnumModelContent.class);
    } else if ("org.guvnor.structure.repositories.NewBranchEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_structure_repositories_NewBranchEvent.class);
    } else if ("org.dashbuilder.dataset.group.GroupStrategy".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_group_GroupStrategy.class);
    } else if ("org.drools.workbench.models.guided.dtree.shared.model.parser.messages.AmbiguousRootParserMessage".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_AmbiguousRootParserMessage.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.model.adaptors.ActionInsertFactCol52ActionInsertLogicalFactAdaptor".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_adaptors_ActionInsertFactCol52ActionInsertLogicalFactAdaptor.class);
    } else if ("org.dashbuilder.dataset.impl.DataSetLookupBuilderImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_impl_DataSetLookupBuilderImpl.class);
    } else if ("org.kie.workbench.common.services.datamodeller.core.JavaTypeKind".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_JavaTypeKind.class);
    } else if ("org.uberfire.java.nio.file.FileSystemException".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_java_nio_file_FileSystemException.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.model.DTCellValue52".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_DTCellValue52.class);
    } else if ("org.uberfire.ext.security.management.api.Capability".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_security_management_api_Capability.class);
    } else if ("org.guvnor.common.services.shared.test.Failure".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_shared_test_Failure.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.auditlog.LimitedEntryActionInsertFactColumnDetails".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_LimitedEntryActionInsertFactColumnDetails.class);
    } else if ("org.uberfire.workbench.events.ResourceBatchChangesEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceBatchChangesEvent.class);
    } else if ("org.uberfire.ext.properties.editor.model.validators.ColorValidator".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_properties_editor_model_validators_ColorValidator.class);
    } else if ("org.jbpm.console.ng.ht.model.TaskAssignmentSummary".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_ht_model_TaskAssignmentSummary.class);
    } else if ("org.dashbuilder.dataset.filter.LogicalExprType".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_filter_LogicalExprType.class);
    } else if ("org.uberfire.java.nio.file.AccessDeniedException".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_java_nio_file_AccessDeniedException.class);
    } else if ("org.kie.workbench.common.screens.social.hp.predicate.UserTimeLineFileChangesPredicate".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_social_hp_predicate_UserTimeLineFileChangesPredicate.class);
    } else if ("org.optaplanner.workbench.screens.solver.model.SolverModelContent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_optaplanner_workbench_screens_solver_model_SolverModelContent.class);
    } else if ("org.kie.server.api.model.ReleaseId".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_server_api_model_ReleaseId.class);
    } else if ("org.drools.workbench.screens.workitems.model.WorkItemsModelContent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_screens_workitems_model_WorkItemsModelContent.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.model.TypeInfoResult".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_TypeInfoResult.class);
    } else if ("org.drools.workbench.models.datamodel.rule.BaseSingleFieldConstraint".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_BaseSingleFieldConstraint.class);
    } else if ("org.guvnor.common.services.project.model.ProjectRepositories$ProjectRepository".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_project_model_ProjectRepositories_erraiD_ProjectRepository.class);
    } else if ("org.uberfire.workbench.model.impl.PerspectiveDefinitionImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_workbench_model_impl_PerspectiveDefinitionImpl.class);
    } else if ("org.guvnor.common.services.project.service.GAVAlreadyExistsException".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_project_service_GAVAlreadyExistsException.class);
    } else if ("org.uberfire.ext.security.management.api.exception.GroupNotFoundException".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_security_management_api_exception_GroupNotFoundException.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.model.adaptors.Pattern52FactPatternAdaptor".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_adaptors_Pattern52FactPatternAdaptor.class);
    } else if ("org.dashbuilder.dataprovider.CSVProviderType".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataprovider_CSVProviderType.class);
    } else if ("org.kie.workbench.common.services.shared.dependencies.EnhancedDependencies".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_dependencies_EnhancedDependencies.class);
    } else if ("org.dashbuilder.displayer.ColumnSettings".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_displayer_ColumnSettings.class);
    } else if ("org.uberfire.ext.plugin.event.MediaDeleted".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_plugin_event_MediaDeleted.class);
    } else if ("org.kie.workbench.common.services.datamodeller.driver.model.AnnotationSource".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_AnnotationSource.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.model.DataModelerError".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_DataModelerError.class);
    } else if ("org.jbpm.console.ng.es.model.RequestDetails".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_es_model_RequestDetails.class);
    } else if ("org.drools.workbench.models.datamodel.rule.ActionExecuteWorkItem".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionExecuteWorkItem.class);
    } else if ("org.guvnor.messageconsole.events.PublishMessagesEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_messageconsole_events_PublishMessagesEvent.class);
    } else if ("org.uberfire.ext.properties.editor.model.PropertyEditorCategory".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_properties_editor_model_PropertyEditorCategory.class);
    } else if ("org.drools.workbench.screens.dsltext.model.DSLTextEditorContent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_screens_dsltext_model_DSLTextEditorContent.class);
    } else if ("org.uberfire.java.nio.file.AtomicMoveNotSupportedException".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_java_nio_file_AtomicMoveNotSupportedException.class);
    } else if ("org.kie.server.controller.api.model.events.ServerInstanceUpdated".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_server_controller_api_model_events_ServerInstanceUpdated.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.model.BRLActionVariableColumn".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_BRLActionVariableColumn.class);
    } else if ("org.kie.workbench.common.services.datamodeller.core.impl.AnnotationImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_AnnotationImpl.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.model.ActionCol52".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_ActionCol52.class);
    } else if ("org.uberfire.backend.vfs.PathFactory$PathImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_backend_vfs_PathFactory_erraiD_PathImpl.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.model.ConditionCol52".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_ConditionCol52.class);
    } else if ("org.dashbuilder.dataset.ColumnType".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_ColumnType.class);
    } else if ("org.uberfire.ext.plugin.model.Activity".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_Activity.class);
    } else if ("org.uberfire.ext.layout.editor.api.editor.LayoutRow".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_layout_editor_api_editor_LayoutRow.class);
    } else if ("org.uberfire.ext.services.shared.preferences.MultiGridPreferencesStore".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_services_shared_preferences_MultiGridPreferencesStore.class);
    } else if ("org.drools.workbench.models.testscenarios.shared.ActivateRuleFlowGroup".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_ActivateRuleFlowGroup.class);
    }
    return putIfNotNull(a0, m);
  }

  private boolean loadMarshaller7(String a0) {
    Marshaller m = null;
    if ("org.guvnor.common.services.shared.message.Level".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_shared_message_Level.class);
    } else if ("org.uberfire.ext.security.management.api.exception.OperationFailedException".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_security_management_api_exception_OperationFailedException.class);
    } else if ("org.uberfire.ext.security.management.impl.SearchRequestImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_security_management_impl_SearchRequestImpl.class);
    } else if ("org.kie.workbench.common.services.shared.kmodule.ClockTypeOption".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_kmodule_ClockTypeOption.class);
    } else if ("org.jbpm.console.ng.ht.model.AuditTaskSummary".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_ht_model_AuditTaskSummary.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.events.DataObjectFieldCreatedEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataObjectFieldCreatedEvent.class);
    } else if ("org.uberfire.backend.vfs.impl.ObservablePathImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_backend_vfs_impl_ObservablePathImpl.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.model.BaseColumnFieldDiffImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_BaseColumnFieldDiffImpl.class);
    } else if ("org.drools.workbench.models.datamodel.workitems.PortableListParameterDefinition".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableListParameterDefinition.class);
    } else if ("org.uberfire.ext.plugin.model.Framework".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_Framework.class);
    } else if ("org.drools.workbench.models.guided.dtree.shared.model.nodes.impl.ActionInsertNodeImpl".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_nodes_impl_ActionInsertNodeImpl.class);
    } else if ("org.jbpm.console.ng.es.model.RequestParameterSummary".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_es_model_RequestParameterSummary.class);
    } else if ("org.jbpm.console.ng.pr.model.events.NewProcessInstanceEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_pr_model_events_NewProcessInstanceEvent.class);
    } else if ("org.dashbuilder.dataset.group.GroupFunction".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_group_GroupFunction.class);
    } else if ("org.guvnor.common.services.project.social.ProjectEventType".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_project_social_ProjectEventType.class);
    } else if ("org.guvnor.common.services.project.model.Project".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_common_services_project_model_Project.class);
    } else if ("org.uberfire.ext.security.management.api.exception.UnsupportedServiceCapabilityException".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_security_management_api_exception_UnsupportedServiceCapabilityException.class);
    } else if ("org.kie.workbench.common.services.datamodeller.driver.model.DriverRequest".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_DriverRequest.class);
    } else if ("org.dashbuilder.dataset.def.CSVDataSetDef".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_def_CSVDataSetDef.class);
    } else if ("org.jbpm.console.ng.pr.model.DocumentSummary".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_pr_model_DocumentSummary.class);
    } else if ("org.jbpm.console.ng.pr.model.ProcessSummary".equals(a0)) {
      m = GWT.create(Marshaller_for_org_jbpm_console_ng_pr_model_ProcessSummary.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.auditlog.InsertColumnAuditLogEntry".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_InsertColumnAuditLogEntry.class);
    } else if ("org.kie.workbench.common.services.datamodeller.driver.model.DriverResponse".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_DriverResponse.class);
    } else if ("org.kie.workbench.common.services.datamodeller.driver.model.AnnotationDefinitionRequest".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_AnnotationDefinitionRequest.class);
    } else if ("org.drools.workbench.models.datamodel.workitems.PortableEnumParameterDefinition".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableEnumParameterDefinition.class);
    } else if ("org.dashbuilder.dataset.exception.DataSetLookupException".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_exception_DataSetLookupException.class);
    } else if ("org.drools.workbench.models.datamodel.rule.CompositeFieldConstraint".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_CompositeFieldConstraint.class);
    } else if ("org.guvnor.structure.config.SystemRepositoryChangedEvent".equals(a0)) {
      m = GWT.create(Marshaller_for_org_guvnor_structure_config_SystemRepositoryChangedEvent.class);
    } else if ("org.uberfire.security.impl.authz.DefaultAuthorizationEntry".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_security_impl_authz_DefaultAuthorizationEntry.class);
    } else if ("org.uberfire.ext.services.shared.preferences.GridGlobalPreferences".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_services_shared_preferences_GridGlobalPreferences.class);
    } else if ("org.dashbuilder.dataset.date.TimeInstant".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_date_TimeInstant.class);
    } else if ("org.uberfire.ext.apps.api.DirectoryBreadCrumb".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_apps_api_DirectoryBreadCrumb.class);
    } else if ("org.kie.workbench.common.screens.datamodeller.model.index.terms.valueterms.ValueJavaTypeInterfaceIndexTerm".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_index_terms_valueterms_ValueJavaTypeInterfaceIndexTerm.class);
    } else if ("org.drools.workbench.models.testscenarios.shared.Scenario".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_Scenario.class);
    } else if ("org.uberfire.ext.properties.editor.model.PropertyEditorType".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_properties_editor_model_PropertyEditorType.class);
    } else if ("org.uberfire.ext.services.shared.preferences.UserPreferencesType".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_ext_services_shared_preferences_UserPreferencesType.class);
    } else if ("org.uberfire.workbench.events.NotificationEvent$NotificationType".equals(a0)) {
      m = GWT.create(Marshaller_for_org_uberfire_workbench_events_NotificationEvent_erraiD_NotificationType.class);
    } else if ("org.kie.server.api.model.KieScannerStatus".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_server_api_model_KieScannerStatus.class);
    } else if ("org.drools.workbench.models.guided.dtable.shared.model.GuidedDecisionTable52$TableFormat".equals(a0)) {
      m = GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_GuidedDecisionTable52_erraiD_TableFormat.class);
    } else if ("org.kie.workbench.common.services.datamodeller.core.AnnotationValuePairDefinition$ValuePairType".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_AnnotationValuePairDefinition_erraiD_ValuePairType.class);
    } else if ("org.kie.workbench.common.services.shared.kmodule.DeclarativeAgendaOption".equals(a0)) {
      m = GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_kmodule_DeclarativeAgendaOption.class);
    } else if ("org.dashbuilder.dataset.sort.SortOrder".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_sort_SortOrder.class);
    } else if ("org.dashbuilder.dataset.date.TimeInstant$TimeMode".equals(a0)) {
      m = GWT.create(Marshaller_for_org_dashbuilder_dataset_date_TimeInstant_erraiD_TimeMode.class);
    }
    return putIfNotNull(a0, m);
  }

  public Marshaller getMarshaller(String a0) {
    if (a0 == null) {
      return null;
    }
    Marshaller m = marshallers.get(a0);
    if (m != null) {
      return m;
    } else if (loadMarshaller0(a0)) {
      return marshallers.get(a0);
    } else if (loadMarshaller1(a0)) {
      return marshallers.get(a0);
    } else if (loadMarshaller2(a0)) {
      return marshallers.get(a0);
    } else if (loadMarshaller3(a0)) {
      return marshallers.get(a0);
    } else if (loadMarshaller4(a0)) {
      return marshallers.get(a0);
    } else if (loadMarshaller5(a0)) {
      return marshallers.get(a0);
    } else if (loadMarshaller6(a0)) {
      return marshallers.get(a0);
    } else if (loadMarshaller7(a0)) {
      return marshallers.get(a0);
    }
    return null;
  }

  public void registerMarshaller(String a0, Marshaller a1) {
    marshallers.put(a0, a1);
  }
}